::wallworm_mapsize = [0, 0]
::wallworm_point_entity_list = #("ambient_generic", "armoury_entity", "cycler", "cycler_sprite", "cycler_wreckage", "env_beam", "env_beverage", "env_blood", "env_explosion", "env_funnel", "env_global", "env_glow", "env_fade", "env_fog", "env_laser", "env_message", "env_rain", "env_render", "env_shake", "env_shooter", "env_smoker", "env_sound", "env_snow", "env_spark", "env_sprite", "game_counter", "game_counter_set", "game_end", "game_player_equip", "game_player_hurt", "game_player_team", "game_score", "game_team_master", "game_team_set", "game_text", "gibshooter", "hostage_entity", "info_bomb_target", "info_compile_parameters", "info_hostage_rescue", "info_lights_rad", "info_map_parameters", "info_null", "info_player_deathmatch", "info_player_start", "info_target", "info_teleport_destination", "info_vip_start", "infodecal", "item_battery", "item_healthkit", "item_longjump", "light", "light_environment", "light_spot", "multi_manager", "multisource", "path_corner", "path_track", "player_weaponstrip", "monster_scientist", "trigger_auto", "trigger_camera", "trigger_changetarget", "trigger_relay", "weapon_c4", "xen_plantlight", "xen_hair", "xen_tree", "xen_spore_small", "xen_spore_medium", "xen_spore_large")
::wallworm_brush_entity_list = #("worldspawn", "env_bubbles", "game_zone_player", "trigger_counter", "trigger_gravity", "trigger_hurt", "trigger_multiple", "trigger_once", "trigger_push", "trigger_teleport", "func_bomb_target", "func_breakable", "func_button", "func_buyzone", "func_conveyor", "func_door", "func_door_rotating", "func_escapezone", "func_friction", "func_grencatch", "func_guntarget", "func_healthcharger", "func_hostage_rescue", "func_illusionary", "func_ladder", "func_mortar_field", "func_pendulum", "func_plat", "func_platrot", "func_pushable", "func_recharge", "func_rot_button", "func_rotating", "func_tank", "func_tankcontrols", "func_tanklaser", "func_tankmortar", "func_trackautochange", "func_trackchange", "func_tracktrain", "func_train", "func_traincontrols", "func_vehicle", "func_vehiclecontrols", "func_vip_safetyzone", "func_wall", "func_wall_toggle", "func_water", "button_target", "momentary_door", "momentary_rot_button")

fileIn (::wallworm_installation_path + "/WallWorm.com/common/fgd_funcs.ms")
::wallworm_worldspawn_CA = attributes "WW Entity worldspawn" version: 78 attribID:#(391958850L,-112077181L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "worldspawn"
	local isWWPRO = true
	local description = "World entity"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("message", "skyname", "sounds", "light", "WaveHeight", "MaxRange", "startdark", "newunit")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValstartdark = 0
	local propMapstartdark = #("0", "1")
	local propValnewunit = 0
	local propMapnewunit = #("0", "1")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		message type:#string ui:wwmt_message_ui
		skyname type:#string ui:wwmt_skyname_ui
		sounds type:#integer ui:wwmt_sounds_ui default:0
		light type:#integer ui:wwmt_light_ui default:0
		WaveHeight type:#string ui:wwmt_WaveHeight_ui default:"0"
		MaxRange type:#string ui:wwmt_MaxRange_ui default:"4096"
		startdark type:#string ui:wwmt_startdark_ui default:"0"
		newunit type:#string ui:wwmt_newunit_ui default:"0"
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "worldspawn"
		Label wwmt_message_ui_label "Map Description / Title" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_skyname_ui_label "environment map (cl_skyname)" align:#left
		EditText wwmt_skyname_ui "" type:#string
		Label wwmt_label_sounds_ui "CD track to play" align:#left
		Spinner wwmt_sounds_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_light_ui "Default light level" align:#left
		Spinner wwmt_light_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_WaveHeight_ui_label "Default Wave Height" align:#left
		EditText wwmt_WaveHeight_ui "" type:#string
		Label wwmt_MaxRange_ui_label "Max viewable distance" align:#left
		EditText wwmt_MaxRange_ui "" type:#string
		DropDownList wwmt_startdark_ui "Level Fade In" type:#string items:#("No", "Yes")
		on wwmt_startdark_ui selected i do
		(
			startdark = propMapstartdark[i]
		)
		DropDownList wwmt_newunit_ui "New Level Unit" type:#string items:#("No, keep current", "Yes, clear previous levels")
		on wwmt_newunit_ui selected i do
		(
			newunit = propMapnewunit[i]
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=worldspawn&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: worldspawn" address:"https://developer.valvesoftware.com/wiki/worldspawn?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if startdark != undefined then
			(
				if findItem propMapstartdark startdark == 0 then
				(
					append propMapstartdark startdark
					local tmp = wwmt_startdark_ui.items
					append tmp startdark
					wwmt_startdark_ui.items = tmp
					wwmt_startdark_ui.selection = propMapstartdark.count
				)
				else
				(
					wwmt_startdark_ui.selection = (findItem propMapstartdark startdark)
				)
			)
			if newunit != undefined then
			(
				if findItem propMapnewunit newunit == 0 then
				(
					append propMapnewunit newunit
					local tmp = wwmt_newunit_ui.items
					append tmp newunit
					wwmt_newunit_ui.items = tmp
					wwmt_newunit_ui.selection = propMapnewunit.count
				)
				else
				(
					wwmt_newunit_ui.selection = (findItem propMapnewunit newunit)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_ambient_generic_CA = attributes "WW Entity ambient_generic" version: 78 attribID:#(-114829662L,324374276L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "ambient_generic"
	local isWWPRO = true
	local description = "Universal sound Ambient"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "message", "health", "preset", "volstart", "fadein", "fadeout", "pitch", "pitchstart", "spinup", "spindown", "lfotype", "lforate", "lfomodpitch", "lfomodvol", "cspinup")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/AmbientGeneric.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValpreset = 0
	local propMappreset = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		message type:#string ui:wwmt_message_ui
		health type:#integer ui:wwmt_health_ui default:10
		preset type:#string ui:wwmt_preset_ui default:"0"
		volstart type:#integer ui:wwmt_volstart_ui default:0
		fadein type:#integer ui:wwmt_fadein_ui default:0
		fadeout type:#integer ui:wwmt_fadeout_ui default:0
		pitch type:#float ui:wwmt_pitch_ui default:100
		pitchstart type:#integer ui:wwmt_pitchstart_ui default:100
		spinup type:#integer ui:wwmt_spinup_ui default:0
		spindown type:#integer ui:wwmt_spindown_ui default:0
		lfotype type:#integer ui:wwmt_lfotype_ui default:0
		lforate type:#integer ui:wwmt_lforate_ui default:0
		lfomodpitch type:#integer ui:wwmt_lfomodpitch_ui default:0
		lfomodvol type:#integer ui:wwmt_lfomodvol_ui default:0
		cspinup type:#integer ui:wwmt_cspinup_ui default:0
		spawnflags type:#integer default:4
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "ambient_generic"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_message_ui_label "Path/filename.wav of WAV" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_label_health_ui "Volume (10 = loudest)" align:#left
		Spinner wwmt_health_ui "" type:#integer range:[-10000, 10000, 10]
		ComboBox wwmt_preset_ui "Dynamic Presets" type:#string items:#("None", "Huge Machine", "Big Machine", "Machine", "Slow Fade in", "Fade in", "Quick Fade in", "Slow Pulse", "Pulse", "Quick pulse", "Slow Oscillator", "Oscillator", "Quick Oscillator", "Grunge pitch", "Very low pitch", "Low pitch", "High pitch", "Very high pitch", "Screaming pitch", "Oscillate spinup/down", "Pulse spinup/down", "Random pitch", "Random pitch fast", "Incremental Spinup", "Alien", "Bizzare", "Planet X", "Haunted") height:3
		on wwmt_preset_ui selected i do
		(
			preset = propMappreset[i]
		)
		on wwmt_preset_ui entered tex do
		(
			preset = trimLeft(trimRight(tex))
			if propMappreset != undefined AND findItem propMappreset tex == 0 then
			(
				append propMappreset tex
				sort propMappreset
				wwmt_preset_ui.items = propMappreset
				wwmt_preset_ui.selection = findItem wwmt_preset_ui.items tex
			)
		)
		Spinner wwmt_volstart_ui "Start Volume" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_fadein_ui "Fade in time (0-100)" align:#left
		Spinner wwmt_fadein_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_fadeout_ui "Fade out time (0-100)" align:#left
		Spinner wwmt_fadeout_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_pitch_ui "Pitch (> 100 = higher)" align:#left
		Spinner wwmt_pitch_ui "" type:#float scale:1.0 range:[-10000, 10000, 100]
		Spinner wwmt_pitchstart_ui "Start Pitch" type:#integer range:[-10000, 10000, 100]
		Label wwmt_label_spinup_ui "Spin up time (0-100)" align:#left
		Spinner wwmt_spinup_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_spindown_ui "Spin down time (0-100)" align:#left
		Spinner wwmt_spindown_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_lfotype_ui "LFO type 0)off 1)sqr 2)tri 3)rnd" align:#left
		Spinner wwmt_lfotype_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_lforate_ui "LFO rate (0-1000)" align:#left
		Spinner wwmt_lforate_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_lfomodpitch_ui "LFO mod pitch (0-100)" align:#left
		Spinner wwmt_lfomodpitch_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_lfomodvol_ui "LFO mod vol (0-100)" align:#left
		Spinner wwmt_lfomodvol_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_cspinup_ui "Incremental spinup count" align:#left
		Spinner wwmt_cspinup_ui "" type:#integer range:[-10000, 10000, 0]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Play Everywhere" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Small Radius" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Medium Radius" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Large Radius" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Start Silent" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Not Toggled" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=ambient_generic&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: ambient_generic" address:"https://developer.valvesoftware.com/wiki/ambient_generic?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if preset != undefined then
			(
				if findItem propMappreset preset == 0 then
				(
					append propMappreset preset
					local tmp = wwmt_preset_ui.items
					append tmp preset
					wwmt_preset_ui.items = tmp
					wwmt_preset_ui.selection = propMappreset.count
				)
				else
				(
					wwmt_preset_ui.selection = (findItem propMappreset preset)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_armoury_entity_CA = attributes "WW Entity armoury_entity" version: 78 attribID:#(1714225879L,529278052L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "armoury_entity"
	local isWWPRO = true
	local description = "Items in the armoury"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("angles", "item", "count")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/Armoury.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValitem = 0
	local propMapitem = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18")
	parameters main rollout:params
	(
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		item type:#string ui:wwmt_item_ui default:"0"
		count type:#integer ui:wwmt_count_ui default:1
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "armoury_entity"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_item_ui "Item" type:#string items:#("weapon_mp5navy", "weapon_tmp", "weapon_p90", "weapon_mac10", "weapon_ak47", "weapon_sg552", "weapon_m4a1", "weapon_aug", "weapon_scout", "weapon_g3sg1", "weapon_awp", "weapon_m3", "weapon_xm1014", "weapon_m249", "weapon_flashbang", "weapon_hegrenade", "item_kevlar", "item_assaultsuit", "weapon_smokegrenade") height:3
		on wwmt_item_ui selected i do
		(
			item = propMapitem[i]
		)
		on wwmt_item_ui entered tex do
		(
			item = trimLeft(trimRight(tex))
			if propMapitem != undefined AND findItem propMapitem tex == 0 then
			(
				append propMapitem tex
				sort propMapitem
				wwmt_item_ui.items = propMapitem
				wwmt_item_ui.selection = findItem wwmt_item_ui.items tex
			)
		)
		Spinner wwmt_count_ui "Count" type:#integer range:[-10000, 10000, 1]
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=armoury_entity&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: armoury_entity" address:"https://developer.valvesoftware.com/wiki/armoury_entity?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if item != undefined then
			(
				if findItem propMapitem item == 0 then
				(
					append propMapitem item
					local tmp = wwmt_item_ui.items
					append tmp item
					wwmt_item_ui.items = tmp
					wwmt_item_ui.selection = propMapitem.count
				)
				else
				(
					wwmt_item_ui.selection = (findItem propMapitem item)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_cycler_CA = attributes "WW Entity cycler" version: 78 attribID:#(-372661583L,-1273339045L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "cycler"
	local isWWPRO = true
	local description = "Monster Cycler"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "renderfx", "rendermode", "renderamt", "rendercolor", "model")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/monster.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	function target_wwmt_filter obj =
	(
		if ((isProperty obj #wwmt_ca OR isProperty obj #wallwormProxy) AND isProperty obj #wallworm) then
		(
			true
		)
		else
		(
			false
		)
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		model type:#string ui:wwmt_model_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "cycler"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_model_ui_label "Model" align:#left
		EditText wwmt_model_ui "" type:#string
		PickButton wwmt_model_pickwwmt_ui "wwmt" align:#left across:3 message:"Pick WWMT OR Proxy from scene Model" filter:target_wwmt_filter tooltip:"Create a proxy from a model in the scene."
		on wwmt_model_pickwwmt_ui picked obj do
		(
			local wwmt = obj.getWWMT()
			if wwmt != undefined AND (getNode()) != undefined then
			(
				wwmt.updateObjectAsProxy thisNode useRotation:false
			)
		)
		Button wwmt_model_importwmt_ui "import" tooltip:"Import a QC AND create a proxy."
		on wwmt_model_importwmt_ui pressed do with undo label:"Import QC" on
		(
			::wallworm_import_qc_from_filename
			if ::wallworm_import_qc_from_filename == undefined then
			(
				fileIn (::wallworm_installation_path + "/WallWorm.com/importers/Mario_Kart_SMD_Importer.ms")
			)
			local fsource = GetOpenFileName historyCategory:"Wall Worm SMD Exporter" types: "QC File (*.qc)|*.QC|All files (*.*)|*.*|"
			if fsource != undefined AND wallworm_import_qc_from_filename != undefined then
			(
				wwmt = ::wallworm_import_qc_from_filename fsource saveToLib:true tnoVMF:true skipLODS:true deepSearchMaterials:false
				if wwmt != undefined then
				(
					if (getNode()) != undefined then
					(
						wwmt.updateObjectAsProxy thisNode
					)
				)
			)
		)
		Button wwmt_model_libwmt_ui "library" tooltip:"Use a prop in the prop library. Right-click to load the mesh rotated 90 degrees."
		on wwmt_model_libwmt_ui pressed do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:false
		)
		on wwmt_model_libwmt_ui rightClick do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:true
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=cycler&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: cycler" address:"https://developer.valvesoftware.com/wiki/cycler?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_cycler_sprite_CA = attributes "WW Entity cycler_sprite" version: 78 attribID:#(802606826L,-266448266L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "cycler_sprite"
	local isWWPRO = true
	local description = "Sprite Cycler"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "renderfx", "rendermode", "renderamt", "rendercolor", "model", "sequence", "framerate")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	function target_wwmt_filter obj =
	(
		if ((isProperty obj #wwmt_ca OR isProperty obj #wallwormProxy) AND isProperty obj #wallworm) then
		(
			true
		)
		else
		(
			false
		)
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		model type:#string ui:wwmt_model_ui
		sequence type:#string ui:wwmt_sequence_ui
		framerate type:#integer ui:wwmt_framerate_ui default:10
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "cycler_sprite"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_model_ui_label "Model" align:#left
		EditText wwmt_model_ui "" type:#string
		PickButton wwmt_model_pickwwmt_ui "wwmt" align:#left across:3 message:"Pick WWMT OR Proxy from scene Model" filter:target_wwmt_filter tooltip:"Create a proxy from a model in the scene."
		on wwmt_model_pickwwmt_ui picked obj do
		(
			local wwmt = obj.getWWMT()
			if wwmt != undefined AND (getNode()) != undefined then
			(
				wwmt.updateObjectAsProxy thisNode useRotation:false
			)
		)
		Button wwmt_model_importwmt_ui "import" tooltip:"Import a QC AND create a proxy."
		on wwmt_model_importwmt_ui pressed do with undo label:"Import QC" on
		(
			::wallworm_import_qc_from_filename
			if ::wallworm_import_qc_from_filename == undefined then
			(
				fileIn (::wallworm_installation_path + "/WallWorm.com/importers/Mario_Kart_SMD_Importer.ms")
			)
			local fsource = GetOpenFileName historyCategory:"Wall Worm SMD Exporter" types: "QC File (*.qc)|*.QC|All files (*.*)|*.*|"
			if fsource != undefined AND wallworm_import_qc_from_filename != undefined then
			(
				wwmt = ::wallworm_import_qc_from_filename fsource saveToLib:true tnoVMF:true skipLODS:true deepSearchMaterials:false
				if wwmt != undefined then
				(
					if (getNode()) != undefined then
					(
						wwmt.updateObjectAsProxy thisNode
					)
				)
			)
		)
		Button wwmt_model_libwmt_ui "library" tooltip:"Use a prop in the prop library. Right-click to load the mesh rotated 90 degrees."
		on wwmt_model_libwmt_ui pressed do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:false
		)
		on wwmt_model_libwmt_ui rightClick do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:true
		)
		Label wwmt_sequence_ui_label "model only sequence # of animation" align:#left
		EditText wwmt_sequence_ui "" type:#string
		Label wwmt_label_framerate_ui "Frames per second" align:#left
		Spinner wwmt_framerate_ui "" type:#integer range:[-10000, 10000, 10]
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=cycler_sprite&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: cycler_sprite" address:"https://developer.valvesoftware.com/wiki/cycler_sprite?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_cycler_wreckage_CA = attributes "WW Entity cycler_wreckage" version: 78 attribID:#(-1598010679L,1206473035L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "cycler_wreckage"
	local isWWPRO = true
	local description = "Wreckage"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "renderfx", "rendermode", "renderamt", "rendercolor", "framerate", "model", "wwmt_scale")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/wreck.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	function target_wwmt_filter obj =
	(
		if ((isProperty obj #wwmt_ca OR isProperty obj #wallwormProxy) AND isProperty obj #wallworm) then
		(
			true
		)
		else
		(
			false
		)
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		framerate type:#string ui:wwmt_framerate_ui default:"10.0"
		model type:#string ui:wwmt_model_ui default:"sprites/dot.spr"
		wwmt_scale type:#string ui:wwmt_scale_ui default:"1.0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "cycler_wreckage"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_framerate_ui_label "Framerate" align:#left
		EditText wwmt_framerate_ui "" type:#string
		Label wwmt_model_ui_label "Sprite Name" align:#left
		EditText wwmt_model_ui "" type:#string
		PickButton wwmt_model_pickwwmt_ui "wwmt" align:#left across:3 message:"Pick WWMT OR Proxy from scene Sprite Name" filter:target_wwmt_filter tooltip:"Create a proxy from a model in the scene."
		on wwmt_model_pickwwmt_ui picked obj do
		(
			local wwmt = obj.getWWMT()
			if wwmt != undefined AND (getNode()) != undefined then
			(
				wwmt.updateObjectAsProxy thisNode useRotation:false
			)
		)
		Button wwmt_model_importwmt_ui "import" tooltip:"Import a QC AND create a proxy."
		on wwmt_model_importwmt_ui pressed do with undo label:"Import QC" on
		(
			::wallworm_import_qc_from_filename
			if ::wallworm_import_qc_from_filename == undefined then
			(
				fileIn (::wallworm_installation_path + "/WallWorm.com/importers/Mario_Kart_SMD_Importer.ms")
			)
			local fsource = GetOpenFileName historyCategory:"Wall Worm SMD Exporter" types: "QC File (*.qc)|*.QC|All files (*.*)|*.*|"
			if fsource != undefined AND wallworm_import_qc_from_filename != undefined then
			(
				wwmt = ::wallworm_import_qc_from_filename fsource saveToLib:true tnoVMF:true skipLODS:true deepSearchMaterials:false
				if wwmt != undefined then
				(
					if (getNode()) != undefined then
					(
						wwmt.updateObjectAsProxy thisNode
					)
				)
			)
		)
		Button wwmt_model_libwmt_ui "library" tooltip:"Use a prop in the prop library. Right-click to load the mesh rotated 90 degrees."
		on wwmt_model_libwmt_ui pressed do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:false
		)
		on wwmt_model_libwmt_ui rightClick do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:true
		)
		Label wwmt_scale_ui_label "Scale" align:#left
		EditText wwmt_scale_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_32_ui "Toggle" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "Start ON" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=cycler_wreckage&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: cycler_wreckage" address:"https://developer.valvesoftware.com/wiki/cycler_wreckage?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_beam_CA = attributes "WW Entity env_beam" version: 78 attribID:#(654729850L,1051108103L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_beam"
	local isWWPRO = true
	local description = "Energy Beam Effect"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "LightningStart", "LightningEnd", "renderfx", "renderamt", "rendercolor", "Radius", "life", "BoltWidth", "NoiseAmplitude", "texture", "TextureScroll", "framerate", "framestart", "StrikeTime", "damage")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/beam.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		LightningStart type:#string ui:wwmt_LightningStart_ui
		LightningEnd type:#string ui:wwmt_LightningEnd_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:100
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		Radius type:#integer ui:wwmt_Radius_ui default:256
		life type:#string ui:wwmt_life_ui default:"1"
		BoltWidth type:#integer ui:wwmt_BoltWidth_ui default:20
		NoiseAmplitude type:#integer ui:wwmt_NoiseAmplitude_ui default:0
		texture type:#string ui:wwmt_texture_ui default:"sprites/laserbeam.spr"
		TextureScroll type:#integer ui:wwmt_TextureScroll_ui default:35
		framerate type:#integer ui:wwmt_framerate_ui default:0
		framestart type:#integer ui:wwmt_framestart_ui default:0
		StrikeTime type:#string ui:wwmt_StrikeTime_ui default:"1"
		damage type:#string ui:wwmt_damage_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_beam"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_LightningStart_ui_label "Start Entity" align:#left
		EditText wwmt_LightningStart_ui "" type:#string
		PickButton wwmt_LightningStart_pickme_ui "Pick Start Entity" message:"Pick Target Entity for Start Entity" filter:target_name_filter
		on wwmt_LightningStart_pickme_ui picked obj do
		(
			LightningStart = obj.targetname
		)
		Label wwmt_LightningEnd_ui_label "Ending Entity" align:#left
		EditText wwmt_LightningEnd_ui "" type:#string
		PickButton wwmt_LightningEnd_pickme_ui "Pick Ending Entity" message:"Pick Target Entity for Ending Entity" filter:target_name_filter
		on wwmt_LightningEnd_pickme_ui picked obj do
		(
			LightningEnd = obj.targetname
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "Brightness (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 100]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "Beam Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for Beam Color (R G B)"
		Spinner wwmt_Radius_ui "Radius" type:#integer range:[-10000, 10000, 256]
		Label wwmt_life_ui_label "Life (seconds 0 = infinite)" align:#left
		EditText wwmt_life_ui "" type:#string
		Label wwmt_label_BoltWidth_ui "Width of beam (pixels*0.1 0-255)" align:#left
		Spinner wwmt_BoltWidth_ui "" type:#integer range:[-10000, 10000, 20]
		Label wwmt_label_NoiseAmplitude_ui "Amount of noise (0-255)" align:#left
		Spinner wwmt_NoiseAmplitude_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_texture_ui_label "Sprite Name" align:#left
		EditText wwmt_texture_ui "" type:#string
		Label wwmt_label_TextureScroll_ui "Texture Scroll Rate (0-100)" align:#left
		Spinner wwmt_TextureScroll_ui "" type:#integer range:[-10000, 10000, 35]
		Label wwmt_label_framerate_ui "Frames per 10 seconds" align:#left
		Spinner wwmt_framerate_ui "" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt_framestart_ui "Starting Frame" type:#integer range:[-10000, 10000, 0]
		Label wwmt_StrikeTime_ui_label "Strike again time (secs)" align:#left
		EditText wwmt_StrikeTime_ui "" type:#string
		Label wwmt_damage_ui_label "Damage / second" align:#left
		EditText wwmt_damage_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Start On" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Toggle" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Random Strike" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Ring" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "StartSparks" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "EndSparks" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "Decal End" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Fade Start" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Fade End" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_beam&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_beam" address:"https://developer.valvesoftware.com/wiki/env_beam?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_beverage_CA = attributes "WW Entity env_beverage" version: 78 attribID:#(-292239031L,461097402L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_beverage"
	local isWWPRO = true
	local description = "Beverage Dispenser"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "health", "skin")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValskin = 0
	local propMapskin = #("0", "1", "2", "3", "4", "5", "6")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		health type:#integer ui:wwmt_health_ui default:10
		skin type:#string ui:wwmt_skin_ui default:"0"
		on skin set val do
		(
			getNode()
			if (isValidNode thisNode AND classof thisNode != ::WallWormMDL AND val != undefined) then
			(
				if ::WallWormHelperOps != undefined then
				(
					::WallWormHelperOps.setProxySkin thisNode  val
				)
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_beverage"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Spinner wwmt_health_ui "Capacity" type:#integer range:[-10000, 10000, 10]
		ComboBox wwmt_skin_ui "Beverage Type" type:#string items:#("Coca-Cola", "Sprite", "Diet Coke", "Orange", "Surge", "Moxie", "Random") height:3
		on wwmt_skin_ui selected i do
		(
			skin = propMapskin[i]
		)
		on wwmt_skin_ui entered tex do
		(
			skin = trimLeft(trimRight(tex))
			if propMapskin != undefined AND findItem propMapskin tex == 0 then
			(
				append propMapskin tex
				sort propMapskin
				wwmt_skin_ui.items = propMapskin
				wwmt_skin_ui.selection = findItem wwmt_skin_ui.items tex
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_beverage&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_beverage" address:"https://developer.valvesoftware.com/wiki/env_beverage?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if skin != undefined then
			(
				if findItem propMapskin skin == 0 then
				(
					append propMapskin skin
					local tmp = wwmt_skin_ui.items
					append tmp skin
					wwmt_skin_ui.items = tmp
					wwmt_skin_ui.selection = propMapskin.count
				)
				else
				(
					wwmt_skin_ui.selection = (findItem propMapskin skin)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_blood_CA = attributes "WW Entity env_blood" version: 78 attribID:#(654729850L,1776460938L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_blood"
	local isWWPRO = true
	local description = "Blood Effects"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "wwmt_color", "amount")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local entcolor = (Color 255 0 0)
	local iconsprite = "sprites/CS/blood.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValcolor = 0
	local propMapcolor = #("0", "1", "2")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		wwmt_color type:#string ui:wwmt_color_ui default:"0"
		amount type:#string ui:wwmt_amount_ui default:"100"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_blood"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		DropDownList wwmt_color_ui "Blood Color" type:#string items:#("Black/White blood with yellow decals", "Yellow blood with yellow decals", "Red blood with red decals")
		on wwmt_color_ui selected i do
		(
			wwmt_color = propMapcolor[i]
		)
		Label wwmt_amount_ui_label "Amount of blood (damage to simulate)" align:#left
		EditText wwmt_amount_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Random Direction" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Blood Stream" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "On Player" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Spray decals" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_blood&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_blood" address:"https://developer.valvesoftware.com/wiki/env_blood?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if wwmt_color != undefined then
			(
				if findItem propMapcolor wwmt_color == 0 then
				(
					append propMapcolor wwmt_color
					local tmp = wwmt_color_ui.items
					append tmp wwmt_color
					wwmt_color_ui.items = tmp
					wwmt_color_ui.selection = propMapcolor.count
				)
				else
				(
					wwmt_color_ui.selection = (findItem propMapcolor wwmt_color)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_bubbles_CA = attributes "WW Entity env_bubbles" version: 78 attribID:#(842275032L,-496060337L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "env_bubbles"
	local isWWPRO = true
	local description = "Bubble Volume"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "density", "frequency", "current")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		density type:#integer ui:wwmt_density_ui default:2
		frequency type:#integer ui:wwmt_frequency_ui default:2
		current type:#integer ui:wwmt_current_ui default:0
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_bubbles"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Spinner wwmt_density_ui "Bubble density" type:#integer range:[-10000, 10000, 2]
		Label wwmt_label_frequency_ui "Bubble frequency" align:#left
		Spinner wwmt_frequency_ui "" type:#integer range:[-10000, 10000, 2]
		Label wwmt_label_current_ui "Speed of Current" align:#left
		Spinner wwmt_current_ui "" type:#integer range:[-10000, 10000, 0]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Start Off" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with env_bubbles" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"env_bubbles_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_bubbles&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_bubbles" address:"https://developer.valvesoftware.com/wiki/env_bubbles?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_explosion_CA = attributes "WW Entity env_explosion" version: 78 attribID:#(467275855L,-793244314L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_explosion"
	local isWWPRO = true
	local description = "Explosion"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "iMagnitude")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/bang.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		iMagnitude type:#integer ui:wwmt_iMagnitude_ui default:100
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_explosion"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Spinner wwmt_iMagnitude_ui "Magnitude" type:#integer range:[-10000, 10000, 100]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "No Damage" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Repeatable" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "No Fireball" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "No Smoke" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "No Decal" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "No Sparks" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_explosion&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_explosion" address:"https://developer.valvesoftware.com/wiki/env_explosion?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_funnel_CA = attributes "WW Entity env_funnel" version: 78 attribID:#(842275028L,1460644568L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_funnel"
	local isWWPRO = true
	local description = "Large Portal Funnel"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_funnel"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Reverse" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_funnel&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_funnel" address:"https://developer.valvesoftware.com/wiki/env_funnel?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_global_CA = attributes "WW Entity env_global" version: 78 attribID:#(842275029L,-367571522L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_global"
	local isWWPRO = true
	local description = "Global State"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalstate", "triggermode", "initialstate")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local entcolor = (Color 255 255 128)
	local iconsprite = "sprites/CS/EnvGlobal.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValtriggermode = 0
	local propMaptriggermode = #("0", "1", "2", "3")
	local propValinitialstate = 0
	local propMapinitialstate = #("0", "1", "2")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		globalstate type:#string ui:wwmt_globalstate_ui
		triggermode type:#string ui:wwmt_triggermode_ui default:"0"
		initialstate type:#string ui:wwmt_initialstate_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_global"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalstate_ui_label "Global State to Set" align:#left
		EditText wwmt_globalstate_ui "" type:#string
		ComboBox wwmt_triggermode_ui "Trigger Mode" type:#string items:#("Off", "On", "Dead", "Toggle") height:3
		on wwmt_triggermode_ui selected i do
		(
			triggermode = propMaptriggermode[i]
		)
		on wwmt_triggermode_ui entered tex do
		(
			triggermode = trimLeft(trimRight(tex))
			if propMaptriggermode != undefined AND findItem propMaptriggermode tex == 0 then
			(
				append propMaptriggermode tex
				sort propMaptriggermode
				wwmt_triggermode_ui.items = propMaptriggermode
				wwmt_triggermode_ui.selection = findItem wwmt_triggermode_ui.items tex
			)
		)
		DropDownList wwmt_initialstate_ui "Initial State" type:#string items:#("Off", "On", "Dead")
		on wwmt_initialstate_ui selected i do
		(
			initialstate = propMapinitialstate[i]
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Set Initial State" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_global&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_global" address:"https://developer.valvesoftware.com/wiki/env_global?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if triggermode != undefined then
			(
				if findItem propMaptriggermode triggermode == 0 then
				(
					append propMaptriggermode triggermode
					local tmp = wwmt_triggermode_ui.items
					append tmp triggermode
					wwmt_triggermode_ui.items = tmp
					wwmt_triggermode_ui.selection = propMaptriggermode.count
				)
				else
				(
					wwmt_triggermode_ui.selection = (findItem propMaptriggermode triggermode)
				)
			)
			if initialstate != undefined then
			(
				if findItem propMapinitialstate initialstate == 0 then
				(
					append propMapinitialstate initialstate
					local tmp = wwmt_initialstate_ui.items
					append tmp initialstate
					wwmt_initialstate_ui.items = tmp
					wwmt_initialstate_ui.selection = propMapinitialstate.count
				)
				else
				(
					wwmt_initialstate_ui.selection = (findItem propMapinitialstate initialstate)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_glow_CA = attributes "WW Entity env_glow" version: 78 attribID:#(654729850L,520215747L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_glow"
	local isWWPRO = true
	local description = "Light Glow/Haze"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "model", "wwmt_scale")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local entcolor = (Color 30 100 0)
	local iconsprite = "sprites/CS/envglow.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	function target_wwmt_filter obj =
	(
		if ((isProperty obj #wwmt_ca OR isProperty obj #wallwormProxy) AND isProperty obj #wallworm) then
		(
			true
		)
		else
		(
			false
		)
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		model type:#string ui:wwmt_model_ui default:"sprites/glow01.spr"
		wwmt_scale type:#integer ui:wwmt_scale_ui default:1
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_glow"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_model_ui_label "model" align:#left
		EditText wwmt_model_ui "" type:#string
		PickButton wwmt_model_pickwwmt_ui "wwmt" align:#left across:3 message:"Pick WWMT OR Proxy from scene model" filter:target_wwmt_filter tooltip:"Create a proxy from a model in the scene."
		on wwmt_model_pickwwmt_ui picked obj do
		(
			local wwmt = obj.getWWMT()
			if wwmt != undefined AND (getNode()) != undefined then
			(
				wwmt.updateObjectAsProxy thisNode useRotation:false
			)
		)
		Button wwmt_model_importwmt_ui "import" tooltip:"Import a QC AND create a proxy."
		on wwmt_model_importwmt_ui pressed do with undo label:"Import QC" on
		(
			::wallworm_import_qc_from_filename
			if ::wallworm_import_qc_from_filename == undefined then
			(
				fileIn (::wallworm_installation_path + "/WallWorm.com/importers/Mario_Kart_SMD_Importer.ms")
			)
			local fsource = GetOpenFileName historyCategory:"Wall Worm SMD Exporter" types: "QC File (*.qc)|*.QC|All files (*.*)|*.*|"
			if fsource != undefined AND wallworm_import_qc_from_filename != undefined then
			(
				wwmt = ::wallworm_import_qc_from_filename fsource saveToLib:true tnoVMF:true skipLODS:true deepSearchMaterials:false
				if wwmt != undefined then
				(
					if (getNode()) != undefined then
					(
						wwmt.updateObjectAsProxy thisNode
					)
				)
			)
		)
		Button wwmt_model_libwmt_ui "library" tooltip:"Use a prop in the prop library. Right-click to load the mesh rotated 90 degrees."
		on wwmt_model_libwmt_ui pressed do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:false
		)
		on wwmt_model_libwmt_ui rightClick do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:true
		)
		Spinner wwmt_scale_ui "Sprite Scale" type:#integer range:[-10000, 10000, 1]
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_glow&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_glow" address:"https://developer.valvesoftware.com/wiki/env_glow?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_fade_CA = attributes "WW Entity env_fade" version: 78 attribID:#(654729850L,-1966748596L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_fade"
	local isWWPRO = true
	local description = "Screen Fade"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "duration", "holdtime", "renderamt", "rendercolor")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/fade.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		duration type:#string ui:wwmt_duration_ui default:"2"
		holdtime type:#string ui:wwmt_holdtime_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_fade"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_duration_ui_label "Duration (seconds)" align:#left
		EditText wwmt_duration_ui "" type:#string
		Label wwmt_holdtime_ui_label "Hold Fade (seconds)" align:#left
		EditText wwmt_holdtime_ui "" type:#string
		Spinner wwmt_renderamt_ui "Fade Alpha" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "Fade Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for Fade Color (R G B)"
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Fade From" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Modulate" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Activator Only" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_fade&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_fade" address:"https://developer.valvesoftware.com/wiki/env_fade?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_fog_CA = attributes "WW Entity env_fog" version: 78 attribID:#(-1226285107L,1306583593L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_fog"
	local isWWPRO = true
	local description = "Global Fog Properties"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "fadein", "holdtime", "fadeout", "startdist", "enddist", "rendercolor")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		fadein type:#integer ui:wwmt_fadein_ui default:0
		holdtime type:#string ui:wwmt_holdtime_ui default:"0"
		fadeout type:#integer ui:wwmt_fadeout_ui default:0
		startdist type:#integer ui:wwmt_startdist_ui default:0
		enddist type:#integer ui:wwmt_enddist_ui default:1000
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 255 255 255)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_fog"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Spinner wwmt_fadein_ui "Fade in time" type:#integer range:[-10000, 10000, 0]
		Label wwmt_holdtime_ui_label "Hold time (0 = permanent)" align:#left
		EditText wwmt_holdtime_ui "" type:#string
		Spinner wwmt_fadeout_ui "Fade out time" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_startdist_ui "Fog start position" align:#left
		Spinner wwmt_startdist_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_enddist_ui "Fog end position" align:#left
		Spinner wwmt_enddist_ui "" type:#integer range:[-10000, 10000, 1000]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 255 255 255)
		Spinner wwmt_rendercolor_intensity_ui "Fog Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for Fog Color (R G B)"
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Start active" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_fog&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_fog" address:"https://developer.valvesoftware.com/wiki/env_fog?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_laser_CA = attributes "WW Entity env_laser" version: 78 attribID:#(654729850L,-1779195987L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_laser"
	local isWWPRO = true
	local description = "Laser Beam Effect"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "angles", "LaserTarget", "renderamt", "rendercolor", "width", "NoiseAmplitude", "texture", "EndSprite", "TextureScroll", "framestart", "damage")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/laser.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		LaserTarget type:#string ui:wwmt_LaserTarget_ui
		renderamt type:#integer ui:wwmt_renderamt_ui default:100
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		width type:#integer ui:wwmt_width_ui default:20
		NoiseAmplitude type:#integer ui:wwmt_NoiseAmplitude_ui default:0
		texture type:#string ui:wwmt_texture_ui default:"sprites/laserbeam.spr"
		EndSprite type:#string ui:wwmt_EndSprite_ui
		TextureScroll type:#integer ui:wwmt_TextureScroll_ui default:35
		framestart type:#integer ui:wwmt_framestart_ui default:0
		damage type:#string ui:wwmt_damage_ui default:"100"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_laser"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_LaserTarget_ui_label "Target of Laser" align:#left
		EditText wwmt_LaserTarget_ui "" type:#string
		PickButton wwmt_LaserTarget_pickme_ui "Pick Target of Laser" message:"Pick Target Entity for Target of Laser" filter:target_name_filter
		on wwmt_LaserTarget_pickme_ui picked obj do
		(
			LaserTarget = obj.targetname
		)
		Label wwmt_label_renderamt_ui "Brightness (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 100]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "Beam Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for Beam Color (R G B)"
		Label wwmt_label_width_ui "Width of beam (pixels*0.1 0-255)" align:#left
		Spinner wwmt_width_ui "" type:#integer range:[-10000, 10000, 20]
		Label wwmt_label_NoiseAmplitude_ui "Amount of noise (0-255)" align:#left
		Spinner wwmt_NoiseAmplitude_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_texture_ui_label "Sprite Name" align:#left
		EditText wwmt_texture_ui "" type:#string
		Label wwmt_EndSprite_ui_label "End Sprite" align:#left
		EditText wwmt_EndSprite_ui "" type:#string
		Label wwmt_label_TextureScroll_ui "Texture Scroll Rate (0-100)" align:#left
		Spinner wwmt_TextureScroll_ui "" type:#integer range:[-10000, 10000, 35]
		Spinner wwmt_framestart_ui "Starting Frame" type:#integer range:[-10000, 10000, 0]
		Label wwmt_damage_ui_label "Damage / second" align:#left
		EditText wwmt_damage_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Start On" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "StartSparks" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "EndSparks" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "Decal End" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_laser&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_laser" address:"https://developer.valvesoftware.com/wiki/env_laser?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_message_CA = attributes "WW Entity env_message" version: 78 attribID:#(842275039L,1110997934L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_message"
	local isWWPRO = true
	local description = "HUD Text Message"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "message", "messagesound", "messagevolume", "messageattenuation")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/Announcement.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValmessageattenuation = 0
	local propMapmessageattenuation = #("0", "1", "2", "3")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		message type:#string ui:wwmt_message_ui
		messagesound type:#string ui:wwmt_messagesound_ui
		messagevolume type:#string ui:wwmt_messagevolume_ui default:"10"
		messageattenuation type:#string ui:wwmt_messageattenuation_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_message"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_message_ui_label "Message Name" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_messagesound_ui_label "Sound effect" align:#left
		EditText wwmt_messagesound_ui "" type:#string
		Label wwmt_messagevolume_ui_label "Volume 0-10" align:#left
		EditText wwmt_messagevolume_ui "" type:#string
		ComboBox wwmt_messageattenuation_ui "Sound Radius" type:#string items:#("Small Radius", "Medium Radius", "Large  Radius", "Play Everywhere") height:3
		on wwmt_messageattenuation_ui selected i do
		(
			messageattenuation = propMapmessageattenuation[i]
		)
		on wwmt_messageattenuation_ui entered tex do
		(
			messageattenuation = trimLeft(trimRight(tex))
			if propMapmessageattenuation != undefined AND findItem propMapmessageattenuation tex == 0 then
			(
				append propMapmessageattenuation tex
				sort propMapmessageattenuation
				wwmt_messageattenuation_ui.items = propMapmessageattenuation
				wwmt_messageattenuation_ui.selection = findItem wwmt_messageattenuation_ui.items tex
			)
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Play Once" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "All Clients" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_message&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_message" address:"https://developer.valvesoftware.com/wiki/env_message?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if messageattenuation != undefined then
			(
				if findItem propMapmessageattenuation messageattenuation == 0 then
				(
					append propMapmessageattenuation messageattenuation
					local tmp = wwmt_messageattenuation_ui.items
					append tmp messageattenuation
					wwmt_messageattenuation_ui.items = tmp
					wwmt_messageattenuation_ui.selection = propMapmessageattenuation.count
				)
				else
				(
					wwmt_messageattenuation_ui.selection = (findItem propMapmessageattenuation messageattenuation)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_rain_CA = attributes "WW Entity env_rain" version: 78 attribID:#(654729850L,-756894352L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_rain"
	local isWWPRO = true
	local description = "rain Properties"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_rain"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_rain&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_rain" address:"https://developer.valvesoftware.com/wiki/env_rain?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_render_CA = attributes "WW Entity env_render" version: 78 attribID:#(842275016L,1460626972L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_render"
	local isWWPRO = true
	local description = "Render Controls"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "renderfx", "rendermode", "renderamt", "rendercolor")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local entcolor = (Color 100 100 0)
	local iconsprite = "sprites/CS/render.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_render"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "No Renderfx" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "No Renderamt" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "No Rendermode" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "No Rendercolor" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_render&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_render" address:"https://developer.valvesoftware.com/wiki/env_render?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_shake_CA = attributes "WW Entity env_shake" version: 78 attribID:#(654729850L,371760912L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_shake"
	local isWWPRO = true
	local description = "Screen Shake"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "amplitude", "radius", "duration", "frequency")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		amplitude type:#string ui:wwmt_amplitude_ui default:"4"
		radius type:#string ui:wwmt_radius_ui default:"500"
		duration type:#string ui:wwmt_duration_ui default:"1"
		frequency type:#string ui:wwmt_frequency_ui default:"2.5"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_shake"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_amplitude_ui_label "Amplitude 0-16" align:#left
		EditText wwmt_amplitude_ui "" type:#string
		Label wwmt_radius_ui_label "Effect radius" align:#left
		EditText wwmt_radius_ui "" type:#string
		Label wwmt_duration_ui_label "Duration (seconds)" align:#left
		EditText wwmt_duration_ui "" type:#string
		Label wwmt_frequency_ui_label "0.1 = jerk, 255.0 = rumble" align:#left
		EditText wwmt_frequency_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "GlobalShake" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_shake&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_shake" address:"https://developer.valvesoftware.com/wiki/env_shake?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_shooter_CA = attributes "WW Entity env_shooter" version: 78 attribID:#(842275017L,1993223203L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_shooter"
	local isWWPRO = true
	local description = "Model Shooter"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "m_iGibs", "delay", "m_flVelocity", "m_flVariance", "m_flGibLife", "renderfx", "rendermode", "renderamt", "rendercolor", "shootmodel", "shootsounds", "wwmt_scale", "skin")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValshootsounds = -1
	local propMapshootsounds = #("-1", "0", "1", "2", "3", "4")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		m_iGibs type:#integer ui:wwmt_m_iGibs_ui default:3
		delay type:#string ui:wwmt_delay_ui default:"0"
		m_flVelocity type:#integer ui:wwmt_m_flVelocity_ui default:200
		m_flVariance type:#string ui:wwmt_m_flVariance_ui default:"0.15"
		m_flGibLife type:#string ui:wwmt_m_flGibLife_ui default:"4"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		shootmodel type:#string ui:wwmt_shootmodel_ui
		shootsounds type:#string ui:wwmt_shootsounds_ui default:"-1"
		wwmt_scale type:#string ui:wwmt_scale_ui
		skin type:#integer ui:wwmt_skin_ui default:0
		spawnflags type:#integer default:0
		on skin set val do
		(
			getNode()
			if (isValidNode thisNode AND classof thisNode != ::WallWormMDL AND val != undefined) then
			(
				if ::WallWormHelperOps != undefined then
				(
					::WallWormHelperOps.setProxySkin thisNode  val
				)
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_shooter"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Spinner wwmt_m_iGibs_ui "Number of Gibs" type:#integer range:[-10000, 10000, 3]
		Label wwmt_delay_ui_label "Delay between shots" align:#left
		EditText wwmt_delay_ui "" type:#string
		Spinner wwmt_m_flVelocity_ui "Gib Velocity" type:#integer range:[-10000, 10000, 200]
		Label wwmt_m_flVariance_ui_label "Course Variance" align:#left
		EditText wwmt_m_flVariance_ui "" type:#string
		Label wwmt_m_flGibLife_ui_label "Gib Life" align:#left
		EditText wwmt_m_flGibLife_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_shootmodel_ui_label "Model" align:#left
		EditText wwmt_shootmodel_ui "" type:#string
		ComboBox wwmt_shootsounds_ui "Material Sound" type:#string items:#("None", "Glass", "Wood", "Metal", "Flesh", "Concrete") height:3
		on wwmt_shootsounds_ui selected i do
		(
			shootsounds = propMapshootsounds[i]
		)
		on wwmt_shootsounds_ui entered tex do
		(
			shootsounds = trimLeft(trimRight(tex))
			if propMapshootsounds != undefined AND findItem propMapshootsounds tex == 0 then
			(
				append propMapshootsounds tex
				sort propMapshootsounds
				wwmt_shootsounds_ui.items = propMapshootsounds
				wwmt_shootsounds_ui.selection = findItem wwmt_shootsounds_ui.items tex
			)
		)
		Label wwmt_scale_ui_label "Gib Scale" align:#left
		EditText wwmt_scale_ui "" type:#string
		Spinner wwmt_skin_ui "Gib Skin" type:#integer range:[-10000, 10000, 0]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Repeatable" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_shooter&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_shooter" address:"https://developer.valvesoftware.com/wiki/env_shooter?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if shootsounds != undefined then
			(
				if findItem propMapshootsounds shootsounds == 0 then
				(
					append propMapshootsounds shootsounds
					local tmp = wwmt_shootsounds_ui.items
					append tmp shootsounds
					wwmt_shootsounds_ui.items = tmp
					wwmt_shootsounds_ui.selection = propMapshootsounds.count
				)
				else
				(
					wwmt_shootsounds_ui.selection = (findItem propMapshootsounds shootsounds)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_smoker_CA = attributes "WW Entity env_smoker" version: 78 attribID:#(842275017L,1601797948L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_smoker"
	local isWWPRO = true
	local description = "Smoke"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "health", "wwmt_scale")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local entcolor = (Color 30 100 0)
	local iconsprite = "sprites/CS/smoke.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		health type:#integer ui:wwmt_health_ui default:1
		wwmt_scale type:#integer ui:wwmt_scale_ui default:1
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_smoker"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Spinner wwmt_health_ui "Strength" type:#integer range:[-10000, 10000, 1]
		Spinner wwmt_scale_ui "Smoke Scale" type:#integer range:[-10000, 10000, 1]
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_smoker&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_smoker" address:"https://developer.valvesoftware.com/wiki/env_smoker?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_sound_CA = attributes "WW Entity env_sound" version: 78 attribID:#(654729850L,1554762651L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_sound"
	local isWWPRO = true
	local description = "DSP Sound"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("radius", "roomtype")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/EnvSound.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValroomtype = 0
	local propMaproomtype = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28")
	parameters main rollout:params
	(
		radius type:#integer ui:wwmt_radius_ui default:128
		roomtype type:#string ui:wwmt_roomtype_ui default:"0"
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_sound"
		Spinner wwmt_radius_ui "Radius" type:#integer range:[-10000, 10000, 128]
		ComboBox wwmt_roomtype_ui "Room Type" type:#string items:#("Normal (off)", "Generic", "Metal Small", "Metal Medium", "Metal Large", "Tunnel Small", "Tunnel Medium", "Tunnel Large", "Chamber Small", "Chamber Medium", "Chamber Large", "Bright Small", "Bright Medium", "Bright Large", "Water 1", "Water 2", "Water 3", "Concrete Small", "Concrete Medium", "Concrete Large", "Big 1", "Big 2", "Big 3", "Cavern Small", "Cavern Medium", "Cavern Large", "Weirdo 1", "Weirdo 2", "Weirdo 3") height:3
		on wwmt_roomtype_ui selected i do
		(
			roomtype = propMaproomtype[i]
		)
		on wwmt_roomtype_ui entered tex do
		(
			roomtype = trimLeft(trimRight(tex))
			if propMaproomtype != undefined AND findItem propMaproomtype tex == 0 then
			(
				append propMaproomtype tex
				sort propMaproomtype
				wwmt_roomtype_ui.items = propMaproomtype
				wwmt_roomtype_ui.selection = findItem wwmt_roomtype_ui.items tex
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_sound&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_sound" address:"https://developer.valvesoftware.com/wiki/env_sound?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if roomtype != undefined then
			(
				if findItem propMaproomtype roomtype == 0 then
				(
					append propMaproomtype roomtype
					local tmp = wwmt_roomtype_ui.items
					append tmp roomtype
					wwmt_roomtype_ui.items = tmp
					wwmt_roomtype_ui.selection = propMaproomtype.count
				)
				else
				(
					wwmt_roomtype_ui.selection = (findItem propMaproomtype roomtype)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_snow_CA = attributes "WW Entity env_snow" version: 78 attribID:#(654729850L,1723421765L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_snow"
	local isWWPRO = true
	local description = "snow Properties"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_snow"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_snow&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_snow" address:"https://developer.valvesoftware.com/wiki/env_snow?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_spark_CA = attributes "WW Entity env_spark" version: 78 attribID:#(654729850L,-871592065L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_spark"
	local isWWPRO = true
	local description = "Spark"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "MaxDelay")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/EnvSpark.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		MaxDelay type:#string ui:wwmt_MaxDelay_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_spark"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_MaxDelay_ui_label "Max Delay" align:#left
		EditText wwmt_MaxDelay_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_32_ui "Toggle" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "Start ON" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_spark&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_spark" address:"https://developer.valvesoftware.com/wiki/env_spark?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_sprite_CA = attributes "WW Entity env_sprite" version: 78 attribID:#(842275017L,1494405608L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_sprite"
	local isWWPRO = true
	local description = "Still Sprite Effect"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "renderfx", "rendermode", "renderamt", "rendercolor", "framerate", "model", "wwmt_scale")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/sprite.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	function target_wwmt_filter obj =
	(
		if ((isProperty obj #wwmt_ca OR isProperty obj #wallwormProxy) AND isProperty obj #wallworm) then
		(
			true
		)
		else
		(
			false
		)
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		framerate type:#string ui:wwmt_framerate_ui default:"10.0"
		model type:#string ui:wwmt_model_ui default:"sprites/glow01.spr"
		wwmt_scale type:#integer ui:wwmt_scale_ui default:1
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_sprite"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_framerate_ui_label "Framerate" align:#left
		EditText wwmt_framerate_ui "" type:#string
		Label wwmt_model_ui_label "Sprite Name" align:#left
		EditText wwmt_model_ui "" type:#string
		PickButton wwmt_model_pickwwmt_ui "wwmt" align:#left across:3 message:"Pick WWMT OR Proxy from scene Sprite Name" filter:target_wwmt_filter tooltip:"Create a proxy from a model in the scene."
		on wwmt_model_pickwwmt_ui picked obj do
		(
			local wwmt = obj.getWWMT()
			if wwmt != undefined AND (getNode()) != undefined then
			(
				wwmt.updateObjectAsProxy thisNode useRotation:false
			)
		)
		Button wwmt_model_importwmt_ui "import" tooltip:"Import a QC AND create a proxy."
		on wwmt_model_importwmt_ui pressed do with undo label:"Import QC" on
		(
			::wallworm_import_qc_from_filename
			if ::wallworm_import_qc_from_filename == undefined then
			(
				fileIn (::wallworm_installation_path + "/WallWorm.com/importers/Mario_Kart_SMD_Importer.ms")
			)
			local fsource = GetOpenFileName historyCategory:"Wall Worm SMD Exporter" types: "QC File (*.qc)|*.QC|All files (*.*)|*.*|"
			if fsource != undefined AND wallworm_import_qc_from_filename != undefined then
			(
				wwmt = ::wallworm_import_qc_from_filename fsource saveToLib:true tnoVMF:true skipLODS:true deepSearchMaterials:false
				if wwmt != undefined then
				(
					if (getNode()) != undefined then
					(
						wwmt.updateObjectAsProxy thisNode
					)
				)
			)
		)
		Button wwmt_model_libwmt_ui "library" tooltip:"Use a prop in the prop library. Right-click to load the mesh rotated 90 degrees."
		on wwmt_model_libwmt_ui pressed do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:false
		)
		on wwmt_model_libwmt_ui rightClick do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:true
		)
		Spinner wwmt_scale_ui "Scale" type:#integer range:[-10000, 10000, 1]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Start on" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Play Once" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_sprite&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_sprite" address:"https://developer.valvesoftware.com/wiki/env_sprite?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_game_counter_CA = attributes "WW Entity game_counter" version: 78 attribID:#(-1782154886L,-688086161L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "game_counter"
	local isWWPRO = true
	local description = "Fires when it hits limit"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "wwmt_target", "delay", "killtarget", "frags", "health")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/GameCounter.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		frags type:#integer ui:wwmt_frags_ui default:0
		health type:#integer ui:wwmt_health_ui default:10
		spawnflags type:#integer default:2
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "game_counter"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Spinner wwmt_frags_ui "Initial Value" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt_health_ui "Limit Value" type:#integer range:[-10000, 10000, 10]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Remove On fire" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Reset On fire" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=game_counter&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: game_counter" address:"https://developer.valvesoftware.com/wiki/game_counter?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_game_counter_set_CA = attributes "WW Entity game_counter_set" version: 78 attribID:#(-173747566L,768122376L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "game_counter_set"
	local isWWPRO = true
	local description = "Sets a game_counter"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "wwmt_target", "frags")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/GameCounterSet.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		wwmt_target type:#string ui:wwmt_target_ui
		frags type:#integer ui:wwmt_frags_ui default:10
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "game_counter_set"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Spinner wwmt_frags_ui "New Value" type:#integer range:[-10000, 10000, 10]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Remove On fire" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=game_counter_set&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: game_counter_set" address:"https://developer.valvesoftware.com/wiki/game_counter_set?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_game_end_CA = attributes "WW Entity game_end" version: 78 attribID:#(-1966748556L,-158743800L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "game_end"
	local isWWPRO = true
	local description = "End this multiplayer game"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/GameEnd.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "game_end"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=game_end&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: game_end" address:"https://developer.valvesoftware.com/wiki/game_end?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_game_player_equip_CA = attributes "WW Entity game_player_equip" version: 78 attribID:#(-1000261268L,-206482415L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "game_player_equip"
	local isWWPRO = true
	local description = "Initial player equipment"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "weapon_knife", "weapon_usp", "weapon_glock18", "weapon_deagle", "weapon_p228", "weapon_elite", "weapon_fiveseven", "weapon_m3", "weapon_xm1014", "weapon_mp5navy", "weapon_tmp", "weapon_p90", "weapon_mac10", "weapon_ump45", "weapon_ak47", "weapon_sg552", "weapon_m4a1", "weapon_aug", "weapon_scout", "weapon_awp", "weapon_g3sg1", "weapon_sg550", "weapon_m249", "weapon_famas", "weapon_galil", "weapon_shield", "item_kevlar", "item_assaultsuit", "weapon_flashbang", "weapon_hegrenade", "weapon_smokegrenade", "item_thighpack", "weapon_c4", "ammo_9mm", "ammo_45acp", "ammo_50ae", "ammo_57mm", "ammo_357sig", "ammo_buckshot", "ammo_762nato", "ammo_556nato", "ammo_556natobox", "ammo_338magnum", "item_healthkit", "item_battery", "item_longjump")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/GamePlayerEquip.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValweapon_knife = 0
	local propMapweapon_knife = #("0", "1")
	local propValweapon_usp = 0
	local propMapweapon_usp = #("0", "1")
	local propValweapon_glock18 = 0
	local propMapweapon_glock18 = #("0", "1")
	local propValweapon_deagle = 0
	local propMapweapon_deagle = #("0", "1")
	local propValweapon_p228 = 0
	local propMapweapon_p228 = #("0", "1")
	local propValweapon_elite = 0
	local propMapweapon_elite = #("0", "1")
	local propValweapon_fiveseven = 0
	local propMapweapon_fiveseven = #("0", "1")
	local propValweapon_m3 = 0
	local propMapweapon_m3 = #("0", "1")
	local propValweapon_xm1014 = 0
	local propMapweapon_xm1014 = #("0", "1")
	local propValweapon_mp5navy = 0
	local propMapweapon_mp5navy = #("0", "1")
	local propValweapon_tmp = 0
	local propMapweapon_tmp = #("0", "1")
	local propValweapon_p90 = 0
	local propMapweapon_p90 = #("0", "1")
	local propValweapon_mac10 = 0
	local propMapweapon_mac10 = #("0", "1")
	local propValweapon_ump45 = 0
	local propMapweapon_ump45 = #("0", "1")
	local propValweapon_ak47 = 0
	local propMapweapon_ak47 = #("0", "1")
	local propValweapon_sg552 = 0
	local propMapweapon_sg552 = #("0", "1")
	local propValweapon_m4a1 = 0
	local propMapweapon_m4a1 = #("0", "1")
	local propValweapon_aug = 0
	local propMapweapon_aug = #("0", "1")
	local propValweapon_scout = 0
	local propMapweapon_scout = #("0", "1")
	local propValweapon_awp = 0
	local propMapweapon_awp = #("0", "1")
	local propValweapon_g3sg1 = 0
	local propMapweapon_g3sg1 = #("0", "1")
	local propValweapon_sg550 = 0
	local propMapweapon_sg550 = #("0", "1")
	local propValweapon_m249 = 0
	local propMapweapon_m249 = #("0", "1")
	local propValweapon_famas = 0
	local propMapweapon_famas = #("0", "1")
	local propValweapon_galil = 0
	local propMapweapon_galil = #("0", "1")
	local propValweapon_shield = 0
	local propMapweapon_shield = #("0", "1")
	local propValitem_kevlar = 0
	local propMapitem_kevlar = #("0", "1")
	local propValitem_assaultsuit = 0
	local propMapitem_assaultsuit = #("0", "1")
	local propValweapon_flashbang = 0
	local propMapweapon_flashbang = #("0", "1", "2")
	local propValweapon_hegrenade = 0
	local propMapweapon_hegrenade = #("0", "1")
	local propValweapon_smokegrenade = 0
	local propMapweapon_smokegrenade = #("0", "1")
	local propValitem_thighpack = 0
	local propMapitem_thighpack = #("0", "1")
	local propValweapon_c4 = 0
	local propMapweapon_c4 = #("0", "1")
	local propValammo_9mm = 0
	local propMapammo_9mm = #("0", "1", "2", "3", "4")
	local propValammo_45acp = 0
	local propMapammo_45acp = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
	local propValammo_50ae = 0
	local propMapammo_50ae = #("0", "1", "2", "3", "4", "5")
	local propValammo_57mm = 0
	local propMapammo_57mm = #("0", "1", "2")
	local propValammo_357sig = 0
	local propMapammo_357sig = #("0", "1", "2", "3", "4")
	local propValammo_buckshot = 0
	local propMapammo_buckshot = #("0", "1", "2", "3", "4")
	local propValammo_762nato = 0
	local propMapammo_762nato = #("0", "1", "2", "3")
	local propValammo_556nato = 0
	local propMapammo_556nato = #("0", "1", "2", "3")
	local propValammo_556natobox = 0
	local propMapammo_556natobox = #("0", "1", "2", "3", "4", "5", "6", "7")
	local propValammo_338magnum = 0
	local propMapammo_338magnum = #("0", "1", "2", "3")
	local propValitem_healthkit = 0
	local propMapitem_healthkit = #("0", "1", "2", "3", "4", "5", "6", "7")
	local propValitem_battery = 0
	local propMapitem_battery = #("0", "1", "2", "3", "4", "5", "6", "7")
	local propValitem_longjump = 0
	local propMapitem_longjump = #("0", "1")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		weapon_knife type:#string ui:wwmt_weapon_knife_ui default:"0"
		weapon_usp type:#string ui:wwmt_weapon_usp_ui default:"0"
		weapon_glock18 type:#string ui:wwmt_weapon_glock18_ui default:"0"
		weapon_deagle type:#string ui:wwmt_weapon_deagle_ui default:"0"
		weapon_p228 type:#string ui:wwmt_weapon_p228_ui default:"0"
		weapon_elite type:#string ui:wwmt_weapon_elite_ui default:"0"
		weapon_fiveseven type:#string ui:wwmt_weapon_fiveseven_ui default:"0"
		weapon_m3 type:#string ui:wwmt_weapon_m3_ui default:"0"
		weapon_xm1014 type:#string ui:wwmt_weapon_xm1014_ui default:"0"
		weapon_mp5navy type:#string ui:wwmt_weapon_mp5navy_ui default:"0"
		weapon_tmp type:#string ui:wwmt_weapon_tmp_ui default:"0"
		weapon_p90 type:#string ui:wwmt_weapon_p90_ui default:"0"
		weapon_mac10 type:#string ui:wwmt_weapon_mac10_ui default:"0"
		weapon_ump45 type:#string ui:wwmt_weapon_ump45_ui default:"0"
		weapon_ak47 type:#string ui:wwmt_weapon_ak47_ui default:"0"
		weapon_sg552 type:#string ui:wwmt_weapon_sg552_ui default:"0"
		weapon_m4a1 type:#string ui:wwmt_weapon_m4a1_ui default:"0"
		weapon_aug type:#string ui:wwmt_weapon_aug_ui default:"0"
		weapon_scout type:#string ui:wwmt_weapon_scout_ui default:"0"
		weapon_awp type:#string ui:wwmt_weapon_awp_ui default:"0"
		weapon_g3sg1 type:#string ui:wwmt_weapon_g3sg1_ui default:"0"
		weapon_sg550 type:#string ui:wwmt_weapon_sg550_ui default:"0"
		weapon_m249 type:#string ui:wwmt_weapon_m249_ui default:"0"
		weapon_famas type:#string ui:wwmt_weapon_famas_ui default:"0"
		weapon_galil type:#string ui:wwmt_weapon_galil_ui default:"0"
		weapon_shield type:#string ui:wwmt_weapon_shield_ui default:"0"
		item_kevlar type:#string ui:wwmt_item_kevlar_ui default:"0"
		item_assaultsuit type:#string ui:wwmt_item_assaultsuit_ui default:"0"
		weapon_flashbang type:#string ui:wwmt_weapon_flashbang_ui default:"0"
		weapon_hegrenade type:#string ui:wwmt_weapon_hegrenade_ui default:"0"
		weapon_smokegrenade type:#string ui:wwmt_weapon_smokegrenade_ui default:"0"
		item_thighpack type:#string ui:wwmt_item_thighpack_ui default:"0"
		weapon_c4 type:#string ui:wwmt_weapon_c4_ui default:"0"
		ammo_9mm type:#string ui:wwmt_ammo_9mm_ui default:"0"
		ammo_45acp type:#string ui:wwmt_ammo_45acp_ui default:"0"
		ammo_50ae type:#string ui:wwmt_ammo_50ae_ui default:"0"
		ammo_57mm type:#string ui:wwmt_ammo_57mm_ui default:"0"
		ammo_357sig type:#string ui:wwmt_ammo_357sig_ui default:"0"
		ammo_buckshot type:#string ui:wwmt_ammo_buckshot_ui default:"0"
		ammo_762nato type:#string ui:wwmt_ammo_762nato_ui default:"0"
		ammo_556nato type:#string ui:wwmt_ammo_556nato_ui default:"0"
		ammo_556natobox type:#string ui:wwmt_ammo_556natobox_ui default:"0"
		ammo_338magnum type:#string ui:wwmt_ammo_338magnum_ui default:"0"
		item_healthkit type:#string ui:wwmt_item_healthkit_ui default:"0"
		item_battery type:#string ui:wwmt_item_battery_ui default:"0"
		item_longjump type:#string ui:wwmt_item_longjump_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "game_player_equip"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Team Master" align:#left
		EditText wwmt_master_ui "" type:#string
		DropDownList wwmt_weapon_knife_ui "Give Knife" type:#string items:#("No", "Yes")
		on wwmt_weapon_knife_ui selected i do
		(
			weapon_knife = propMapweapon_knife[i]
		)
		DropDownList wwmt_weapon_usp_ui "Give USP45 (45acp Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_usp_ui selected i do
		(
			weapon_usp = propMapweapon_usp[i]
		)
		DropDownList wwmt_weapon_glock18_ui "Give Glock 18 (9mm Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_glock18_ui selected i do
		(
			weapon_glock18 = propMapweapon_glock18[i]
		)
		DropDownList wwmt_weapon_deagle_ui "Give Desert Eagle (50ae Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_deagle_ui selected i do
		(
			weapon_deagle = propMapweapon_deagle[i]
		)
		DropDownList wwmt_weapon_p228_ui "Give P-228 (357sig Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_p228_ui selected i do
		(
			weapon_p228 = propMapweapon_p228[i]
		)
		DropDownList wwmt_weapon_elite_ui "Give Beretta Elites (9mm Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_elite_ui selected i do
		(
			weapon_elite = propMapweapon_elite[i]
		)
		DropDownList wwmt_weapon_fiveseven_ui "Give Five-Seven (57mm Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_fiveseven_ui selected i do
		(
			weapon_fiveseven = propMapweapon_fiveseven[i]
		)
		DropDownList wwmt_weapon_m3_ui "Give Benelli M3 (12 Gauge)" type:#string items:#("No", "Yes")
		on wwmt_weapon_m3_ui selected i do
		(
			weapon_m3 = propMapweapon_m3[i]
		)
		DropDownList wwmt_weapon_xm1014_ui "Give Benelli XM1014 (12 Gauge)" type:#string items:#("No", "Yes")
		on wwmt_weapon_xm1014_ui selected i do
		(
			weapon_xm1014 = propMapweapon_xm1014[i]
		)
		DropDownList wwmt_weapon_mp5navy_ui "Give MP5/Navy (9mm Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_mp5navy_ui selected i do
		(
			weapon_mp5navy = propMapweapon_mp5navy[i]
		)
		DropDownList wwmt_weapon_tmp_ui "Give TMP (9mm Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_tmp_ui selected i do
		(
			weapon_tmp = propMapweapon_tmp[i]
		)
		DropDownList wwmt_weapon_p90_ui "Give FN P90 (57mm Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_p90_ui selected i do
		(
			weapon_p90 = propMapweapon_p90[i]
		)
		DropDownList wwmt_weapon_mac10_ui "Give Mac-10 (45acp Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_mac10_ui selected i do
		(
			weapon_mac10 = propMapweapon_mac10[i]
		)
		DropDownList wwmt_weapon_ump45_ui "Give UMP 45 (45acp Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_ump45_ui selected i do
		(
			weapon_ump45 = propMapweapon_ump45[i]
		)
		DropDownList wwmt_weapon_ak47_ui "Give AK-47 (762nato Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_ak47_ui selected i do
		(
			weapon_ak47 = propMapweapon_ak47[i]
		)
		DropDownList wwmt_weapon_sg552_ui "Give SG552 (556nato Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_sg552_ui selected i do
		(
			weapon_sg552 = propMapweapon_sg552[i]
		)
		DropDownList wwmt_weapon_m4a1_ui "Give M4A1 (556nato Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_m4a1_ui selected i do
		(
			weapon_m4a1 = propMapweapon_m4a1[i]
		)
		DropDownList wwmt_weapon_aug_ui "Give Aug (556nato Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_aug_ui selected i do
		(
			weapon_aug = propMapweapon_aug[i]
		)
		DropDownList wwmt_weapon_scout_ui "Give Scout (762nato Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_scout_ui selected i do
		(
			weapon_scout = propMapweapon_scout[i]
		)
		DropDownList wwmt_weapon_awp_ui "Give AWP (338magnum Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_awp_ui selected i do
		(
			weapon_awp = propMapweapon_awp[i]
		)
		DropDownList wwmt_weapon_g3sg1_ui "Give G3/SG-1 (762nato Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_g3sg1_ui selected i do
		(
			weapon_g3sg1 = propMapweapon_g3sg1[i]
		)
		DropDownList wwmt_weapon_sg550_ui "Give SG550 (556nato Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_sg550_ui selected i do
		(
			weapon_sg550 = propMapweapon_sg550[i]
		)
		DropDownList wwmt_weapon_m249_ui "Give M249 (556natobox Calibre)" type:#string items:#("No", "Yes")
		on wwmt_weapon_m249_ui selected i do
		(
			weapon_m249 = propMapweapon_m249[i]
		)
		DropDownList wwmt_weapon_famas_ui "CS 1.6 Famas (762nato)" type:#string items:#("No", "Yes")
		on wwmt_weapon_famas_ui selected i do
		(
			weapon_famas = propMapweapon_famas[i]
		)
		DropDownList wwmt_weapon_galil_ui "CS 1.6 Galil (556natobox)" type:#string items:#("No", "Yes")
		on wwmt_weapon_galil_ui selected i do
		(
			weapon_galil = propMapweapon_galil[i]
		)
		DropDownList wwmt_weapon_shield_ui "CS 1.6 Police Riot Shield" type:#string items:#("No", "Yes")
		on wwmt_weapon_shield_ui selected i do
		(
			weapon_shield = propMapweapon_shield[i]
		)
		DropDownList wwmt_item_kevlar_ui "Give Kevlar Vest" type:#string items:#("No", "Yes")
		on wwmt_item_kevlar_ui selected i do
		(
			item_kevlar = propMapitem_kevlar[i]
		)
		DropDownList wwmt_item_assaultsuit_ui "Give Kevlar Vest+Ballistic Helmet" type:#string items:#("No", "Yes")
		on wwmt_item_assaultsuit_ui selected i do
		(
			item_assaultsuit = propMapitem_assaultsuit[i]
		)
		DropDownList wwmt_weapon_flashbang_ui "Give Flash Bang" type:#string items:#("No", "1", "2")
		on wwmt_weapon_flashbang_ui selected i do
		(
			weapon_flashbang = propMapweapon_flashbang[i]
		)
		DropDownList wwmt_weapon_hegrenade_ui "Give High-Explosive Grenade" type:#string items:#("No", "Yes")
		on wwmt_weapon_hegrenade_ui selected i do
		(
			weapon_hegrenade = propMapweapon_hegrenade[i]
		)
		DropDownList wwmt_weapon_smokegrenade_ui "Give Smoke Grenade" type:#string items:#("No", "Yes")
		on wwmt_weapon_smokegrenade_ui selected i do
		(
			weapon_smokegrenade = propMapweapon_smokegrenade[i]
		)
		DropDownList wwmt_item_thighpack_ui "Give Defuse Kit" type:#string items:#("No", "Yes")
		on wwmt_item_thighpack_ui selected i do
		(
			item_thighpack = propMapitem_thighpack[i]
		)
		DropDownList wwmt_weapon_c4_ui "Give C4 Plastique Bomb" type:#string items:#("No", "Yes")
		on wwmt_weapon_c4_ui selected i do
		(
			weapon_c4 = propMapweapon_c4[i]
		)
		ComboBox wwmt_ammo_9mm_ui "Give 9mm Parabellum Ammo" type:#string items:#("No", "1 Clip (30 Bullets Per Clip)", "2 Clips", "3 Clips (Fill Glock 18)", "4 Clips (Fill Elites, MP5 & TMP)") height:3
		on wwmt_ammo_9mm_ui selected i do
		(
			ammo_9mm = propMapammo_9mm[i]
		)
		on wwmt_ammo_9mm_ui entered tex do
		(
			ammo_9mm = trimLeft(trimRight(tex))
			if propMapammo_9mm != undefined AND findItem propMapammo_9mm tex == 0 then
			(
				append propMapammo_9mm tex
				sort propMapammo_9mm
				wwmt_ammo_9mm_ui.items = propMapammo_9mm
				wwmt_ammo_9mm_ui.selection = findItem wwmt_ammo_9mm_ui.items tex
			)
		)
		ComboBox wwmt_ammo_45acp_ui "Give .45 ACP Ammo" type:#string items:#("No", "1 Clip (12 Bullets Per Clip)", "2 Clips", "3 Clips", "4 Clips (Fill USP45)", "5 Clips", "6 Clips", "7 Clips", "8 Clips (Fill Mac-10)", "9 Clips (Fill UMP 45)") height:3
		on wwmt_ammo_45acp_ui selected i do
		(
			ammo_45acp = propMapammo_45acp[i]
		)
		on wwmt_ammo_45acp_ui entered tex do
		(
			ammo_45acp = trimLeft(trimRight(tex))
			if propMapammo_45acp != undefined AND findItem propMapammo_45acp tex == 0 then
			(
				append propMapammo_45acp tex
				sort propMapammo_45acp
				wwmt_ammo_45acp_ui.items = propMapammo_45acp
				wwmt_ammo_45acp_ui.selection = findItem wwmt_ammo_45acp_ui.items tex
			)
		)
		ComboBox wwmt_ammo_50ae_ui "Give .50 Deagle Ammo" type:#string items:#("No", "1 Clip (7 Bullets Per Clip)", "2 Clips", "3 Clips", "4 Clips", "5 Clips (Fill Desert Eagle)") height:3
		on wwmt_ammo_50ae_ui selected i do
		(
			ammo_50ae = propMapammo_50ae[i]
		)
		on wwmt_ammo_50ae_ui entered tex do
		(
			ammo_50ae = trimLeft(trimRight(tex))
			if propMapammo_50ae != undefined AND findItem propMapammo_50ae tex == 0 then
			(
				append propMapammo_50ae tex
				sort propMapammo_50ae
				wwmt_ammo_50ae_ui.items = propMapammo_50ae
				wwmt_ammo_50ae_ui.selection = findItem wwmt_ammo_50ae_ui.items tex
			)
		)
		DropDownList wwmt_ammo_57mm_ui "Give 5.7mm Ammo" type:#string items:#("No", "1 Clip (50 Bullets Per Clip)", "2 Clips (Fill Five-Seven & P90)")
		on wwmt_ammo_57mm_ui selected i do
		(
			ammo_57mm = propMapammo_57mm[i]
		)
		ComboBox wwmt_ammo_357sig_ui "Give .357 SIG Ammo" type:#string items:#("No", "1 Clip (13 Bullets Per Clip)", "2 Clips", "3 Clips", "4 Clips (Fill P-228)") height:3
		on wwmt_ammo_357sig_ui selected i do
		(
			ammo_357sig = propMapammo_357sig[i]
		)
		on wwmt_ammo_357sig_ui entered tex do
		(
			ammo_357sig = trimLeft(trimRight(tex))
			if propMapammo_357sig != undefined AND findItem propMapammo_357sig tex == 0 then
			(
				append propMapammo_357sig tex
				sort propMapammo_357sig
				wwmt_ammo_357sig_ui.items = propMapammo_357sig
				wwmt_ammo_357sig_ui.selection = findItem wwmt_ammo_357sig_ui.items tex
			)
		)
		ComboBox wwmt_ammo_buckshot_ui "Give 12 Gauge Ammo" type:#string items:#("No", "1 Clip (8 Shells Per Clip)", "2 Clips", "3 Clips", "4 Clips (Fill Benelli M3, XM1014)") height:3
		on wwmt_ammo_buckshot_ui selected i do
		(
			ammo_buckshot = propMapammo_buckshot[i]
		)
		on wwmt_ammo_buckshot_ui entered tex do
		(
			ammo_buckshot = trimLeft(trimRight(tex))
			if propMapammo_buckshot != undefined AND findItem propMapammo_buckshot tex == 0 then
			(
				append propMapammo_buckshot tex
				sort propMapammo_buckshot
				wwmt_ammo_buckshot_ui.items = propMapammo_buckshot
				wwmt_ammo_buckshot_ui.selection = findItem wwmt_ammo_buckshot_ui.items tex
			)
		)
		ComboBox wwmt_ammo_762nato_ui "Give 7.62mm NATO Ammo" type:#string items:#("No", "1 Clip (30 Bullets Per Clip)", "2 Clips (Fill Scout & G3/S-G1)", "3 Clips (Fill AK-47)") height:3
		on wwmt_ammo_762nato_ui selected i do
		(
			ammo_762nato = propMapammo_762nato[i]
		)
		on wwmt_ammo_762nato_ui entered tex do
		(
			ammo_762nato = trimLeft(trimRight(tex))
			if propMapammo_762nato != undefined AND findItem propMapammo_762nato tex == 0 then
			(
				append propMapammo_762nato tex
				sort propMapammo_762nato
				wwmt_ammo_762nato_ui.items = propMapammo_762nato
				wwmt_ammo_762nato_ui.selection = findItem wwmt_ammo_762nato_ui.items tex
			)
		)
		ComboBox wwmt_ammo_556nato_ui "Give 5.56mm NATO Ammo" type:#string items:#("No", "1 Clip (30 Bullets Per Clip)", "2 Clips", "3 Fill SG552 M4A1 Aug SG550") height:3
		on wwmt_ammo_556nato_ui selected i do
		(
			ammo_556nato = propMapammo_556nato[i]
		)
		on wwmt_ammo_556nato_ui entered tex do
		(
			ammo_556nato = trimLeft(trimRight(tex))
			if propMapammo_556nato != undefined AND findItem propMapammo_556nato tex == 0 then
			(
				append propMapammo_556nato tex
				sort propMapammo_556nato
				wwmt_ammo_556nato_ui.items = propMapammo_556nato
				wwmt_ammo_556nato_ui.selection = findItem wwmt_ammo_556nato_ui.items tex
			)
		)
		ComboBox wwmt_ammo_556natobox_ui "Give 5.56mm NATO Box Ammo" type:#string items:#("No", "1 Clip (30 Bullets Per Clip)", "2 Clips", "3 Clips", "4 Clips", "5 Clips", "6 Clips", "7 Clips (Fill FN M249 Para)") height:3
		on wwmt_ammo_556natobox_ui selected i do
		(
			ammo_556natobox = propMapammo_556natobox[i]
		)
		on wwmt_ammo_556natobox_ui entered tex do
		(
			ammo_556natobox = trimLeft(trimRight(tex))
			if propMapammo_556natobox != undefined AND findItem propMapammo_556natobox tex == 0 then
			(
				append propMapammo_556natobox tex
				sort propMapammo_556natobox
				wwmt_ammo_556natobox_ui.items = propMapammo_556natobox
				wwmt_ammo_556natobox_ui.selection = findItem wwmt_ammo_556natobox_ui.items tex
			)
		)
		ComboBox wwmt_ammo_338magnum_ui "Give .338 AWP Ammo" type:#string items:#("No", "1 Clip (10 Bullets Per Clip)", "2 Clips", "3 Clips (Fill AWP)") height:3
		on wwmt_ammo_338magnum_ui selected i do
		(
			ammo_338magnum = propMapammo_338magnum[i]
		)
		on wwmt_ammo_338magnum_ui entered tex do
		(
			ammo_338magnum = trimLeft(trimRight(tex))
			if propMapammo_338magnum != undefined AND findItem propMapammo_338magnum tex == 0 then
			(
				append propMapammo_338magnum tex
				sort propMapammo_338magnum
				wwmt_ammo_338magnum_ui.items = propMapammo_338magnum
				wwmt_ammo_338magnum_ui.selection = findItem wwmt_ammo_338magnum_ui.items tex
			)
		)
		ComboBox wwmt_item_healthkit_ui "Give Health Kit" type:#string items:#("No", "1 Healthkit = 15 Health Points", "2 Healthkits = 30 Health Points", "3 Healthkits = 45 Health Points", "4 Healthkits = 60 Health Points", "5 Healthkits = 75 Health Points", "6 Healthkits = 90 Health Points", "7 Healthkits = 100 Health Points") height:3
		on wwmt_item_healthkit_ui selected i do
		(
			item_healthkit = propMapitem_healthkit[i]
		)
		on wwmt_item_healthkit_ui entered tex do
		(
			item_healthkit = trimLeft(trimRight(tex))
			if propMapitem_healthkit != undefined AND findItem propMapitem_healthkit tex == 0 then
			(
				append propMapitem_healthkit tex
				sort propMapitem_healthkit
				wwmt_item_healthkit_ui.items = propMapitem_healthkit
				wwmt_item_healthkit_ui.selection = findItem wwmt_item_healthkit_ui.items tex
			)
		)
		ComboBox wwmt_item_battery_ui "Give HL HEV Battery" type:#string items:#("No", "1 Battery = 15 Kevlar Points", "2 Batteries = 30 Kevlar Points", "3 Batteries = 45 Kevlar Points", "4 Batteries = 60 Kevlar Points", "5 Batteries = 75 Kevlar Points", "6 Batteries = 90 Kevlar Points", "7 Batteries = 100 Kevlar Points") height:3
		on wwmt_item_battery_ui selected i do
		(
			item_battery = propMapitem_battery[i]
		)
		on wwmt_item_battery_ui entered tex do
		(
			item_battery = trimLeft(trimRight(tex))
			if propMapitem_battery != undefined AND findItem propMapitem_battery tex == 0 then
			(
				append propMapitem_battery tex
				sort propMapitem_battery
				wwmt_item_battery_ui.items = propMapitem_battery
				wwmt_item_battery_ui.selection = findItem wwmt_item_battery_ui.items tex
			)
		)
		DropDownList wwmt_item_longjump_ui "Give HL Long Jump Module" type:#string items:#("No", "Yes (An Unrealistic Item)")
		on wwmt_item_longjump_ui selected i do
		(
			item_longjump = propMapitem_longjump[i]
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Use Only" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=game_player_equip&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: game_player_equip" address:"https://developer.valvesoftware.com/wiki/game_player_equip?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if weapon_knife != undefined then
			(
				if findItem propMapweapon_knife weapon_knife == 0 then
				(
					append propMapweapon_knife weapon_knife
					local tmp = wwmt_weapon_knife_ui.items
					append tmp weapon_knife
					wwmt_weapon_knife_ui.items = tmp
					wwmt_weapon_knife_ui.selection = propMapweapon_knife.count
				)
				else
				(
					wwmt_weapon_knife_ui.selection = (findItem propMapweapon_knife weapon_knife)
				)
			)
			if weapon_usp != undefined then
			(
				if findItem propMapweapon_usp weapon_usp == 0 then
				(
					append propMapweapon_usp weapon_usp
					local tmp = wwmt_weapon_usp_ui.items
					append tmp weapon_usp
					wwmt_weapon_usp_ui.items = tmp
					wwmt_weapon_usp_ui.selection = propMapweapon_usp.count
				)
				else
				(
					wwmt_weapon_usp_ui.selection = (findItem propMapweapon_usp weapon_usp)
				)
			)
			if weapon_glock18 != undefined then
			(
				if findItem propMapweapon_glock18 weapon_glock18 == 0 then
				(
					append propMapweapon_glock18 weapon_glock18
					local tmp = wwmt_weapon_glock18_ui.items
					append tmp weapon_glock18
					wwmt_weapon_glock18_ui.items = tmp
					wwmt_weapon_glock18_ui.selection = propMapweapon_glock18.count
				)
				else
				(
					wwmt_weapon_glock18_ui.selection = (findItem propMapweapon_glock18 weapon_glock18)
				)
			)
			if weapon_deagle != undefined then
			(
				if findItem propMapweapon_deagle weapon_deagle == 0 then
				(
					append propMapweapon_deagle weapon_deagle
					local tmp = wwmt_weapon_deagle_ui.items
					append tmp weapon_deagle
					wwmt_weapon_deagle_ui.items = tmp
					wwmt_weapon_deagle_ui.selection = propMapweapon_deagle.count
				)
				else
				(
					wwmt_weapon_deagle_ui.selection = (findItem propMapweapon_deagle weapon_deagle)
				)
			)
			if weapon_p228 != undefined then
			(
				if findItem propMapweapon_p228 weapon_p228 == 0 then
				(
					append propMapweapon_p228 weapon_p228
					local tmp = wwmt_weapon_p228_ui.items
					append tmp weapon_p228
					wwmt_weapon_p228_ui.items = tmp
					wwmt_weapon_p228_ui.selection = propMapweapon_p228.count
				)
				else
				(
					wwmt_weapon_p228_ui.selection = (findItem propMapweapon_p228 weapon_p228)
				)
			)
			if weapon_elite != undefined then
			(
				if findItem propMapweapon_elite weapon_elite == 0 then
				(
					append propMapweapon_elite weapon_elite
					local tmp = wwmt_weapon_elite_ui.items
					append tmp weapon_elite
					wwmt_weapon_elite_ui.items = tmp
					wwmt_weapon_elite_ui.selection = propMapweapon_elite.count
				)
				else
				(
					wwmt_weapon_elite_ui.selection = (findItem propMapweapon_elite weapon_elite)
				)
			)
			if weapon_fiveseven != undefined then
			(
				if findItem propMapweapon_fiveseven weapon_fiveseven == 0 then
				(
					append propMapweapon_fiveseven weapon_fiveseven
					local tmp = wwmt_weapon_fiveseven_ui.items
					append tmp weapon_fiveseven
					wwmt_weapon_fiveseven_ui.items = tmp
					wwmt_weapon_fiveseven_ui.selection = propMapweapon_fiveseven.count
				)
				else
				(
					wwmt_weapon_fiveseven_ui.selection = (findItem propMapweapon_fiveseven weapon_fiveseven)
				)
			)
			if weapon_m3 != undefined then
			(
				if findItem propMapweapon_m3 weapon_m3 == 0 then
				(
					append propMapweapon_m3 weapon_m3
					local tmp = wwmt_weapon_m3_ui.items
					append tmp weapon_m3
					wwmt_weapon_m3_ui.items = tmp
					wwmt_weapon_m3_ui.selection = propMapweapon_m3.count
				)
				else
				(
					wwmt_weapon_m3_ui.selection = (findItem propMapweapon_m3 weapon_m3)
				)
			)
			if weapon_xm1014 != undefined then
			(
				if findItem propMapweapon_xm1014 weapon_xm1014 == 0 then
				(
					append propMapweapon_xm1014 weapon_xm1014
					local tmp = wwmt_weapon_xm1014_ui.items
					append tmp weapon_xm1014
					wwmt_weapon_xm1014_ui.items = tmp
					wwmt_weapon_xm1014_ui.selection = propMapweapon_xm1014.count
				)
				else
				(
					wwmt_weapon_xm1014_ui.selection = (findItem propMapweapon_xm1014 weapon_xm1014)
				)
			)
			if weapon_mp5navy != undefined then
			(
				if findItem propMapweapon_mp5navy weapon_mp5navy == 0 then
				(
					append propMapweapon_mp5navy weapon_mp5navy
					local tmp = wwmt_weapon_mp5navy_ui.items
					append tmp weapon_mp5navy
					wwmt_weapon_mp5navy_ui.items = tmp
					wwmt_weapon_mp5navy_ui.selection = propMapweapon_mp5navy.count
				)
				else
				(
					wwmt_weapon_mp5navy_ui.selection = (findItem propMapweapon_mp5navy weapon_mp5navy)
				)
			)
			if weapon_tmp != undefined then
			(
				if findItem propMapweapon_tmp weapon_tmp == 0 then
				(
					append propMapweapon_tmp weapon_tmp
					local tmp = wwmt_weapon_tmp_ui.items
					append tmp weapon_tmp
					wwmt_weapon_tmp_ui.items = tmp
					wwmt_weapon_tmp_ui.selection = propMapweapon_tmp.count
				)
				else
				(
					wwmt_weapon_tmp_ui.selection = (findItem propMapweapon_tmp weapon_tmp)
				)
			)
			if weapon_p90 != undefined then
			(
				if findItem propMapweapon_p90 weapon_p90 == 0 then
				(
					append propMapweapon_p90 weapon_p90
					local tmp = wwmt_weapon_p90_ui.items
					append tmp weapon_p90
					wwmt_weapon_p90_ui.items = tmp
					wwmt_weapon_p90_ui.selection = propMapweapon_p90.count
				)
				else
				(
					wwmt_weapon_p90_ui.selection = (findItem propMapweapon_p90 weapon_p90)
				)
			)
			if weapon_mac10 != undefined then
			(
				if findItem propMapweapon_mac10 weapon_mac10 == 0 then
				(
					append propMapweapon_mac10 weapon_mac10
					local tmp = wwmt_weapon_mac10_ui.items
					append tmp weapon_mac10
					wwmt_weapon_mac10_ui.items = tmp
					wwmt_weapon_mac10_ui.selection = propMapweapon_mac10.count
				)
				else
				(
					wwmt_weapon_mac10_ui.selection = (findItem propMapweapon_mac10 weapon_mac10)
				)
			)
			if weapon_ump45 != undefined then
			(
				if findItem propMapweapon_ump45 weapon_ump45 == 0 then
				(
					append propMapweapon_ump45 weapon_ump45
					local tmp = wwmt_weapon_ump45_ui.items
					append tmp weapon_ump45
					wwmt_weapon_ump45_ui.items = tmp
					wwmt_weapon_ump45_ui.selection = propMapweapon_ump45.count
				)
				else
				(
					wwmt_weapon_ump45_ui.selection = (findItem propMapweapon_ump45 weapon_ump45)
				)
			)
			if weapon_ak47 != undefined then
			(
				if findItem propMapweapon_ak47 weapon_ak47 == 0 then
				(
					append propMapweapon_ak47 weapon_ak47
					local tmp = wwmt_weapon_ak47_ui.items
					append tmp weapon_ak47
					wwmt_weapon_ak47_ui.items = tmp
					wwmt_weapon_ak47_ui.selection = propMapweapon_ak47.count
				)
				else
				(
					wwmt_weapon_ak47_ui.selection = (findItem propMapweapon_ak47 weapon_ak47)
				)
			)
			if weapon_sg552 != undefined then
			(
				if findItem propMapweapon_sg552 weapon_sg552 == 0 then
				(
					append propMapweapon_sg552 weapon_sg552
					local tmp = wwmt_weapon_sg552_ui.items
					append tmp weapon_sg552
					wwmt_weapon_sg552_ui.items = tmp
					wwmt_weapon_sg552_ui.selection = propMapweapon_sg552.count
				)
				else
				(
					wwmt_weapon_sg552_ui.selection = (findItem propMapweapon_sg552 weapon_sg552)
				)
			)
			if weapon_m4a1 != undefined then
			(
				if findItem propMapweapon_m4a1 weapon_m4a1 == 0 then
				(
					append propMapweapon_m4a1 weapon_m4a1
					local tmp = wwmt_weapon_m4a1_ui.items
					append tmp weapon_m4a1
					wwmt_weapon_m4a1_ui.items = tmp
					wwmt_weapon_m4a1_ui.selection = propMapweapon_m4a1.count
				)
				else
				(
					wwmt_weapon_m4a1_ui.selection = (findItem propMapweapon_m4a1 weapon_m4a1)
				)
			)
			if weapon_aug != undefined then
			(
				if findItem propMapweapon_aug weapon_aug == 0 then
				(
					append propMapweapon_aug weapon_aug
					local tmp = wwmt_weapon_aug_ui.items
					append tmp weapon_aug
					wwmt_weapon_aug_ui.items = tmp
					wwmt_weapon_aug_ui.selection = propMapweapon_aug.count
				)
				else
				(
					wwmt_weapon_aug_ui.selection = (findItem propMapweapon_aug weapon_aug)
				)
			)
			if weapon_scout != undefined then
			(
				if findItem propMapweapon_scout weapon_scout == 0 then
				(
					append propMapweapon_scout weapon_scout
					local tmp = wwmt_weapon_scout_ui.items
					append tmp weapon_scout
					wwmt_weapon_scout_ui.items = tmp
					wwmt_weapon_scout_ui.selection = propMapweapon_scout.count
				)
				else
				(
					wwmt_weapon_scout_ui.selection = (findItem propMapweapon_scout weapon_scout)
				)
			)
			if weapon_awp != undefined then
			(
				if findItem propMapweapon_awp weapon_awp == 0 then
				(
					append propMapweapon_awp weapon_awp
					local tmp = wwmt_weapon_awp_ui.items
					append tmp weapon_awp
					wwmt_weapon_awp_ui.items = tmp
					wwmt_weapon_awp_ui.selection = propMapweapon_awp.count
				)
				else
				(
					wwmt_weapon_awp_ui.selection = (findItem propMapweapon_awp weapon_awp)
				)
			)
			if weapon_g3sg1 != undefined then
			(
				if findItem propMapweapon_g3sg1 weapon_g3sg1 == 0 then
				(
					append propMapweapon_g3sg1 weapon_g3sg1
					local tmp = wwmt_weapon_g3sg1_ui.items
					append tmp weapon_g3sg1
					wwmt_weapon_g3sg1_ui.items = tmp
					wwmt_weapon_g3sg1_ui.selection = propMapweapon_g3sg1.count
				)
				else
				(
					wwmt_weapon_g3sg1_ui.selection = (findItem propMapweapon_g3sg1 weapon_g3sg1)
				)
			)
			if weapon_sg550 != undefined then
			(
				if findItem propMapweapon_sg550 weapon_sg550 == 0 then
				(
					append propMapweapon_sg550 weapon_sg550
					local tmp = wwmt_weapon_sg550_ui.items
					append tmp weapon_sg550
					wwmt_weapon_sg550_ui.items = tmp
					wwmt_weapon_sg550_ui.selection = propMapweapon_sg550.count
				)
				else
				(
					wwmt_weapon_sg550_ui.selection = (findItem propMapweapon_sg550 weapon_sg550)
				)
			)
			if weapon_m249 != undefined then
			(
				if findItem propMapweapon_m249 weapon_m249 == 0 then
				(
					append propMapweapon_m249 weapon_m249
					local tmp = wwmt_weapon_m249_ui.items
					append tmp weapon_m249
					wwmt_weapon_m249_ui.items = tmp
					wwmt_weapon_m249_ui.selection = propMapweapon_m249.count
				)
				else
				(
					wwmt_weapon_m249_ui.selection = (findItem propMapweapon_m249 weapon_m249)
				)
			)
			if weapon_famas != undefined then
			(
				if findItem propMapweapon_famas weapon_famas == 0 then
				(
					append propMapweapon_famas weapon_famas
					local tmp = wwmt_weapon_famas_ui.items
					append tmp weapon_famas
					wwmt_weapon_famas_ui.items = tmp
					wwmt_weapon_famas_ui.selection = propMapweapon_famas.count
				)
				else
				(
					wwmt_weapon_famas_ui.selection = (findItem propMapweapon_famas weapon_famas)
				)
			)
			if weapon_galil != undefined then
			(
				if findItem propMapweapon_galil weapon_galil == 0 then
				(
					append propMapweapon_galil weapon_galil
					local tmp = wwmt_weapon_galil_ui.items
					append tmp weapon_galil
					wwmt_weapon_galil_ui.items = tmp
					wwmt_weapon_galil_ui.selection = propMapweapon_galil.count
				)
				else
				(
					wwmt_weapon_galil_ui.selection = (findItem propMapweapon_galil weapon_galil)
				)
			)
			if weapon_shield != undefined then
			(
				if findItem propMapweapon_shield weapon_shield == 0 then
				(
					append propMapweapon_shield weapon_shield
					local tmp = wwmt_weapon_shield_ui.items
					append tmp weapon_shield
					wwmt_weapon_shield_ui.items = tmp
					wwmt_weapon_shield_ui.selection = propMapweapon_shield.count
				)
				else
				(
					wwmt_weapon_shield_ui.selection = (findItem propMapweapon_shield weapon_shield)
				)
			)
			if item_kevlar != undefined then
			(
				if findItem propMapitem_kevlar item_kevlar == 0 then
				(
					append propMapitem_kevlar item_kevlar
					local tmp = wwmt_item_kevlar_ui.items
					append tmp item_kevlar
					wwmt_item_kevlar_ui.items = tmp
					wwmt_item_kevlar_ui.selection = propMapitem_kevlar.count
				)
				else
				(
					wwmt_item_kevlar_ui.selection = (findItem propMapitem_kevlar item_kevlar)
				)
			)
			if item_assaultsuit != undefined then
			(
				if findItem propMapitem_assaultsuit item_assaultsuit == 0 then
				(
					append propMapitem_assaultsuit item_assaultsuit
					local tmp = wwmt_item_assaultsuit_ui.items
					append tmp item_assaultsuit
					wwmt_item_assaultsuit_ui.items = tmp
					wwmt_item_assaultsuit_ui.selection = propMapitem_assaultsuit.count
				)
				else
				(
					wwmt_item_assaultsuit_ui.selection = (findItem propMapitem_assaultsuit item_assaultsuit)
				)
			)
			if weapon_flashbang != undefined then
			(
				if findItem propMapweapon_flashbang weapon_flashbang == 0 then
				(
					append propMapweapon_flashbang weapon_flashbang
					local tmp = wwmt_weapon_flashbang_ui.items
					append tmp weapon_flashbang
					wwmt_weapon_flashbang_ui.items = tmp
					wwmt_weapon_flashbang_ui.selection = propMapweapon_flashbang.count
				)
				else
				(
					wwmt_weapon_flashbang_ui.selection = (findItem propMapweapon_flashbang weapon_flashbang)
				)
			)
			if weapon_hegrenade != undefined then
			(
				if findItem propMapweapon_hegrenade weapon_hegrenade == 0 then
				(
					append propMapweapon_hegrenade weapon_hegrenade
					local tmp = wwmt_weapon_hegrenade_ui.items
					append tmp weapon_hegrenade
					wwmt_weapon_hegrenade_ui.items = tmp
					wwmt_weapon_hegrenade_ui.selection = propMapweapon_hegrenade.count
				)
				else
				(
					wwmt_weapon_hegrenade_ui.selection = (findItem propMapweapon_hegrenade weapon_hegrenade)
				)
			)
			if weapon_smokegrenade != undefined then
			(
				if findItem propMapweapon_smokegrenade weapon_smokegrenade == 0 then
				(
					append propMapweapon_smokegrenade weapon_smokegrenade
					local tmp = wwmt_weapon_smokegrenade_ui.items
					append tmp weapon_smokegrenade
					wwmt_weapon_smokegrenade_ui.items = tmp
					wwmt_weapon_smokegrenade_ui.selection = propMapweapon_smokegrenade.count
				)
				else
				(
					wwmt_weapon_smokegrenade_ui.selection = (findItem propMapweapon_smokegrenade weapon_smokegrenade)
				)
			)
			if item_thighpack != undefined then
			(
				if findItem propMapitem_thighpack item_thighpack == 0 then
				(
					append propMapitem_thighpack item_thighpack
					local tmp = wwmt_item_thighpack_ui.items
					append tmp item_thighpack
					wwmt_item_thighpack_ui.items = tmp
					wwmt_item_thighpack_ui.selection = propMapitem_thighpack.count
				)
				else
				(
					wwmt_item_thighpack_ui.selection = (findItem propMapitem_thighpack item_thighpack)
				)
			)
			if weapon_c4 != undefined then
			(
				if findItem propMapweapon_c4 weapon_c4 == 0 then
				(
					append propMapweapon_c4 weapon_c4
					local tmp = wwmt_weapon_c4_ui.items
					append tmp weapon_c4
					wwmt_weapon_c4_ui.items = tmp
					wwmt_weapon_c4_ui.selection = propMapweapon_c4.count
				)
				else
				(
					wwmt_weapon_c4_ui.selection = (findItem propMapweapon_c4 weapon_c4)
				)
			)
			if ammo_9mm != undefined then
			(
				if findItem propMapammo_9mm ammo_9mm == 0 then
				(
					append propMapammo_9mm ammo_9mm
					local tmp = wwmt_ammo_9mm_ui.items
					append tmp ammo_9mm
					wwmt_ammo_9mm_ui.items = tmp
					wwmt_ammo_9mm_ui.selection = propMapammo_9mm.count
				)
				else
				(
					wwmt_ammo_9mm_ui.selection = (findItem propMapammo_9mm ammo_9mm)
				)
			)
			if ammo_45acp != undefined then
			(
				if findItem propMapammo_45acp ammo_45acp == 0 then
				(
					append propMapammo_45acp ammo_45acp
					local tmp = wwmt_ammo_45acp_ui.items
					append tmp ammo_45acp
					wwmt_ammo_45acp_ui.items = tmp
					wwmt_ammo_45acp_ui.selection = propMapammo_45acp.count
				)
				else
				(
					wwmt_ammo_45acp_ui.selection = (findItem propMapammo_45acp ammo_45acp)
				)
			)
			if ammo_50ae != undefined then
			(
				if findItem propMapammo_50ae ammo_50ae == 0 then
				(
					append propMapammo_50ae ammo_50ae
					local tmp = wwmt_ammo_50ae_ui.items
					append tmp ammo_50ae
					wwmt_ammo_50ae_ui.items = tmp
					wwmt_ammo_50ae_ui.selection = propMapammo_50ae.count
				)
				else
				(
					wwmt_ammo_50ae_ui.selection = (findItem propMapammo_50ae ammo_50ae)
				)
			)
			if ammo_57mm != undefined then
			(
				if findItem propMapammo_57mm ammo_57mm == 0 then
				(
					append propMapammo_57mm ammo_57mm
					local tmp = wwmt_ammo_57mm_ui.items
					append tmp ammo_57mm
					wwmt_ammo_57mm_ui.items = tmp
					wwmt_ammo_57mm_ui.selection = propMapammo_57mm.count
				)
				else
				(
					wwmt_ammo_57mm_ui.selection = (findItem propMapammo_57mm ammo_57mm)
				)
			)
			if ammo_357sig != undefined then
			(
				if findItem propMapammo_357sig ammo_357sig == 0 then
				(
					append propMapammo_357sig ammo_357sig
					local tmp = wwmt_ammo_357sig_ui.items
					append tmp ammo_357sig
					wwmt_ammo_357sig_ui.items = tmp
					wwmt_ammo_357sig_ui.selection = propMapammo_357sig.count
				)
				else
				(
					wwmt_ammo_357sig_ui.selection = (findItem propMapammo_357sig ammo_357sig)
				)
			)
			if ammo_buckshot != undefined then
			(
				if findItem propMapammo_buckshot ammo_buckshot == 0 then
				(
					append propMapammo_buckshot ammo_buckshot
					local tmp = wwmt_ammo_buckshot_ui.items
					append tmp ammo_buckshot
					wwmt_ammo_buckshot_ui.items = tmp
					wwmt_ammo_buckshot_ui.selection = propMapammo_buckshot.count
				)
				else
				(
					wwmt_ammo_buckshot_ui.selection = (findItem propMapammo_buckshot ammo_buckshot)
				)
			)
			if ammo_762nato != undefined then
			(
				if findItem propMapammo_762nato ammo_762nato == 0 then
				(
					append propMapammo_762nato ammo_762nato
					local tmp = wwmt_ammo_762nato_ui.items
					append tmp ammo_762nato
					wwmt_ammo_762nato_ui.items = tmp
					wwmt_ammo_762nato_ui.selection = propMapammo_762nato.count
				)
				else
				(
					wwmt_ammo_762nato_ui.selection = (findItem propMapammo_762nato ammo_762nato)
				)
			)
			if ammo_556nato != undefined then
			(
				if findItem propMapammo_556nato ammo_556nato == 0 then
				(
					append propMapammo_556nato ammo_556nato
					local tmp = wwmt_ammo_556nato_ui.items
					append tmp ammo_556nato
					wwmt_ammo_556nato_ui.items = tmp
					wwmt_ammo_556nato_ui.selection = propMapammo_556nato.count
				)
				else
				(
					wwmt_ammo_556nato_ui.selection = (findItem propMapammo_556nato ammo_556nato)
				)
			)
			if ammo_556natobox != undefined then
			(
				if findItem propMapammo_556natobox ammo_556natobox == 0 then
				(
					append propMapammo_556natobox ammo_556natobox
					local tmp = wwmt_ammo_556natobox_ui.items
					append tmp ammo_556natobox
					wwmt_ammo_556natobox_ui.items = tmp
					wwmt_ammo_556natobox_ui.selection = propMapammo_556natobox.count
				)
				else
				(
					wwmt_ammo_556natobox_ui.selection = (findItem propMapammo_556natobox ammo_556natobox)
				)
			)
			if ammo_338magnum != undefined then
			(
				if findItem propMapammo_338magnum ammo_338magnum == 0 then
				(
					append propMapammo_338magnum ammo_338magnum
					local tmp = wwmt_ammo_338magnum_ui.items
					append tmp ammo_338magnum
					wwmt_ammo_338magnum_ui.items = tmp
					wwmt_ammo_338magnum_ui.selection = propMapammo_338magnum.count
				)
				else
				(
					wwmt_ammo_338magnum_ui.selection = (findItem propMapammo_338magnum ammo_338magnum)
				)
			)
			if item_healthkit != undefined then
			(
				if findItem propMapitem_healthkit item_healthkit == 0 then
				(
					append propMapitem_healthkit item_healthkit
					local tmp = wwmt_item_healthkit_ui.items
					append tmp item_healthkit
					wwmt_item_healthkit_ui.items = tmp
					wwmt_item_healthkit_ui.selection = propMapitem_healthkit.count
				)
				else
				(
					wwmt_item_healthkit_ui.selection = (findItem propMapitem_healthkit item_healthkit)
				)
			)
			if item_battery != undefined then
			(
				if findItem propMapitem_battery item_battery == 0 then
				(
					append propMapitem_battery item_battery
					local tmp = wwmt_item_battery_ui.items
					append tmp item_battery
					wwmt_item_battery_ui.items = tmp
					wwmt_item_battery_ui.selection = propMapitem_battery.count
				)
				else
				(
					wwmt_item_battery_ui.selection = (findItem propMapitem_battery item_battery)
				)
			)
			if item_longjump != undefined then
			(
				if findItem propMapitem_longjump item_longjump == 0 then
				(
					append propMapitem_longjump item_longjump
					local tmp = wwmt_item_longjump_ui.items
					append tmp item_longjump
					wwmt_item_longjump_ui.items = tmp
					wwmt_item_longjump_ui.selection = propMapitem_longjump.count
				)
				else
				(
					wwmt_item_longjump_ui.selection = (findItem propMapitem_longjump item_longjump)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_game_player_hurt_CA = attributes "WW Entity game_player_hurt" version: 78 attribID:#(-1000261268L,454243242L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "game_player_hurt"
	local isWWPRO = true
	local description = "Hurts player who fires"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "dmg")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/GamePlayerHurt.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		dmg type:#string ui:wwmt_dmg_ui default:"999"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "game_player_hurt"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_dmg_ui_label "Damage To Apply" align:#left
		EditText wwmt_dmg_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Remove On fire" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=game_player_hurt&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: game_player_hurt" address:"https://developer.valvesoftware.com/wiki/game_player_hurt?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_game_player_team_CA = attributes "WW Entity game_player_team" version: 78 attribID:#(-1000261268L,1052651630L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "game_player_team"
	local isWWPRO = true
	local description = "Allows player to change teams"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "wwmt_target")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/GamePlayerTeam.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		wwmt_target type:#string ui:wwmt_target_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "game_player_team"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_target_ui_label "game_team_master to use" align:#left
		EditText wwmt_target_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Remove On fire" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Kill Player" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Gib Player" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=game_player_team&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: game_player_team" address:"https://developer.valvesoftware.com/wiki/game_player_team?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_game_score_CA = attributes "WW Entity game_score" version: 78 attribID:#(-1779197419L,-2047946048L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "game_score"
	local isWWPRO = true
	local description = "Award/Deduct Points"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "points")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/GameScore.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		points type:#integer ui:wwmt_points_ui default:1
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "game_score"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_label_points_ui "Points to add (+/-)" align:#left
		Spinner wwmt_points_ui "" type:#integer range:[-10000, 10000, 1]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Allow Negative" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Team Points" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=game_score&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: game_score" address:"https://developer.valvesoftware.com/wiki/game_score?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_game_team_master_CA = attributes "WW Entity game_team_master" version: 78 attribID:#(-435611271L,1219551684L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "game_team_master"
	local isWWPRO = true
	local description = "Team based master/relay"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "wwmt_target", "delay", "killtarget", "triggerstate", "teamindex")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/GameTeamMaster.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValtriggerstate = 0
	local propMaptriggerstate = #("0", "1", "2")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		triggerstate type:#string ui:wwmt_triggerstate_ui default:"0"
		teamindex type:#integer ui:wwmt_teamindex_ui default:-1
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "game_team_master"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		DropDownList wwmt_triggerstate_ui "Trigger State" type:#string items:#("Off", "On", "Toggle")
		on wwmt_triggerstate_ui selected i do
		(
			triggerstate = propMaptriggerstate[i]
		)
		Label wwmt_label_teamindex_ui "Team Index (-1 = no team)" align:#left
		Spinner wwmt_teamindex_ui "" type:#integer range:[-10000, 10000, -1]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Remove On fire" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=game_team_master&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: game_team_master" address:"https://developer.valvesoftware.com/wiki/game_team_master?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if triggerstate != undefined then
			(
				if findItem propMaptriggerstate triggerstate == 0 then
				(
					append propMaptriggerstate triggerstate
					local tmp = wwmt_triggerstate_ui.items
					append tmp triggerstate
					wwmt_triggerstate_ui.items = tmp
					wwmt_triggerstate_ui.selection = propMaptriggerstate.count
				)
				else
				(
					wwmt_triggerstate_ui.selection = (findItem propMaptriggerstate triggerstate)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_game_team_set_CA = attributes "WW Entity game_team_set" version: 78 attribID:#(-2091331079L,951924064L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "game_team_set"
	local isWWPRO = true
	local description = "Sets team of team_master"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "wwmt_target", "delay", "killtarget")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/GameTeamSet.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "game_team_set"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Remove On fire" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=game_team_set&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: game_team_set" address:"https://developer.valvesoftware.com/wiki/game_team_set?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_game_text_CA = attributes "WW Entity game_text" version: 78 attribID:#(-1966748556L,-629635752L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "game_text"
	local isWWPRO = true
	local description = "HUD Text Message"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "wwmt_target", "message", "x", "y", "effect", "wwmt_color", "color2", "fadein", "fadeout", "holdtime", "fxtime", "channel")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/GameText.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValeffect = 0
	local propMapeffect = #("0", "1", "2")
	local propValchannel = 1
	local propMapchannel = #("1", "2", "3", "4")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		wwmt_target type:#string ui:wwmt_target_ui
		message type:#string ui:wwmt_message_ui
		x type:#string ui:wwmt_x_ui default:"-1"
		y type:#string ui:wwmt_y_ui default:"-1"
		effect type:#string ui:wwmt_effect_ui default:"0"
		wwmt_color type:#color ui:wwmt_color_ui default:(Color 100 100 100)
		wwmt_color_intensity type:#integer ui:wwmt_color_intensity_ui default:20
		color2 type:#color ui:wwmt_color2_ui default:(Color 240 110 0)
		color2_intensity type:#integer ui:wwmt_color2_intensity_ui default:20
		fadein type:#string ui:wwmt_fadein_ui default:"1.5"
		fadeout type:#string ui:wwmt_fadeout_ui default:"0.5"
		holdtime type:#string ui:wwmt_holdtime_ui default:"1.2"
		fxtime type:#string ui:wwmt_fxtime_ui default:"0.25"
		channel type:#string ui:wwmt_channel_ui default:"1"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "game_text"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_message_ui_label "Message Text (79 Char. Limit)" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_x_ui_label "X (0 - 1.0 = left to right) (-1 centers)" align:#left
		EditText wwmt_x_ui "" type:#string
		Label wwmt_y_ui_label "Y (0 - 1.0 = top to bottom) (-1 centers)" align:#left
		EditText wwmt_y_ui "" type:#string
		DropDownList wwmt_effect_ui "Text Effect" type:#string items:#("Fade In/Out", "Credits", "Scan Out")
		on wwmt_effect_ui selected i do
		(
			effect = propMapeffect[i]
		)
		ColorPicker wwmt_color_ui "wwmt_color" color:(Color 100 100 100)
		Spinner wwmt_color_intensity_ui "Color1 Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for Color1"
		ColorPicker wwmt_color2_ui "color2" color:(Color 240 110 0)
		Spinner wwmt_color2_intensity_ui "Color2 Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for Color2"
		Label wwmt_fadein_ui_label "Fade in Time (or character scan time)" align:#left
		EditText wwmt_fadein_ui "" type:#string
		Label wwmt_fadeout_ui_label "Fade Out Time" align:#left
		EditText wwmt_fadeout_ui "" type:#string
		Label wwmt_holdtime_ui_label "Hold Time" align:#left
		EditText wwmt_holdtime_ui "" type:#string
		Label wwmt_fxtime_ui_label "Scan time (scan effect only)" align:#left
		EditText wwmt_fxtime_ui "" type:#string
		ComboBox wwmt_channel_ui "Text Channel" type:#string items:#("Channel 1", "Channel 2", "Channel 3", "Channel 4") height:3
		on wwmt_channel_ui selected i do
		(
			channel = propMapchannel[i]
		)
		on wwmt_channel_ui entered tex do
		(
			channel = trimLeft(trimRight(tex))
			if propMapchannel != undefined AND findItem propMapchannel tex == 0 then
			(
				append propMapchannel tex
				sort propMapchannel
				wwmt_channel_ui.items = propMapchannel
				wwmt_channel_ui.selection = findItem wwmt_channel_ui.items tex
			)
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "All Players" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=game_text&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: game_text" address:"https://developer.valvesoftware.com/wiki/game_text?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if effect != undefined then
			(
				if findItem propMapeffect effect == 0 then
				(
					append propMapeffect effect
					local tmp = wwmt_effect_ui.items
					append tmp effect
					wwmt_effect_ui.items = tmp
					wwmt_effect_ui.selection = propMapeffect.count
				)
				else
				(
					wwmt_effect_ui.selection = (findItem propMapeffect effect)
				)
			)
			if channel != undefined then
			(
				if findItem propMapchannel channel == 0 then
				(
					append propMapchannel channel
					local tmp = wwmt_channel_ui.items
					append tmp channel
					wwmt_channel_ui.items = tmp
					wwmt_channel_ui.selection = propMapchannel.count
				)
				else
				(
					wwmt_channel_ui.selection = (findItem propMapchannel channel)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_game_zone_player_CA = attributes "WW Entity game_zone_player" version: 78 attribID:#(-233839832L,-892536155L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "game_zone_player"
	local isWWPRO = true
	local description = "Player Zone brush"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "intarget", "outtarget", "incount", "outcount")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		intarget type:#string ui:wwmt_intarget_ui
		outtarget type:#string ui:wwmt_outtarget_ui
		incount type:#string ui:wwmt_incount_ui
		outcount type:#string ui:wwmt_outcount_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "game_zone_player"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_intarget_ui_label "Target for IN players" align:#left
		EditText wwmt_intarget_ui "" type:#string
		PickButton wwmt_intarget_pickme_ui "Pick Target for IN players" message:"Pick Target Entity for Target for IN players" filter:target_name_filter
		on wwmt_intarget_pickme_ui picked obj do
		(
			intarget = obj.targetname
		)
		Label wwmt_outtarget_ui_label "Target for OUT players" align:#left
		EditText wwmt_outtarget_ui "" type:#string
		PickButton wwmt_outtarget_pickme_ui "Pick Target for OUT players" message:"Pick Target Entity for Target for OUT players" filter:target_name_filter
		on wwmt_outtarget_pickme_ui picked obj do
		(
			outtarget = obj.targetname
		)
		Label wwmt_incount_ui_label "Counter for IN players" align:#left
		EditText wwmt_incount_ui "" type:#string
		PickButton wwmt_incount_pickme_ui "Pick Counter for IN players" message:"Pick Target Entity for Counter for IN players" filter:target_name_filter
		on wwmt_incount_pickme_ui picked obj do
		(
			incount = obj.targetname
		)
		Label wwmt_outcount_ui_label "Counter for OUT players" align:#left
		EditText wwmt_outcount_ui "" type:#string
		PickButton wwmt_outcount_pickme_ui "Pick Counter for OUT players" message:"Pick Target Entity for Counter for OUT players" filter:target_name_filter
		on wwmt_outcount_pickme_ui picked obj do
		(
			outcount = obj.targetname
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with game_zone_player" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"game_zone_player_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=game_zone_player&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: game_zone_player" address:"https://developer.valvesoftware.com/wiki/game_zone_player?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_gibshooter_CA = attributes "WW Entity gibshooter" version: 78 attribID:#(-555789597L,1601805079L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "gibshooter"
	local isWWPRO = true
	local description = "Gib Shooter"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "m_iGibs", "delay", "m_flVelocity", "m_flVariance", "m_flGibLife")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/gib.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		m_iGibs type:#integer ui:wwmt_m_iGibs_ui default:3
		delay type:#string ui:wwmt_delay_ui default:"0"
		m_flVelocity type:#integer ui:wwmt_m_flVelocity_ui default:200
		m_flVariance type:#string ui:wwmt_m_flVariance_ui default:"0.15"
		m_flGibLife type:#string ui:wwmt_m_flGibLife_ui default:"4"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "gibshooter"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Spinner wwmt_m_iGibs_ui "Number of Gibs" type:#integer range:[-10000, 10000, 3]
		Label wwmt_delay_ui_label "Delay between shots" align:#left
		EditText wwmt_delay_ui "" type:#string
		Spinner wwmt_m_flVelocity_ui "Gib Velocity" type:#integer range:[-10000, 10000, 200]
		Label wwmt_m_flVariance_ui_label "Course Variance" align:#left
		EditText wwmt_m_flVariance_ui "" type:#string
		Label wwmt_m_flGibLife_ui_label "Gib Life" align:#left
		EditText wwmt_m_flGibLife_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Repeatable" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=gibshooter&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: gibshooter" address:"https://developer.valvesoftware.com/wiki/gibshooter?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_hostage_entity_CA = attributes "WW Entity hostage_entity" version: 78 attribID:#(-1523082217L,529278052L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "hostage_entity"
	local isWWPRO = true
	local description = "Hostage"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("angles", "renderfx", "rendermode", "renderamt", "rendercolor", "model", "skin", "body")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/Hostage.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	function target_wwmt_filter obj =
	(
		if ((isProperty obj #wwmt_ca OR isProperty obj #wallwormProxy) AND isProperty obj #wallworm) then
		(
			true
		)
		else
		(
			false
		)
	)
	local propValskin = 0
	local propMapskin = #("0", "1")
	local propValbody = 0
	local propMapbody = #("-1", "0", "1", "2", "3", "4")
	parameters main rollout:params
	(
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		model type:#string ui:wwmt_model_ui default:"models/hostage.mdl"
		skin type:#string ui:wwmt_skin_ui default:"0"
		body type:#string ui:wwmt_body_ui default:"0"
		spawnflags type:#integer default:0
		on skin set val do
		(
			getNode()
			if (isValidNode thisNode AND classof thisNode != ::WallWormMDL AND val != undefined) then
			(
				if ::WallWormHelperOps != undefined then
				(
					::WallWormHelperOps.setProxySkin thisNode  val
				)
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "hostage_entity"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_model_ui_label "Model" align:#left
		EditText wwmt_model_ui "" type:#string
		PickButton wwmt_model_pickwwmt_ui "wwmt" align:#left across:3 message:"Pick WWMT OR Proxy from scene Model" filter:target_wwmt_filter tooltip:"Create a proxy from a model in the scene."
		on wwmt_model_pickwwmt_ui picked obj do
		(
			local wwmt = obj.getWWMT()
			if wwmt != undefined AND (getNode()) != undefined then
			(
				wwmt.updateObjectAsProxy thisNode useRotation:false
			)
		)
		Button wwmt_model_importwmt_ui "import" tooltip:"Import a QC AND create a proxy."
		on wwmt_model_importwmt_ui pressed do with undo label:"Import QC" on
		(
			::wallworm_import_qc_from_filename
			if ::wallworm_import_qc_from_filename == undefined then
			(
				fileIn (::wallworm_installation_path + "/WallWorm.com/importers/Mario_Kart_SMD_Importer.ms")
			)
			local fsource = GetOpenFileName historyCategory:"Wall Worm SMD Exporter" types: "QC File (*.qc)|*.QC|All files (*.*)|*.*|"
			if fsource != undefined AND wallworm_import_qc_from_filename != undefined then
			(
				wwmt = ::wallworm_import_qc_from_filename fsource saveToLib:true tnoVMF:true skipLODS:true deepSearchMaterials:false
				if wwmt != undefined then
				(
					if (getNode()) != undefined then
					(
						wwmt.updateObjectAsProxy thisNode
					)
				)
			)
		)
		Button wwmt_model_libwmt_ui "library" tooltip:"Use a prop in the prop library. Right-click to load the mesh rotated 90 degrees."
		on wwmt_model_libwmt_ui pressed do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:false
		)
		on wwmt_model_libwmt_ui rightClick do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:true
		)
		DropDownList wwmt_skin_ui "Skin" type:#string items:#("Orange Suit Worker", "Shirt & Tie")
		on wwmt_skin_ui selected i do
		(
			skin = propMapskin[i]
		)
		ComboBox wwmt_body_ui "Body type if scientist model" type:#string items:#("random", "default none", "einstien", "negro", "caucasian", "glasses") height:3
		on wwmt_body_ui selected i do
		(
			body = propMapbody[i]
		)
		on wwmt_body_ui entered tex do
		(
			body = trimLeft(trimRight(tex))
			if propMapbody != undefined AND findItem propMapbody tex == 0 then
			(
				append propMapbody tex
				sort propMapbody
				wwmt_body_ui.items = propMapbody
				wwmt_body_ui.selection = findItem wwmt_body_ui.items tex
			)
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=hostage_entity&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: hostage_entity" address:"https://developer.valvesoftware.com/wiki/hostage_entity?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if skin != undefined then
			(
				if findItem propMapskin skin == 0 then
				(
					append propMapskin skin
					local tmp = wwmt_skin_ui.items
					append tmp skin
					wwmt_skin_ui.items = tmp
					wwmt_skin_ui.selection = propMapskin.count
				)
				else
				(
					wwmt_skin_ui.selection = (findItem propMapskin skin)
				)
			)
			if body != undefined then
			(
				if findItem propMapbody body == 0 then
				(
					append propMapbody body
					local tmp = wwmt_body_ui.items
					append tmp body
					wwmt_body_ui.items = tmp
					wwmt_body_ui.selection = propMapbody.count
				)
				else
				(
					wwmt_body_ui.selection = (findItem propMapbody body)
				)
			)
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_bomb_target_CA = attributes "WW Entity info_bomb_target" version: 78 attribID:#(-946088943L,-97655604L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_bomb_target"
	local isWWPRO = true
	local description = "Bomb target point"
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/BombTarget.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function resetThis = (thisNode = undefined)
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_compile_parameters_CA = attributes "WW Entity info_compile_parameters" version: 78 attribID:#(-2102317035L,431232886L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_compile_parameters"
	local isWWPRO = true
	local description = "Compile Options"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("texdata", "estimate", "bounce", "ambient", "smooth", "dscale", "chop", "texchop", "hullfile")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/MapParams.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValestimate = 0
	local propMapestimate = #("0", "1")
	parameters main rollout:params
	(
		texdata type:#string ui:wwmt_texdata_ui default:"4096"
		estimate type:#string ui:wwmt_estimate_ui default:"0"
		bounce type:#integer ui:wwmt_bounce_ui default:0
		ambient type:#string ui:wwmt_ambient_ui default:"0 0 0"
		smooth type:#integer ui:wwmt_smooth_ui default:0
		dscale type:#integer ui:wwmt_dscale_ui default:1
		chop type:#integer ui:wwmt_chop_ui default:64
		texchop type:#integer ui:wwmt_texchop_ui default:32
		hullfile type:#string ui:wwmt_hullfile_ui
		spawnflags type:#integer default:2337
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "info_compile_parameters"
		Label wwmt_texdata_ui_label "Texture Data Memory" align:#left
		EditText wwmt_texdata_ui "" type:#string
		DropDownList wwmt_estimate_ui "Estimate Compile Times?" type:#string items:#("Yes", "No")
		on wwmt_estimate_ui selected i do
		(
			estimate = propMapestimate[i]
		)
		Label wwmt_label_bounce_ui "Number of radiosity bounces" align:#left
		Spinner wwmt_bounce_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_ambient_ui_label "Ambient world light (0.0 to 1.0, R G B)" align:#left
		EditText wwmt_ambient_ui "" type:#string
		Label wwmt_label_smooth_ui "Smoothing threshold (in degrees)" align:#left
		Spinner wwmt_smooth_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_dscale_ui "Direct Lighting Scale" align:#left
		Spinner wwmt_dscale_ui "" type:#integer range:[-10000, 10000, 1]
		Spinner wwmt_chop_ui "Chop Size" type:#integer range:[-10000, 10000, 64]
		Label wwmt_label_texchop_ui "Texture Light Chop Size" align:#left
		Spinner wwmt_texchop_ui "" type:#integer range:[-10000, 10000, 32]
		Label wwmt_hullfile_ui_label "Custom Hullfile" align:#left
		EditText wwmt_hullfile_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			if params.flag_512_ui.checked == true then
			(
				sfs += 512
			)
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			if params.flag_4096_ui.checked == true then
			(
				sfs += 4096
			)
			if params.flag_8192_ui.checked == true then
			(
				sfs += 8192
			)
			if params.flag_16384_ui.checked == true then
			(
				sfs += 16384
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Run CSG" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "  No Clip" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "  Only Ents" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "  No Sky Clip" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Run BSP" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "  Leak Only" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "  No Clip" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Run VIS" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_512_ui "  Fast   " type:#integer
			on flag_512_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2048_ui "Run RAD" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4096_ui "  Sparse     " type:#integer
			on flag_4096_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8192_ui "  Circus Mode" type:#integer
			on flag_8192_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16384_ui "  Extra Mode " type:#integer
			on flag_16384_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_compile_parameters&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: info_compile_parameters" address:"https://developer.valvesoftware.com/wiki/info_compile_parameters?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if estimate != undefined then
			(
				if findItem propMapestimate estimate == 0 then
				(
					append propMapestimate estimate
					local tmp = wwmt_estimate_ui.items
					append tmp estimate
					wwmt_estimate_ui.items = tmp
					wwmt_estimate_ui.selection = propMapestimate.count
				)
				else
				(
					wwmt_estimate_ui.selection = (findItem propMapestimate estimate)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			flag_512_ui.checked = (bit.and (getProperty this #spawnflags) 512 == 512)
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
			flag_4096_ui.checked = (bit.and (getProperty this #spawnflags) 4096 == 4096)
			flag_8192_ui.checked = (bit.and (getProperty this #spawnflags) 8192 == 8192)
			flag_16384_ui.checked = (bit.and (getProperty this #spawnflags) 16384 == 16384)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_hostage_rescue_CA = attributes "WW Entity info_hostage_rescue" version: 78 attribID:#(1332759817L,1774392075L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_hostage_rescue"
	local isWWPRO = true
	local description = "Hostage rescue point"
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/HostageRescue.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function resetThis = (thisNode = undefined)
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_lights_rad_CA = attributes "WW Entity info_lights_rad" version: 78 attribID:#(-1355831292L,1281714000L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_lights_rad"
	local isWWPRO = true
	local description = "Lights RAD Override"
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function resetThis = (thisNode = undefined)
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_map_parameters_CA = attributes "WW Entity info_map_parameters" version: 78 attribID:#(-939136664L,877801146L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_map_parameters"
	local isWWPRO = true
	local description = "Miscellaneous mapping parameters"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("buying", "bombradius")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/MapParams.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValbuying = 0
	local propMapbuying = #("0", "1", "2", "3")
	parameters main rollout:params
	(
		buying type:#string ui:wwmt_buying_ui default:"0"
		bombradius type:#integer ui:wwmt_bombradius_ui default:500
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "info_map_parameters"
		ComboBox wwmt_buying_ui "Weapon_Buying" type:#string items:#("Both teams can buy guns", "Only CT's can buy guns", "Only T's can buy guns", "Neither CT's nor T's can buy guns") height:3
		on wwmt_buying_ui selected i do
		(
			buying = propMapbuying[i]
		)
		on wwmt_buying_ui entered tex do
		(
			buying = trimLeft(trimRight(tex))
			if propMapbuying != undefined AND findItem propMapbuying tex == 0 then
			(
				append propMapbuying tex
				sort propMapbuying
				wwmt_buying_ui.items = propMapbuying
				wwmt_buying_ui.selection = findItem wwmt_buying_ui.items tex
			)
		)
		Spinner wwmt_bombradius_ui "Bomb Radius" type:#integer range:[-10000, 10000, 500]
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_map_parameters&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: info_map_parameters" address:"https://developer.valvesoftware.com/wiki/info_map_parameters?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if buying != undefined then
			(
				if findItem propMapbuying buying == 0 then
				(
					append propMapbuying buying
					local tmp = wwmt_buying_ui.items
					append tmp buying
					wwmt_buying_ui.items = tmp
					wwmt_buying_ui.selection = propMapbuying.count
				)
				else
				(
					wwmt_buying_ui.selection = (findItem propMapbuying buying)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_null_CA = attributes "WW Entity info_null" version: 78 attribID:#(-1502854914L,-911961274L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_null"
	local isWWPRO = true
	local description = "info_null (spotlight target)"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/EnvTarget.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "info_null"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_null&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: info_null" address:"https://developer.valvesoftware.com/wiki/info_null?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_player_deathmatch_CA = attributes "WW Entity info_player_deathmatch" version: 78 attribID:#(2136950434L,-1255139572L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_player_deathmatch"
	local isWWPRO = true
	local description = "Terrorist start"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("angles")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/Terrorist.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "info_player_deathmatch"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_player_deathmatch&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: info_player_deathmatch" address:"https://developer.valvesoftware.com/wiki/info_player_deathmatch?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_player_start_CA = attributes "WW Entity info_player_start" version: 78 attribID:#(1951066434L,747920517L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_player_start"
	local isWWPRO = true
	local description = "Counter-terrorist start"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("angles")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/CT.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "info_player_start"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_player_start&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: info_player_start" address:"https://developer.valvesoftware.com/wiki/info_player_start?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_target_CA = attributes "WW Entity info_target" version: 78 attribID:#(-1315297783L,1081251833L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_target"
	local isWWPRO = true
	local description = "Beam Target"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local entcolor = (Color 200 100 50)
	local iconsprite = "sprites/CS/EnvTarget.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "info_target"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_target&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: info_target" address:"https://developer.valvesoftware.com/wiki/info_target?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_teleport_destination_CA = attributes "WW Entity info_teleport_destination" version: 78 attribID:#(490295984L,2021799711L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_teleport_destination"
	local isWWPRO = true
	local description = "Teleport destination"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "info_teleport_destination"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_teleport_destination&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: info_teleport_destination" address:"https://developer.valvesoftware.com/wiki/info_teleport_destination?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_vip_start_CA = attributes "WW Entity info_vip_start" version: 78 attribID:#(1420106230L,-790477345L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_vip_start"
	local isWWPRO = true
	local description = "VIP start"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("angles")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/VIP.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "info_vip_start"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_vip_start&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: info_vip_start" address:"https://developer.valvesoftware.com/wiki/info_vip_start?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_infodecal_CA = attributes "WW Entity infodecal" version: 78 attribID:#(-1502854914L,-374486733L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "infodecal"
	local isWWPRO = true
	local description = "Decal"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "texture")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		texture type:#string ui:wwmt_texture_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "infodecal"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_texture_ui_label "" align:#left
		EditText wwmt_texture_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=infodecal&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: infodecal" address:"https://developer.valvesoftware.com/wiki/infodecal?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_item_battery_CA = attributes "WW Entity item_battery" version: 78 attribID:#(340197068L,-1998964669L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "item_battery"
	local isWWPRO = true
	local description = "HEV battery"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "wwmt_target", "delay", "killtarget", "renderfx", "rendermode", "renderamt", "rendercolor")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "item_battery"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=item_battery&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: item_battery" address:"https://developer.valvesoftware.com/wiki/item_battery?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_item_healthkit_CA = attributes "WW Entity item_healthkit" version: 78 attribID:#(-541323401L,-1264575305L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "item_healthkit"
	local isWWPRO = true
	local description = "Small Health Kit"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "wwmt_target", "delay", "killtarget", "renderfx", "rendermode", "renderamt", "rendercolor")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "item_healthkit"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=item_healthkit&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: item_healthkit" address:"https://developer.valvesoftware.com/wiki/item_healthkit?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_item_longjump_CA = attributes "WW Entity item_longjump" version: 78 attribID:#(-110141626L,-851712060L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "item_longjump"
	local isWWPRO = true
	local description = "Longjump Module"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "wwmt_target", "delay", "killtarget", "renderfx", "rendermode", "renderamt", "rendercolor")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "item_longjump"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=item_longjump&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: item_longjump" address:"https://developer.valvesoftware.com/wiki/item_longjump?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_light_CA = attributes "WW Entity light" version: 78 attribID:#(334115653L,1905882967L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "light"
	local isWWPRO = true
	local description = "Invisible lightsource"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "_light", "style", "pattern", "_fade", "_falloff")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/lightbulb.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValstyle = 0
	local propMapstyle = #("0", "2", "5", "1", "6", "3", "7", "8", "4", "9", "10", "11")
	local propVal_falloff = 0
	local propMap_falloff = #("0", "1", "2")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		_light type:#color ui:wwmt__light_ui default:(Color 255 255 255)
		_light_intensity type:#integer ui:wwmt__light_intensity_ui default:200
		style type:#string ui:wwmt_style_ui default:"0"
		pattern type:#string ui:wwmt_pattern_ui
		_fade type:#string ui:wwmt__fade_ui default:"1.0"
		_falloff type:#string ui:wwmt__falloff_ui default:"0"
		spawnflags type:#integer default:0
		on _light set val do
		(
			if (val != undefined) AND (isValidNode (getNode())) AND (isProperty thisNode #color) then
			(
				thisNode.color = _light
			)
		)
		on _light_intensity set val do
		(
			if (val != undefined) AND (isValidNode (getNode())) AND (isProperty thisNode #multiplier) then
			(
				if ::WallWormHelperOps != undefined then ::WallWormHelperOps.setLightMultiplier thisNode val
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "light"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		ColorPicker wwmt__light_ui "_light" color:(Color 255 255 255)
		Spinner wwmt__light_intensity_ui "Brightness Intensity" type:#integer range:[-16000, 16000, 200] tooltip:"Intensity for Brightness"
		ComboBox wwmt_style_ui "Appearance (no name allowed)" type:#string items:#("Normal", "Slow, strong pulse", "Gentle pulse", "Flicker A", "Flicker B", "Candle A", "Candle B", "Candle C", "Fast strobe", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_pattern_ui_label "Custom Appearance" align:#left
		EditText wwmt_pattern_ui "" type:#string
		Label wwmt__fade_ui_label "Fade (ZHLT Only)" align:#left
		EditText wwmt__fade_ui "" type:#string
		DropDownList wwmt__falloff_ui "Falloff (ZHLT Only)" type:#string items:#("Default", "Inverse Linear", "Inverse Square")
		on wwmt__falloff_ui selected i do
		(
			_falloff = propMap_falloff[i]
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Initially dark" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=light&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: light" address:"https://developer.valvesoftware.com/wiki/light?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			if _falloff != undefined then
			(
				if findItem propMap_falloff _falloff == 0 then
				(
					append propMap_falloff _falloff
					local tmp = wwmt__falloff_ui.items
					append tmp _falloff
					wwmt__falloff_ui.items = tmp
					wwmt__falloff_ui.selection = propMap_falloff.count
				)
				else
				(
					wwmt__falloff_ui.selection = (findItem propMap_falloff _falloff)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_light_environment_CA = attributes "WW Entity light_environment" version: 78 attribID:#(1044210184L,-888099970L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "light_environment"
	local isWWPRO = true
	local description = "Environment"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "_light", "style", "pattern", "_fade", "_falloff", "angles", "pitch", "_diffuse_light")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/LightEnvironment.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValstyle = 0
	local propMapstyle = #("0", "2", "5", "1", "6", "3", "7", "8", "4", "9", "10", "11")
	local propVal_falloff = 0
	local propMap_falloff = #("0", "1", "2")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		_light type:#color ui:wwmt__light_ui default:(Color 255 255 255)
		_light_intensity type:#integer ui:wwmt__light_intensity_ui default:200
		style type:#string ui:wwmt_style_ui default:"0"
		pattern type:#string ui:wwmt_pattern_ui
		_fade type:#string ui:wwmt__fade_ui default:"1.0"
		_falloff type:#string ui:wwmt__falloff_ui default:"0"
		angles type:#string ui:wwmt_angles_ui default:"0 270 0"
		pitch type:#float ui:wwmt_pitch_ui default:-90
		_diffuse_light type:#color ui:wwmt__diffuse_light_ui default:(Color 255 255 128)
		_diffuse_light_intensity type:#integer ui:wwmt__diffuse_light_intensity_ui default:200
		spawnflags type:#integer default:0
		on _light set val do
		(
			if (val != undefined) AND (isValidNode (getNode())) AND (isProperty thisNode #color) then
			(
				thisNode.color = _light
			)
		)
		on _light_intensity set val do
		(
			if (val != undefined) AND (isValidNode (getNode())) AND (isProperty thisNode #multiplier) then
			(
				if ::WallWormHelperOps != undefined then ::WallWormHelperOps.setLightMultiplier thisNode val
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "light_environment"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		ColorPicker wwmt__light_ui "_light" color:(Color 255 255 255)
		Spinner wwmt__light_intensity_ui "Brightness Intensity" type:#integer range:[-16000, 16000, 200] tooltip:"Intensity for Brightness"
		ComboBox wwmt_style_ui "Appearance (no name allowed)" type:#string items:#("Normal", "Slow, strong pulse", "Gentle pulse", "Flicker A", "Flicker B", "Candle A", "Candle B", "Candle C", "Fast strobe", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_pattern_ui_label "Custom Appearance" align:#left
		EditText wwmt_pattern_ui "" type:#string
		Label wwmt__fade_ui_label "Fade (ZHLT Only)" align:#left
		EditText wwmt__fade_ui "" type:#string
		DropDownList wwmt__falloff_ui "Falloff (ZHLT Only)" type:#string items:#("Default", "Inverse Linear", "Inverse Square")
		on wwmt__falloff_ui selected i do
		(
			_falloff = propMap_falloff[i]
		)
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Spinner wwmt_pitch_ui "Pitch" type:#float scale:1.0 range:[-10000, 10000, -90]
		ColorPicker wwmt__diffuse_light_ui "_diffuse_light" color:(Color 255 255 128)
		Spinner wwmt__diffuse_light_intensity_ui "Shade Intensity" type:#integer range:[-16000, 16000, 200] tooltip:"Intensity for Shade"
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Initially dark" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=light_environment&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: light_environment" address:"https://developer.valvesoftware.com/wiki/light_environment?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			if _falloff != undefined then
			(
				if findItem propMap_falloff _falloff == 0 then
				(
					append propMap_falloff _falloff
					local tmp = wwmt__falloff_ui.items
					append tmp _falloff
					wwmt__falloff_ui.items = tmp
					wwmt__falloff_ui.selection = propMap_falloff.count
				)
				else
				(
					wwmt__falloff_ui.selection = (findItem propMap_falloff _falloff)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_light_spot_CA = attributes "WW Entity light_spot" version: 78 attribID:#(109618542L,163636283L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "light_spot"
	local isWWPRO = true
	local description = "Spotlight"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "angles", "_light", "style", "pattern", "_fade", "_falloff", "pitch", "_cone", "_cone2", "_sky")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/LightSpot.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValstyle = 0
	local propMapstyle = #("0", "2", "5", "1", "6", "3", "7", "8", "4", "9", "10", "11")
	local propVal_falloff = 0
	local propMap_falloff = #("0", "1", "2")
	local propVal_sky = 0
	local propMap_sky = #("0", "1")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		_light type:#color ui:wwmt__light_ui default:(Color 255 255 255)
		_light_intensity type:#integer ui:wwmt__light_intensity_ui default:200
		style type:#string ui:wwmt_style_ui default:"0"
		pattern type:#string ui:wwmt_pattern_ui
		_fade type:#string ui:wwmt__fade_ui default:"1.0"
		_falloff type:#string ui:wwmt__falloff_ui default:"0"
		pitch type:#float ui:wwmt_pitch_ui default:-90
		_cone type:#integer ui:wwmt__cone_ui default:30
		_cone2 type:#integer ui:wwmt__cone2_ui default:45
		_sky type:#string ui:wwmt__sky_ui default:"0"
		spawnflags type:#integer default:0
		on _light set val do
		(
			if (val != undefined) AND (isValidNode (getNode())) AND (isProperty thisNode #color) then
			(
				thisNode.color = _light
			)
		)
		on _light_intensity set val do
		(
			if (val != undefined) AND (isValidNode (getNode())) AND (isProperty thisNode #multiplier) then
			(
				if ::WallWormHelperOps != undefined then ::WallWormHelperOps.setLightMultiplier thisNode val
			)
		)
		on _cone set val do
		(
			if (val != undefined AND val as Integer != undefined) AND (getNode()) != undefined AND (isProperty thisNode #falloff) then
			(
				thisNode.falloff = (_cone as Float) * 2.0
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "light_spot"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ColorPicker wwmt__light_ui "_light" color:(Color 255 255 255)
		Spinner wwmt__light_intensity_ui "Brightness Intensity" type:#integer range:[-16000, 16000, 200] tooltip:"Intensity for Brightness"
		ComboBox wwmt_style_ui "Appearance (no name allowed)" type:#string items:#("Normal", "Slow, strong pulse", "Gentle pulse", "Flicker A", "Flicker B", "Candle A", "Candle B", "Candle C", "Fast strobe", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_pattern_ui_label "Custom Appearance" align:#left
		EditText wwmt_pattern_ui "" type:#string
		Label wwmt__fade_ui_label "Fade (ZHLT Only)" align:#left
		EditText wwmt__fade_ui "" type:#string
		DropDownList wwmt__falloff_ui "Falloff (ZHLT Only)" type:#string items:#("Default", "Inverse Linear", "Inverse Square")
		on wwmt__falloff_ui selected i do
		(
			_falloff = propMap_falloff[i]
		)
		Spinner wwmt_pitch_ui "Pitch" type:#float scale:1.0 range:[-10000, 10000, -90]
		Label wwmt_label__cone_ui "Inner (bright) angle" align:#left
		Spinner wwmt__cone_ui "" type:#integer range:[-10000, 10000, 30]
		Label wwmt_label__cone2_ui "Outer (fading) angle" align:#left
		Spinner wwmt__cone2_ui "" type:#integer range:[-10000, 10000, 45]
		DropDownList wwmt__sky_ui "Is Sky" type:#string items:#("No", "Yes")
		on wwmt__sky_ui selected i do
		(
			_sky = propMap_sky[i]
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Initially dark" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=light_spot&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: light_spot" address:"https://developer.valvesoftware.com/wiki/light_spot?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			if _falloff != undefined then
			(
				if findItem propMap_falloff _falloff == 0 then
				(
					append propMap_falloff _falloff
					local tmp = wwmt__falloff_ui.items
					append tmp _falloff
					wwmt__falloff_ui.items = tmp
					wwmt__falloff_ui.selection = propMap_falloff.count
				)
				else
				(
					wwmt__falloff_ui.selection = (findItem propMap_falloff _falloff)
				)
			)
			if _sky != undefined then
			(
				if findItem propMap_sky _sky == 0 then
				(
					append propMap_sky _sky
					local tmp = wwmt__sky_ui.items
					append tmp _sky
					wwmt__sky_ui.items = tmp
					wwmt__sky_ui.selection = propMap_sky.count
				)
				else
				(
					wwmt__sky_ui.selection = (findItem propMap_sky _sky)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_multi_manager_CA = attributes "WW Entity multi_manager" version: 78 attribID:#(1422438612L,-129794957L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "multi_manager"
	local isWWPRO = true
	local description = "MultiTarget Manager"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local entcolor = (Color 255 128 0)
	local iconsprite = "sprites/CS/multi_manager.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "multi_manager"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "multithreaded" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=multi_manager&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: multi_manager" address:"https://developer.valvesoftware.com/wiki/multi_manager?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_multisource_CA = attributes "WW Entity multisource" version: 78 attribID:#(-1295099135L,-83792495L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "multisource"
	local isWWPRO = true
	local description = "Multisource"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "globalstate")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local entcolor = (Color 128 255 128)
	local iconsprite = "sprites/CS/MultiSource.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		globalstate type:#string ui:wwmt_globalstate_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "multisource"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_globalstate_ui_label "Global State Master" align:#left
		EditText wwmt_globalstate_ui "" type:#string
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=multisource&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: multisource" address:"https://developer.valvesoftware.com/wiki/multisource?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_path_corner_CA = attributes "WW Entity path_corner" version: 78 attribID:#(-1732129830L,272163135L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "path_corner"
	local isWWPRO = true
	local description = "Moving platform stop"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "wwmt_target", "message", "wait", "speed", "yaw_speed")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local entcolor = (Color 247 181 82)
	local iconsprite = "sprites/CS/PathCorner.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		wwmt_target type:#string ui:wwmt_target_ui
		message type:#string ui:wwmt_message_ui
		wait type:#integer ui:wwmt_wait_ui default:0
		speed type:#integer ui:wwmt_speed_ui default:0
		yaw_speed type:#integer ui:wwmt_yaw_speed_ui default:0
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "path_corner"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_target_ui_label "Next stop target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Next stop target" message:"Pick Target Entity for Next stop target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_message_ui_label "Fire On Pass" align:#left
		EditText wwmt_message_ui "" type:#string
		PickButton wwmt_message_pickme_ui "Pick Fire On Pass" message:"Pick Target Entity for Fire On Pass" filter:target_name_filter
		on wwmt_message_pickme_ui picked obj do
		(
			message = obj.targetname
		)
		Label wwmt_label_wait_ui "Wait here (secs)" align:#left
		Spinner wwmt_wait_ui "" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt_speed_ui "New Train Speed" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_yaw_speed_ui "New Train rot. Speed" align:#left
		Spinner wwmt_yaw_speed_ui "" type:#integer range:[-10000, 10000, 0]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Wait for retrigger" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Teleport to next corner" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Fire once" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=path_corner&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: path_corner" address:"https://developer.valvesoftware.com/wiki/path_corner?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_path_track_CA = attributes "WW Entity path_track" version: 78 attribID:#(-1732129830L,-1946943073L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "path_track"
	local isWWPRO = true
	local description = "Train Track Path"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "message", "altpath", "netname", "speed")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/PathCorner.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		message type:#string ui:wwmt_message_ui
		altpath type:#string ui:wwmt_altpath_ui
		netname type:#string ui:wwmt_netname_ui
		speed type:#integer ui:wwmt_speed_ui default:0
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "path_track"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Next stop target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Next stop target" message:"Pick Target Entity for Next stop target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_message_ui_label "Fire On Pass" align:#left
		EditText wwmt_message_ui "" type:#string
		PickButton wwmt_message_pickme_ui "Pick Fire On Pass" message:"Pick Target Entity for Fire On Pass" filter:target_name_filter
		on wwmt_message_pickme_ui picked obj do
		(
			message = obj.targetname
		)
		Label wwmt_altpath_ui_label "Branch Path" align:#left
		EditText wwmt_altpath_ui "" type:#string
		PickButton wwmt_altpath_pickme_ui "Pick Branch Path" message:"Pick Target Entity for Branch Path" filter:target_name_filter
		on wwmt_altpath_pickme_ui picked obj do
		(
			altpath = obj.targetname
		)
		Label wwmt_netname_ui_label "Fire on dead end" align:#left
		EditText wwmt_netname_ui "" type:#string
		PickButton wwmt_netname_pickme_ui "Pick Fire on dead end" message:"Pick Target Entity for Fire on dead end" filter:target_name_filter
		on wwmt_netname_pickme_ui picked obj do
		(
			netname = obj.targetname
		)
		Spinner wwmt_speed_ui "New Train Speed" type:#integer range:[-10000, 10000, 0]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Disabled" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Fire once" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Branch Reverse" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Disable train" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=path_track&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: path_track" address:"https://developer.valvesoftware.com/wiki/path_track?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_player_weaponstrip_CA = attributes "WW Entity player_weaponstrip" version: 78 attribID:#(-1861946124L,-619340136L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "player_weaponstrip"
	local isWWPRO = true
	local description = "Strips player's weapons"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/PlayerWeaponStrip.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "player_weaponstrip"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=player_weaponstrip&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: player_weaponstrip" address:"https://developer.valvesoftware.com/wiki/player_weaponstrip?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_monster_scientist_CA = attributes "WW Entity monster_scientist" version: 78 attribID:#(1001138671L,-77518016L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "monster_scientist"
	local isWWPRO = true
	local description = "Scientist Hostage"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("angles", "renderfx", "rendermode", "renderamt", "rendercolor", "body")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/Hostage.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValbody = -1
	local propMapbody = #("-1", "0", "1", "2", "3")
	parameters main rollout:params
	(
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		body type:#string ui:wwmt_body_ui default:"-1"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "monster_scientist"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_body_ui "Body" type:#string items:#("Random", "Glasses", "Einstein", "Luther", "Slick") height:3
		on wwmt_body_ui selected i do
		(
			body = propMapbody[i]
		)
		on wwmt_body_ui entered tex do
		(
			body = trimLeft(trimRight(tex))
			if propMapbody != undefined AND findItem propMapbody tex == 0 then
			(
				append propMapbody tex
				sort propMapbody
				wwmt_body_ui.items = propMapbody
				wwmt_body_ui.selection = findItem wwmt_body_ui.items tex
			)
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=monster_scientist&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: monster_scientist" address:"https://developer.valvesoftware.com/wiki/monster_scientist?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if body != undefined then
			(
				if findItem propMapbody body == 0 then
				(
					append propMapbody body
					local tmp = wwmt_body_ui.items
					append tmp body
					wwmt_body_ui.items = tmp
					wwmt_body_ui.selection = propMapbody.count
				)
				else
				(
					wwmt_body_ui.selection = (findItem propMapbody body)
				)
			)
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_auto_CA = attributes "WW Entity trigger_auto" version: 78 attribID:#(-1618386072L,2134089762L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "trigger_auto"
	local isWWPRO = true
	local description = "AutoTrigger"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target", "delay", "killtarget", "globalstate", "triggerstate")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/TriggerAuto.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValtriggerstate = 0
	local propMaptriggerstate = #("0", "1", "2")
	parameters main rollout:params
	(
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		globalstate type:#string ui:wwmt_globalstate_ui
		triggerstate type:#string ui:wwmt_triggerstate_ui default:"0"
		spawnflags type:#integer default:1
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_auto"
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Label wwmt_globalstate_ui_label "Global State to Read" align:#left
		EditText wwmt_globalstate_ui "" type:#string
		DropDownList wwmt_triggerstate_ui "Trigger State" type:#string items:#("Off", "On", "Toggle")
		on wwmt_triggerstate_ui selected i do
		(
			triggerstate = propMaptriggerstate[i]
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Remove On fire" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_auto&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_auto" address:"https://developer.valvesoftware.com/wiki/trigger_auto?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if triggerstate != undefined then
			(
				if findItem propMaptriggerstate triggerstate == 0 then
				(
					append propMaptriggerstate triggerstate
					local tmp = wwmt_triggerstate_ui.items
					append tmp triggerstate
					wwmt_triggerstate_ui.items = tmp
					wwmt_triggerstate_ui.selection = propMaptriggerstate.count
				)
				else
				(
					wwmt_triggerstate_ui.selection = (findItem propMaptriggerstate triggerstate)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_camera_CA = attributes "WW Entity trigger_camera" version: 78 attribID:#(276153110L,1743274620L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "trigger_camera"
	local isWWPRO = true
	local description = "Trigger Camera"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "delay", "killtarget", "wait", "moveto", "speed", "acceleration", "deceleration")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/TriggerCamera.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		wait type:#integer ui:wwmt_wait_ui default:10
		moveto type:#string ui:wwmt_moveto_ui
		speed type:#string ui:wwmt_speed_ui default:"0"
		acceleration type:#string ui:wwmt_acceleration_ui default:"500"
		deceleration type:#string ui:wwmt_deceleration_ui default:"500"
		spawnflags type:#integer default:3
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_camera"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Spinner wwmt_wait_ui "Hold time" type:#integer range:[-10000, 10000, 10]
		Label wwmt_moveto_ui_label "Path Corner" align:#left
		EditText wwmt_moveto_ui "" type:#string
		Label wwmt_speed_ui_label "Initial Speed" align:#left
		EditText wwmt_speed_ui "" type:#string
		Label wwmt_acceleration_ui_label "Acceleration units/sec^2" align:#left
		EditText wwmt_acceleration_ui "" type:#string
		Label wwmt_deceleration_ui_label "Stop Deceleration units/sec^2" align:#left
		EditText wwmt_deceleration_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Start At Player" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Follow Player" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Freeze Player" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_camera&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_camera" address:"https://developer.valvesoftware.com/wiki/trigger_camera?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_changetarget_CA = attributes "WW Entity trigger_changetarget" version: 78 attribID:#(-1701943912L,279935596L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "trigger_changetarget"
	local isWWPRO = true
	local description = "Trigger Change Target"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "delay", "killtarget", "m_iszNewTarget")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/TriggerChangetarget.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		m_iszNewTarget type:#string ui:wwmt_m_iszNewTarget_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_changetarget"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Label wwmt_m_iszNewTarget_ui_label "New Target" align:#left
		EditText wwmt_m_iszNewTarget_ui "" type:#string
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_changetarget&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_changetarget" address:"https://developer.valvesoftware.com/wiki/trigger_changetarget?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_counter_CA = attributes "WW Entity trigger_counter" version: 78 attribID:#(276153110L,-1040629305L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "trigger_counter"
	local isWWPRO = true
	local description = "Trigger counter"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "wwmt_target", "delay", "killtarget", "netname", "sounds", "message", "count")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValsounds = 0
	local propMapsounds = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "14")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		netname type:#string ui:wwmt_netname_ui
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		message type:#string ui:wwmt_message_ui
		count type:#integer ui:wwmt_count_ui default:2
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_counter"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "Kill target" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick Kill target" message:"Pick Target Entity for Kill target" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Label wwmt_netname_ui_label "Target Path" align:#left
		EditText wwmt_netname_ui "" type:#string
		PickButton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter
		on wwmt_netname_pickme_ui picked obj do
		(
			netname = obj.targetname
		)
		ComboBox wwmt_sounds_ui "Sound style" type:#string items:#("No Sound, None", "Big zap & Warmup", "Access Denied", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Buzz Off", "Lightswitch") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		Label wwmt_message_ui_label "Message (set sound too)" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_label_count_ui "Count before activation" align:#left
		Spinner wwmt_count_ui "" type:#integer range:[-10000, 10000, 2]
		function addFlags =
		(
			local sfs = 0
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2_ui "No Players,entity only" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Pushables" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_1_ui "No Message" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with trigger_counter" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"trigger_counter_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_counter&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_counter" address:"https://developer.valvesoftware.com/wiki/trigger_counter?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_gravity_CA = attributes "WW Entity trigger_gravity" version: 78 attribID:#(276153110L,1571249033L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "trigger_gravity"
	local isWWPRO = true
	local description = "Trigger Gravity"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "wwmt_target", "delay", "killtarget", "netname", "sounds", "message", "gravity")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValsounds = 0
	local propMapsounds = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "14")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		netname type:#string ui:wwmt_netname_ui
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		message type:#string ui:wwmt_message_ui
		gravity type:#integer ui:wwmt_gravity_ui default:1
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_gravity"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "Kill target" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick Kill target" message:"Pick Target Entity for Kill target" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Label wwmt_netname_ui_label "Target Path" align:#left
		EditText wwmt_netname_ui "" type:#string
		PickButton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter
		on wwmt_netname_pickme_ui picked obj do
		(
			netname = obj.targetname
		)
		ComboBox wwmt_sounds_ui "Sound style" type:#string items:#("No Sound, None", "Big zap & Warmup", "Access Denied", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Buzz Off", "Lightswitch") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		Label wwmt_message_ui_label "Message (set sound too)" align:#left
		EditText wwmt_message_ui "" type:#string
		Spinner wwmt_gravity_ui "Gravity (0.0-1)" type:#integer range:[-10000, 10000, 1]
		function addFlags =
		(
			local sfs = 0
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2_ui "No Players,entity only" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Pushables" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with trigger_gravity" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"trigger_gravity_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_gravity&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_gravity" address:"https://developer.valvesoftware.com/wiki/trigger_gravity?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_hurt_CA = attributes "WW Entity trigger_hurt" version: 78 attribID:#(-1618386072L,1468683444L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "trigger_hurt"
	local isWWPRO = true
	local description = "Trigger player hurt"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "wwmt_target", "delay", "dmg", "damagetype")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValdamagetype = 0
	local propMapdamagetype = #("0", "1", "2", "4", "8", "16", "32", "64", "128", "256", "512", "1024", "16384", "32768", "65536", "131072", "262144", "524288", "1048576", "2097152", "4194304")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		dmg type:#integer ui:wwmt_dmg_ui default:10
		damagetype type:#string ui:wwmt_damagetype_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_hurt"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Spinner wwmt_dmg_ui "Damage" type:#integer range:[-10000, 10000, 10]
		ComboBox wwmt_damagetype_ui "Damage Type" type:#string items:#("GENERIC", "CRUSH", "BULLET", "SLASH", "BURN", "FREEZE", "FALL", "BLAST", "CLUB", "SHOCK", "SONIC", "ENERGYBEAM", "DROWN", "PARALYSE", "NERVEGAS", "POISON", "RADIATION", "DROWNRECOVER", "CHEMICAL", "SLOWBURN", "SLOWFREEZE") height:3
		on wwmt_damagetype_ui selected i do
		(
			damagetype = propMapdamagetype[i]
		)
		on wwmt_damagetype_ui entered tex do
		(
			damagetype = trimLeft(trimRight(tex))
			if propMapdamagetype != undefined AND findItem propMapdamagetype tex == 0 then
			(
				append propMapdamagetype tex
				sort propMapdamagetype
				wwmt_damagetype_ui.items = propMapdamagetype
				wwmt_damagetype_ui.selection = findItem wwmt_damagetype_ui.items tex
			)
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Target Once" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Start Off" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "FireClientOnly" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "TouchClientOnly" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with trigger_hurt" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"trigger_hurt_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_hurt&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_hurt" address:"https://developer.valvesoftware.com/wiki/trigger_hurt?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if damagetype != undefined then
			(
				if findItem propMapdamagetype damagetype == 0 then
				(
					append propMapdamagetype damagetype
					local tmp = wwmt_damagetype_ui.items
					append tmp damagetype
					wwmt_damagetype_ui.items = tmp
					wwmt_damagetype_ui.selection = propMapdamagetype.count
				)
				else
				(
					wwmt_damagetype_ui.selection = (findItem propMapdamagetype damagetype)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_multiple_CA = attributes "WW Entity trigger_multiple" version: 78 attribID:#(935655839L,-492899498L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "trigger_multiple"
	local isWWPRO = true
	local description = "Trigger: Activate multiple"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "wwmt_target", "delay", "killtarget", "netname", "sounds", "message", "wait")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValsounds = 0
	local propMapsounds = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "14")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		netname type:#string ui:wwmt_netname_ui
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		message type:#string ui:wwmt_message_ui
		wait type:#integer ui:wwmt_wait_ui default:10
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_multiple"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "Kill target" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick Kill target" message:"Pick Target Entity for Kill target" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Label wwmt_netname_ui_label "Target Path" align:#left
		EditText wwmt_netname_ui "" type:#string
		PickButton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter
		on wwmt_netname_pickme_ui picked obj do
		(
			netname = obj.targetname
		)
		ComboBox wwmt_sounds_ui "Sound style" type:#string items:#("No Sound, None", "Big zap & Warmup", "Access Denied", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Buzz Off", "Lightswitch") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		Label wwmt_message_ui_label "Message (set sound too)" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_label_wait_ui "Delay before reset" align:#left
		Spinner wwmt_wait_ui "" type:#integer range:[-10000, 10000, 10]
		function addFlags =
		(
			local sfs = 0
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2_ui "No Players,entity only" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Pushables" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with trigger_multiple" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"trigger_multiple_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_multiple&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_multiple" address:"https://developer.valvesoftware.com/wiki/trigger_multiple?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_once_CA = attributes "WW Entity trigger_once" version: 78 attribID:#(-1618386072L,-1287051376L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "trigger_once"
	local isWWPRO = true
	local description = "Trigger: Activate once"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "wwmt_target", "delay", "killtarget", "netname", "sounds", "message")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValsounds = 0
	local propMapsounds = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "14")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		netname type:#string ui:wwmt_netname_ui
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		message type:#string ui:wwmt_message_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_once"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "Kill target" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick Kill target" message:"Pick Target Entity for Kill target" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Label wwmt_netname_ui_label "Target Path" align:#left
		EditText wwmt_netname_ui "" type:#string
		PickButton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter
		on wwmt_netname_pickme_ui picked obj do
		(
			netname = obj.targetname
		)
		ComboBox wwmt_sounds_ui "Sound style" type:#string items:#("No Sound, None", "Big zap & Warmup", "Access Denied", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Buzz Off", "Lightswitch") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		Label wwmt_message_ui_label "Message (set sound too)" align:#left
		EditText wwmt_message_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2_ui "No Players,entity only" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Pushables" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with trigger_once" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"trigger_once_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_once&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_once" address:"https://developer.valvesoftware.com/wiki/trigger_once?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_push_CA = attributes "WW Entity trigger_push" version: 78 attribID:#(-1618386072L,211774935L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "trigger_push"
	local isWWPRO = true
	local description = "Trigger player push"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "wwmt_target", "delay", "killtarget", "netname", "sounds", "message", "angles", "speed")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValsounds = 0
	local propMapsounds = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "14")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		netname type:#string ui:wwmt_netname_ui
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		message type:#string ui:wwmt_message_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		speed type:#integer ui:wwmt_speed_ui default:40
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_push"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "Kill target" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick Kill target" message:"Pick Target Entity for Kill target" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Label wwmt_netname_ui_label "Target Path" align:#left
		EditText wwmt_netname_ui "" type:#string
		PickButton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter
		on wwmt_netname_pickme_ui picked obj do
		(
			netname = obj.targetname
		)
		ComboBox wwmt_sounds_ui "Sound style" type:#string items:#("No Sound, None", "Big zap & Warmup", "Access Denied", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Buzz Off", "Lightswitch") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		Label wwmt_message_ui_label "Message (set sound too)" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Spinner wwmt_speed_ui "Speed of push" type:#integer range:[-10000, 10000, 40]
		function addFlags =
		(
			local sfs = 0
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2_ui "Start Off" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Pushables" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_1_ui "Once Only" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with trigger_push" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"trigger_push_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_push&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_push" address:"https://developer.valvesoftware.com/wiki/trigger_push?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_relay_CA = attributes "WW Entity trigger_relay" version: 78 attribID:#(-1618386072L,-1852055962L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "trigger_relay"
	local isWWPRO = true
	local description = "Trigger Relay"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "delay", "killtarget", "triggerstate")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/TriggerRelay.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValtriggerstate = 0
	local propMaptriggerstate = #("0", "1", "2")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		triggerstate type:#string ui:wwmt_triggerstate_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_relay"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		DropDownList wwmt_triggerstate_ui "Trigger State" type:#string items:#("Off", "On", "Toggle")
		on wwmt_triggerstate_ui selected i do
		(
			triggerstate = propMaptriggerstate[i]
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Remove On fire" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_relay&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_relay" address:"https://developer.valvesoftware.com/wiki/trigger_relay?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if triggerstate != undefined then
			(
				if findItem propMaptriggerstate triggerstate == 0 then
				(
					append propMaptriggerstate triggerstate
					local tmp = wwmt_triggerstate_ui.items
					append tmp triggerstate
					wwmt_triggerstate_ui.items = tmp
					wwmt_triggerstate_ui.selection = propMaptriggerstate.count
				)
				else
				(
					wwmt_triggerstate_ui.selection = (findItem propMaptriggerstate triggerstate)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_teleport_CA = attributes "WW Entity trigger_teleport" version: 78 attribID:#(935655839L,1008780661L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "trigger_teleport"
	local isWWPRO = true
	local description = "Trigger teleport"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "wwmt_target", "delay", "killtarget", "netname", "sounds", "message")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValsounds = 0
	local propMapsounds = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "14")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		netname type:#string ui:wwmt_netname_ui
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		message type:#string ui:wwmt_message_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_teleport"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "Kill target" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick Kill target" message:"Pick Target Entity for Kill target" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Label wwmt_netname_ui_label "Target Path" align:#left
		EditText wwmt_netname_ui "" type:#string
		PickButton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter
		on wwmt_netname_pickme_ui picked obj do
		(
			netname = obj.targetname
		)
		ComboBox wwmt_sounds_ui "Sound style" type:#string items:#("No Sound, None", "Big zap & Warmup", "Access Denied", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Buzz Off", "Lightswitch") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		Label wwmt_message_ui_label "Message (set sound too)" align:#left
		EditText wwmt_message_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2_ui "No Players,entity only" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Pushables" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with trigger_teleport" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"trigger_teleport_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_teleport&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_teleport" address:"https://developer.valvesoftware.com/wiki/trigger_teleport?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_bomb_target_CA = attributes "WW Entity func_bomb_target" version: 78 attribID:#(1907091721L,-97655604L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_bomb_target"
	local isWWPRO = true
	local description = "Bomb target zone"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		wwmt_target type:#string ui:wwmt_target_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_bomb_target"
		Label wwmt_target_ui_label "Target (when bomb blows)" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target (when bomb blows)" message:"Pick Target Entity for Target (when bomb blows)" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_bomb_target" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_bomb_target_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_bomb_target&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_bomb_target" address:"https://developer.valvesoftware.com/wiki/func_bomb_target?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_breakable_CA = attributes "WW Entity func_breakable" version: 78 attribID:#(-783224043L,1079791769L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_breakable"
	local isWWPRO = true
	local description = "Breakable Object"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "wwmt_target", "delay", "health", "wwmt_material", "explosion", "gibmodel", "spawnobject", "explodemagnitude", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "style", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValmaterial = 0
	local propMapmaterial = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propValexplosion = 0
	local propMapexplosion = #("0", "1")
	local propValspawnobject = 0
	local propMapspawnobject = #("0", "1", "2", "9")
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		health type:#integer ui:wwmt_health_ui default:1
		wwmt_material type:#string ui:wwmt_material_ui default:"0"
		explosion type:#string ui:wwmt_explosion_ui default:"0"
		gibmodel type:#string ui:wwmt_gibmodel_ui
		spawnobject type:#string ui:wwmt_spawnobject_ui default:"0"
		explodemagnitude type:#integer ui:wwmt_explodemagnitude_ui default:0
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnflags type:#integer default:256
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_breakable"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		Label wwmt_target_ui_label "Target on break" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target on break" message:"Pick Target Entity for Target on break" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before fire" align:#left
		EditText wwmt_delay_ui "" type:#string
		Spinner wwmt_health_ui "Strength" type:#integer range:[-10000, 10000, 1]
		ComboBox wwmt_material_ui "Material type" type:#string items:#("Glass", "Wood", "Metal", "Flesh", "Cinder Block", "Ceiling Tile", "Computer", "Unbreakable Glass", "Rocks") height:3
		on wwmt_material_ui selected i do
		(
			wwmt_material = propMapmaterial[i]
		)
		on wwmt_material_ui entered tex do
		(
			wwmt_material = trimLeft(trimRight(tex))
			if propMapmaterial != undefined AND findItem propMapmaterial tex == 0 then
			(
				append propMapmaterial tex
				sort propMapmaterial
				wwmt_material_ui.items = propMapmaterial
				wwmt_material_ui.selection = findItem wwmt_material_ui.items tex
			)
		)
		DropDownList wwmt_explosion_ui "Gibs Direction" type:#string items:#("Random", "Relative to Attack")
		on wwmt_explosion_ui selected i do
		(
			explosion = propMapexplosion[i]
		)
		Label wwmt_gibmodel_ui_label "Gib Model" align:#left
		EditText wwmt_gibmodel_ui "" type:#string
		ComboBox wwmt_spawnobject_ui "Spawn On Break" type:#string items:#("Nothing", "Battery", "Healthkit", "Shotgun Shells") height:3
		on wwmt_spawnobject_ui selected i do
		(
			spawnobject = propMapspawnobject[i]
		)
		on wwmt_spawnobject_ui entered tex do
		(
			spawnobject = trimLeft(trimRight(tex))
			if propMapspawnobject != undefined AND findItem propMapspawnobject tex == 0 then
			(
				append propMapspawnobject tex
				sort propMapspawnobject
				wwmt_spawnobject_ui.items = propMapspawnobject
				wwmt_spawnobject_ui.selection = findItem wwmt_spawnobject_ui.items tex
			)
		)
		Label wwmt_label_explodemagnitude_ui "Explode Magnitude (0=none)" align:#left
		Spinner wwmt_explodemagnitude_ui "" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Only Trigger" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Touch" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Stand on Pressure is buggy" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Instant Crowbar" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_breakable" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_breakable_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_breakable&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_breakable" address:"https://developer.valvesoftware.com/wiki/func_breakable?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if wwmt_material != undefined then
			(
				if findItem propMapmaterial wwmt_material == 0 then
				(
					append propMapmaterial wwmt_material
					local tmp = wwmt_material_ui.items
					append tmp wwmt_material
					wwmt_material_ui.items = tmp
					wwmt_material_ui.selection = propMapmaterial.count
				)
				else
				(
					wwmt_material_ui.selection = (findItem propMapmaterial wwmt_material)
				)
			)
			if explosion != undefined then
			(
				if findItem propMapexplosion explosion == 0 then
				(
					append propMapexplosion explosion
					local tmp = wwmt_explosion_ui.items
					append tmp explosion
					wwmt_explosion_ui.items = tmp
					wwmt_explosion_ui.selection = propMapexplosion.count
				)
				else
				(
					wwmt_explosion_ui.selection = (findItem propMapexplosion explosion)
				)
			)
			if spawnobject != undefined then
			(
				if findItem propMapspawnobject spawnobject == 0 then
				(
					append propMapspawnobject spawnobject
					local tmp = wwmt_spawnobject_ui.items
					append tmp spawnobject
					wwmt_spawnobject_ui.items = tmp
					wwmt_spawnobject_ui.selection = propMapspawnobject.count
				)
				else
				(
					wwmt_spawnobject_ui.selection = (findItem propMapspawnobject spawnobject)
				)
			)
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_button_CA = attributes "WW Entity func_button" version: 78 attribID:#(721320529L,1993738382L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_button"
	local isWWPRO = true
	local description = "Button"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "master", "wwmt_target", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "zhlt_lightflags", "light_origin", "style", "speed", "netname", "health", "lip", "sounds", "wait", "delay", "locked_sound", "unlocked_sound", "locked_sentence", "unlocked_sentence", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	local propValsounds = 0
	local propMapsounds = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "14")
	local propVallocked_sound = 0
	local propMaplocked_sound = #("0", "2", "8", "10", "11", "12")
	local propValunlocked_sound = 0
	local propMapunlocked_sound = #("0", "1", "3", "4", "5", "6", "7", "8", "9", "10", "13", "14")
	local propVallocked_sentence = 0
	local propMaplocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
	local propValunlocked_sentence = 0
	local propMapunlocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		master type:#string ui:wwmt_master_ui
		wwmt_target type:#string ui:wwmt_target_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		speed type:#integer ui:wwmt_speed_ui default:5
		netname type:#string ui:wwmt_netname_ui
		health type:#integer ui:wwmt_health_ui default:0
		lip type:#integer ui:wwmt_lip_ui default:0
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		wait type:#integer ui:wwmt_wait_ui default:3
		delay type:#string ui:wwmt_delay_ui default:"0"
		locked_sound type:#string ui:wwmt_locked_sound_ui default:"0"
		unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:"0"
		locked_sentence type:#string ui:wwmt_locked_sentence_ui default:"0"
		unlocked_sentence type:#string ui:wwmt_unlocked_sentence_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_button"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 5]
		Label wwmt_netname_ui_label "Target Path" align:#left
		EditText wwmt_netname_ui "" type:#string
		PickButton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter
		on wwmt_netname_pickme_ui picked obj do
		(
			netname = obj.targetname
		)
		Label wwmt_label_health_ui "Health (shootable if > 0)" align:#left
		Spinner wwmt_health_ui "" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt_lip_ui "Lip" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_sounds_ui "Sounds" type:#string items:#("None", "Big zap & Warmup", "Access Denied", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Buzz Off", "Lightswitch") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		Label wwmt_label_wait_ui "delay before reset (-1 stay)" align:#left
		Spinner wwmt_wait_ui "" type:#integer range:[-10000, 10000, 3]
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		ComboBox wwmt_locked_sound_ui "Locked Sound" type:#string items:#("None", "Access Denied", "Small zap", "Buzz", "Buzz Off", "Latch Locked") height:3
		on wwmt_locked_sound_ui selected i do
		(
			locked_sound = propMaplocked_sound[i]
		)
		on wwmt_locked_sound_ui entered tex do
		(
			locked_sound = trimLeft(trimRight(tex))
			if propMaplocked_sound != undefined AND findItem propMaplocked_sound tex == 0 then
			(
				append propMaplocked_sound tex
				sort propMaplocked_sound
				wwmt_locked_sound_ui.items = propMaplocked_sound
				wwmt_locked_sound_ui.selection = findItem wwmt_locked_sound_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sound_ui "Unlocked Sound" type:#string items:#("None", "Big zap & Warmup", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Latch Unlocked", "Lightswitch") height:3
		on wwmt_unlocked_sound_ui selected i do
		(
			unlocked_sound = propMapunlocked_sound[i]
		)
		on wwmt_unlocked_sound_ui entered tex do
		(
			unlocked_sound = trimLeft(trimRight(tex))
			if propMapunlocked_sound != undefined AND findItem propMapunlocked_sound tex == 0 then
			(
				append propMapunlocked_sound tex
				sort propMapunlocked_sound
				wwmt_unlocked_sound_ui.items = propMapunlocked_sound
				wwmt_unlocked_sound_ui.selection = findItem wwmt_unlocked_sound_ui.items tex
			)
		)
		ComboBox wwmt_locked_sentence_ui "Locked Sentence" type:#string items:#("None", "Gen. Access Denied", "Security Lockout", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance Door", "Broken Shut Door") height:3
		on wwmt_locked_sentence_ui selected i do
		(
			locked_sentence = propMaplocked_sentence[i]
		)
		on wwmt_locked_sentence_ui entered tex do
		(
			locked_sentence = trimLeft(trimRight(tex))
			if propMaplocked_sentence != undefined AND findItem propMaplocked_sentence tex == 0 then
			(
				append propMaplocked_sentence tex
				sort propMaplocked_sentence
				wwmt_locked_sentence_ui.items = propMaplocked_sentence
				wwmt_locked_sentence_ui.selection = findItem wwmt_locked_sentence_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sentence_ui "Unlocked Sentence" type:#string items:#("None", "Gen. Access Granted", "Security Disengaged", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance area") height:3
		on wwmt_unlocked_sentence_ui selected i do
		(
			unlocked_sentence = propMapunlocked_sentence[i]
		)
		on wwmt_unlocked_sentence_ui entered tex do
		(
			unlocked_sentence = trimLeft(trimRight(tex))
			if propMapunlocked_sentence != undefined AND findItem propMapunlocked_sentence tex == 0 then
			(
				append propMapunlocked_sentence tex
				sort propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.items = propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.selection = findItem wwmt_unlocked_sentence_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Don't move" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Toggle" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "Sparks" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Touch Activates" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_button" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_button_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_button&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_button" address:"https://developer.valvesoftware.com/wiki/func_button?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			if locked_sound != undefined then
			(
				if findItem propMaplocked_sound locked_sound == 0 then
				(
					append propMaplocked_sound locked_sound
					local tmp = wwmt_locked_sound_ui.items
					append tmp locked_sound
					wwmt_locked_sound_ui.items = tmp
					wwmt_locked_sound_ui.selection = propMaplocked_sound.count
				)
				else
				(
					wwmt_locked_sound_ui.selection = (findItem propMaplocked_sound locked_sound)
				)
			)
			if unlocked_sound != undefined then
			(
				if findItem propMapunlocked_sound unlocked_sound == 0 then
				(
					append propMapunlocked_sound unlocked_sound
					local tmp = wwmt_unlocked_sound_ui.items
					append tmp unlocked_sound
					wwmt_unlocked_sound_ui.items = tmp
					wwmt_unlocked_sound_ui.selection = propMapunlocked_sound.count
				)
				else
				(
					wwmt_unlocked_sound_ui.selection = (findItem propMapunlocked_sound unlocked_sound)
				)
			)
			if locked_sentence != undefined then
			(
				if findItem propMaplocked_sentence locked_sentence == 0 then
				(
					append propMaplocked_sentence locked_sentence
					local tmp = wwmt_locked_sentence_ui.items
					append tmp locked_sentence
					wwmt_locked_sentence_ui.items = tmp
					wwmt_locked_sentence_ui.selection = propMaplocked_sentence.count
				)
				else
				(
					wwmt_locked_sentence_ui.selection = (findItem propMaplocked_sentence locked_sentence)
				)
			)
			if unlocked_sentence != undefined then
			(
				if findItem propMapunlocked_sentence unlocked_sentence == 0 then
				(
					append propMapunlocked_sentence unlocked_sentence
					local tmp = wwmt_unlocked_sentence_ui.items
					append tmp unlocked_sentence
					wwmt_unlocked_sentence_ui.items = tmp
					wwmt_unlocked_sentence_ui.selection = propMapunlocked_sentence.count
				)
				else
				(
					wwmt_unlocked_sentence_ui.selection = (findItem propMapunlocked_sentence unlocked_sentence)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_buyzone_CA = attributes "WW Entity func_buyzone" version: 78 attribID:#(1617558855L,-770119022L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_buyzone"
	local isWWPRO = true
	local description = "Buy zone"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("team")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValteam = 0
	local propMapteam = #("0", "1", "2")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		team type:#string ui:wwmt_team_ui default:"0"
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_buyzone"
		DropDownList wwmt_team_ui "Team" type:#string items:#("All teams (unassigned)", "Terrorist", "Counter-terrorist")
		on wwmt_team_ui selected i do
		(
			team = propMapteam[i]
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_buyzone" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_buyzone_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_buyzone&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_buyzone" address:"https://developer.valvesoftware.com/wiki/func_buyzone?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if team != undefined then
			(
				if findItem propMapteam team == 0 then
				(
					append propMapteam team
					local tmp = wwmt_team_ui.items
					append tmp team
					wwmt_team_ui.items = tmp
					wwmt_team_ui.selection = propMapteam.count
				)
				else
				(
					wwmt_team_ui.selection = (findItem propMapteam team)
				)
			)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_conveyor_CA = attributes "WW Entity func_conveyor" version: 78 attribID:#(51474914L,2092506524L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_conveyor"
	local isWWPRO = true
	local description = "Conveyor Belt"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "zhlt_lightflags", "light_origin", "style", "speed", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		speed type:#string ui:wwmt_speed_ui default:"100"
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_conveyor"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_speed_ui_label "Conveyor Speed" align:#left
		EditText wwmt_speed_ui "" type:#string
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "No Push" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Not Solid" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_conveyor" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_conveyor_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_conveyor&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_conveyor" address:"https://developer.valvesoftware.com/wiki/func_conveyor?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_door_CA = attributes "WW Entity func_door" version: 78 attribID:#(533770476L,-65244531L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_door"
	local isWWPRO = true
	local description = "Basic sliding door"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "master", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "wwmt_target", "delay", "killtarget", "speed", "movesnd", "stopsnd", "wait", "lip", "dmg", "message", "netname", "health", "locked_sound", "unlocked_sound", "locked_sentence", "unlocked_sentence", "_minlight", "zhlt_lightflags", "light_origin", "style")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propVallocked_sound = 0
	local propMaplocked_sound = #("0", "2", "8", "10", "11", "12")
	local propValunlocked_sound = 0
	local propMapunlocked_sound = #("0", "1", "3", "4", "5", "6", "7", "8", "9", "10", "13")
	local propVallocked_sentence = 0
	local propMaplocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
	local propValunlocked_sentence = 0
	local propMapunlocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		master type:#string ui:wwmt_master_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#integer ui:wwmt_delay_ui default:0
		killtarget type:#string ui:wwmt_killtarget_ui
		speed type:#integer ui:wwmt_speed_ui default:100
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		wait type:#integer ui:wwmt_wait_ui default:4
		lip type:#integer ui:wwmt_lip_ui default:0
		dmg type:#integer ui:wwmt_dmg_ui default:0
		message type:#string ui:wwmt_message_ui
		netname type:#string ui:wwmt_netname_ui
		health type:#integer ui:wwmt_health_ui default:0
		locked_sound type:#string ui:wwmt_locked_sound_ui default:"0"
		unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:"0"
		locked_sentence type:#string ui:wwmt_locked_sentence_ui default:"0"
		unlocked_sentence type:#string ui:wwmt_unlocked_sentence_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_door"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_label_delay_ui "Delay before fire" align:#left
		Spinner wwmt_delay_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 100]
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "Servo (Sliding)", "Pneumatic (Sliding)", "Pneumatic (Rolling)", "Vacuum", "Power Hydraulic", "Large Rollers", "Track Door", "Snappy Metal Door", "Squeaky 1", "Squeaky 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "Clang with brake", "Clang reverb", "Ratchet Stop", "Chunk", "Light airbrake", "Metal Slide Stop", "Metal Lock Stop", "Snappy Metal Stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_label_wait_ui "delay before close, -1 stay open " align:#left
		Spinner wwmt_wait_ui "" type:#integer range:[-10000, 10000, 4]
		Spinner wwmt_lip_ui "Lip" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_dmg_ui "Damage inflicted when blocked" align:#left
		Spinner wwmt_dmg_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_message_ui_label "Message if triggered" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_netname_ui_label "Fire on Close" align:#left
		EditText wwmt_netname_ui "" type:#string
		Label wwmt_label_health_ui "Health (shoot open)" align:#left
		Spinner wwmt_health_ui "" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_locked_sound_ui "Locked Sound" type:#string items:#("None", "Access Denied", "Small zap", "Buzz", "Buzz Off", "Latch Locked") height:3
		on wwmt_locked_sound_ui selected i do
		(
			locked_sound = propMaplocked_sound[i]
		)
		on wwmt_locked_sound_ui entered tex do
		(
			locked_sound = trimLeft(trimRight(tex))
			if propMaplocked_sound != undefined AND findItem propMaplocked_sound tex == 0 then
			(
				append propMaplocked_sound tex
				sort propMaplocked_sound
				wwmt_locked_sound_ui.items = propMaplocked_sound
				wwmt_locked_sound_ui.selection = findItem wwmt_locked_sound_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sound_ui "Unlocked Sound" type:#string items:#("None", "Big zap & Warmup", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Latch Unlocked") height:3
		on wwmt_unlocked_sound_ui selected i do
		(
			unlocked_sound = propMapunlocked_sound[i]
		)
		on wwmt_unlocked_sound_ui entered tex do
		(
			unlocked_sound = trimLeft(trimRight(tex))
			if propMapunlocked_sound != undefined AND findItem propMapunlocked_sound tex == 0 then
			(
				append propMapunlocked_sound tex
				sort propMapunlocked_sound
				wwmt_unlocked_sound_ui.items = propMapunlocked_sound
				wwmt_unlocked_sound_ui.selection = findItem wwmt_unlocked_sound_ui.items tex
			)
		)
		ComboBox wwmt_locked_sentence_ui "Locked Sentence" type:#string items:#("None", "Gen. Access Denied", "Security Lockout", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance Door", "Broken Shut Door") height:3
		on wwmt_locked_sentence_ui selected i do
		(
			locked_sentence = propMaplocked_sentence[i]
		)
		on wwmt_locked_sentence_ui entered tex do
		(
			locked_sentence = trimLeft(trimRight(tex))
			if propMaplocked_sentence != undefined AND findItem propMaplocked_sentence tex == 0 then
			(
				append propMaplocked_sentence tex
				sort propMaplocked_sentence
				wwmt_locked_sentence_ui.items = propMaplocked_sentence
				wwmt_locked_sentence_ui.selection = findItem wwmt_locked_sentence_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sentence_ui "Unlocked Sentence" type:#string items:#("None", "Gen. Access Granted", "Security Disengaged", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance area") height:3
		on wwmt_unlocked_sentence_ui selected i do
		(
			unlocked_sentence = propMapunlocked_sentence[i]
		)
		on wwmt_unlocked_sentence_ui entered tex do
		(
			unlocked_sentence = trimLeft(trimRight(tex))
			if propMapunlocked_sentence != undefined AND findItem propMapunlocked_sentence tex == 0 then
			(
				append propMapunlocked_sentence tex
				sort propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.items = propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.selection = findItem wwmt_unlocked_sentence_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_1_ui "Starts Open" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Don't link" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Passable" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Toggle" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Use Only" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_door" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_door_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_door&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_door" address:"https://developer.valvesoftware.com/wiki/func_door?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			if locked_sound != undefined then
			(
				if findItem propMaplocked_sound locked_sound == 0 then
				(
					append propMaplocked_sound locked_sound
					local tmp = wwmt_locked_sound_ui.items
					append tmp locked_sound
					wwmt_locked_sound_ui.items = tmp
					wwmt_locked_sound_ui.selection = propMaplocked_sound.count
				)
				else
				(
					wwmt_locked_sound_ui.selection = (findItem propMaplocked_sound locked_sound)
				)
			)
			if unlocked_sound != undefined then
			(
				if findItem propMapunlocked_sound unlocked_sound == 0 then
				(
					append propMapunlocked_sound unlocked_sound
					local tmp = wwmt_unlocked_sound_ui.items
					append tmp unlocked_sound
					wwmt_unlocked_sound_ui.items = tmp
					wwmt_unlocked_sound_ui.selection = propMapunlocked_sound.count
				)
				else
				(
					wwmt_unlocked_sound_ui.selection = (findItem propMapunlocked_sound unlocked_sound)
				)
			)
			if locked_sentence != undefined then
			(
				if findItem propMaplocked_sentence locked_sentence == 0 then
				(
					append propMaplocked_sentence locked_sentence
					local tmp = wwmt_locked_sentence_ui.items
					append tmp locked_sentence
					wwmt_locked_sentence_ui.items = tmp
					wwmt_locked_sentence_ui.selection = propMaplocked_sentence.count
				)
				else
				(
					wwmt_locked_sentence_ui.selection = (findItem propMaplocked_sentence locked_sentence)
				)
			)
			if unlocked_sentence != undefined then
			(
				if findItem propMapunlocked_sentence unlocked_sentence == 0 then
				(
					append propMapunlocked_sentence unlocked_sentence
					local tmp = wwmt_unlocked_sentence_ui.items
					append tmp unlocked_sentence
					wwmt_unlocked_sentence_ui.items = tmp
					wwmt_unlocked_sentence_ui.selection = propMapunlocked_sentence.count
				)
				else
				(
					wwmt_unlocked_sentence_ui.selection = (findItem propMapunlocked_sentence unlocked_sentence)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_door_rotating_CA = attributes "WW Entity func_door_rotating" version: 78 attribID:#(-533575577L,120708247L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_door_rotating"
	local isWWPRO = true
	local description = "Rotating door"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "master", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "wwmt_target", "delay", "killtarget", "speed", "movesnd", "stopsnd", "wait", "lip", "dmg", "message", "netname", "health", "locked_sound", "unlocked_sound", "locked_sentence", "unlocked_sentence", "_minlight", "zhlt_lightflags", "light_origin", "style", "distance")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propVallocked_sound = 0
	local propMaplocked_sound = #("0", "2", "8", "10", "11", "12")
	local propValunlocked_sound = 0
	local propMapunlocked_sound = #("0", "1", "3", "4", "5", "6", "7", "8", "9", "10", "13")
	local propVallocked_sentence = 0
	local propMaplocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
	local propValunlocked_sentence = 0
	local propMapunlocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		master type:#string ui:wwmt_master_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#integer ui:wwmt_delay_ui default:0
		killtarget type:#string ui:wwmt_killtarget_ui
		speed type:#integer ui:wwmt_speed_ui default:100
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		wait type:#integer ui:wwmt_wait_ui default:4
		lip type:#integer ui:wwmt_lip_ui default:0
		dmg type:#integer ui:wwmt_dmg_ui default:0
		message type:#string ui:wwmt_message_ui
		netname type:#string ui:wwmt_netname_ui
		health type:#integer ui:wwmt_health_ui default:0
		locked_sound type:#string ui:wwmt_locked_sound_ui default:"0"
		unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:"0"
		locked_sentence type:#string ui:wwmt_locked_sentence_ui default:"0"
		unlocked_sentence type:#string ui:wwmt_unlocked_sentence_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		distance type:#integer ui:wwmt_distance_ui default:90
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_door_rotating"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_label_delay_ui "Delay before fire" align:#left
		Spinner wwmt_delay_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 100]
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "Servo (Sliding)", "Pneumatic (Sliding)", "Pneumatic (Rolling)", "Vacuum", "Power Hydraulic", "Large Rollers", "Track Door", "Snappy Metal Door", "Squeaky 1", "Squeaky 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "Clang with brake", "Clang reverb", "Ratchet Stop", "Chunk", "Light airbrake", "Metal Slide Stop", "Metal Lock Stop", "Snappy Metal Stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_label_wait_ui "delay before close, -1 stay open " align:#left
		Spinner wwmt_wait_ui "" type:#integer range:[-10000, 10000, 4]
		Spinner wwmt_lip_ui "Lip" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_dmg_ui "Damage inflicted when blocked" align:#left
		Spinner wwmt_dmg_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_message_ui_label "Message if triggered" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_netname_ui_label "Fire on Close" align:#left
		EditText wwmt_netname_ui "" type:#string
		Label wwmt_label_health_ui "Health (shoot open)" align:#left
		Spinner wwmt_health_ui "" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_locked_sound_ui "Locked Sound" type:#string items:#("None", "Access Denied", "Small zap", "Buzz", "Buzz Off", "Latch Locked") height:3
		on wwmt_locked_sound_ui selected i do
		(
			locked_sound = propMaplocked_sound[i]
		)
		on wwmt_locked_sound_ui entered tex do
		(
			locked_sound = trimLeft(trimRight(tex))
			if propMaplocked_sound != undefined AND findItem propMaplocked_sound tex == 0 then
			(
				append propMaplocked_sound tex
				sort propMaplocked_sound
				wwmt_locked_sound_ui.items = propMaplocked_sound
				wwmt_locked_sound_ui.selection = findItem wwmt_locked_sound_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sound_ui "Unlocked Sound" type:#string items:#("None", "Big zap & Warmup", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Latch Unlocked") height:3
		on wwmt_unlocked_sound_ui selected i do
		(
			unlocked_sound = propMapunlocked_sound[i]
		)
		on wwmt_unlocked_sound_ui entered tex do
		(
			unlocked_sound = trimLeft(trimRight(tex))
			if propMapunlocked_sound != undefined AND findItem propMapunlocked_sound tex == 0 then
			(
				append propMapunlocked_sound tex
				sort propMapunlocked_sound
				wwmt_unlocked_sound_ui.items = propMapunlocked_sound
				wwmt_unlocked_sound_ui.selection = findItem wwmt_unlocked_sound_ui.items tex
			)
		)
		ComboBox wwmt_locked_sentence_ui "Locked Sentence" type:#string items:#("None", "Gen. Access Denied", "Security Lockout", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance Door", "Broken Shut Door") height:3
		on wwmt_locked_sentence_ui selected i do
		(
			locked_sentence = propMaplocked_sentence[i]
		)
		on wwmt_locked_sentence_ui entered tex do
		(
			locked_sentence = trimLeft(trimRight(tex))
			if propMaplocked_sentence != undefined AND findItem propMaplocked_sentence tex == 0 then
			(
				append propMaplocked_sentence tex
				sort propMaplocked_sentence
				wwmt_locked_sentence_ui.items = propMaplocked_sentence
				wwmt_locked_sentence_ui.selection = findItem wwmt_locked_sentence_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sentence_ui "Unlocked Sentence" type:#string items:#("None", "Gen. Access Granted", "Security Disengaged", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance area") height:3
		on wwmt_unlocked_sentence_ui selected i do
		(
			unlocked_sentence = propMapunlocked_sentence[i]
		)
		on wwmt_unlocked_sentence_ui entered tex do
		(
			unlocked_sentence = trimLeft(trimRight(tex))
			if propMapunlocked_sentence != undefined AND findItem propMapunlocked_sentence tex == 0 then
			(
				append propMapunlocked_sentence tex
				sort propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.items = propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.selection = findItem wwmt_unlocked_sentence_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Spinner wwmt_distance_ui "Distance (deg)" type:#integer range:[-10000, 10000, 90]
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_1_ui "Starts Open" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Don't link" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Passable" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Toggle" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Use Only" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Reverse Dir" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "One-way" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "X Axis" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Y Axis" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_door_rotating" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_door_rotating_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_door_rotating&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_door_rotating" address:"https://developer.valvesoftware.com/wiki/func_door_rotating?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			if locked_sound != undefined then
			(
				if findItem propMaplocked_sound locked_sound == 0 then
				(
					append propMaplocked_sound locked_sound
					local tmp = wwmt_locked_sound_ui.items
					append tmp locked_sound
					wwmt_locked_sound_ui.items = tmp
					wwmt_locked_sound_ui.selection = propMaplocked_sound.count
				)
				else
				(
					wwmt_locked_sound_ui.selection = (findItem propMaplocked_sound locked_sound)
				)
			)
			if unlocked_sound != undefined then
			(
				if findItem propMapunlocked_sound unlocked_sound == 0 then
				(
					append propMapunlocked_sound unlocked_sound
					local tmp = wwmt_unlocked_sound_ui.items
					append tmp unlocked_sound
					wwmt_unlocked_sound_ui.items = tmp
					wwmt_unlocked_sound_ui.selection = propMapunlocked_sound.count
				)
				else
				(
					wwmt_unlocked_sound_ui.selection = (findItem propMapunlocked_sound unlocked_sound)
				)
			)
			if locked_sentence != undefined then
			(
				if findItem propMaplocked_sentence locked_sentence == 0 then
				(
					append propMaplocked_sentence locked_sentence
					local tmp = wwmt_locked_sentence_ui.items
					append tmp locked_sentence
					wwmt_locked_sentence_ui.items = tmp
					wwmt_locked_sentence_ui.selection = propMaplocked_sentence.count
				)
				else
				(
					wwmt_locked_sentence_ui.selection = (findItem propMaplocked_sentence locked_sentence)
				)
			)
			if unlocked_sentence != undefined then
			(
				if findItem propMapunlocked_sentence unlocked_sentence == 0 then
				(
					append propMapunlocked_sentence unlocked_sentence
					local tmp = wwmt_unlocked_sentence_ui.items
					append tmp unlocked_sentence
					wwmt_unlocked_sentence_ui.items = tmp
					wwmt_unlocked_sentence_ui.selection = propMapunlocked_sentence.count
				)
				else
				(
					wwmt_unlocked_sentence_ui.selection = (findItem propMapunlocked_sentence unlocked_sentence)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_escapezone_CA = attributes "WW Entity func_escapezone" version: 78 attribID:#(-1542738929L,-1705924103L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_escapezone"
	local isWWPRO = true
	local description = "Terrorist escape zone"
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_escapezone"
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_escapezone" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_escapezone_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_escapezone&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_escapezone" address:"https://developer.valvesoftware.com/wiki/func_escapezone?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined)
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_friction_CA = attributes "WW Entity func_friction" version: 78 attribID:#(-708039973L,-844677114L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_friction"
	local isWWPRO = true
	local description = "Surface with a change in friction"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "style", "modifier")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		modifier type:#integer ui:wwmt_modifier_ui default:15
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_friction"
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_label_modifier_ui "Percentage of standard (0 - 100)" align:#left
		Spinner wwmt_modifier_ui "" type:#integer range:[-10000, 10000, 15]
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_friction" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_friction_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_friction&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_friction" address:"https://developer.valvesoftware.com/wiki/func_friction?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_grencatch_CA = attributes "WW Entity func_grencatch" version: 78 attribID:#(-379939516L,-1154480084L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_grencatch"
	local isWWPRO = true
	local description = "Grenade Check"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("triggerongrenade", "grenadetype", "disableongrenade")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValgrenadetype = 0
	local propMapgrenadetype = #("0", "1")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		triggerongrenade type:#string ui:wwmt_triggerongrenade_ui
		grenadetype type:#string ui:wwmt_grenadetype_ui default:"0"
		disableongrenade type:#string ui:wwmt_disableongrenade_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_grencatch"
		Label wwmt_triggerongrenade_ui_label "Trigger When Grenade Hits" align:#left
		EditText wwmt_triggerongrenade_ui "" type:#string
		DropDownList wwmt_grenadetype_ui "grenade type" type:#string items:#("flash", "smoke")
		on wwmt_grenadetype_ui selected i do
		(
			grenadetype = propMapgrenadetype[i]
		)
		Label wwmt_disableongrenade_ui_label "Disable On Grenade" align:#left
		EditText wwmt_disableongrenade_ui "" type:#string
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_grencatch" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_grencatch_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_grencatch&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_grencatch" address:"https://developer.valvesoftware.com/wiki/func_grencatch?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if grenadetype != undefined then
			(
				if findItem propMapgrenadetype grenadetype == 0 then
				(
					append propMapgrenadetype grenadetype
					local tmp = wwmt_grenadetype_ui.items
					append tmp grenadetype
					wwmt_grenadetype_ui.items = tmp
					wwmt_grenadetype_ui.selection = propMapgrenadetype.count
				)
				else
				(
					wwmt_grenadetype_ui.selection = (findItem propMapgrenadetype grenadetype)
				)
			)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_guntarget_CA = attributes "WW Entity func_guntarget" version: 78 attribID:#(-379939509L,231270615L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_guntarget"
	local isWWPRO = true
	local description = "Moving platform"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "style", "wwmt_target", "speed", "message", "health", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		wwmt_target type:#string ui:wwmt_target_ui
		speed type:#integer ui:wwmt_speed_ui default:100
		message type:#string ui:wwmt_message_ui
		health type:#integer ui:wwmt_health_ui default:0
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_guntarget"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_target_ui_label "First stop target" align:#left
		EditText wwmt_target_ui "" type:#string
		Label wwmt_label_speed_ui "Speed (units per second)" align:#left
		Spinner wwmt_speed_ui "" type:#integer range:[-10000, 10000, 100]
		Label wwmt_message_ui_label "Fire on damage" align:#left
		EditText wwmt_message_ui "" type:#string
		Spinner wwmt_health_ui "Damage to Take" type:#integer range:[-10000, 10000, 0]
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_guntarget" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_guntarget_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_guntarget&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_guntarget" address:"https://developer.valvesoftware.com/wiki/func_guntarget?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_healthcharger_CA = attributes "WW Entity func_healthcharger" version: 78 attribID:#(1193873533L,-1452723872L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_healthcharger"
	local isWWPRO = true
	local description = "Wall health recharger"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("globalname", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "style", "dmdelay", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		globalname type:#string ui:wwmt_globalname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		dmdelay type:#integer ui:wwmt_dmdelay_ui default:0
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_healthcharger"
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_label_dmdelay_ui "Deathmatch recharge delay" align:#left
		Spinner wwmt_dmdelay_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_healthcharger" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_healthcharger_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_healthcharger&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_healthcharger" address:"https://developer.valvesoftware.com/wiki/func_healthcharger?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_hostage_rescue_CA = attributes "WW Entity func_hostage_rescue" version: 78 attribID:#(-1225833327L,1774392075L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_hostage_rescue"
	local isWWPRO = true
	local description = "Hostage rescue zone"
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_hostage_rescue"
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_hostage_rescue" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_hostage_rescue_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_hostage_rescue&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_hostage_rescue" address:"https://developer.valvesoftware.com/wiki/func_hostage_rescue?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined)
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_illusionary_CA = attributes "WW Entity func_illusionary" version: 78 attribID:#(-283992820L,-1491237814L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_illusionary"
	local isWWPRO = true
	local description = "Fake Wall/Light"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "style", "skin", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	local propValskin = -1
	local propMapskin = #("-1", "-3", "-4", "-5", "-7", "-16")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		skin type:#string ui:wwmt_skin_ui default:"-1"
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		on skin set val do
		(
			getNode()
			if (isValidNode thisNode AND classof thisNode != ::WallWormMDL AND val != undefined) then
			(
				if ::WallWormHelperOps != undefined then
				(
					::WallWormHelperOps.setProxySkin thisNode  val
				)
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_illusionary"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		ComboBox wwmt_skin_ui "Contents" type:#string items:#("Empty", "water", "slime touch drown", "lava touch fire death", "Volumetric Light", "make ladder") height:3
		on wwmt_skin_ui selected i do
		(
			skin = propMapskin[i]
		)
		on wwmt_skin_ui entered tex do
		(
			skin = trimLeft(trimRight(tex))
			if propMapskin != undefined AND findItem propMapskin tex == 0 then
			(
				append propMapskin tex
				sort propMapskin
				wwmt_skin_ui.items = propMapskin
				wwmt_skin_ui.selection = findItem wwmt_skin_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_illusionary" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_illusionary_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_illusionary&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_illusionary" address:"https://developer.valvesoftware.com/wiki/func_illusionary?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			if skin != undefined then
			(
				if findItem propMapskin skin == 0 then
				(
					append propMapskin skin
					local tmp = wwmt_skin_ui.items
					append tmp skin
					wwmt_skin_ui.items = tmp
					wwmt_skin_ui.selection = propMapskin.count
				)
				else
				(
					wwmt_skin_ui.selection = (findItem propMapskin skin)
				)
			)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_ladder_CA = attributes "WW Entity func_ladder" version: 78 attribID:#(721320529L,375431330L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_ladder"
	local isWWPRO = true
	local description = "Ladder"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_ladder"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_ladder" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_ladder_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_ladder&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_ladder" address:"https://developer.valvesoftware.com/wiki/func_ladder?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_mortar_field_CA = attributes "WW Entity func_mortar_field" version: 78 attribID:#(-169681511L,-1585325670L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_mortar_field"
	local isWWPRO = true
	local description = "Mortar Field"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "m_flSpread", "m_iCount", "m_fControl", "m_iszXController", "m_iszYController")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValm_fControl = 0
	local propMapm_fControl = #("0", "1", "2")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		m_flSpread type:#integer ui:wwmt_m_flSpread_ui default:64
		m_iCount type:#integer ui:wwmt_m_iCount_ui default:1
		m_fControl type:#string ui:wwmt_m_fControl_ui default:"0"
		m_iszXController type:#string ui:wwmt_m_iszXController_ui
		m_iszYController type:#string ui:wwmt_m_iszYController_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_mortar_field"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Spinner wwmt_m_flSpread_ui "Spread Radius" type:#integer range:[-10000, 10000, 64]
		Spinner wwmt_m_iCount_ui "Repeat Count" type:#integer range:[-10000, 10000, 1]
		DropDownList wwmt_m_fControl_ui "Targeting" type:#string items:#("Random", "Activator", "Table")
		on wwmt_m_fControl_ui selected i do
		(
			m_fControl = propMapm_fControl[i]
		)
		Label wwmt_m_iszXController_ui_label "X Controller" align:#left
		EditText wwmt_m_iszXController_ui "" type:#string
		PickButton wwmt_m_iszXController_pickme_ui "Pick X Controller" message:"Pick Target Entity for X Controller" filter:target_name_filter
		on wwmt_m_iszXController_pickme_ui picked obj do
		(
			m_iszXController = obj.targetname
		)
		Label wwmt_m_iszYController_ui_label "Y Controller" align:#left
		EditText wwmt_m_iszYController_ui "" type:#string
		PickButton wwmt_m_iszYController_pickme_ui "Pick Y Controller" message:"Pick Target Entity for Y Controller" filter:target_name_filter
		on wwmt_m_iszYController_pickme_ui picked obj do
		(
			m_iszYController = obj.targetname
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_mortar_field" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_mortar_field_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_mortar_field&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_mortar_field" address:"https://developer.valvesoftware.com/wiki/func_mortar_field?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if m_fControl != undefined then
			(
				if findItem propMapm_fControl m_fControl == 0 then
				(
					append propMapm_fControl m_fControl
					local tmp = wwmt_m_fControl_ui.items
					append tmp m_fControl
					wwmt_m_fControl_ui.items = tmp
					wwmt_m_fControl_ui.selection = propMapm_fControl.count
				)
				else
				(
					wwmt_m_fControl_ui.selection = (findItem propMapm_fControl m_fControl)
				)
			)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_pendulum_CA = attributes "WW Entity func_pendulum" version: 78 attribID:#(1167220161L,-750938788L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_pendulum"
	local isWWPRO = true
	local description = "Swings back and forth"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "angles", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "style", "speed", "distance", "damp", "dmg", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		speed type:#integer ui:wwmt_speed_ui default:100
		distance type:#integer ui:wwmt_distance_ui default:90
		damp type:#integer ui:wwmt_damp_ui default:0
		dmg type:#integer ui:wwmt_dmg_ui default:0
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_pendulum"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 100]
		Spinner wwmt_distance_ui "Distance (deg)" type:#integer range:[-10000, 10000, 90]
		Label wwmt_label_damp_ui "Damping (0-1000)" align:#left
		Spinner wwmt_damp_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_dmg_ui "Damage inflicted when blocked" align:#left
		Spinner wwmt_dmg_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_1_ui "Start ON" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Passable" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Auto-return" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "X Axis" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Y Axis" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_pendulum" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_pendulum_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_pendulum&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_pendulum" address:"https://developer.valvesoftware.com/wiki/func_pendulum?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_plat_CA = attributes "WW Entity func_plat" version: 78 attribID:#(533770476L,-1987300282L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_plat"
	local isWWPRO = true
	local description = "Elevator"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "renderfx", "rendermode", "renderamt", "rendercolor", "movesnd", "stopsnd", "volume", "zhlt_lightflags", "light_origin", "style", "height", "speed", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		volume type:#string ui:wwmt_volume_ui default:"0.85"
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		height type:#integer ui:wwmt_height_ui default:0
		speed type:#integer ui:wwmt_speed_ui default:50
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_plat"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "big elev 1", "big elev 2", "tech elev 1", "tech elev 2", "tech elev 3", "freight elev 1", "freight elev 2", "heavy elev", "rack elev", "rail elev", "squeek elev", "odd elev 1", "odd elev 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "big elev stop1", "big elev stop2", "freight elev stop", "heavy elev stop", "rack stop", "rail stop", "squeek stop", "quick stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_volume_ui_label "Sound Volume 0.0 - 1.0" align:#left
		EditText wwmt_volume_ui "" type:#string
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_label_height_ui "Travel altitude (can be negative)" align:#left
		Spinner wwmt_height_ui "" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 50]
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Toggle" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_plat" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_plat_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_plat&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_plat" address:"https://developer.valvesoftware.com/wiki/func_plat?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_platrot_CA = attributes "WW Entity func_platrot" version: 78 attribID:#(1167220161L,1209110428L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_platrot"
	local isWWPRO = true
	local description = "Moving Rotating platform"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "angles", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "style", "movesnd", "stopsnd", "volume", "speed", "height", "rotation", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		volume type:#string ui:wwmt_volume_ui default:"0.85"
		speed type:#integer ui:wwmt_speed_ui default:50
		height type:#integer ui:wwmt_height_ui default:0
		rotation type:#integer ui:wwmt_rotation_ui default:0
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnflags type:#integer default:1
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_platrot"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "big elev 1", "big elev 2", "tech elev 1", "tech elev 2", "tech elev 3", "freight elev 1", "freight elev 2", "heavy elev", "rack elev", "rail elev", "squeek elev", "odd elev 1", "odd elev 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "big elev stop1", "big elev stop2", "freight elev stop", "heavy elev stop", "rack stop", "rail stop", "squeek stop", "quick stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_volume_ui_label "Sound Volume 0.0 - 1.0" align:#left
		EditText wwmt_volume_ui "" type:#string
		Label wwmt_label_speed_ui "Speed of rotation" align:#left
		Spinner wwmt_speed_ui "" type:#integer range:[-10000, 10000, 50]
		Label wwmt_label_height_ui "Travel altitude (can be negative)" align:#left
		Spinner wwmt_height_ui "" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt_rotation_ui "Spin amount" type:#integer range:[-10000, 10000, 0]
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Toggle" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "X Axis" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Y Axis" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_platrot" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_platrot_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_platrot&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_platrot" address:"https://developer.valvesoftware.com/wiki/func_platrot?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_pushable_CA = attributes "WW Entity func_pushable" version: 78 attribID:#(1167220161L,-79527866L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_pushable"
	local isWWPRO = true
	local description = "Pushable object"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "wwmt_target", "delay", "health", "wwmt_material", "explosion", "gibmodel", "spawnobject", "explodemagnitude", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "style", "size", "friction", "buoyancy", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValmaterial = 0
	local propMapmaterial = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propValexplosion = 0
	local propMapexplosion = #("0", "1")
	local propValspawnobject = 0
	local propMapspawnobject = #("0", "1", "2", "9")
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	local propValsize = 0
	local propMapsize = #("0", "1", "2", "3")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		health type:#integer ui:wwmt_health_ui default:1
		wwmt_material type:#string ui:wwmt_material_ui default:"0"
		explosion type:#string ui:wwmt_explosion_ui default:"0"
		gibmodel type:#string ui:wwmt_gibmodel_ui
		spawnobject type:#string ui:wwmt_spawnobject_ui default:"0"
		explodemagnitude type:#integer ui:wwmt_explodemagnitude_ui default:0
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		size type:#string ui:wwmt_size_ui default:"0"
		friction type:#integer ui:wwmt_friction_ui default:50
		buoyancy type:#integer ui:wwmt_buoyancy_ui default:20
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnflags type:#integer default:384
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_pushable"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		Label wwmt_target_ui_label "Target on break" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target on break" message:"Pick Target Entity for Target on break" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before fire" align:#left
		EditText wwmt_delay_ui "" type:#string
		Spinner wwmt_health_ui "Strength" type:#integer range:[-10000, 10000, 1]
		ComboBox wwmt_material_ui "Material type" type:#string items:#("Glass", "Wood", "Metal", "Flesh", "Cinder Block", "Ceiling Tile", "Computer", "Unbreakable Glass", "Rocks") height:3
		on wwmt_material_ui selected i do
		(
			wwmt_material = propMapmaterial[i]
		)
		on wwmt_material_ui entered tex do
		(
			wwmt_material = trimLeft(trimRight(tex))
			if propMapmaterial != undefined AND findItem propMapmaterial tex == 0 then
			(
				append propMapmaterial tex
				sort propMapmaterial
				wwmt_material_ui.items = propMapmaterial
				wwmt_material_ui.selection = findItem wwmt_material_ui.items tex
			)
		)
		DropDownList wwmt_explosion_ui "Gibs Direction" type:#string items:#("Random", "Relative to Attack")
		on wwmt_explosion_ui selected i do
		(
			explosion = propMapexplosion[i]
		)
		Label wwmt_gibmodel_ui_label "Gib Model" align:#left
		EditText wwmt_gibmodel_ui "" type:#string
		ComboBox wwmt_spawnobject_ui "Spawn On Break" type:#string items:#("Nothing", "Battery", "Healthkit", "Shotgun Shells") height:3
		on wwmt_spawnobject_ui selected i do
		(
			spawnobject = propMapspawnobject[i]
		)
		on wwmt_spawnobject_ui entered tex do
		(
			spawnobject = trimLeft(trimRight(tex))
			if propMapspawnobject != undefined AND findItem propMapspawnobject tex == 0 then
			(
				append propMapspawnobject tex
				sort propMapspawnobject
				wwmt_spawnobject_ui.items = propMapspawnobject
				wwmt_spawnobject_ui.selection = findItem wwmt_spawnobject_ui.items tex
			)
		)
		Label wwmt_label_explodemagnitude_ui "Explode Magnitude (0=none)" align:#left
		Spinner wwmt_explodemagnitude_ui "" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		ComboBox wwmt_size_ui "Hull Size" type:#string items:#("Point size", "Player size", "Big Size", "Player duck") height:3
		on wwmt_size_ui selected i do
		(
			size = propMapsize[i]
		)
		on wwmt_size_ui entered tex do
		(
			size = trimLeft(trimRight(tex))
			if propMapsize != undefined AND findItem propMapsize tex == 0 then
			(
				append propMapsize tex
				sort propMapsize
				wwmt_size_ui.items = propMapsize
				wwmt_size_ui.selection = findItem wwmt_size_ui.items tex
			)
		)
		Label wwmt_label_friction_ui "Friction (0-400)" align:#left
		Spinner wwmt_friction_ui "" type:#integer range:[-10000, 10000, 50]
		Spinner wwmt_buoyancy_ui "Buoyancy" type:#integer range:[-10000, 10000, 20]
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Only Trigger" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Broken on touch is buggy" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Pressure is buggy" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Breakable" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Instant Crowbar" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_pushable" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_pushable_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_pushable&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_pushable" address:"https://developer.valvesoftware.com/wiki/func_pushable?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if wwmt_material != undefined then
			(
				if findItem propMapmaterial wwmt_material == 0 then
				(
					append propMapmaterial wwmt_material
					local tmp = wwmt_material_ui.items
					append tmp wwmt_material
					wwmt_material_ui.items = tmp
					wwmt_material_ui.selection = propMapmaterial.count
				)
				else
				(
					wwmt_material_ui.selection = (findItem propMapmaterial wwmt_material)
				)
			)
			if explosion != undefined then
			(
				if findItem propMapexplosion explosion == 0 then
				(
					append propMapexplosion explosion
					local tmp = wwmt_explosion_ui.items
					append tmp explosion
					wwmt_explosion_ui.items = tmp
					wwmt_explosion_ui.selection = propMapexplosion.count
				)
				else
				(
					wwmt_explosion_ui.selection = (findItem propMapexplosion explosion)
				)
			)
			if spawnobject != undefined then
			(
				if findItem propMapspawnobject spawnobject == 0 then
				(
					append propMapspawnobject spawnobject
					local tmp = wwmt_spawnobject_ui.items
					append tmp spawnobject
					wwmt_spawnobject_ui.items = tmp
					wwmt_spawnobject_ui.selection = propMapspawnobject.count
				)
				else
				(
					wwmt_spawnobject_ui.selection = (findItem propMapspawnobject spawnobject)
				)
			)
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			if size != undefined then
			(
				if findItem propMapsize size == 0 then
				(
					append propMapsize size
					local tmp = wwmt_size_ui.items
					append tmp size
					wwmt_size_ui.items = tmp
					wwmt_size_ui.selection = propMapsize.count
				)
				else
				(
					wwmt_size_ui.selection = (findItem propMapsize size)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_recharge_CA = attributes "WW Entity func_recharge" version: 78 attribID:#(-1964947721L,-1646512993L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_recharge"
	local isWWPRO = true
	local description = "Battery recharger"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("globalname", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "style", "dmdelay", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		globalname type:#string ui:wwmt_globalname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		dmdelay type:#integer ui:wwmt_dmdelay_ui default:0
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_recharge"
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_label_dmdelay_ui "Deathmatch recharge delay" align:#left
		Spinner wwmt_dmdelay_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_recharge" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_recharge_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_recharge&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_recharge" address:"https://developer.valvesoftware.com/wiki/func_recharge?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_rot_button_CA = attributes "WW Entity func_rot_button" version: 78 attribID:#(-70763294L,-1009942767L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_rot_button"
	local isWWPRO = true
	local description = "RotatingButton"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "master", "wwmt_target", "angles", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "style", "delay", "changetarget", "speed", "health", "sounds", "wait", "distance", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	local propValsounds = 21
	local propMapsounds = #("21", "22", "23", "24", "25")
	local propValwait = 3
	local propMapwait = #("-1", "3")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		master type:#string ui:wwmt_master_ui
		wwmt_target type:#string ui:wwmt_target_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		delay type:#string ui:wwmt_delay_ui default:"0"
		changetarget type:#string ui:wwmt_changetarget_ui
		speed type:#integer ui:wwmt_speed_ui default:50
		health type:#integer ui:wwmt_health_ui default:0
		sounds type:#string ui:wwmt_sounds_ui default:"21"
		wait type:#string ui:wwmt_wait_ui default:"3"
		distance type:#integer ui:wwmt_distance_ui default:90
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_rot_button"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_changetarget_ui_label "ChangeTarget Name" align:#left
		EditText wwmt_changetarget_ui "" type:#string
		PickButton wwmt_changetarget_pickme_ui "Pick ChangeTarget Name" message:"Pick Target Entity for ChangeTarget Name" filter:target_name_filter
		on wwmt_changetarget_pickme_ui picked obj do
		(
			changetarget = obj.targetname
		)
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 50]
		Label wwmt_label_health_ui "Health (shootable if > 0)" align:#left
		Spinner wwmt_health_ui "" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_sounds_ui "Sounds" type:#string items:#("Squeaky", "Squeaky Pneumatic", "Ratchet Groan", "Clean Ratchet", "Gas Clunk") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		DropDownList wwmt_wait_ui "Delay before reset" type:#string items:#("Stays pressed", "3 sec default")
		on wwmt_wait_ui selected i do
		(
			wait = propMapwait[i]
		)
		Spinner wwmt_distance_ui "Distance (deg)" type:#integer range:[-10000, 10000, 90]
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Not solid" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Reverse Dir" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Toggle" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "X Axis" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Y Axis" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Touch Activates" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_rot_button" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_rot_button_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_rot_button&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_rot_button" address:"https://developer.valvesoftware.com/wiki/func_rot_button?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			if wait != undefined then
			(
				if findItem propMapwait wait == 0 then
				(
					append propMapwait wait
					local tmp = wwmt_wait_ui.items
					append tmp wait
					wwmt_wait_ui.items = tmp
					wwmt_wait_ui.selection = propMapwait.count
				)
				else
				(
					wwmt_wait_ui.selection = (findItem propMapwait wait)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_rotating_CA = attributes "WW Entity func_rotating" version: 78 attribID:#(-1964947721L,-487807204L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_rotating"
	local isWWPRO = true
	local description = "Rotating Object"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "angles", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "style", "speed", "volume", "fanfriction", "sounds", "message", "_minlight", "spawnorigin", "dmg")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	local propValsounds = 0
	local propMapsounds = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		speed type:#integer ui:wwmt_speed_ui default:0
		volume type:#integer ui:wwmt_volume_ui default:10
		fanfriction type:#integer ui:wwmt_fanfriction_ui default:20
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		message type:#string ui:wwmt_message_ui
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnorigin type:#string ui:wwmt_spawnorigin_ui default:"0 0 0"
		dmg type:#integer ui:wwmt_dmg_ui default:0
		spawnflags type:#integer default:512
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_rotating"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Spinner wwmt_speed_ui "Rotation Speed" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_volume_ui "Volume (10 = loudest)" align:#left
		Spinner wwmt_volume_ui "" type:#integer range:[-10000, 10000, 10]
		Label wwmt_label_fanfriction_ui "Friction (0 - 100%)" align:#left
		Spinner wwmt_fanfriction_ui "" type:#integer range:[-10000, 10000, 20]
		ComboBox wwmt_sounds_ui "Fan Sounds" type:#string items:#("No Sound", "Fast Whine", "Slow Rush", "Medium Rickety", "Fast Beating", "Slow Smooth") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		Label wwmt_message_ui_label "WAV Name" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		Label wwmt_spawnorigin_ui_label "X Y Z - Move here after lighting" align:#left
		EditText wwmt_spawnorigin_ui "" type:#string
		Label wwmt_label_dmg_ui "Damage inflicted when blocked" align:#left
		Spinner wwmt_dmg_ui "" type:#integer range:[-10000, 10000, 0]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			if params.flag_512_ui.checked == true then
			(
				sfs += 512
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Start ON" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Reverse Direction" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "X Axis" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Y Axis" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Acc/Dcc" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Fan Pain" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "Not Solid" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Small Radius" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Medium Radius" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_512_ui "Large Radius" type:#integer
			on flag_512_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_rotating" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_rotating_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_rotating&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_rotating" address:"https://developer.valvesoftware.com/wiki/func_rotating?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			flag_512_ui.checked = (bit.and (getProperty this #spawnflags) 512 == 512)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_tank_CA = attributes "WW Entity func_tank" version: 78 attribID:#(533770476L,-535527541L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_tank"
	local isWWPRO = true
	local description = "Brush MG Turret"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "wwmt_target", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "master", "yawrate", "yawrange", "yawtolerance", "pitchrate", "pitchrange", "pitchtolerance", "barrel", "barrely", "barrelz", "spritesmoke", "spriteflash", "spritescale", "rotatesound", "firerate", "bullet_damage", "persistence", "firespread", "minRange", "maxRange", "_minlight", "zhlt_lightflags", "light_origin", "style", "bullet")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValfirespread = 0
	local propMapfirespread = #("0", "1", "2", "3", "4")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	local propValbullet = 0
	local propMapbullet = #("0", "1", "2", "3")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		master type:#string ui:wwmt_master_ui
		yawrate type:#string ui:wwmt_yawrate_ui default:"30"
		yawrange type:#string ui:wwmt_yawrange_ui default:"180"
		yawtolerance type:#string ui:wwmt_yawtolerance_ui default:"15"
		pitchrate type:#string ui:wwmt_pitchrate_ui default:"0"
		pitchrange type:#string ui:wwmt_pitchrange_ui default:"0"
		pitchtolerance type:#string ui:wwmt_pitchtolerance_ui default:"5"
		barrel type:#string ui:wwmt_barrel_ui default:"0"
		barrely type:#string ui:wwmt_barrely_ui default:"0"
		barrelz type:#string ui:wwmt_barrelz_ui default:"0"
		spritesmoke type:#string ui:wwmt_spritesmoke_ui
		spriteflash type:#string ui:wwmt_spriteflash_ui
		spritescale type:#string ui:wwmt_spritescale_ui default:"1"
		rotatesound type:#string ui:wwmt_rotatesound_ui
		firerate type:#string ui:wwmt_firerate_ui default:"1"
		bullet_damage type:#string ui:wwmt_bullet_damage_ui default:"0"
		persistence type:#string ui:wwmt_persistence_ui default:"1"
		firespread type:#string ui:wwmt_firespread_ui default:"0"
		minRange type:#string ui:wwmt_minRange_ui default:"0"
		maxRange type:#string ui:wwmt_maxRange_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		bullet type:#string ui:wwmt_bullet_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_tank"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_master_ui_label "(Team) Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_yawrate_ui_label "Yaw rate" align:#left
		EditText wwmt_yawrate_ui "" type:#string
		Label wwmt_yawrange_ui_label "Yaw range" align:#left
		EditText wwmt_yawrange_ui "" type:#string
		Label wwmt_yawtolerance_ui_label "Yaw tolerance" align:#left
		EditText wwmt_yawtolerance_ui "" type:#string
		Label wwmt_pitchrate_ui_label "Pitch rate" align:#left
		EditText wwmt_pitchrate_ui "" type:#string
		Label wwmt_pitchrange_ui_label "Pitch range" align:#left
		EditText wwmt_pitchrange_ui "" type:#string
		Label wwmt_pitchtolerance_ui_label "Pitch tolerance" align:#left
		EditText wwmt_pitchtolerance_ui "" type:#string
		Label wwmt_barrel_ui_label "Barrel Length" align:#left
		EditText wwmt_barrel_ui "" type:#string
		Label wwmt_barrely_ui_label "Barrel Horizontal" align:#left
		EditText wwmt_barrely_ui "" type:#string
		Label wwmt_barrelz_ui_label "Barrel Vertical" align:#left
		EditText wwmt_barrelz_ui "" type:#string
		Label wwmt_spritesmoke_ui_label "Smoke Sprite" align:#left
		EditText wwmt_spritesmoke_ui "" type:#string
		Label wwmt_spriteflash_ui_label "Flash Sprite" align:#left
		EditText wwmt_spriteflash_ui "" type:#string
		Label wwmt_spritescale_ui_label "Sprite scale" align:#left
		EditText wwmt_spritescale_ui "" type:#string
		Label wwmt_rotatesound_ui_label "Rotate Sound" align:#left
		EditText wwmt_rotatesound_ui "" type:#string
		Label wwmt_firerate_ui_label "Rate of Fire" align:#left
		EditText wwmt_firerate_ui "" type:#string
		Label wwmt_bullet_damage_ui_label "Damage Per Bullet" align:#left
		EditText wwmt_bullet_damage_ui "" type:#string
		Label wwmt_persistence_ui_label "Firing persistence" align:#left
		EditText wwmt_persistence_ui "" type:#string
		ComboBox wwmt_firespread_ui "Bullet accuracy" type:#string items:#("Perfect Shot", "Small cone", "Medium cone", "Large cone", "Extra-large cone") height:3
		on wwmt_firespread_ui selected i do
		(
			firespread = propMapfirespread[i]
		)
		on wwmt_firespread_ui entered tex do
		(
			firespread = trimLeft(trimRight(tex))
			if propMapfirespread != undefined AND findItem propMapfirespread tex == 0 then
			(
				append propMapfirespread tex
				sort propMapfirespread
				wwmt_firespread_ui.items = propMapfirespread
				wwmt_firespread_ui.selection = findItem wwmt_firespread_ui.items tex
			)
		)
		Label wwmt_minRange_ui_label "Minmum target range" align:#left
		EditText wwmt_minRange_ui "" type:#string
		Label wwmt_maxRange_ui_label "Maximum target range" align:#left
		EditText wwmt_maxRange_ui "" type:#string
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		ComboBox wwmt_bullet_ui "Bullets" type:#string items:#("None", "9mm", "MP5", "12mm") height:3
		on wwmt_bullet_ui selected i do
		(
			bullet = propMapbullet[i]
		)
		on wwmt_bullet_ui entered tex do
		(
			bullet = trimLeft(trimRight(tex))
			if propMapbullet != undefined AND findItem propMapbullet tex == 0 then
			(
				append propMapbullet tex
				sort propMapbullet
				wwmt_bullet_ui.items = propMapbullet
				wwmt_bullet_ui.selection = findItem wwmt_bullet_ui.items tex
			)
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Active" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Only Direct" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Controllable" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_tank" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_tank_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_tank&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_tank" address:"https://developer.valvesoftware.com/wiki/func_tank?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if firespread != undefined then
			(
				if findItem propMapfirespread firespread == 0 then
				(
					append propMapfirespread firespread
					local tmp = wwmt_firespread_ui.items
					append tmp firespread
					wwmt_firespread_ui.items = tmp
					wwmt_firespread_ui.selection = propMapfirespread.count
				)
				else
				(
					wwmt_firespread_ui.selection = (findItem propMapfirespread firespread)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			if bullet != undefined then
			(
				if findItem propMapbullet bullet == 0 then
				(
					append propMapbullet bullet
					local tmp = wwmt_bullet_ui.items
					append tmp bullet
					wwmt_bullet_ui.items = tmp
					wwmt_bullet_ui.selection = propMapbullet.count
				)
				else
				(
					wwmt_bullet_ui.selection = (findItem propMapbullet bullet)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_tankcontrols_CA = attributes "WW Entity func_tankcontrols" version: 78 attribID:#(690331584L,128744087L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_tankcontrols"
	local isWWPRO = true
	local description = "Tank controls"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		wwmt_target type:#string ui:wwmt_target_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_tankcontrols"
		Label wwmt_target_ui_label "Tank entity name" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Tank entity name" message:"Pick Target Entity for Tank entity name" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_tankcontrols" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_tankcontrols_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_tankcontrols&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_tankcontrols" address:"https://developer.valvesoftware.com/wiki/func_tankcontrols?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_tanklaser_CA = attributes "WW Entity func_tanklaser" version: 78 attribID:#(735805750L,98301112L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_tanklaser"
	local isWWPRO = true
	local description = "Brush Laser Turret"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "wwmt_target", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "master", "yawrate", "yawrange", "yawtolerance", "pitchrate", "pitchrange", "pitchtolerance", "barrel", "barrely", "barrelz", "spritesmoke", "spriteflash", "spritescale", "rotatesound", "firerate", "bullet_damage", "persistence", "firespread", "minRange", "maxRange", "_minlight", "zhlt_lightflags", "light_origin", "style", "laserentity")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValfirespread = 0
	local propMapfirespread = #("0", "1", "2", "3", "4")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		master type:#string ui:wwmt_master_ui
		yawrate type:#string ui:wwmt_yawrate_ui default:"30"
		yawrange type:#string ui:wwmt_yawrange_ui default:"180"
		yawtolerance type:#string ui:wwmt_yawtolerance_ui default:"15"
		pitchrate type:#string ui:wwmt_pitchrate_ui default:"0"
		pitchrange type:#string ui:wwmt_pitchrange_ui default:"0"
		pitchtolerance type:#string ui:wwmt_pitchtolerance_ui default:"5"
		barrel type:#string ui:wwmt_barrel_ui default:"0"
		barrely type:#string ui:wwmt_barrely_ui default:"0"
		barrelz type:#string ui:wwmt_barrelz_ui default:"0"
		spritesmoke type:#string ui:wwmt_spritesmoke_ui
		spriteflash type:#string ui:wwmt_spriteflash_ui
		spritescale type:#string ui:wwmt_spritescale_ui default:"1"
		rotatesound type:#string ui:wwmt_rotatesound_ui
		firerate type:#string ui:wwmt_firerate_ui default:"1"
		bullet_damage type:#string ui:wwmt_bullet_damage_ui default:"0"
		persistence type:#string ui:wwmt_persistence_ui default:"1"
		firespread type:#string ui:wwmt_firespread_ui default:"0"
		minRange type:#string ui:wwmt_minRange_ui default:"0"
		maxRange type:#string ui:wwmt_maxRange_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		laserentity type:#string ui:wwmt_laserentity_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_tanklaser"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_master_ui_label "(Team) Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_yawrate_ui_label "Yaw rate" align:#left
		EditText wwmt_yawrate_ui "" type:#string
		Label wwmt_yawrange_ui_label "Yaw range" align:#left
		EditText wwmt_yawrange_ui "" type:#string
		Label wwmt_yawtolerance_ui_label "Yaw tolerance" align:#left
		EditText wwmt_yawtolerance_ui "" type:#string
		Label wwmt_pitchrate_ui_label "Pitch rate" align:#left
		EditText wwmt_pitchrate_ui "" type:#string
		Label wwmt_pitchrange_ui_label "Pitch range" align:#left
		EditText wwmt_pitchrange_ui "" type:#string
		Label wwmt_pitchtolerance_ui_label "Pitch tolerance" align:#left
		EditText wwmt_pitchtolerance_ui "" type:#string
		Label wwmt_barrel_ui_label "Barrel Length" align:#left
		EditText wwmt_barrel_ui "" type:#string
		Label wwmt_barrely_ui_label "Barrel Horizontal" align:#left
		EditText wwmt_barrely_ui "" type:#string
		Label wwmt_barrelz_ui_label "Barrel Vertical" align:#left
		EditText wwmt_barrelz_ui "" type:#string
		Label wwmt_spritesmoke_ui_label "Smoke Sprite" align:#left
		EditText wwmt_spritesmoke_ui "" type:#string
		Label wwmt_spriteflash_ui_label "Flash Sprite" align:#left
		EditText wwmt_spriteflash_ui "" type:#string
		Label wwmt_spritescale_ui_label "Sprite scale" align:#left
		EditText wwmt_spritescale_ui "" type:#string
		Label wwmt_rotatesound_ui_label "Rotate Sound" align:#left
		EditText wwmt_rotatesound_ui "" type:#string
		Label wwmt_firerate_ui_label "Rate of Fire" align:#left
		EditText wwmt_firerate_ui "" type:#string
		Label wwmt_bullet_damage_ui_label "Damage Per Bullet" align:#left
		EditText wwmt_bullet_damage_ui "" type:#string
		Label wwmt_persistence_ui_label "Firing persistence" align:#left
		EditText wwmt_persistence_ui "" type:#string
		ComboBox wwmt_firespread_ui "Bullet accuracy" type:#string items:#("Perfect Shot", "Small cone", "Medium cone", "Large cone", "Extra-large cone") height:3
		on wwmt_firespread_ui selected i do
		(
			firespread = propMapfirespread[i]
		)
		on wwmt_firespread_ui entered tex do
		(
			firespread = trimLeft(trimRight(tex))
			if propMapfirespread != undefined AND findItem propMapfirespread tex == 0 then
			(
				append propMapfirespread tex
				sort propMapfirespread
				wwmt_firespread_ui.items = propMapfirespread
				wwmt_firespread_ui.selection = findItem wwmt_firespread_ui.items tex
			)
		)
		Label wwmt_minRange_ui_label "Minmum target range" align:#left
		EditText wwmt_minRange_ui "" type:#string
		Label wwmt_maxRange_ui_label "Maximum target range" align:#left
		EditText wwmt_maxRange_ui "" type:#string
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_laserentity_ui_label "env_laser Entity" align:#left
		EditText wwmt_laserentity_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Active" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Only Direct" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Controllable" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_tanklaser" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_tanklaser_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_tanklaser&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_tanklaser" address:"https://developer.valvesoftware.com/wiki/func_tanklaser?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if firespread != undefined then
			(
				if findItem propMapfirespread firespread == 0 then
				(
					append propMapfirespread firespread
					local tmp = wwmt_firespread_ui.items
					append tmp firespread
					wwmt_firespread_ui.items = tmp
					wwmt_firespread_ui.selection = propMapfirespread.count
				)
				else
				(
					wwmt_firespread_ui.selection = (findItem propMapfirespread firespread)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_tankmortar_CA = attributes "WW Entity func_tankmortar" version: 78 attribID:#(735805750L,-243104968L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_tankmortar"
	local isWWPRO = true
	local description = "Brush Mortar Turret"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "wwmt_target", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "master", "yawrate", "yawrange", "yawtolerance", "pitchrate", "pitchrange", "pitchtolerance", "barrel", "barrely", "barrelz", "spritesmoke", "spriteflash", "spritescale", "rotatesound", "firerate", "bullet_damage", "persistence", "firespread", "minRange", "maxRange", "_minlight", "zhlt_lightflags", "light_origin", "style", "iMagnitude")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValfirespread = 0
	local propMapfirespread = #("0", "1", "2", "3", "4")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		master type:#string ui:wwmt_master_ui
		yawrate type:#string ui:wwmt_yawrate_ui default:"30"
		yawrange type:#string ui:wwmt_yawrange_ui default:"180"
		yawtolerance type:#string ui:wwmt_yawtolerance_ui default:"15"
		pitchrate type:#string ui:wwmt_pitchrate_ui default:"0"
		pitchrange type:#string ui:wwmt_pitchrange_ui default:"0"
		pitchtolerance type:#string ui:wwmt_pitchtolerance_ui default:"5"
		barrel type:#string ui:wwmt_barrel_ui default:"0"
		barrely type:#string ui:wwmt_barrely_ui default:"0"
		barrelz type:#string ui:wwmt_barrelz_ui default:"0"
		spritesmoke type:#string ui:wwmt_spritesmoke_ui
		spriteflash type:#string ui:wwmt_spriteflash_ui
		spritescale type:#string ui:wwmt_spritescale_ui default:"1"
		rotatesound type:#string ui:wwmt_rotatesound_ui
		firerate type:#string ui:wwmt_firerate_ui default:"1"
		bullet_damage type:#string ui:wwmt_bullet_damage_ui default:"0"
		persistence type:#string ui:wwmt_persistence_ui default:"1"
		firespread type:#string ui:wwmt_firespread_ui default:"0"
		minRange type:#string ui:wwmt_minRange_ui default:"0"
		maxRange type:#string ui:wwmt_maxRange_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		iMagnitude type:#integer ui:wwmt_iMagnitude_ui default:100
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_tankmortar"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_master_ui_label "(Team) Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_yawrate_ui_label "Yaw rate" align:#left
		EditText wwmt_yawrate_ui "" type:#string
		Label wwmt_yawrange_ui_label "Yaw range" align:#left
		EditText wwmt_yawrange_ui "" type:#string
		Label wwmt_yawtolerance_ui_label "Yaw tolerance" align:#left
		EditText wwmt_yawtolerance_ui "" type:#string
		Label wwmt_pitchrate_ui_label "Pitch rate" align:#left
		EditText wwmt_pitchrate_ui "" type:#string
		Label wwmt_pitchrange_ui_label "Pitch range" align:#left
		EditText wwmt_pitchrange_ui "" type:#string
		Label wwmt_pitchtolerance_ui_label "Pitch tolerance" align:#left
		EditText wwmt_pitchtolerance_ui "" type:#string
		Label wwmt_barrel_ui_label "Barrel Length" align:#left
		EditText wwmt_barrel_ui "" type:#string
		Label wwmt_barrely_ui_label "Barrel Horizontal" align:#left
		EditText wwmt_barrely_ui "" type:#string
		Label wwmt_barrelz_ui_label "Barrel Vertical" align:#left
		EditText wwmt_barrelz_ui "" type:#string
		Label wwmt_spritesmoke_ui_label "Smoke Sprite" align:#left
		EditText wwmt_spritesmoke_ui "" type:#string
		Label wwmt_spriteflash_ui_label "Flash Sprite" align:#left
		EditText wwmt_spriteflash_ui "" type:#string
		Label wwmt_spritescale_ui_label "Sprite scale" align:#left
		EditText wwmt_spritescale_ui "" type:#string
		Label wwmt_rotatesound_ui_label "Rotate Sound" align:#left
		EditText wwmt_rotatesound_ui "" type:#string
		Label wwmt_firerate_ui_label "Rate of Fire" align:#left
		EditText wwmt_firerate_ui "" type:#string
		Label wwmt_bullet_damage_ui_label "Damage Per Bullet" align:#left
		EditText wwmt_bullet_damage_ui "" type:#string
		Label wwmt_persistence_ui_label "Firing persistence" align:#left
		EditText wwmt_persistence_ui "" type:#string
		ComboBox wwmt_firespread_ui "Bullet accuracy" type:#string items:#("Perfect Shot", "Small cone", "Medium cone", "Large cone", "Extra-large cone") height:3
		on wwmt_firespread_ui selected i do
		(
			firespread = propMapfirespread[i]
		)
		on wwmt_firespread_ui entered tex do
		(
			firespread = trimLeft(trimRight(tex))
			if propMapfirespread != undefined AND findItem propMapfirespread tex == 0 then
			(
				append propMapfirespread tex
				sort propMapfirespread
				wwmt_firespread_ui.items = propMapfirespread
				wwmt_firespread_ui.selection = findItem wwmt_firespread_ui.items tex
			)
		)
		Label wwmt_minRange_ui_label "Minmum target range" align:#left
		EditText wwmt_minRange_ui "" type:#string
		Label wwmt_maxRange_ui_label "Maximum target range" align:#left
		EditText wwmt_maxRange_ui "" type:#string
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_label_iMagnitude_ui "Explosion Magnitude" align:#left
		Spinner wwmt_iMagnitude_ui "" type:#integer range:[-10000, 10000, 100]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Active" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Only Direct" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Controllable" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_tankmortar" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_tankmortar_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_tankmortar&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_tankmortar" address:"https://developer.valvesoftware.com/wiki/func_tankmortar?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if firespread != undefined then
			(
				if findItem propMapfirespread firespread == 0 then
				(
					append propMapfirespread firespread
					local tmp = wwmt_firespread_ui.items
					append tmp firespread
					wwmt_firespread_ui.items = tmp
					wwmt_firespread_ui.selection = propMapfirespread.count
				)
				else
				(
					wwmt_firespread_ui.selection = (findItem propMapfirespread firespread)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_trackautochange_CA = attributes "WW Entity func_trackautochange" version: 78 attribID:#(-1059899516L,-1832384351L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_trackautochange"
	local isWWPRO = true
	local description = "Automatic track changing platform"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "renderfx", "rendermode", "renderamt", "rendercolor", "movesnd", "stopsnd", "volume", "height", "rotation", "train", "toptrack", "bottomtrack", "speed", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		volume type:#string ui:wwmt_volume_ui default:"0.85"
		height type:#integer ui:wwmt_height_ui default:0
		rotation type:#integer ui:wwmt_rotation_ui default:0
		train type:#string ui:wwmt_train_ui
		toptrack type:#string ui:wwmt_toptrack_ui
		bottomtrack type:#string ui:wwmt_bottomtrack_ui
		speed type:#integer ui:wwmt_speed_ui default:0
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_trackautochange"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "big elev 1", "big elev 2", "tech elev 1", "tech elev 2", "tech elev 3", "freight elev 1", "freight elev 2", "heavy elev", "rack elev", "rail elev", "squeek elev", "odd elev 1", "odd elev 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "big elev stop1", "big elev stop2", "freight elev stop", "heavy elev stop", "rack stop", "rail stop", "squeek stop", "quick stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_volume_ui_label "Sound Volume 0.0 - 1.0" align:#left
		EditText wwmt_volume_ui "" type:#string
		Spinner wwmt_height_ui "Travel altitude" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt_rotation_ui "Spin amount" type:#integer range:[-10000, 10000, 0]
		Label wwmt_train_ui_label "Train to switch" align:#left
		EditText wwmt_train_ui "" type:#string
		PickButton wwmt_train_pickme_ui "Pick Train to switch" message:"Pick Target Entity for Train to switch" filter:target_name_filter
		on wwmt_train_pickme_ui picked obj do
		(
			train = obj.targetname
		)
		Label wwmt_toptrack_ui_label "Top track" align:#left
		EditText wwmt_toptrack_ui "" type:#string
		PickButton wwmt_toptrack_pickme_ui "Pick Top track" message:"Pick Target Entity for Top track" filter:target_name_filter
		on wwmt_toptrack_pickme_ui picked obj do
		(
			toptrack = obj.targetname
		)
		Label wwmt_bottomtrack_ui_label "Bottom track" align:#left
		EditText wwmt_bottomtrack_ui "" type:#string
		PickButton wwmt_bottomtrack_pickme_ui "Pick Bottom track" message:"Pick Target Entity for Bottom track" filter:target_name_filter
		on wwmt_bottomtrack_pickme_ui picked obj do
		(
			bottomtrack = obj.targetname
		)
		Label wwmt_label_speed_ui "Move/Rotate speed" align:#left
		Spinner wwmt_speed_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Auto Activate train" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Relink track" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Start at Bottom" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Rotate Only" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "X Axis" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Y Axis" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_trackautochange" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_trackautochange_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_trackautochange&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_trackautochange" address:"https://developer.valvesoftware.com/wiki/func_trackautochange?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_trackchange_CA = attributes "WW Entity func_trackchange" version: 78 attribID:#(287047038L,-316083132L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_trackchange"
	local isWWPRO = true
	local description = "Train track changing platform"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "renderfx", "rendermode", "renderamt", "rendercolor", "movesnd", "stopsnd", "volume", "height", "rotation", "train", "toptrack", "bottomtrack", "speed", "zhlt_lightflags", "light_origin", "style", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		volume type:#string ui:wwmt_volume_ui default:"0.85"
		height type:#integer ui:wwmt_height_ui default:0
		rotation type:#integer ui:wwmt_rotation_ui default:0
		train type:#string ui:wwmt_train_ui
		toptrack type:#string ui:wwmt_toptrack_ui
		bottomtrack type:#string ui:wwmt_bottomtrack_ui
		speed type:#integer ui:wwmt_speed_ui default:0
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_trackchange"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "big elev 1", "big elev 2", "tech elev 1", "tech elev 2", "tech elev 3", "freight elev 1", "freight elev 2", "heavy elev", "rack elev", "rail elev", "squeek elev", "odd elev 1", "odd elev 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "big elev stop1", "big elev stop2", "freight elev stop", "heavy elev stop", "rack stop", "rail stop", "squeek stop", "quick stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_volume_ui_label "Sound Volume 0.0 - 1.0" align:#left
		EditText wwmt_volume_ui "" type:#string
		Spinner wwmt_height_ui "Travel altitude" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt_rotation_ui "Spin amount" type:#integer range:[-10000, 10000, 0]
		Label wwmt_train_ui_label "Train to switch" align:#left
		EditText wwmt_train_ui "" type:#string
		PickButton wwmt_train_pickme_ui "Pick Train to switch" message:"Pick Target Entity for Train to switch" filter:target_name_filter
		on wwmt_train_pickme_ui picked obj do
		(
			train = obj.targetname
		)
		Label wwmt_toptrack_ui_label "Top track" align:#left
		EditText wwmt_toptrack_ui "" type:#string
		PickButton wwmt_toptrack_pickme_ui "Pick Top track" message:"Pick Target Entity for Top track" filter:target_name_filter
		on wwmt_toptrack_pickme_ui picked obj do
		(
			toptrack = obj.targetname
		)
		Label wwmt_bottomtrack_ui_label "Bottom track" align:#left
		EditText wwmt_bottomtrack_ui "" type:#string
		PickButton wwmt_bottomtrack_pickme_ui "Pick Bottom track" message:"Pick Target Entity for Bottom track" filter:target_name_filter
		on wwmt_bottomtrack_pickme_ui picked obj do
		(
			bottomtrack = obj.targetname
		)
		Label wwmt_label_speed_ui "Move/Rotate speed" align:#left
		Spinner wwmt_speed_ui "" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Auto Activate train" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Relink track" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Start at Bottom" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Rotate Only" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "X Axis" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Y Axis" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_trackchange" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_trackchange_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_trackchange&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_trackchange" address:"https://developer.valvesoftware.com/wiki/func_trackchange?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_tracktrain_CA = attributes "WW Entity func_tracktrain" version: 78 attribID:#(735805731L,1754041765L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_tracktrain"
	local isWWPRO = true
	local description = "Track Train"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "angles", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "style", "wwmt_target", "sounds", "wheels", "height", "startspeed", "speed", "dmg", "volume", "bank", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	local propValsounds = 0
	local propMapsounds = #("0", "1", "2", "3", "4", "5", "6")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		wwmt_target type:#string ui:wwmt_target_ui
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		wheels type:#integer ui:wwmt_wheels_ui default:50
		height type:#integer ui:wwmt_height_ui default:4
		startspeed type:#integer ui:wwmt_startspeed_ui default:0
		speed type:#integer ui:wwmt_speed_ui default:64
		dmg type:#integer ui:wwmt_dmg_ui default:0
		volume type:#integer ui:wwmt_volume_ui default:10
		bank type:#string ui:wwmt_bank_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_tracktrain"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_target_ui_label "First stop target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick First stop target" message:"Pick Target Entity for First stop target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		ComboBox wwmt_sounds_ui "Sound" type:#string items:#("None", "Rail 1", "Rail 2", "Rail 3", "Rail 4", "Rail 6", "Rail 7") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		Label wwmt_label_wheels_ui "Distance between the wheels" align:#left
		Spinner wwmt_wheels_ui "" type:#integer range:[-10000, 10000, 50]
		Label wwmt_label_height_ui "Height above track" align:#left
		Spinner wwmt_height_ui "" type:#integer range:[-10000, 10000, 4]
		Spinner wwmt_startspeed_ui "Initial speed" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_speed_ui "Speed (units per second)" align:#left
		Spinner wwmt_speed_ui "" type:#integer range:[-10000, 10000, 64]
		Spinner wwmt_dmg_ui "Damage on crush" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_volume_ui "Volume (10 = loudest)" align:#left
		Spinner wwmt_volume_ui "" type:#integer range:[-10000, 10000, 10]
		Label wwmt_bank_ui_label "Bank angle on turns" align:#left
		EditText wwmt_bank_ui "" type:#string
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "No Pitch (X-rot)" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "No User Control" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Passable" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_tracktrain" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_tracktrain_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_tracktrain&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_tracktrain" address:"https://developer.valvesoftware.com/wiki/func_tracktrain?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_train_CA = attributes "WW Entity func_train" version: 78 attribID:#(721320529L,828994452L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_train"
	local isWWPRO = true
	local description = "Moving platform"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "style", "wwmt_target", "movesnd", "stopsnd", "speed", "avelocity", "dmg", "skin", "volume", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propValskin = 0
	local propMapskin = #("0", "-1", "-3", "-4", "-5", "-7", "-16")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		wwmt_target type:#string ui:wwmt_target_ui
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		speed type:#integer ui:wwmt_speed_ui default:64
		avelocity type:#string ui:wwmt_avelocity_ui default:"0 0 0"
		dmg type:#integer ui:wwmt_dmg_ui default:0
		skin type:#string ui:wwmt_skin_ui default:"0"
		volume type:#string ui:wwmt_volume_ui default:"0.85"
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnflags type:#integer default:0
		on skin set val do
		(
			getNode()
			if (isValidNode thisNode AND classof thisNode != ::WallWormMDL AND val != undefined) then
			(
				if ::WallWormHelperOps != undefined then
				(
					::WallWormHelperOps.setProxySkin thisNode  val
				)
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_train"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_target_ui_label "First stop target" align:#left
		EditText wwmt_target_ui "" type:#string
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "big elev 1", "big elev 2", "tech elev 1", "tech elev 2", "tech elev 3", "freight elev 1", "freight elev 2", "heavy elev", "rack elev", "rail elev", "squeek elev", "odd elev 1", "odd elev 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "big elev stop1", "big elev stop2", "freight elev stop", "heavy elev stop", "rack stop", "rail stop", "squeek stop", "quick stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_label_speed_ui "Speed (units per second)" align:#left
		Spinner wwmt_speed_ui "" type:#integer range:[-10000, 10000, 64]
		Label wwmt_avelocity_ui_label "Angular velocity (Y Z X)" align:#left
		EditText wwmt_avelocity_ui "" type:#string
		Spinner wwmt_dmg_ui "Damage on crush" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_skin_ui "Contents (if not solid)" type:#string items:#("default", "if non solid Empty", "if non solid swimable water", "if non solid odd slime", "if non solid odd lava", "if non solid Volumetric Light", "if non solid odd ladder") height:3
		on wwmt_skin_ui selected i do
		(
			skin = propMapskin[i]
		)
		on wwmt_skin_ui entered tex do
		(
			skin = trimLeft(trimRight(tex))
			if propMapskin != undefined AND findItem propMapskin tex == 0 then
			(
				append propMapskin tex
				sort propMapskin
				wwmt_skin_ui.items = propMapskin
				wwmt_skin_ui.selection = findItem wwmt_skin_ui.items tex
			)
		)
		Label wwmt_volume_ui_label "Sound Volume 0.0 - 1.0" align:#left
		EditText wwmt_volume_ui "" type:#string
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_8_ui "Not solid" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_train" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_train_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_train&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_train" address:"https://developer.valvesoftware.com/wiki/func_train?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			if skin != undefined then
			(
				if findItem propMapskin skin == 0 then
				(
					append propMapskin skin
					local tmp = wwmt_skin_ui.items
					append tmp skin
					wwmt_skin_ui.items = tmp
					wwmt_skin_ui.selection = propMapskin.count
				)
				else
				(
					wwmt_skin_ui.selection = (findItem propMapskin skin)
				)
			)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_traincontrols_CA = attributes "WW Entity func_traincontrols" version: 78 attribID:#(-1629377049L,122952090L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_traincontrols"
	local isWWPRO = true
	local description = "Train Controls"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		wwmt_target type:#string ui:wwmt_target_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_traincontrols"
		Label wwmt_target_ui_label "Train Name" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Train Name" message:"Pick Target Entity for Train Name" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_traincontrols" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_traincontrols_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_traincontrols&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_traincontrols" address:"https://developer.valvesoftware.com/wiki/func_traincontrols?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_vehicle_CA = attributes "WW Entity func_vehicle" version: 78 attribID:#(4420747L,-360788196L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_vehicle"
	local isWWPRO = true
	local description = "Drivable Vehicles"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "style", "wwmt_target", "sounds", "length", "width", "height", "startspeed", "speed", "dmg", "volume", "bank", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	local propValsounds = 0
	local propMapsounds = #("0", "1", "2", "3", "4", "5", "6")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		wwmt_target type:#string ui:wwmt_target_ui
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		length type:#integer ui:wwmt_length_ui default:256
		width type:#integer ui:wwmt_width_ui default:128
		height type:#integer ui:wwmt_height_ui default:4
		startspeed type:#integer ui:wwmt_startspeed_ui default:0
		speed type:#integer ui:wwmt_speed_ui default:64
		dmg type:#integer ui:wwmt_dmg_ui default:0
		volume type:#integer ui:wwmt_volume_ui default:10
		bank type:#string ui:wwmt_bank_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_vehicle"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_target_ui_label "First stop target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick First stop target" message:"Pick Target Entity for First stop target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		ComboBox wwmt_sounds_ui "Sound" type:#string items:#("None", "Vehicle 1", "Vehicle 2", "Vehicle 3", "Vehicle 4", "Vehicle 6", "Vehicle 7") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		Label wwmt_label_length_ui "Length of the vehicle" align:#left
		Spinner wwmt_length_ui "" type:#integer range:[-10000, 10000, 256]
		Label wwmt_label_width_ui "Width of the vehicle" align:#left
		Spinner wwmt_width_ui "" type:#integer range:[-10000, 10000, 128]
		Label wwmt_label_height_ui "Height above track" align:#left
		Spinner wwmt_height_ui "" type:#integer range:[-10000, 10000, 4]
		Spinner wwmt_startspeed_ui "Initial speed" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_speed_ui "Speed (units per second)" align:#left
		Spinner wwmt_speed_ui "" type:#integer range:[-10000, 10000, 64]
		Spinner wwmt_dmg_ui "Damage on crush" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_volume_ui "Volume (10 = loudest)" align:#left
		Spinner wwmt_volume_ui "" type:#integer range:[-10000, 10000, 10]
		Label wwmt_bank_ui_label "Bank angle on turns" align:#left
		EditText wwmt_bank_ui "" type:#string
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "No Pitch (X-rot)" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "No User Control" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Passable" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_vehicle" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_vehicle_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_vehicle&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_vehicle" address:"https://developer.valvesoftware.com/wiki/func_vehicle?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_vehiclecontrols_CA = attributes "WW Entity func_vehiclecontrols" version: 78 attribID:#(-393459068L,1014015997L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_vehiclecontrols"
	local isWWPRO = true
	local description = "Vehicle Controls"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		wwmt_target type:#string ui:wwmt_target_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_vehiclecontrols"
		Label wwmt_target_ui_label "Vehicle Name" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Vehicle Name" message:"Pick Target Entity for Vehicle Name" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_vehiclecontrols" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_vehiclecontrols_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_vehiclecontrols&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_vehiclecontrols" address:"https://developer.valvesoftware.com/wiki/func_vehiclecontrols?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_vip_safetyzone_CA = attributes "WW Entity func_vip_safetyzone" version: 78 attribID:#(1832170701L,-598038102L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_vip_safetyzone"
	local isWWPRO = true
	local description = "VIP safety zone"
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_vip_safetyzone"
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_vip_safetyzone" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_vip_safetyzone_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_vip_safetyzone&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_vip_safetyzone" address:"https://developer.valvesoftware.com/wiki/func_vip_safetyzone?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined)
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_wall_CA = attributes "WW Entity func_wall" version: 78 attribID:#(533770476L,808840333L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_wall"
	local isWWPRO = true
	local description = "Wall"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "style", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_wall"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_wall" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_wall_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_wall&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_wall" address:"https://developer.valvesoftware.com/wiki/func_wall?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_wall_toggle_CA = attributes "WW Entity func_wall_toggle" version: 78 attribID:#(1953887547L,1060694057L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_wall_toggle"
	local isWWPRO = true
	local description = "Toggleable geometry"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "style", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValstyle = 0
	local propMapstyle = #("0", "-3", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		style type:#string ui:wwmt_style_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_wall_toggle"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		ComboBox wwmt_style_ui "Texture Light Style" type:#string items:#("Normal", "Switch with TL@name", "Flicker A", "Slow, strong pulse", "Candle A", "Fast strobe", "Gentle pulse", "Flicker B", "Candle B", "Candle C", "Slow strobe", "Fluorescent flicker", "Slow pulse, noblack", "underwater weird & buggy") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_1_ui "Starts Invisible" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_wall_toggle" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_wall_toggle_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_wall_toggle&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_wall_toggle" address:"https://developer.valvesoftware.com/wiki/func_wall_toggle?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_water_CA = attributes "WW Entity func_water" version: 78 attribID:#(721320529L,-1779180711L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_water"
	local isWWPRO = true
	local description = "Liquid"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "master", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "wwmt_target", "delay", "killtarget", "speed", "movesnd", "stopsnd", "wait", "lip", "dmg", "message", "netname", "health", "locked_sound", "unlocked_sound", "locked_sentence", "unlocked_sentence", "_minlight", "skin", "WaveHeight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propVallocked_sound = 0
	local propMaplocked_sound = #("0", "2", "8", "10", "11", "12")
	local propValunlocked_sound = 0
	local propMapunlocked_sound = #("0", "1", "3", "4", "5", "6", "7", "8", "9", "10", "13")
	local propVallocked_sentence = 0
	local propMaplocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
	local propValunlocked_sentence = 0
	local propMapunlocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propValskin = -3
	local propMapskin = #("-1", "-3", "-4", "-5", "-16")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		master type:#string ui:wwmt_master_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#integer ui:wwmt_delay_ui default:0
		killtarget type:#string ui:wwmt_killtarget_ui
		speed type:#integer ui:wwmt_speed_ui default:100
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		wait type:#integer ui:wwmt_wait_ui default:4
		lip type:#integer ui:wwmt_lip_ui default:0
		dmg type:#integer ui:wwmt_dmg_ui default:0
		message type:#string ui:wwmt_message_ui
		netname type:#string ui:wwmt_netname_ui
		health type:#integer ui:wwmt_health_ui default:0
		locked_sound type:#string ui:wwmt_locked_sound_ui default:"0"
		unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:"0"
		locked_sentence type:#string ui:wwmt_locked_sentence_ui default:"0"
		unlocked_sentence type:#string ui:wwmt_unlocked_sentence_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		skin type:#string ui:wwmt_skin_ui default:"-3"
		WaveHeight type:#string ui:wwmt_WaveHeight_ui default:"0"
		spawnflags type:#integer default:0
		on skin set val do
		(
			getNode()
			if (isValidNode thisNode AND classof thisNode != ::WallWormMDL AND val != undefined) then
			(
				if ::WallWormHelperOps != undefined then
				(
					::WallWormHelperOps.setProxySkin thisNode  val
				)
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_water"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_label_delay_ui "Delay before fire" align:#left
		Spinner wwmt_delay_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 100]
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "Servo (Sliding)", "Pneumatic (Sliding)", "Pneumatic (Rolling)", "Vacuum", "Power Hydraulic", "Large Rollers", "Track Door", "Snappy Metal Door", "Squeaky 1", "Squeaky 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "Clang with brake", "Clang reverb", "Ratchet Stop", "Chunk", "Light airbrake", "Metal Slide Stop", "Metal Lock Stop", "Snappy Metal Stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_label_wait_ui "delay before close, -1 stay open " align:#left
		Spinner wwmt_wait_ui "" type:#integer range:[-10000, 10000, 4]
		Spinner wwmt_lip_ui "Lip" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_dmg_ui "Damage inflicted when blocked" align:#left
		Spinner wwmt_dmg_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_message_ui_label "Message if triggered" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_netname_ui_label "Fire on Close" align:#left
		EditText wwmt_netname_ui "" type:#string
		Label wwmt_label_health_ui "Health (shoot open)" align:#left
		Spinner wwmt_health_ui "" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_locked_sound_ui "Locked Sound" type:#string items:#("None", "Access Denied", "Small zap", "Buzz", "Buzz Off", "Latch Locked") height:3
		on wwmt_locked_sound_ui selected i do
		(
			locked_sound = propMaplocked_sound[i]
		)
		on wwmt_locked_sound_ui entered tex do
		(
			locked_sound = trimLeft(trimRight(tex))
			if propMaplocked_sound != undefined AND findItem propMaplocked_sound tex == 0 then
			(
				append propMaplocked_sound tex
				sort propMaplocked_sound
				wwmt_locked_sound_ui.items = propMaplocked_sound
				wwmt_locked_sound_ui.selection = findItem wwmt_locked_sound_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sound_ui "Unlocked Sound" type:#string items:#("None", "Big zap & Warmup", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Latch Unlocked") height:3
		on wwmt_unlocked_sound_ui selected i do
		(
			unlocked_sound = propMapunlocked_sound[i]
		)
		on wwmt_unlocked_sound_ui entered tex do
		(
			unlocked_sound = trimLeft(trimRight(tex))
			if propMapunlocked_sound != undefined AND findItem propMapunlocked_sound tex == 0 then
			(
				append propMapunlocked_sound tex
				sort propMapunlocked_sound
				wwmt_unlocked_sound_ui.items = propMapunlocked_sound
				wwmt_unlocked_sound_ui.selection = findItem wwmt_unlocked_sound_ui.items tex
			)
		)
		ComboBox wwmt_locked_sentence_ui "Locked Sentence" type:#string items:#("None", "Gen. Access Denied", "Security Lockout", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance Door", "Broken Shut Door") height:3
		on wwmt_locked_sentence_ui selected i do
		(
			locked_sentence = propMaplocked_sentence[i]
		)
		on wwmt_locked_sentence_ui entered tex do
		(
			locked_sentence = trimLeft(trimRight(tex))
			if propMaplocked_sentence != undefined AND findItem propMaplocked_sentence tex == 0 then
			(
				append propMaplocked_sentence tex
				sort propMaplocked_sentence
				wwmt_locked_sentence_ui.items = propMaplocked_sentence
				wwmt_locked_sentence_ui.selection = findItem wwmt_locked_sentence_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sentence_ui "Unlocked Sentence" type:#string items:#("None", "Gen. Access Granted", "Security Disengaged", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance area") height:3
		on wwmt_unlocked_sentence_ui selected i do
		(
			unlocked_sentence = propMapunlocked_sentence[i]
		)
		on wwmt_unlocked_sentence_ui entered tex do
		(
			unlocked_sentence = trimLeft(trimRight(tex))
			if propMapunlocked_sentence != undefined AND findItem propMapunlocked_sentence tex == 0 then
			(
				append propMapunlocked_sentence tex
				sort propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.items = propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.selection = findItem wwmt_unlocked_sentence_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		ComboBox wwmt_skin_ui "Contents" type:#string items:#("Empty", "Water", "Slime", "Lava", "ladder (only with non ! texture)") height:3
		on wwmt_skin_ui selected i do
		(
			skin = propMapskin[i]
		)
		on wwmt_skin_ui entered tex do
		(
			skin = trimLeft(trimRight(tex))
			if propMapskin != undefined AND findItem propMapskin tex == 0 then
			(
				append propMapskin tex
				sort propMapskin
				wwmt_skin_ui.items = propMapskin
				wwmt_skin_ui.selection = findItem wwmt_skin_ui.items tex
			)
		)
		Label wwmt_WaveHeight_ui_label "Wave Height" align:#left
		EditText wwmt_WaveHeight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_1_ui "Starts Open" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Don't link" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Passable" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Toggle" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Use Only" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_water" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_water_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_water&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_water" address:"https://developer.valvesoftware.com/wiki/func_water?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			if locked_sound != undefined then
			(
				if findItem propMaplocked_sound locked_sound == 0 then
				(
					append propMaplocked_sound locked_sound
					local tmp = wwmt_locked_sound_ui.items
					append tmp locked_sound
					wwmt_locked_sound_ui.items = tmp
					wwmt_locked_sound_ui.selection = propMaplocked_sound.count
				)
				else
				(
					wwmt_locked_sound_ui.selection = (findItem propMaplocked_sound locked_sound)
				)
			)
			if unlocked_sound != undefined then
			(
				if findItem propMapunlocked_sound unlocked_sound == 0 then
				(
					append propMapunlocked_sound unlocked_sound
					local tmp = wwmt_unlocked_sound_ui.items
					append tmp unlocked_sound
					wwmt_unlocked_sound_ui.items = tmp
					wwmt_unlocked_sound_ui.selection = propMapunlocked_sound.count
				)
				else
				(
					wwmt_unlocked_sound_ui.selection = (findItem propMapunlocked_sound unlocked_sound)
				)
			)
			if locked_sentence != undefined then
			(
				if findItem propMaplocked_sentence locked_sentence == 0 then
				(
					append propMaplocked_sentence locked_sentence
					local tmp = wwmt_locked_sentence_ui.items
					append tmp locked_sentence
					wwmt_locked_sentence_ui.items = tmp
					wwmt_locked_sentence_ui.selection = propMaplocked_sentence.count
				)
				else
				(
					wwmt_locked_sentence_ui.selection = (findItem propMaplocked_sentence locked_sentence)
				)
			)
			if unlocked_sentence != undefined then
			(
				if findItem propMapunlocked_sentence unlocked_sentence == 0 then
				(
					append propMapunlocked_sentence unlocked_sentence
					local tmp = wwmt_unlocked_sentence_ui.items
					append tmp unlocked_sentence
					wwmt_unlocked_sentence_ui.items = tmp
					wwmt_unlocked_sentence_ui.selection = propMapunlocked_sentence.count
				)
				else
				(
					wwmt_unlocked_sentence_ui.selection = (findItem propMapunlocked_sentence unlocked_sentence)
				)
			)
			if skin != undefined then
			(
				if findItem propMapskin skin == 0 then
				(
					append propMapskin skin
					local tmp = wwmt_skin_ui.items
					append tmp skin
					wwmt_skin_ui.items = tmp
					wwmt_skin_ui.selection = propMapskin.count
				)
				else
				(
					wwmt_skin_ui.selection = (findItem propMapskin skin)
				)
			)
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_button_target_CA = attributes "WW Entity button_target" version: 78 attribID:#(1993738382L,232959494L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "button_target"
	local isWWPRO = true
	local description = "Target Button"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("master", "wwmt_target", "angles", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		master type:#string ui:wwmt_master_ui
		wwmt_target type:#string ui:wwmt_target_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		spawnflags type:#integer default:1
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "button_target"
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Use Activates" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Start On" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with button_target" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"button_target_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=button_target&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: button_target" address:"https://developer.valvesoftware.com/wiki/button_target?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_momentary_door_CA = attributes "WW Entity momentary_door" version: 78 attribID:#(62814769L,-1583901336L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "momentary_door"
	local isWWPRO = true
	local description = "Momentary/Continuous door"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalname", "master", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "wwmt_target", "delay", "killtarget", "speed", "movesnd", "stopsnd", "wait", "lip", "dmg", "message", "netname", "health", "locked_sound", "unlocked_sound", "locked_sentence", "unlocked_sentence", "_minlight", "zhlt_lightflags", "light_origin")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propVallocked_sound = 0
	local propMaplocked_sound = #("0", "2", "8", "10", "11", "12")
	local propValunlocked_sound = 0
	local propMapunlocked_sound = #("0", "1", "3", "4", "5", "6", "7", "8", "9", "10", "13")
	local propVallocked_sentence = 0
	local propMaplocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
	local propValunlocked_sentence = 0
	local propMapunlocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		globalname type:#string ui:wwmt_globalname_ui
		master type:#string ui:wwmt_master_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#integer ui:wwmt_delay_ui default:0
		killtarget type:#string ui:wwmt_killtarget_ui
		speed type:#integer ui:wwmt_speed_ui default:100
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		wait type:#integer ui:wwmt_wait_ui default:4
		lip type:#integer ui:wwmt_lip_ui default:0
		dmg type:#integer ui:wwmt_dmg_ui default:0
		message type:#string ui:wwmt_message_ui
		netname type:#string ui:wwmt_netname_ui
		health type:#integer ui:wwmt_health_ui default:0
		locked_sound type:#string ui:wwmt_locked_sound_ui default:"0"
		unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:"0"
		locked_sentence type:#string ui:wwmt_locked_sentence_ui default:"0"
		unlocked_sentence type:#string ui:wwmt_unlocked_sentence_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "momentary_door"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalname_ui_label "Global Entity Name" align:#left
		EditText wwmt_globalname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_label_delay_ui "Delay before fire" align:#left
		Spinner wwmt_delay_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 100]
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "Servo (Sliding)", "Pneumatic (Sliding)", "Pneumatic (Rolling)", "Vacuum", "Power Hydraulic", "Large Rollers", "Track Door", "Snappy Metal Door", "Squeaky 1", "Squeaky 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "Clang with brake", "Clang reverb", "Ratchet Stop", "Chunk", "Light airbrake", "Metal Slide Stop", "Metal Lock Stop", "Snappy Metal Stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_label_wait_ui "delay before close, -1 stay open " align:#left
		Spinner wwmt_wait_ui "" type:#integer range:[-10000, 10000, 4]
		Spinner wwmt_lip_ui "Lip" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_dmg_ui "Damage inflicted when blocked" align:#left
		Spinner wwmt_dmg_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_message_ui_label "Message if triggered" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_netname_ui_label "Fire on Close" align:#left
		EditText wwmt_netname_ui "" type:#string
		Label wwmt_label_health_ui "Health (shoot open)" align:#left
		Spinner wwmt_health_ui "" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_locked_sound_ui "Locked Sound" type:#string items:#("None", "Access Denied", "Small zap", "Buzz", "Buzz Off", "Latch Locked") height:3
		on wwmt_locked_sound_ui selected i do
		(
			locked_sound = propMaplocked_sound[i]
		)
		on wwmt_locked_sound_ui entered tex do
		(
			locked_sound = trimLeft(trimRight(tex))
			if propMaplocked_sound != undefined AND findItem propMaplocked_sound tex == 0 then
			(
				append propMaplocked_sound tex
				sort propMaplocked_sound
				wwmt_locked_sound_ui.items = propMaplocked_sound
				wwmt_locked_sound_ui.selection = findItem wwmt_locked_sound_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sound_ui "Unlocked Sound" type:#string items:#("None", "Big zap & Warmup", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Latch Unlocked") height:3
		on wwmt_unlocked_sound_ui selected i do
		(
			unlocked_sound = propMapunlocked_sound[i]
		)
		on wwmt_unlocked_sound_ui entered tex do
		(
			unlocked_sound = trimLeft(trimRight(tex))
			if propMapunlocked_sound != undefined AND findItem propMapunlocked_sound tex == 0 then
			(
				append propMapunlocked_sound tex
				sort propMapunlocked_sound
				wwmt_unlocked_sound_ui.items = propMapunlocked_sound
				wwmt_unlocked_sound_ui.selection = findItem wwmt_unlocked_sound_ui.items tex
			)
		)
		ComboBox wwmt_locked_sentence_ui "Locked Sentence" type:#string items:#("None", "Gen. Access Denied", "Security Lockout", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance Door", "Broken Shut Door") height:3
		on wwmt_locked_sentence_ui selected i do
		(
			locked_sentence = propMaplocked_sentence[i]
		)
		on wwmt_locked_sentence_ui entered tex do
		(
			locked_sentence = trimLeft(trimRight(tex))
			if propMaplocked_sentence != undefined AND findItem propMaplocked_sentence tex == 0 then
			(
				append propMaplocked_sentence tex
				sort propMaplocked_sentence
				wwmt_locked_sentence_ui.items = propMaplocked_sentence
				wwmt_locked_sentence_ui.selection = findItem wwmt_locked_sentence_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sentence_ui "Unlocked Sentence" type:#string items:#("None", "Gen. Access Granted", "Security Disengaged", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance area") height:3
		on wwmt_unlocked_sentence_ui selected i do
		(
			unlocked_sentence = propMapunlocked_sentence[i]
		)
		on wwmt_unlocked_sentence_ui entered tex do
		(
			unlocked_sentence = trimLeft(trimRight(tex))
			if propMapunlocked_sentence != undefined AND findItem propMapunlocked_sentence tex == 0 then
			(
				append propMapunlocked_sentence tex
				sort propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.items = propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.selection = findItem wwmt_unlocked_sentence_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_1_ui "Starts Open" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Don't link" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Passable" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Toggle" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Use Only" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with momentary_door" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"momentary_door_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=momentary_door&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: momentary_door" address:"https://developer.valvesoftware.com/wiki/momentary_door?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			if locked_sound != undefined then
			(
				if findItem propMaplocked_sound locked_sound == 0 then
				(
					append propMaplocked_sound locked_sound
					local tmp = wwmt_locked_sound_ui.items
					append tmp locked_sound
					wwmt_locked_sound_ui.items = tmp
					wwmt_locked_sound_ui.selection = propMaplocked_sound.count
				)
				else
				(
					wwmt_locked_sound_ui.selection = (findItem propMaplocked_sound locked_sound)
				)
			)
			if unlocked_sound != undefined then
			(
				if findItem propMapunlocked_sound unlocked_sound == 0 then
				(
					append propMapunlocked_sound unlocked_sound
					local tmp = wwmt_unlocked_sound_ui.items
					append tmp unlocked_sound
					wwmt_unlocked_sound_ui.items = tmp
					wwmt_unlocked_sound_ui.selection = propMapunlocked_sound.count
				)
				else
				(
					wwmt_unlocked_sound_ui.selection = (findItem propMapunlocked_sound unlocked_sound)
				)
			)
			if locked_sentence != undefined then
			(
				if findItem propMaplocked_sentence locked_sentence == 0 then
				(
					append propMaplocked_sentence locked_sentence
					local tmp = wwmt_locked_sentence_ui.items
					append tmp locked_sentence
					wwmt_locked_sentence_ui.items = tmp
					wwmt_locked_sentence_ui.selection = propMaplocked_sentence.count
				)
				else
				(
					wwmt_locked_sentence_ui.selection = (findItem propMaplocked_sentence locked_sentence)
				)
			)
			if unlocked_sentence != undefined then
			(
				if findItem propMapunlocked_sentence unlocked_sentence == 0 then
				(
					append propMapunlocked_sentence unlocked_sentence
					local tmp = wwmt_unlocked_sentence_ui.items
					append tmp unlocked_sentence
					wwmt_unlocked_sentence_ui.items = tmp
					wwmt_unlocked_sentence_ui.selection = propMapunlocked_sentence.count
				)
				else
				(
					wwmt_unlocked_sentence_ui.selection = (findItem propMapunlocked_sentence unlocked_sentence)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_momentary_rot_button_CA = attributes "WW Entity momentary_rot_button" version: 78 attribID:#(1150846017L,-748493796L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "momentary_rot_button"
	local isWWPRO = true
	local description = "Direct wheel control"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "master", "angles", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "light_origin", "wwmt_target", "speed", "sounds", "distance", "returnspeed", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3", "6")
	local propValsounds = 0
	local propMapsounds = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "21", "22", "23", "24", "25")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		master type:#string ui:wwmt_master_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		light_origin type:#string ui:wwmt_light_origin_ui
		wwmt_target type:#string ui:wwmt_target_ui
		speed type:#integer ui:wwmt_speed_ui default:50
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		distance type:#integer ui:wwmt_distance_ui default:90
		returnspeed type:#integer ui:wwmt_returnspeed_ui default:0
		_minlight type:#string ui:wwmt__minlight_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "momentary_rot_button"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix", "Opaque + Concave Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt_light_origin_ui_label "Light Origin (Zhlt 2.2+)" align:#left
		EditText wwmt_light_origin_ui "" type:#string
		Label wwmt_target_ui_label "Targetted object" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Targetted object" message:"Pick Target Entity for Targetted object" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 50]
		ComboBox wwmt_sounds_ui "Sounds" type:#string items:#("None", "Big zap & Warmup", "Access Denied", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Squeaky", "Squeaky Pneumatic", "Ratchet Groan", "Clean Ratchet", "Gas Clunk") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		Spinner wwmt_distance_ui "Distance (deg)" type:#integer range:[-10000, 10000, 90]
		Label wwmt_label_returnspeed_ui "Auto-return speed" align:#left
		Spinner wwmt_returnspeed_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Door Hack" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Not useable" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Auto Return" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "X Axis" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Y Axis" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with momentary_rot_button" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"momentary_rot_button_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=momentary_rot_button&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: momentary_rot_button" address:"https://developer.valvesoftware.com/wiki/momentary_rot_button?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_weapon_c4_CA = attributes "WW Entity weapon_c4" version: 78 attribID:#(1454393059L,654072105L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "weapon_c4"
	local isWWPRO = true
	local description = "C4 Plastique Bomb"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "wwmt_target", "delay", "killtarget", "renderfx", "rendermode", "renderamt", "rendercolor", "detonatedelay", "detonatetarget", "defusetarget")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/Armoury.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		detonatedelay type:#string ui:wwmt_detonatedelay_ui default:"20"
		detonatetarget type:#string ui:wwmt_detonatetarget_ui
		defusetarget type:#string ui:wwmt_defusetarget_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "weapon_c4"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_detonatedelay_ui_label "C4 Detonate Delay" align:#left
		EditText wwmt_detonatedelay_ui "" type:#string
		Label wwmt_detonatetarget_ui_label "Trigger When Detonated" align:#left
		EditText wwmt_detonatetarget_ui "" type:#string
		Label wwmt_defusetarget_ui_label "Trigger When Defused" align:#left
		EditText wwmt_defusetarget_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_2048_ui.checked == true then
			(
				sfs += 2048
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_2048_ui "Not in Deathmatch" type:#integer
			on flag_2048_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=weapon_c4&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: weapon_c4" address:"https://developer.valvesoftware.com/wiki/weapon_c4?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			flag_2048_ui.checked = (bit.and (getProperty this #spawnflags) 2048 == 2048)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_xen_plantlight_CA = attributes "WW Entity xen_plantlight" version: 78 attribID:#(-1387835263L,-1105938204L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "xen_plantlight"
	local isWWPRO = true
	local description = "Xen Plant Light"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "angles", "renderfx", "rendermode", "renderamt", "rendercolor")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "xen_plantlight"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=xen_plantlight&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: xen_plantlight" address:"https://developer.valvesoftware.com/wiki/xen_plantlight?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_xen_hair_CA = attributes "WW Entity xen_hair" version: 78 attribID:#(600769998L,856243282L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "xen_hair"
	local isWWPRO = true
	local description = "Xen Hair"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "renderfx", "rendermode", "renderamt", "rendercolor")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "xen_hair"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Sync Movement" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=xen_hair&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: xen_hair" address:"https://developer.valvesoftware.com/wiki/xen_hair?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_xen_tree_CA = attributes "WW Entity xen_tree" version: 78 attribID:#(600769998L,-971704210L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "xen_tree"
	local isWWPRO = true
	local description = "Xen Tree"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "renderfx", "rendermode", "renderamt", "rendercolor")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "xen_tree"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=xen_tree&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: xen_tree" address:"https://developer.valvesoftware.com/wiki/xen_tree?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_xen_spore_small_CA = attributes "WW Entity xen_spore_small" version: 78 attribID:#(937763674L,795171295L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "xen_spore_small"
	local isWWPRO = true
	local description = "Xen Spore (small)"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "renderfx", "rendermode", "renderamt", "rendercolor")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "xen_spore_small"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=xen_spore_small&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: xen_spore_small" address:"https://developer.valvesoftware.com/wiki/xen_spore_small?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_xen_spore_medium_CA = attributes "WW Entity xen_spore_medium" version: 78 attribID:#(-1091667360L,-963347005L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "xen_spore_medium"
	local isWWPRO = true
	local description = "Xen Spore (medium)"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "renderfx", "rendermode", "renderamt", "rendercolor")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "xen_spore_medium"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=xen_spore_medium&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: xen_spore_medium" address:"https://developer.valvesoftware.com/wiki/xen_spore_medium?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_xen_spore_large_CA = attributes "WW Entity xen_spore_large" version: 78 attribID:#(937763674L,-82271403L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "xen_spore_large"
	local isWWPRO = true
	local description = "Xen Spore (large)"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "renderfx", "rendermode", "renderamt", "rendercolor")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:255
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "xen_spore_large"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Constant Glow (Sprites)", "Distort (Models)", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal - no light", "Pure Color", "Texture - some light", "Glow (sprites only)", "Solid - no light", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 255]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=xen_spore_large&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: xen_spore_large" address:"https://developer.valvesoftware.com/wiki/xen_spore_large?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
