::wallworm_mapsize = [0, 0]
::wallworm_point_entity_list = #("cycler_sprite", "env_beam", "env_beverage", "env_blood", "env_explosion", "env_global", "env_glow", "env_laser", "env_message", "env_render", "env_shake", "env_shooter", "env_sound", "env_spark", "env_sprite", "infodecal", "info_null", "info_player_deathmatch", "info_player_start", "info_vip_start", "info_target", "light", "light_environment", "light_spot", "trigger_auto", "trigger_camera", "trigger_changetarget", "trigger_relay", "ambient_generic", "multi_manager", "multisource", "path_corner", "path_track", "hostage_entity", "info_hostage_rescue", "info_bomb_target", "armoury_entity", "info_map_parameters")
::wallworm_brush_entity_list = #("worldspawn", "env_bubbles", "func_breakable", "func_button", "func_conveyor", "func_door", "func_door_rotating", "func_friction", "func_illusionary", "func_ladder", "func_mortar_field", "func_pendulum", "func_plat", "func_platrot", "func_pushable", "func_rot_button", "func_rotating", "func_tank", "func_tankcontrols", "func_tankmortar", "func_tankrocket", "func_trackautochange", "func_trackchange", "func_tracktrain", "func_train", "func_traincontrols", "func_wall", "func_wall_toggle", "func_water", "trigger_counter", "trigger_hurt", "trigger_multiple", "trigger_once", "trigger_push", "trigger_teleport", "button_target", "momentary_door", "momentary_rot_button", "func_hostage_rescue", "func_bomb_target", "func_buyzone", "func_escapezone", "func_vip_safetyzone", "func_vehicle", "func_vehiclecontrols")

fileIn (::wallworm_installation_path + "/WallWorm.com/common/fgd_funcs.ms")
::wallworm_worldspawn_CA = attributes "WW Entity worldspawn" version: 78 attribID:#(391958850L,-112077181L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "worldspawn"
	local isWWPRO = true
	local description = "World entity"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("message", "skyname", "light", "WaveHeight", "MaxRange")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		message type:#string ui:wwmt_message_ui
		skyname type:#string ui:wwmt_skyname_ui
		light type:#integer ui:wwmt_light_ui
		WaveHeight type:#string ui:wwmt_WaveHeight_ui
		MaxRange type:#string ui:wwmt_MaxRange_ui default:"4096"
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "worldspawn"
		Label wwmt_message_ui_label "Map Description / Title" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_skyname_ui_label "environment map (cl_skyname)" align:#left
		EditText wwmt_skyname_ui "" type:#string
		Label wwmt_label_light_ui "Default light level" align:#left
		Spinner wwmt_light_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_WaveHeight_ui_label "Default Wave Height" align:#left
		EditText wwmt_WaveHeight_ui "" type:#string
		Label wwmt_MaxRange_ui_label "Max viewable distance" align:#left
		EditText wwmt_MaxRange_ui "" type:#string
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=worldspawn&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: worldspawn" address:"https://developer.valvesoftware.com/wiki/worldspawn?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_cycler_sprite_CA = attributes "WW Entity cycler_sprite" version: 78 attribID:#(802606826L,-266448266L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "cycler_sprite"
	local isWWPRO = true
	local description = "Sprite Cycler"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "model", "framerate", "renderfx", "rendermode", "renderamt", "rendercolor")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	function target_wwmt_filter obj =
	(
		if ((isProperty obj #wwmt_ca OR isProperty obj #wallwormProxy) AND isProperty obj #wallworm) then
		(
			true
		)
		else
		(
			false
		)
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		model type:#string ui:wwmt_model_ui
		framerate type:#integer ui:wwmt_framerate_ui default:10
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "cycler_sprite"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_model_ui_label "Sprite" align:#left
		EditText wwmt_model_ui "" type:#string
		PickButton wwmt_model_pickwwmt_ui "wwmt" align:#left across:3 message:"Pick WWMT OR Proxy from scene Sprite" filter:target_wwmt_filter tooltip:"Create a proxy from a model in the scene."
		on wwmt_model_pickwwmt_ui picked obj do
		(
			local wwmt = obj.getWWMT()
			if wwmt != undefined AND (getNode()) != undefined then
			(
				wwmt.updateObjectAsProxy thisNode useRotation:false
			)
		)
		Button wwmt_model_importwmt_ui "import" tooltip:"Import a QC AND create a proxy."
		on wwmt_model_importwmt_ui pressed do with undo label:"Import QC" on
		(
			::wallworm_import_qc_from_filename
			if ::wallworm_import_qc_from_filename == undefined then
			(
				fileIn (::wallworm_installation_path + "/WallWorm.com/importers/Mario_Kart_SMD_Importer.ms")
			)
			local fsource = GetOpenFileName historyCategory:"Wall Worm SMD Exporter" types: "QC File (*.qc)|*.QC|All files (*.*)|*.*|"
			if fsource != undefined AND wallworm_import_qc_from_filename != undefined then
			(
				wwmt = ::wallworm_import_qc_from_filename fsource saveToLib:true tnoVMF:true skipLODS:true deepSearchMaterials:false
				if wwmt != undefined then
				(
					if (getNode()) != undefined then
					(
						wwmt.updateObjectAsProxy thisNode
					)
				)
			)
		)
		Button wwmt_model_libwmt_ui "library" tooltip:"Use a prop in the prop library. Right-click to load the mesh rotated 90 degrees."
		on wwmt_model_libwmt_ui pressed do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:false
		)
		on wwmt_model_libwmt_ui rightClick do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:true
		)
		Label wwmt_label_framerate_ui "Frames per second" align:#left
		Spinner wwmt_framerate_ui "" type:#integer range:[-10000, 10000, 10]
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=cycler_sprite&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: cycler_sprite" address:"https://developer.valvesoftware.com/wiki/cycler_sprite?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_beam_CA = attributes "WW Entity env_beam" version: 78 attribID:#(654729850L,1051108103L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_beam"
	local isWWPRO = true
	local description = "Energy Beam Effect"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "LightningStart", "LightningEnd", "renderfx", "renderamt", "rendercolor", "Radius", "life", "BoltWidth", "NoiseAmplitude", "texture", "TextureScroll", "framerate", "framestart", "StrikeTime", "damage")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		LightningStart type:#string ui:wwmt_LightningStart_ui
		LightningEnd type:#string ui:wwmt_LightningEnd_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui default:100
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		Radius type:#integer ui:wwmt_Radius_ui default:256
		life type:#string ui:wwmt_life_ui default:"1"
		BoltWidth type:#integer ui:wwmt_BoltWidth_ui default:20
		NoiseAmplitude type:#integer ui:wwmt_NoiseAmplitude_ui default:0
		texture type:#string ui:wwmt_texture_ui default:"sprites/laserbeam.spr"
		TextureScroll type:#integer ui:wwmt_TextureScroll_ui default:35
		framerate type:#integer ui:wwmt_framerate_ui default:0
		framestart type:#integer ui:wwmt_framestart_ui default:0
		StrikeTime type:#string ui:wwmt_StrikeTime_ui default:"1"
		damage type:#string ui:wwmt_damage_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_beam"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_LightningStart_ui_label "Start Entity" align:#left
		EditText wwmt_LightningStart_ui "" type:#string
		PickButton wwmt_LightningStart_pickme_ui "Pick Start Entity" message:"Pick Target Entity for Start Entity" filter:target_name_filter
		on wwmt_LightningStart_pickme_ui picked obj do
		(
			LightningStart = obj.targetname
		)
		Label wwmt_LightningEnd_ui_label "Ending Entity" align:#left
		EditText wwmt_LightningEnd_ui "" type:#string
		PickButton wwmt_LightningEnd_pickme_ui "Pick Ending Entity" message:"Pick Target Entity for Ending Entity" filter:target_name_filter
		on wwmt_LightningEnd_pickme_ui picked obj do
		(
			LightningEnd = obj.targetname
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "Brightness (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 100]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "Beam Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for Beam Color (R G B)"
		Spinner wwmt_Radius_ui "Radius" type:#integer range:[-10000, 10000, 256]
		Label wwmt_life_ui_label "Life (seconds 0 = infinite)" align:#left
		EditText wwmt_life_ui "" type:#string
		Label wwmt_label_BoltWidth_ui "Width of beam (pixels*0.1 0-255)" align:#left
		Spinner wwmt_BoltWidth_ui "" type:#integer range:[-10000, 10000, 20]
		Label wwmt_label_NoiseAmplitude_ui "Amount of noise (0-255)" align:#left
		Spinner wwmt_NoiseAmplitude_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_texture_ui_label "Sprite Name" align:#left
		EditText wwmt_texture_ui "" type:#string
		Label wwmt_label_TextureScroll_ui "Texture Scroll Rate (0-100)" align:#left
		Spinner wwmt_TextureScroll_ui "" type:#integer range:[-10000, 10000, 35]
		Label wwmt_label_framerate_ui "Frames per 10 seconds" align:#left
		Spinner wwmt_framerate_ui "" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt_framestart_ui "Starting Frame" type:#integer range:[-10000, 10000, 0]
		Label wwmt_StrikeTime_ui_label "Strike again time (secs)" align:#left
		EditText wwmt_StrikeTime_ui "" type:#string
		Label wwmt_damage_ui_label "Damage / second" align:#left
		EditText wwmt_damage_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Start On" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Toggle" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Random Strike" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Ring" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "StartSparks" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "EndSparks" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "Decal End" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Shade Start" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Shade End" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_beam&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_beam" address:"https://developer.valvesoftware.com/wiki/env_beam?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_beverage_CA = attributes "WW Entity env_beverage" version: 78 attribID:#(-292239031L,461097402L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_beverage"
	local isWWPRO = true
	local description = "Beverage Dispenser"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "health", "skin")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValskin = 0
	local propMapskin = #("0", "1", "2", "3", "4", "5", "6")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		health type:#integer ui:wwmt_health_ui default:10
		skin type:#string ui:wwmt_skin_ui default:"0"
		on skin set val do
		(
			getNode()
			if (isValidNode thisNode AND classof thisNode != ::WallWormMDL AND val != undefined) then
			(
				if ::WallWormHelperOps != undefined then
				(
					::WallWormHelperOps.setProxySkin thisNode  val
				)
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_beverage"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Spinner wwmt_health_ui "Capacity" type:#integer range:[-10000, 10000, 10]
		ComboBox wwmt_skin_ui "Beverage Type" type:#string items:#("Coca-Cola", "Sprite", "Diet Coke", "Orange", "Surge", "Moxie", "Random") height:3
		on wwmt_skin_ui selected i do
		(
			skin = propMapskin[i]
		)
		on wwmt_skin_ui entered tex do
		(
			skin = trimLeft(trimRight(tex))
			if propMapskin != undefined AND findItem propMapskin tex == 0 then
			(
				append propMapskin tex
				sort propMapskin
				wwmt_skin_ui.items = propMapskin
				wwmt_skin_ui.selection = findItem wwmt_skin_ui.items tex
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_beverage&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_beverage" address:"https://developer.valvesoftware.com/wiki/env_beverage?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if skin != undefined then
			(
				if findItem propMapskin skin == 0 then
				(
					append propMapskin skin
					local tmp = wwmt_skin_ui.items
					append tmp skin
					wwmt_skin_ui.items = tmp
					wwmt_skin_ui.selection = propMapskin.count
				)
				else
				(
					wwmt_skin_ui.selection = (findItem propMapskin skin)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_blood_CA = attributes "WW Entity env_blood" version: 78 attribID:#(654729850L,1776460938L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_blood"
	local isWWPRO = true
	local description = "Blood Effects"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "wwmt_color", "amount")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local entcolor = (Color 255 0 0)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValcolor = 0
	local propMapcolor = #("0")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		wwmt_color type:#string ui:wwmt_color_ui default:"0"
		amount type:#string ui:wwmt_amount_ui default:"100"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_blood"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		DropDownList wwmt_color_ui "Blood Color" type:#string items:#("Red (Human)")
		on wwmt_color_ui selected i do
		(
			wwmt_color = propMapcolor[i]
		)
		Label wwmt_amount_ui_label "Amount of blood (damage to simulate)" align:#left
		EditText wwmt_amount_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Random Direction" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Blood Stream" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "On Player" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Spray decals" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_blood&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_blood" address:"https://developer.valvesoftware.com/wiki/env_blood?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if wwmt_color != undefined then
			(
				if findItem propMapcolor wwmt_color == 0 then
				(
					append propMapcolor wwmt_color
					local tmp = wwmt_color_ui.items
					append tmp wwmt_color
					wwmt_color_ui.items = tmp
					wwmt_color_ui.selection = propMapcolor.count
				)
				else
				(
					wwmt_color_ui.selection = (findItem propMapcolor wwmt_color)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_bubbles_CA = attributes "WW Entity env_bubbles" version: 78 attribID:#(842275032L,-496060337L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "env_bubbles"
	local isWWPRO = true
	local description = "Bubble Volume"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "density", "frequency", "current")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		density type:#integer ui:wwmt_density_ui default:2
		frequency type:#integer ui:wwmt_frequency_ui default:2
		current type:#integer ui:wwmt_current_ui default:0
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_bubbles"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Spinner wwmt_density_ui "Bubble density" type:#integer range:[-10000, 10000, 2]
		Label wwmt_label_frequency_ui "Bubble frequency" align:#left
		Spinner wwmt_frequency_ui "" type:#integer range:[-10000, 10000, 2]
		Label wwmt_label_current_ui "Speed of Current" align:#left
		Spinner wwmt_current_ui "" type:#integer range:[-10000, 10000, 0]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Start Off" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with env_bubbles" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"env_bubbles_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_bubbles&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_bubbles" address:"https://developer.valvesoftware.com/wiki/env_bubbles?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_explosion_CA = attributes "WW Entity env_explosion" version: 78 attribID:#(467275855L,-793244314L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_explosion"
	local isWWPRO = true
	local description = "Explosion"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "iMagnitude")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		iMagnitude type:#integer ui:wwmt_iMagnitude_ui default:100
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_explosion"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Spinner wwmt_iMagnitude_ui "Magnitude" type:#integer range:[-10000, 10000, 100]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "No Damage" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Repeatable" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "No Fireball" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "No Smoke" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "No Decal" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "No Sparks" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_explosion&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_explosion" address:"https://developer.valvesoftware.com/wiki/env_explosion?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_global_CA = attributes "WW Entity env_global" version: 78 attribID:#(842275029L,-367571522L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_global"
	local isWWPRO = true
	local description = "Global State"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "globalstate", "triggermode", "initialstate")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local entcolor = (Color 255 255 128)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValtriggermode = 0
	local propMaptriggermode = #("0", "1", "2", "3")
	local propValinitialstate = 0
	local propMapinitialstate = #("0", "1", "2")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		globalstate type:#string ui:wwmt_globalstate_ui
		triggermode type:#string ui:wwmt_triggermode_ui default:"0"
		initialstate type:#string ui:wwmt_initialstate_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_global"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_globalstate_ui_label "Global State to Set" align:#left
		EditText wwmt_globalstate_ui "" type:#string
		ComboBox wwmt_triggermode_ui "Trigger Mode" type:#string items:#("Off", "On", "Dead", "Toggle") height:3
		on wwmt_triggermode_ui selected i do
		(
			triggermode = propMaptriggermode[i]
		)
		on wwmt_triggermode_ui entered tex do
		(
			triggermode = trimLeft(trimRight(tex))
			if propMaptriggermode != undefined AND findItem propMaptriggermode tex == 0 then
			(
				append propMaptriggermode tex
				sort propMaptriggermode
				wwmt_triggermode_ui.items = propMaptriggermode
				wwmt_triggermode_ui.selection = findItem wwmt_triggermode_ui.items tex
			)
		)
		DropDownList wwmt_initialstate_ui "Initial State" type:#string items:#("Off", "On", "Dead")
		on wwmt_initialstate_ui selected i do
		(
			initialstate = propMapinitialstate[i]
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Set Initial State" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_global&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_global" address:"https://developer.valvesoftware.com/wiki/env_global?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if triggermode != undefined then
			(
				if findItem propMaptriggermode triggermode == 0 then
				(
					append propMaptriggermode triggermode
					local tmp = wwmt_triggermode_ui.items
					append tmp triggermode
					wwmt_triggermode_ui.items = tmp
					wwmt_triggermode_ui.selection = propMaptriggermode.count
				)
				else
				(
					wwmt_triggermode_ui.selection = (findItem propMaptriggermode triggermode)
				)
			)
			if initialstate != undefined then
			(
				if findItem propMapinitialstate initialstate == 0 then
				(
					append propMapinitialstate initialstate
					local tmp = wwmt_initialstate_ui.items
					append tmp initialstate
					wwmt_initialstate_ui.items = tmp
					wwmt_initialstate_ui.selection = propMapinitialstate.count
				)
				else
				(
					wwmt_initialstate_ui.selection = (findItem propMapinitialstate initialstate)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_glow_CA = attributes "WW Entity env_glow" version: 78 attribID:#(654729850L,520215747L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_glow"
	local isWWPRO = true
	local description = "Light Glow/Haze"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "model", "wwmt_scale")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local entcolor = (Color 30 100 0)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	function target_wwmt_filter obj =
	(
		if ((isProperty obj #wwmt_ca OR isProperty obj #wallwormProxy) AND isProperty obj #wallworm) then
		(
			true
		)
		else
		(
			false
		)
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		model type:#string ui:wwmt_model_ui default:"sprites/glow01.spr"
		wwmt_scale type:#integer ui:wwmt_scale_ui default:1
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_glow"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_model_ui_label "model" align:#left
		EditText wwmt_model_ui "" type:#string
		PickButton wwmt_model_pickwwmt_ui "wwmt" align:#left across:3 message:"Pick WWMT OR Proxy from scene model" filter:target_wwmt_filter tooltip:"Create a proxy from a model in the scene."
		on wwmt_model_pickwwmt_ui picked obj do
		(
			local wwmt = obj.getWWMT()
			if wwmt != undefined AND (getNode()) != undefined then
			(
				wwmt.updateObjectAsProxy thisNode useRotation:false
			)
		)
		Button wwmt_model_importwmt_ui "import" tooltip:"Import a QC AND create a proxy."
		on wwmt_model_importwmt_ui pressed do with undo label:"Import QC" on
		(
			::wallworm_import_qc_from_filename
			if ::wallworm_import_qc_from_filename == undefined then
			(
				fileIn (::wallworm_installation_path + "/WallWorm.com/importers/Mario_Kart_SMD_Importer.ms")
			)
			local fsource = GetOpenFileName historyCategory:"Wall Worm SMD Exporter" types: "QC File (*.qc)|*.QC|All files (*.*)|*.*|"
			if fsource != undefined AND wallworm_import_qc_from_filename != undefined then
			(
				wwmt = ::wallworm_import_qc_from_filename fsource saveToLib:true tnoVMF:true skipLODS:true deepSearchMaterials:false
				if wwmt != undefined then
				(
					if (getNode()) != undefined then
					(
						wwmt.updateObjectAsProxy thisNode
					)
				)
			)
		)
		Button wwmt_model_libwmt_ui "library" tooltip:"Use a prop in the prop library. Right-click to load the mesh rotated 90 degrees."
		on wwmt_model_libwmt_ui pressed do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:false
		)
		on wwmt_model_libwmt_ui rightClick do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:true
		)
		Spinner wwmt_scale_ui "Sprite Scale" type:#integer range:[-10000, 10000, 1]
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_glow&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_glow" address:"https://developer.valvesoftware.com/wiki/env_glow?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_laser_CA = attributes "WW Entity env_laser" version: 78 attribID:#(654729850L,-1779195987L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_laser"
	local isWWPRO = true
	local description = "Laser Beam Effect"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "angles", "LaserTarget", "renderamt", "rendercolor", "width", "NoiseAmplitude", "texture", "EndSprite", "TextureScroll", "framestart", "damage")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		LaserTarget type:#string ui:wwmt_LaserTarget_ui
		renderamt type:#integer ui:wwmt_renderamt_ui default:100
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		width type:#integer ui:wwmt_width_ui default:20
		NoiseAmplitude type:#integer ui:wwmt_NoiseAmplitude_ui default:0
		texture type:#string ui:wwmt_texture_ui default:"sprites/laserbeam.spr"
		EndSprite type:#string ui:wwmt_EndSprite_ui
		TextureScroll type:#integer ui:wwmt_TextureScroll_ui default:35
		framestart type:#integer ui:wwmt_framestart_ui default:0
		damage type:#string ui:wwmt_damage_ui default:"100"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_laser"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_LaserTarget_ui_label "Target of Laser" align:#left
		EditText wwmt_LaserTarget_ui "" type:#string
		PickButton wwmt_LaserTarget_pickme_ui "Pick Target of Laser" message:"Pick Target Entity for Target of Laser" filter:target_name_filter
		on wwmt_LaserTarget_pickme_ui picked obj do
		(
			LaserTarget = obj.targetname
		)
		Label wwmt_label_renderamt_ui "Brightness (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 100]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "Beam Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for Beam Color (R G B)"
		Label wwmt_label_width_ui "Width of beam (pixels*0.1 0-255)" align:#left
		Spinner wwmt_width_ui "" type:#integer range:[-10000, 10000, 20]
		Label wwmt_label_NoiseAmplitude_ui "Amount of noise (0-255)" align:#left
		Spinner wwmt_NoiseAmplitude_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_texture_ui_label "Sprite Name" align:#left
		EditText wwmt_texture_ui "" type:#string
		Label wwmt_EndSprite_ui_label "End Sprite" align:#left
		EditText wwmt_EndSprite_ui "" type:#string
		Label wwmt_label_TextureScroll_ui "Texture Scroll Rate (0-100)" align:#left
		Spinner wwmt_TextureScroll_ui "" type:#integer range:[-10000, 10000, 35]
		Spinner wwmt_framestart_ui "Starting Frame" type:#integer range:[-10000, 10000, 0]
		Label wwmt_damage_ui_label "Damage / second" align:#left
		EditText wwmt_damage_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Start On" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "StartSparks" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "EndSparks" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "Decal End" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_laser&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_laser" address:"https://developer.valvesoftware.com/wiki/env_laser?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_message_CA = attributes "WW Entity env_message" version: 78 attribID:#(842275039L,1110997934L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_message"
	local isWWPRO = true
	local description = "HUD Text Message"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "message", "messagesound", "messagevolume", "messageattenuation")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValmessageattenuation = 0
	local propMapmessageattenuation = #("0", "1", "2", "3")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		message type:#string ui:wwmt_message_ui
		messagesound type:#string ui:wwmt_messagesound_ui
		messagevolume type:#string ui:wwmt_messagevolume_ui default:"10"
		messageattenuation type:#string ui:wwmt_messageattenuation_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_message"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_message_ui_label "Message Name" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_messagesound_ui_label "Sound effect" align:#left
		EditText wwmt_messagesound_ui "" type:#string
		Label wwmt_messagevolume_ui_label "Volume 0-10" align:#left
		EditText wwmt_messagevolume_ui "" type:#string
		ComboBox wwmt_messageattenuation_ui "Sound Radius" type:#string items:#("Small Radius", "Medium Radius", "Large  Radius", "Play Everywhere") height:3
		on wwmt_messageattenuation_ui selected i do
		(
			messageattenuation = propMapmessageattenuation[i]
		)
		on wwmt_messageattenuation_ui entered tex do
		(
			messageattenuation = trimLeft(trimRight(tex))
			if propMapmessageattenuation != undefined AND findItem propMapmessageattenuation tex == 0 then
			(
				append propMapmessageattenuation tex
				sort propMapmessageattenuation
				wwmt_messageattenuation_ui.items = propMapmessageattenuation
				wwmt_messageattenuation_ui.selection = findItem wwmt_messageattenuation_ui.items tex
			)
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Play Once" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "All Clients" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_message&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_message" address:"https://developer.valvesoftware.com/wiki/env_message?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if messageattenuation != undefined then
			(
				if findItem propMapmessageattenuation messageattenuation == 0 then
				(
					append propMapmessageattenuation messageattenuation
					local tmp = wwmt_messageattenuation_ui.items
					append tmp messageattenuation
					wwmt_messageattenuation_ui.items = tmp
					wwmt_messageattenuation_ui.selection = propMapmessageattenuation.count
				)
				else
				(
					wwmt_messageattenuation_ui.selection = (findItem propMapmessageattenuation messageattenuation)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_render_CA = attributes "WW Entity env_render" version: 78 attribID:#(842275016L,1460626972L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_render"
	local isWWPRO = true
	local description = "Render Controls"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "renderfx", "rendermode", "renderamt", "rendercolor")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local entcolor = (Color 100 100 0)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_render"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "No Renderfx" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "No Renderamt" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "No Rendermode" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "No Rendercolor" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_render&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_render" address:"https://developer.valvesoftware.com/wiki/env_render?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_shake_CA = attributes "WW Entity env_shake" version: 78 attribID:#(654729850L,371760912L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_shake"
	local isWWPRO = true
	local description = "Screen Shake"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "amplitude", "radius", "duration", "frequency")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		amplitude type:#string ui:wwmt_amplitude_ui default:"4"
		radius type:#string ui:wwmt_radius_ui default:"500"
		duration type:#string ui:wwmt_duration_ui default:"1"
		frequency type:#string ui:wwmt_frequency_ui default:"2.5"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_shake"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_amplitude_ui_label "Amplitude 0-16" align:#left
		EditText wwmt_amplitude_ui "" type:#string
		Label wwmt_radius_ui_label "Effect radius" align:#left
		EditText wwmt_radius_ui "" type:#string
		Label wwmt_duration_ui_label "Duration (seconds)" align:#left
		EditText wwmt_duration_ui "" type:#string
		Label wwmt_frequency_ui_label "0.1 = jerk, 255.0 = rumble" align:#left
		EditText wwmt_frequency_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "GlobalShake" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_shake&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_shake" address:"https://developer.valvesoftware.com/wiki/env_shake?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_shooter_CA = attributes "WW Entity env_shooter" version: 78 attribID:#(842275017L,1993223203L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_shooter"
	local isWWPRO = true
	local description = "Model Shooter"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("angles", "targetname", "m_iGibs", "delay", "m_flVelocity", "m_flVariance", "m_flGibLife", "renderfx", "rendermode", "renderamt", "rendercolor", "shootmodel", "shootsounds", "wwmt_scale", "skin")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValshootsounds = -1
	local propMapshootsounds = #("-1", "0", "1", "2", "3", "4")
	parameters main rollout:params
	(
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		targetname type:#string ui:wwmt_targetname_ui
		m_iGibs type:#integer ui:wwmt_m_iGibs_ui default:3
		delay type:#string ui:wwmt_delay_ui default:"0"
		m_flVelocity type:#integer ui:wwmt_m_flVelocity_ui default:200
		m_flVariance type:#string ui:wwmt_m_flVariance_ui default:"0.15"
		m_flGibLife type:#string ui:wwmt_m_flGibLife_ui default:"4"
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		shootmodel type:#string ui:wwmt_shootmodel_ui
		shootsounds type:#string ui:wwmt_shootsounds_ui default:"-1"
		wwmt_scale type:#string ui:wwmt_scale_ui
		skin type:#integer ui:wwmt_skin_ui default:0
		spawnflags type:#integer default:0
		on skin set val do
		(
			getNode()
			if (isValidNode thisNode AND classof thisNode != ::WallWormMDL AND val != undefined) then
			(
				if ::WallWormHelperOps != undefined then
				(
					::WallWormHelperOps.setProxySkin thisNode  val
				)
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_shooter"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Spinner wwmt_m_iGibs_ui "Number of Gibs" type:#integer range:[-10000, 10000, 3]
		Label wwmt_delay_ui_label "Delay between shots" align:#left
		EditText wwmt_delay_ui "" type:#string
		Spinner wwmt_m_flVelocity_ui "Gib Velocity" type:#integer range:[-10000, 10000, 200]
		Label wwmt_m_flVariance_ui_label "Course Variance" align:#left
		EditText wwmt_m_flVariance_ui "" type:#string
		Label wwmt_m_flGibLife_ui_label "Gib Life" align:#left
		EditText wwmt_m_flGibLife_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_shootmodel_ui_label "Model" align:#left
		EditText wwmt_shootmodel_ui "" type:#string
		ComboBox wwmt_shootsounds_ui "Material Sound" type:#string items:#("None", "Glass", "Wood", "Metal", "Flesh", "Concrete") height:3
		on wwmt_shootsounds_ui selected i do
		(
			shootsounds = propMapshootsounds[i]
		)
		on wwmt_shootsounds_ui entered tex do
		(
			shootsounds = trimLeft(trimRight(tex))
			if propMapshootsounds != undefined AND findItem propMapshootsounds tex == 0 then
			(
				append propMapshootsounds tex
				sort propMapshootsounds
				wwmt_shootsounds_ui.items = propMapshootsounds
				wwmt_shootsounds_ui.selection = findItem wwmt_shootsounds_ui.items tex
			)
		)
		Label wwmt_scale_ui_label "Gib Scale" align:#left
		EditText wwmt_scale_ui "" type:#string
		Spinner wwmt_skin_ui "Gib Skin" type:#integer range:[-10000, 10000, 0]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Repeatable" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_shooter&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_shooter" address:"https://developer.valvesoftware.com/wiki/env_shooter?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if shootsounds != undefined then
			(
				if findItem propMapshootsounds shootsounds == 0 then
				(
					append propMapshootsounds shootsounds
					local tmp = wwmt_shootsounds_ui.items
					append tmp shootsounds
					wwmt_shootsounds_ui.items = tmp
					wwmt_shootsounds_ui.selection = propMapshootsounds.count
				)
				else
				(
					wwmt_shootsounds_ui.selection = (findItem propMapshootsounds shootsounds)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_sound_CA = attributes "WW Entity env_sound" version: 78 attribID:#(654729850L,1554762651L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_sound"
	local isWWPRO = true
	local description = "DSP Sound"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("radius", "roomtype")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/speaker.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValroomtype = 0
	local propMaproomtype = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28")
	parameters main rollout:params
	(
		radius type:#integer ui:wwmt_radius_ui default:128
		roomtype type:#string ui:wwmt_roomtype_ui default:"0"
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_sound"
		Spinner wwmt_radius_ui "Radius" type:#integer range:[-10000, 10000, 128]
		ComboBox wwmt_roomtype_ui "Room Type" type:#string items:#("Normal (off)", "Generic", "Metal Small", "Metal Medium", "Metal Large", "Tunnel Small", "Tunnel Medium", "Tunnel Large", "Chamber Small", "Chamber Medium", "Chamber Large", "Bright Small", "Bright Medium", "Bright Large", "Water 1", "Water 2", "Water 3", "Concrete Small", "Concrete Medium", "Concrete Large", "Big 1", "Big 2", "Big 3", "Cavern Small", "Cavern Medium", "Cavern Large", "Weirdo 1", "Weirdo 2", "Weirdo 3") height:3
		on wwmt_roomtype_ui selected i do
		(
			roomtype = propMaproomtype[i]
		)
		on wwmt_roomtype_ui entered tex do
		(
			roomtype = trimLeft(trimRight(tex))
			if propMaproomtype != undefined AND findItem propMaproomtype tex == 0 then
			(
				append propMaproomtype tex
				sort propMaproomtype
				wwmt_roomtype_ui.items = propMaproomtype
				wwmt_roomtype_ui.selection = findItem wwmt_roomtype_ui.items tex
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_sound&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_sound" address:"https://developer.valvesoftware.com/wiki/env_sound?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if roomtype != undefined then
			(
				if findItem propMaproomtype roomtype == 0 then
				(
					append propMaproomtype roomtype
					local tmp = wwmt_roomtype_ui.items
					append tmp roomtype
					wwmt_roomtype_ui.items = tmp
					wwmt_roomtype_ui.selection = propMaproomtype.count
				)
				else
				(
					wwmt_roomtype_ui.selection = (findItem propMaproomtype roomtype)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_spark_CA = attributes "WW Entity env_spark" version: 78 attribID:#(654729850L,-871592065L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_spark"
	local isWWPRO = true
	local description = "Spark"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "MaxDelay")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		MaxDelay type:#string ui:wwmt_MaxDelay_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_spark"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_MaxDelay_ui_label "Max Delay" align:#left
		EditText wwmt_MaxDelay_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_32_ui "Toggle" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "Start ON" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_spark&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_spark" address:"https://developer.valvesoftware.com/wiki/env_spark?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_env_sprite_CA = attributes "WW Entity env_sprite" version: 78 attribID:#(842275017L,1494405608L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "env_sprite"
	local isWWPRO = true
	local description = "Sprite Effect"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "framerate", "model", "wwmt_scale")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	function target_wwmt_filter obj =
	(
		if ((isProperty obj #wwmt_ca OR isProperty obj #wallwormProxy) AND isProperty obj #wallworm) then
		(
			true
		)
		else
		(
			false
		)
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		framerate type:#string ui:wwmt_framerate_ui default:"10.0"
		model type:#string ui:wwmt_model_ui default:"sprites/glow01.spr"
		wwmt_scale type:#integer ui:wwmt_scale_ui default:1
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "env_sprite"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_framerate_ui_label "Framerate" align:#left
		EditText wwmt_framerate_ui "" type:#string
		Label wwmt_model_ui_label "Sprite Name" align:#left
		EditText wwmt_model_ui "" type:#string
		PickButton wwmt_model_pickwwmt_ui "wwmt" align:#left across:3 message:"Pick WWMT OR Proxy from scene Sprite Name" filter:target_wwmt_filter tooltip:"Create a proxy from a model in the scene."
		on wwmt_model_pickwwmt_ui picked obj do
		(
			local wwmt = obj.getWWMT()
			if wwmt != undefined AND (getNode()) != undefined then
			(
				wwmt.updateObjectAsProxy thisNode useRotation:false
			)
		)
		Button wwmt_model_importwmt_ui "import" tooltip:"Import a QC AND create a proxy."
		on wwmt_model_importwmt_ui pressed do with undo label:"Import QC" on
		(
			::wallworm_import_qc_from_filename
			if ::wallworm_import_qc_from_filename == undefined then
			(
				fileIn (::wallworm_installation_path + "/WallWorm.com/importers/Mario_Kart_SMD_Importer.ms")
			)
			local fsource = GetOpenFileName historyCategory:"Wall Worm SMD Exporter" types: "QC File (*.qc)|*.QC|All files (*.*)|*.*|"
			if fsource != undefined AND wallworm_import_qc_from_filename != undefined then
			(
				wwmt = ::wallworm_import_qc_from_filename fsource saveToLib:true tnoVMF:true skipLODS:true deepSearchMaterials:false
				if wwmt != undefined then
				(
					if (getNode()) != undefined then
					(
						wwmt.updateObjectAsProxy thisNode
					)
				)
			)
		)
		Button wwmt_model_libwmt_ui "library" tooltip:"Use a prop in the prop library. Right-click to load the mesh rotated 90 degrees."
		on wwmt_model_libwmt_ui pressed do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:false
		)
		on wwmt_model_libwmt_ui rightClick do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:true
		)
		Spinner wwmt_scale_ui "Scale" type:#integer range:[-10000, 10000, 1]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Start on" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Play Once" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_sprite&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: env_sprite" address:"https://developer.valvesoftware.com/wiki/env_sprite?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_breakable_CA = attributes "WW Entity func_breakable" version: 78 attribID:#(-783224043L,1079791769L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_breakable"
	local isWWPRO = true
	local description = "Breakable Object"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "health", "wwmt_material", "explosion", "delay", "gibmodel", "spawnobject", "explodemagnitude", "renderfx", "rendermode", "renderamt", "rendercolor", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValmaterial = 0
	local propMapmaterial = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propValexplosion = 0
	local propMapexplosion = #("0", "1")
	local propValspawnobject = 0
	local propMapspawnobject = #("0")
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		health type:#integer ui:wwmt_health_ui default:1
		wwmt_material type:#string ui:wwmt_material_ui default:"0"
		explosion type:#string ui:wwmt_explosion_ui default:"0"
		delay type:#string ui:wwmt_delay_ui default:"0"
		gibmodel type:#string ui:wwmt_gibmodel_ui
		spawnobject type:#string ui:wwmt_spawnobject_ui default:"0"
		explodemagnitude type:#integer ui:wwmt_explodemagnitude_ui default:0
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		_minlight type:#string ui:wwmt__minlight_ui
		spawnflags type:#integer default:256
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_breakable"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target on break" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target on break" message:"Pick Target Entity for Target on break" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Spinner wwmt_health_ui "Strength" type:#integer range:[-10000, 10000, 1]
		ComboBox wwmt_material_ui "Material type" type:#string items:#("Glass", "Wood", "Metal", "Flesh", "Cinder Block", "Ceiling Tile", "Computer", "Unbreakable Glass", "Rocks") height:3
		on wwmt_material_ui selected i do
		(
			wwmt_material = propMapmaterial[i]
		)
		on wwmt_material_ui entered tex do
		(
			wwmt_material = trimLeft(trimRight(tex))
			if propMapmaterial != undefined AND findItem propMapmaterial tex == 0 then
			(
				append propMapmaterial tex
				sort propMapmaterial
				wwmt_material_ui.items = propMapmaterial
				wwmt_material_ui.selection = findItem wwmt_material_ui.items tex
			)
		)
		DropDownList wwmt_explosion_ui "Gibs Direction" type:#string items:#("Random", "Relative to Attack")
		on wwmt_explosion_ui selected i do
		(
			explosion = propMapexplosion[i]
		)
		Label wwmt_delay_ui_label "Delay before fire" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_gibmodel_ui_label "Gib Model" align:#left
		EditText wwmt_gibmodel_ui "" type:#string
		DropDownList wwmt_spawnobject_ui "Spawn On Break" type:#string items:#("Nothing")
		on wwmt_spawnobject_ui selected i do
		(
			spawnobject = propMapspawnobject[i]
		)
		Label wwmt_label_explodemagnitude_ui "Explode Magnitude (0=none)" align:#left
		Spinner wwmt_explodemagnitude_ui "" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Only Trigger" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Touch" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Pressure" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Instant Crowbar" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_breakable" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_breakable_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_breakable&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_breakable" address:"https://developer.valvesoftware.com/wiki/func_breakable?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if wwmt_material != undefined then
			(
				if findItem propMapmaterial wwmt_material == 0 then
				(
					append propMapmaterial wwmt_material
					local tmp = wwmt_material_ui.items
					append tmp wwmt_material
					wwmt_material_ui.items = tmp
					wwmt_material_ui.selection = propMapmaterial.count
				)
				else
				(
					wwmt_material_ui.selection = (findItem propMapmaterial wwmt_material)
				)
			)
			if explosion != undefined then
			(
				if findItem propMapexplosion explosion == 0 then
				(
					append propMapexplosion explosion
					local tmp = wwmt_explosion_ui.items
					append tmp explosion
					wwmt_explosion_ui.items = tmp
					wwmt_explosion_ui.selection = propMapexplosion.count
				)
				else
				(
					wwmt_explosion_ui.selection = (findItem propMapexplosion explosion)
				)
			)
			if spawnobject != undefined then
			(
				if findItem propMapspawnobject spawnobject == 0 then
				(
					append propMapspawnobject spawnobject
					local tmp = wwmt_spawnobject_ui.items
					append tmp spawnobject
					wwmt_spawnobject_ui.items = tmp
					wwmt_spawnobject_ui.selection = propMapspawnobject.count
				)
				else
				(
					wwmt_spawnobject_ui.selection = (findItem propMapspawnobject spawnobject)
				)
			)
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_button_CA = attributes "WW Entity func_button" version: 78 attribID:#(721320529L,1993738382L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_button"
	local isWWPRO = true
	local description = "Button"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "speed", "wwmt_target", "netname", "health", "lip", "master", "sounds", "wait", "delay", "locked_sound", "unlocked_sound", "locked_sentence", "unlocked_sentence", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValsounds = 0
	local propMapsounds = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "14")
	local propVallocked_sound = 0
	local propMaplocked_sound = #("0", "2", "8", "10", "11", "12")
	local propValunlocked_sound = 0
	local propMapunlocked_sound = #("0", "1", "3", "4", "5", "6", "7", "8", "9", "10", "13", "14")
	local propVallocked_sentence = 0
	local propMaplocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
	local propValunlocked_sentence = 0
	local propMapunlocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		speed type:#integer ui:wwmt_speed_ui default:5
		wwmt_target type:#string ui:wwmt_target_ui
		netname type:#string ui:wwmt_netname_ui
		health type:#integer ui:wwmt_health_ui
		lip type:#integer ui:wwmt_lip_ui
		master type:#string ui:wwmt_master_ui
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		wait type:#integer ui:wwmt_wait_ui default:3
		delay type:#string ui:wwmt_delay_ui default:"0"
		locked_sound type:#string ui:wwmt_locked_sound_ui default:"0"
		unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:"0"
		locked_sentence type:#string ui:wwmt_locked_sentence_ui default:"0"
		unlocked_sentence type:#string ui:wwmt_unlocked_sentence_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_button"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 5]
		Label wwmt_target_ui_label "Targetted object" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Targetted object" message:"Pick Target Entity for Targetted object" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_netname_ui_label "Target Path" align:#left
		EditText wwmt_netname_ui "" type:#string
		PickButton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter
		on wwmt_netname_pickme_ui picked obj do
		(
			netname = obj.targetname
		)
		Label wwmt_label_health_ui "Health (shootable if > 0)" align:#left
		Spinner wwmt_health_ui "" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt_lip_ui "Lip" type:#integer range:[-10000, 10000, 0]
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		ComboBox wwmt_sounds_ui "Sounds" type:#string items:#("None", "Big zap & Warmup", "Access Denied", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Buzz Off", "Lightswitch") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		Label wwmt_label_wait_ui "delay before reset (-1 stay)" align:#left
		Spinner wwmt_wait_ui "" type:#integer range:[-10000, 10000, 3]
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		ComboBox wwmt_locked_sound_ui "Locked Sound" type:#string items:#("None", "Access Denied", "Small zap", "Buzz", "Buzz Off", "Latch Locked") height:3
		on wwmt_locked_sound_ui selected i do
		(
			locked_sound = propMaplocked_sound[i]
		)
		on wwmt_locked_sound_ui entered tex do
		(
			locked_sound = trimLeft(trimRight(tex))
			if propMaplocked_sound != undefined AND findItem propMaplocked_sound tex == 0 then
			(
				append propMaplocked_sound tex
				sort propMaplocked_sound
				wwmt_locked_sound_ui.items = propMaplocked_sound
				wwmt_locked_sound_ui.selection = findItem wwmt_locked_sound_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sound_ui "Unlocked Sound" type:#string items:#("None", "Big zap & Warmup", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Latch Unlocked", "Lightswitch") height:3
		on wwmt_unlocked_sound_ui selected i do
		(
			unlocked_sound = propMapunlocked_sound[i]
		)
		on wwmt_unlocked_sound_ui entered tex do
		(
			unlocked_sound = trimLeft(trimRight(tex))
			if propMapunlocked_sound != undefined AND findItem propMapunlocked_sound tex == 0 then
			(
				append propMapunlocked_sound tex
				sort propMapunlocked_sound
				wwmt_unlocked_sound_ui.items = propMapunlocked_sound
				wwmt_unlocked_sound_ui.selection = findItem wwmt_unlocked_sound_ui.items tex
			)
		)
		ComboBox wwmt_locked_sentence_ui "Locked Sentence" type:#string items:#("None", "Gen. Access Denied", "Security Lockout", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance Door", "Broken Shut Door") height:3
		on wwmt_locked_sentence_ui selected i do
		(
			locked_sentence = propMaplocked_sentence[i]
		)
		on wwmt_locked_sentence_ui entered tex do
		(
			locked_sentence = trimLeft(trimRight(tex))
			if propMaplocked_sentence != undefined AND findItem propMaplocked_sentence tex == 0 then
			(
				append propMaplocked_sentence tex
				sort propMaplocked_sentence
				wwmt_locked_sentence_ui.items = propMaplocked_sentence
				wwmt_locked_sentence_ui.selection = findItem wwmt_locked_sentence_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sentence_ui "Unlocked Sentence" type:#string items:#("None", "Gen. Access Granted", "Security Disengaged", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance area") height:3
		on wwmt_unlocked_sentence_ui selected i do
		(
			unlocked_sentence = propMapunlocked_sentence[i]
		)
		on wwmt_unlocked_sentence_ui entered tex do
		(
			unlocked_sentence = trimLeft(trimRight(tex))
			if propMapunlocked_sentence != undefined AND findItem propMapunlocked_sentence tex == 0 then
			(
				append propMapunlocked_sentence tex
				sort propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.items = propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.selection = findItem wwmt_unlocked_sentence_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Don't move" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Toggle" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "Sparks" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Touch Activates" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_button" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_button_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_button&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_button" address:"https://developer.valvesoftware.com/wiki/func_button?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			if locked_sound != undefined then
			(
				if findItem propMaplocked_sound locked_sound == 0 then
				(
					append propMaplocked_sound locked_sound
					local tmp = wwmt_locked_sound_ui.items
					append tmp locked_sound
					wwmt_locked_sound_ui.items = tmp
					wwmt_locked_sound_ui.selection = propMaplocked_sound.count
				)
				else
				(
					wwmt_locked_sound_ui.selection = (findItem propMaplocked_sound locked_sound)
				)
			)
			if unlocked_sound != undefined then
			(
				if findItem propMapunlocked_sound unlocked_sound == 0 then
				(
					append propMapunlocked_sound unlocked_sound
					local tmp = wwmt_unlocked_sound_ui.items
					append tmp unlocked_sound
					wwmt_unlocked_sound_ui.items = tmp
					wwmt_unlocked_sound_ui.selection = propMapunlocked_sound.count
				)
				else
				(
					wwmt_unlocked_sound_ui.selection = (findItem propMapunlocked_sound unlocked_sound)
				)
			)
			if locked_sentence != undefined then
			(
				if findItem propMaplocked_sentence locked_sentence == 0 then
				(
					append propMaplocked_sentence locked_sentence
					local tmp = wwmt_locked_sentence_ui.items
					append tmp locked_sentence
					wwmt_locked_sentence_ui.items = tmp
					wwmt_locked_sentence_ui.selection = propMaplocked_sentence.count
				)
				else
				(
					wwmt_locked_sentence_ui.selection = (findItem propMaplocked_sentence locked_sentence)
				)
			)
			if unlocked_sentence != undefined then
			(
				if findItem propMapunlocked_sentence unlocked_sentence == 0 then
				(
					append propMapunlocked_sentence unlocked_sentence
					local tmp = wwmt_unlocked_sentence_ui.items
					append tmp unlocked_sentence
					wwmt_unlocked_sentence_ui.items = tmp
					wwmt_unlocked_sentence_ui.selection = propMapunlocked_sentence.count
				)
				else
				(
					wwmt_unlocked_sentence_ui.selection = (findItem propMapunlocked_sentence unlocked_sentence)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_conveyor_CA = attributes "WW Entity func_conveyor" version: 78 attribID:#(51474914L,2092506524L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_conveyor"
	local isWWPRO = true
	local description = "Conveyor Belt"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("renderfx", "rendermode", "renderamt", "rendercolor", "targetname", "angles", "speed", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		speed type:#string ui:wwmt_speed_ui default:"100"
		_minlight type:#string ui:wwmt__minlight_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_conveyor"
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_speed_ui_label "Conveyor Speed" align:#left
		EditText wwmt_speed_ui "" type:#string
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "No Push" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Not Solid" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_conveyor" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_conveyor_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_conveyor&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_conveyor" address:"https://developer.valvesoftware.com/wiki/func_conveyor?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_door_CA = attributes "WW Entity func_door" version: 78 attribID:#(533770476L,-65244531L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_door"
	local isWWPRO = true
	local description = "Basic door"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "killtarget", "speed", "master", "movesnd", "stopsnd", "wait", "lip", "dmg", "message", "wwmt_target", "delay", "netname", "health", "locked_sound", "unlocked_sound", "locked_sentence", "unlocked_sentence", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propVallocked_sound = 0
	local propMaplocked_sound = #("0", "2", "8", "10", "11", "12")
	local propValunlocked_sound = 0
	local propMapunlocked_sound = #("0", "1", "3", "4", "5", "6", "7", "8", "9", "10", "13")
	local propVallocked_sentence = 0
	local propMaplocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
	local propValunlocked_sentence = 0
	local propMapunlocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		killtarget type:#string ui:wwmt_killtarget_ui
		speed type:#integer ui:wwmt_speed_ui default:100
		master type:#string ui:wwmt_master_ui
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		wait type:#integer ui:wwmt_wait_ui default:4
		lip type:#integer ui:wwmt_lip_ui
		dmg type:#integer ui:wwmt_dmg_ui default:0
		message type:#string ui:wwmt_message_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#integer ui:wwmt_delay_ui
		netname type:#string ui:wwmt_netname_ui
		health type:#integer ui:wwmt_health_ui default:0
		locked_sound type:#string ui:wwmt_locked_sound_ui default:"0"
		unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:"0"
		locked_sentence type:#string ui:wwmt_locked_sentence_ui default:"0"
		unlocked_sentence type:#string ui:wwmt_unlocked_sentence_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_door"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 100]
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "Servo (Sliding)", "Pneumatic (Sliding)", "Pneumatic (Rolling)", "Vacuum", "Power Hydraulic", "Large Rollers", "Track Door", "Snappy Metal Door", "Squeaky 1", "Squeaky 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "Clang with brake", "Clang reverb", "Ratchet Stop", "Chunk", "Light airbrake", "Metal Slide Stop", "Metal Lock Stop", "Snappy Metal Stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_label_wait_ui "delay before close, -1 stay open " align:#left
		Spinner wwmt_wait_ui "" type:#integer range:[-10000, 10000, 4]
		Spinner wwmt_lip_ui "Lip" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_dmg_ui "Damage inflicted when blocked" align:#left
		Spinner wwmt_dmg_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_message_ui_label "Message if triggered" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_label_delay_ui "Delay before fire" align:#left
		Spinner wwmt_delay_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_netname_ui_label "Fire on Close" align:#left
		EditText wwmt_netname_ui "" type:#string
		Label wwmt_label_health_ui "Health (shoot open)" align:#left
		Spinner wwmt_health_ui "" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_locked_sound_ui "Locked Sound" type:#string items:#("None", "Access Denied", "Small zap", "Buzz", "Buzz Off", "Latch Locked") height:3
		on wwmt_locked_sound_ui selected i do
		(
			locked_sound = propMaplocked_sound[i]
		)
		on wwmt_locked_sound_ui entered tex do
		(
			locked_sound = trimLeft(trimRight(tex))
			if propMaplocked_sound != undefined AND findItem propMaplocked_sound tex == 0 then
			(
				append propMaplocked_sound tex
				sort propMaplocked_sound
				wwmt_locked_sound_ui.items = propMaplocked_sound
				wwmt_locked_sound_ui.selection = findItem wwmt_locked_sound_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sound_ui "Unlocked Sound" type:#string items:#("None", "Big zap & Warmup", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Latch Unlocked") height:3
		on wwmt_unlocked_sound_ui selected i do
		(
			unlocked_sound = propMapunlocked_sound[i]
		)
		on wwmt_unlocked_sound_ui entered tex do
		(
			unlocked_sound = trimLeft(trimRight(tex))
			if propMapunlocked_sound != undefined AND findItem propMapunlocked_sound tex == 0 then
			(
				append propMapunlocked_sound tex
				sort propMapunlocked_sound
				wwmt_unlocked_sound_ui.items = propMapunlocked_sound
				wwmt_unlocked_sound_ui.selection = findItem wwmt_unlocked_sound_ui.items tex
			)
		)
		ComboBox wwmt_locked_sentence_ui "Locked Sentence" type:#string items:#("None", "Gen. Access Denied", "Security Lockout", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance Door", "Broken Shut Door") height:3
		on wwmt_locked_sentence_ui selected i do
		(
			locked_sentence = propMaplocked_sentence[i]
		)
		on wwmt_locked_sentence_ui entered tex do
		(
			locked_sentence = trimLeft(trimRight(tex))
			if propMaplocked_sentence != undefined AND findItem propMaplocked_sentence tex == 0 then
			(
				append propMaplocked_sentence tex
				sort propMaplocked_sentence
				wwmt_locked_sentence_ui.items = propMaplocked_sentence
				wwmt_locked_sentence_ui.selection = findItem wwmt_locked_sentence_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sentence_ui "Unlocked Sentence" type:#string items:#("None", "Gen. Access Granted", "Security Disengaged", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance area") height:3
		on wwmt_unlocked_sentence_ui selected i do
		(
			unlocked_sentence = propMapunlocked_sentence[i]
		)
		on wwmt_unlocked_sentence_ui entered tex do
		(
			unlocked_sentence = trimLeft(trimRight(tex))
			if propMapunlocked_sentence != undefined AND findItem propMapunlocked_sentence tex == 0 then
			(
				append propMapunlocked_sentence tex
				sort propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.items = propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.selection = findItem wwmt_unlocked_sentence_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Starts Open" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Don't link" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Passable" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Toggle" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Use Only" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_door" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_door_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_door&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_door" address:"https://developer.valvesoftware.com/wiki/func_door?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			if locked_sound != undefined then
			(
				if findItem propMaplocked_sound locked_sound == 0 then
				(
					append propMaplocked_sound locked_sound
					local tmp = wwmt_locked_sound_ui.items
					append tmp locked_sound
					wwmt_locked_sound_ui.items = tmp
					wwmt_locked_sound_ui.selection = propMaplocked_sound.count
				)
				else
				(
					wwmt_locked_sound_ui.selection = (findItem propMaplocked_sound locked_sound)
				)
			)
			if unlocked_sound != undefined then
			(
				if findItem propMapunlocked_sound unlocked_sound == 0 then
				(
					append propMapunlocked_sound unlocked_sound
					local tmp = wwmt_unlocked_sound_ui.items
					append tmp unlocked_sound
					wwmt_unlocked_sound_ui.items = tmp
					wwmt_unlocked_sound_ui.selection = propMapunlocked_sound.count
				)
				else
				(
					wwmt_unlocked_sound_ui.selection = (findItem propMapunlocked_sound unlocked_sound)
				)
			)
			if locked_sentence != undefined then
			(
				if findItem propMaplocked_sentence locked_sentence == 0 then
				(
					append propMaplocked_sentence locked_sentence
					local tmp = wwmt_locked_sentence_ui.items
					append tmp locked_sentence
					wwmt_locked_sentence_ui.items = tmp
					wwmt_locked_sentence_ui.selection = propMaplocked_sentence.count
				)
				else
				(
					wwmt_locked_sentence_ui.selection = (findItem propMaplocked_sentence locked_sentence)
				)
			)
			if unlocked_sentence != undefined then
			(
				if findItem propMapunlocked_sentence unlocked_sentence == 0 then
				(
					append propMapunlocked_sentence unlocked_sentence
					local tmp = wwmt_unlocked_sentence_ui.items
					append tmp unlocked_sentence
					wwmt_unlocked_sentence_ui.items = tmp
					wwmt_unlocked_sentence_ui.selection = propMapunlocked_sentence.count
				)
				else
				(
					wwmt_unlocked_sentence_ui.selection = (findItem propMapunlocked_sentence unlocked_sentence)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_door_rotating_CA = attributes "WW Entity func_door_rotating" version: 78 attribID:#(-533575577L,120708247L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_door_rotating"
	local isWWPRO = true
	local description = "Rotating door"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "killtarget", "speed", "master", "movesnd", "stopsnd", "wait", "lip", "dmg", "message", "wwmt_target", "delay", "netname", "health", "locked_sound", "unlocked_sound", "locked_sentence", "unlocked_sentence", "_minlight", "distance")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propVallocked_sound = 0
	local propMaplocked_sound = #("0", "2", "8", "10", "11", "12")
	local propValunlocked_sound = 0
	local propMapunlocked_sound = #("0", "1", "3", "4", "5", "6", "7", "8", "9", "10", "13")
	local propVallocked_sentence = 0
	local propMaplocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
	local propValunlocked_sentence = 0
	local propMapunlocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		killtarget type:#string ui:wwmt_killtarget_ui
		speed type:#integer ui:wwmt_speed_ui default:100
		master type:#string ui:wwmt_master_ui
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		wait type:#integer ui:wwmt_wait_ui default:4
		lip type:#integer ui:wwmt_lip_ui
		dmg type:#integer ui:wwmt_dmg_ui default:0
		message type:#string ui:wwmt_message_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#integer ui:wwmt_delay_ui
		netname type:#string ui:wwmt_netname_ui
		health type:#integer ui:wwmt_health_ui default:0
		locked_sound type:#string ui:wwmt_locked_sound_ui default:"0"
		unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:"0"
		locked_sentence type:#string ui:wwmt_locked_sentence_ui default:"0"
		unlocked_sentence type:#string ui:wwmt_unlocked_sentence_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		distance type:#integer ui:wwmt_distance_ui default:90
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_door_rotating"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 100]
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "Servo (Sliding)", "Pneumatic (Sliding)", "Pneumatic (Rolling)", "Vacuum", "Power Hydraulic", "Large Rollers", "Track Door", "Snappy Metal Door", "Squeaky 1", "Squeaky 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "Clang with brake", "Clang reverb", "Ratchet Stop", "Chunk", "Light airbrake", "Metal Slide Stop", "Metal Lock Stop", "Snappy Metal Stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_label_wait_ui "delay before close, -1 stay open " align:#left
		Spinner wwmt_wait_ui "" type:#integer range:[-10000, 10000, 4]
		Spinner wwmt_lip_ui "Lip" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_dmg_ui "Damage inflicted when blocked" align:#left
		Spinner wwmt_dmg_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_message_ui_label "Message if triggered" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_label_delay_ui "Delay before fire" align:#left
		Spinner wwmt_delay_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_netname_ui_label "Fire on Close" align:#left
		EditText wwmt_netname_ui "" type:#string
		Label wwmt_label_health_ui "Health (shoot open)" align:#left
		Spinner wwmt_health_ui "" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_locked_sound_ui "Locked Sound" type:#string items:#("None", "Access Denied", "Small zap", "Buzz", "Buzz Off", "Latch Locked") height:3
		on wwmt_locked_sound_ui selected i do
		(
			locked_sound = propMaplocked_sound[i]
		)
		on wwmt_locked_sound_ui entered tex do
		(
			locked_sound = trimLeft(trimRight(tex))
			if propMaplocked_sound != undefined AND findItem propMaplocked_sound tex == 0 then
			(
				append propMaplocked_sound tex
				sort propMaplocked_sound
				wwmt_locked_sound_ui.items = propMaplocked_sound
				wwmt_locked_sound_ui.selection = findItem wwmt_locked_sound_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sound_ui "Unlocked Sound" type:#string items:#("None", "Big zap & Warmup", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Latch Unlocked") height:3
		on wwmt_unlocked_sound_ui selected i do
		(
			unlocked_sound = propMapunlocked_sound[i]
		)
		on wwmt_unlocked_sound_ui entered tex do
		(
			unlocked_sound = trimLeft(trimRight(tex))
			if propMapunlocked_sound != undefined AND findItem propMapunlocked_sound tex == 0 then
			(
				append propMapunlocked_sound tex
				sort propMapunlocked_sound
				wwmt_unlocked_sound_ui.items = propMapunlocked_sound
				wwmt_unlocked_sound_ui.selection = findItem wwmt_unlocked_sound_ui.items tex
			)
		)
		ComboBox wwmt_locked_sentence_ui "Locked Sentence" type:#string items:#("None", "Gen. Access Denied", "Security Lockout", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance Door", "Broken Shut Door") height:3
		on wwmt_locked_sentence_ui selected i do
		(
			locked_sentence = propMaplocked_sentence[i]
		)
		on wwmt_locked_sentence_ui entered tex do
		(
			locked_sentence = trimLeft(trimRight(tex))
			if propMaplocked_sentence != undefined AND findItem propMaplocked_sentence tex == 0 then
			(
				append propMaplocked_sentence tex
				sort propMaplocked_sentence
				wwmt_locked_sentence_ui.items = propMaplocked_sentence
				wwmt_locked_sentence_ui.selection = findItem wwmt_locked_sentence_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sentence_ui "Unlocked Sentence" type:#string items:#("None", "Gen. Access Granted", "Security Disengaged", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance area") height:3
		on wwmt_unlocked_sentence_ui selected i do
		(
			unlocked_sentence = propMapunlocked_sentence[i]
		)
		on wwmt_unlocked_sentence_ui entered tex do
		(
			unlocked_sentence = trimLeft(trimRight(tex))
			if propMapunlocked_sentence != undefined AND findItem propMapunlocked_sentence tex == 0 then
			(
				append propMapunlocked_sentence tex
				sort propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.items = propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.selection = findItem wwmt_unlocked_sentence_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		Spinner wwmt_distance_ui "Distance (deg)" type:#integer range:[-10000, 10000, 90]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Starts Open" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Don't link" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Passable" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Toggle" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Use Only" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Reverse Dir" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "One-way" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "X Axis" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Y Axis" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_door_rotating" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_door_rotating_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_door_rotating&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_door_rotating" address:"https://developer.valvesoftware.com/wiki/func_door_rotating?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			if locked_sound != undefined then
			(
				if findItem propMaplocked_sound locked_sound == 0 then
				(
					append propMaplocked_sound locked_sound
					local tmp = wwmt_locked_sound_ui.items
					append tmp locked_sound
					wwmt_locked_sound_ui.items = tmp
					wwmt_locked_sound_ui.selection = propMaplocked_sound.count
				)
				else
				(
					wwmt_locked_sound_ui.selection = (findItem propMaplocked_sound locked_sound)
				)
			)
			if unlocked_sound != undefined then
			(
				if findItem propMapunlocked_sound unlocked_sound == 0 then
				(
					append propMapunlocked_sound unlocked_sound
					local tmp = wwmt_unlocked_sound_ui.items
					append tmp unlocked_sound
					wwmt_unlocked_sound_ui.items = tmp
					wwmt_unlocked_sound_ui.selection = propMapunlocked_sound.count
				)
				else
				(
					wwmt_unlocked_sound_ui.selection = (findItem propMapunlocked_sound unlocked_sound)
				)
			)
			if locked_sentence != undefined then
			(
				if findItem propMaplocked_sentence locked_sentence == 0 then
				(
					append propMaplocked_sentence locked_sentence
					local tmp = wwmt_locked_sentence_ui.items
					append tmp locked_sentence
					wwmt_locked_sentence_ui.items = tmp
					wwmt_locked_sentence_ui.selection = propMaplocked_sentence.count
				)
				else
				(
					wwmt_locked_sentence_ui.selection = (findItem propMaplocked_sentence locked_sentence)
				)
			)
			if unlocked_sentence != undefined then
			(
				if findItem propMapunlocked_sentence unlocked_sentence == 0 then
				(
					append propMapunlocked_sentence unlocked_sentence
					local tmp = wwmt_unlocked_sentence_ui.items
					append tmp unlocked_sentence
					wwmt_unlocked_sentence_ui.items = tmp
					wwmt_unlocked_sentence_ui.selection = propMapunlocked_sentence.count
				)
				else
				(
					wwmt_unlocked_sentence_ui.selection = (findItem propMapunlocked_sentence unlocked_sentence)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_friction_CA = attributes "WW Entity func_friction" version: 78 attribID:#(-708039973L,-844677114L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_friction"
	local isWWPRO = true
	local description = "Surface with a change in friction"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("renderfx", "rendermode", "renderamt", "rendercolor", "modifier")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		modifier type:#integer ui:wwmt_modifier_ui default:15
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_friction"
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_label_modifier_ui "Percentage of standard (0 - 100)" align:#left
		Spinner wwmt_modifier_ui "" type:#integer range:[-10000, 10000, 15]
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_friction" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_friction_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_friction&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_friction" address:"https://developer.valvesoftware.com/wiki/func_friction?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_illusionary_CA = attributes "WW Entity func_illusionary" version: 78 attribID:#(-283992820L,-1491237814L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_illusionary"
	local isWWPRO = true
	local description = "Fake Wall/Light"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "skin", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3")
	local propValskin = -1
	local propMapskin = #("-1", "-7")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		skin type:#string ui:wwmt_skin_ui default:"-1"
		_minlight type:#string ui:wwmt__minlight_ui
		on skin set val do
		(
			getNode()
			if (isValidNode thisNode AND classof thisNode != ::WallWormMDL AND val != undefined) then
			(
				if ::WallWormHelperOps != undefined then
				(
					::WallWormHelperOps.setProxySkin thisNode  val
				)
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_illusionary"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		DropDownList wwmt_skin_ui "Contents" type:#string items:#("Empty", "Volumetric Light")
		on wwmt_skin_ui selected i do
		(
			skin = propMapskin[i]
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_illusionary" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_illusionary_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_illusionary&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_illusionary" address:"https://developer.valvesoftware.com/wiki/func_illusionary?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if skin != undefined then
			(
				if findItem propMapskin skin == 0 then
				(
					append propMapskin skin
					local tmp = wwmt_skin_ui.items
					append tmp skin
					wwmt_skin_ui.items = tmp
					wwmt_skin_ui.selection = propMapskin.count
				)
				else
				(
					wwmt_skin_ui.selection = (findItem propMapskin skin)
				)
			)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_ladder_CA = attributes "WW Entity func_ladder" version: 78 attribID:#(721320529L,375431330L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_ladder"
	local isWWPRO = true
	local description = "Ladder"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_ladder"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_ladder" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_ladder_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_ladder&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_ladder" address:"https://developer.valvesoftware.com/wiki/func_ladder?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_mortar_field_CA = attributes "WW Entity func_mortar_field" version: 78 attribID:#(-169681511L,-1585325670L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_mortar_field"
	local isWWPRO = true
	local description = "Mortar Field"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "m_flSpread", "m_iCount", "m_fControl", "m_iszXController", "m_iszYController")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValm_fControl = 0
	local propMapm_fControl = #("0", "1", "2")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		m_flSpread type:#integer ui:wwmt_m_flSpread_ui default:64
		m_iCount type:#integer ui:wwmt_m_iCount_ui default:1
		m_fControl type:#string ui:wwmt_m_fControl_ui default:"0"
		m_iszXController type:#string ui:wwmt_m_iszXController_ui
		m_iszYController type:#string ui:wwmt_m_iszYController_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_mortar_field"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Spinner wwmt_m_flSpread_ui "Spread Radius" type:#integer range:[-10000, 10000, 64]
		Spinner wwmt_m_iCount_ui "Repeat Count" type:#integer range:[-10000, 10000, 1]
		DropDownList wwmt_m_fControl_ui "Targeting" type:#string items:#("Random", "Activator", "Table")
		on wwmt_m_fControl_ui selected i do
		(
			m_fControl = propMapm_fControl[i]
		)
		Label wwmt_m_iszXController_ui_label "X Controller" align:#left
		EditText wwmt_m_iszXController_ui "" type:#string
		PickButton wwmt_m_iszXController_pickme_ui "Pick X Controller" message:"Pick Target Entity for X Controller" filter:target_name_filter
		on wwmt_m_iszXController_pickme_ui picked obj do
		(
			m_iszXController = obj.targetname
		)
		Label wwmt_m_iszYController_ui_label "Y Controller" align:#left
		EditText wwmt_m_iszYController_ui "" type:#string
		PickButton wwmt_m_iszYController_pickme_ui "Pick Y Controller" message:"Pick Target Entity for Y Controller" filter:target_name_filter
		on wwmt_m_iszYController_pickme_ui picked obj do
		(
			m_iszYController = obj.targetname
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_mortar_field" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_mortar_field_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_mortar_field&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_mortar_field" address:"https://developer.valvesoftware.com/wiki/func_mortar_field?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if m_fControl != undefined then
			(
				if findItem propMapm_fControl m_fControl == 0 then
				(
					append propMapm_fControl m_fControl
					local tmp = wwmt_m_fControl_ui.items
					append tmp m_fControl
					wwmt_m_fControl_ui.items = tmp
					wwmt_m_fControl_ui.selection = propMapm_fControl.count
				)
				else
				(
					wwmt_m_fControl_ui.selection = (findItem propMapm_fControl m_fControl)
				)
			)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_pendulum_CA = attributes "WW Entity func_pendulum" version: 78 attribID:#(1167220161L,-750938788L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_pendulum"
	local isWWPRO = true
	local description = "Swings back and forth"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "speed", "distance", "damp", "dmg", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		speed type:#integer ui:wwmt_speed_ui default:100
		distance type:#integer ui:wwmt_distance_ui default:90
		damp type:#integer ui:wwmt_damp_ui default:0
		dmg type:#integer ui:wwmt_dmg_ui default:0
		_minlight type:#integer ui:wwmt__minlight_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_pendulum"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 100]
		Spinner wwmt_distance_ui "Distance (deg)" type:#integer range:[-10000, 10000, 90]
		Label wwmt_label_damp_ui "Damping (0-1000)" align:#left
		Spinner wwmt_damp_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_dmg_ui "Damage inflicted when blocked" align:#left
		Spinner wwmt_dmg_ui "" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt__minlight_ui "_minlight" type:#integer range:[-10000, 10000, 0]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Start ON" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Passable" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Auto-return" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "X Axis" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Y Axis" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_pendulum" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_pendulum_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_pendulum&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_pendulum" address:"https://developer.valvesoftware.com/wiki/func_pendulum?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_plat_CA = attributes "WW Entity func_plat" version: 78 attribID:#(533770476L,-1987300282L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_plat"
	local isWWPRO = true
	local description = "Elevator"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "movesnd", "stopsnd", "volume", "height", "speed", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		volume type:#string ui:wwmt_volume_ui default:"0.85"
		height type:#integer ui:wwmt_height_ui default:0
		speed type:#integer ui:wwmt_speed_ui default:50
		_minlight type:#string ui:wwmt__minlight_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_plat"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "big elev 1", "big elev 2", "tech elev 1", "tech elev 2", "tech elev 3", "freight elev 1", "freight elev 2", "heavy elev", "rack elev", "rail elev", "squeek elev", "odd elev 1", "odd elev 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "big elev stop1", "big elev stop2", "freight elev stop", "heavy elev stop", "rack stop", "rail stop", "squeek stop", "quick stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_volume_ui_label "Sound Volume 0.0 - 1.0" align:#left
		EditText wwmt_volume_ui "" type:#string
		Label wwmt_label_height_ui "Travel altitude (can be negative)" align:#left
		Spinner wwmt_height_ui "" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 50]
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Toggle" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_plat" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_plat_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_plat&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_plat" address:"https://developer.valvesoftware.com/wiki/func_plat?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_platrot_CA = attributes "WW Entity func_platrot" version: 78 attribID:#(1167220161L,1209110428L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_platrot"
	local isWWPRO = true
	local description = "Moving Rotating platform"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "movesnd", "stopsnd", "volume", "angles", "speed", "height", "rotation", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		volume type:#string ui:wwmt_volume_ui default:"0.85"
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		speed type:#integer ui:wwmt_speed_ui default:50
		height type:#integer ui:wwmt_height_ui default:0
		rotation type:#integer ui:wwmt_rotation_ui default:0
		_minlight type:#string ui:wwmt__minlight_ui
		spawnflags type:#integer default:1
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_platrot"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "big elev 1", "big elev 2", "tech elev 1", "tech elev 2", "tech elev 3", "freight elev 1", "freight elev 2", "heavy elev", "rack elev", "rail elev", "squeek elev", "odd elev 1", "odd elev 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "big elev stop1", "big elev stop2", "freight elev stop", "heavy elev stop", "rack stop", "rail stop", "squeek stop", "quick stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_volume_ui_label "Sound Volume 0.0 - 1.0" align:#left
		EditText wwmt_volume_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_label_speed_ui "Speed of rotation" align:#left
		Spinner wwmt_speed_ui "" type:#integer range:[-10000, 10000, 50]
		Label wwmt_label_height_ui "Travel altitude (can be negative)" align:#left
		Spinner wwmt_height_ui "" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt_rotation_ui "Spin amount" type:#integer range:[-10000, 10000, 0]
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Toggle" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "X Axis" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Y Axis" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_platrot" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_platrot_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_platrot&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_platrot" address:"https://developer.valvesoftware.com/wiki/func_platrot?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_pushable_CA = attributes "WW Entity func_pushable" version: 78 attribID:#(1167220161L,-79527866L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_pushable"
	local isWWPRO = true
	local description = "Pushable object"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "health", "wwmt_material", "explosion", "delay", "gibmodel", "spawnobject", "explodemagnitude", "renderfx", "rendermode", "renderamt", "rendercolor", "size", "friction", "buoyancy", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValmaterial = 0
	local propMapmaterial = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propValexplosion = 0
	local propMapexplosion = #("0", "1")
	local propValspawnobject = 0
	local propMapspawnobject = #("0")
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValsize = 0
	local propMapsize = #("0", "1", "2", "3")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		health type:#integer ui:wwmt_health_ui default:1
		wwmt_material type:#string ui:wwmt_material_ui default:"0"
		explosion type:#string ui:wwmt_explosion_ui default:"0"
		delay type:#string ui:wwmt_delay_ui default:"0"
		gibmodel type:#string ui:wwmt_gibmodel_ui
		spawnobject type:#string ui:wwmt_spawnobject_ui default:"0"
		explodemagnitude type:#integer ui:wwmt_explodemagnitude_ui default:0
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		size type:#string ui:wwmt_size_ui default:"0"
		friction type:#integer ui:wwmt_friction_ui default:50
		buoyancy type:#integer ui:wwmt_buoyancy_ui default:20
		_minlight type:#string ui:wwmt__minlight_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_pushable"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target on break" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target on break" message:"Pick Target Entity for Target on break" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Spinner wwmt_health_ui "Strength" type:#integer range:[-10000, 10000, 1]
		ComboBox wwmt_material_ui "Material type" type:#string items:#("Glass", "Wood", "Metal", "Flesh", "Cinder Block", "Ceiling Tile", "Computer", "Unbreakable Glass", "Rocks") height:3
		on wwmt_material_ui selected i do
		(
			wwmt_material = propMapmaterial[i]
		)
		on wwmt_material_ui entered tex do
		(
			wwmt_material = trimLeft(trimRight(tex))
			if propMapmaterial != undefined AND findItem propMapmaterial tex == 0 then
			(
				append propMapmaterial tex
				sort propMapmaterial
				wwmt_material_ui.items = propMapmaterial
				wwmt_material_ui.selection = findItem wwmt_material_ui.items tex
			)
		)
		DropDownList wwmt_explosion_ui "Gibs Direction" type:#string items:#("Random", "Relative to Attack")
		on wwmt_explosion_ui selected i do
		(
			explosion = propMapexplosion[i]
		)
		Label wwmt_delay_ui_label "Delay before fire" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_gibmodel_ui_label "Gib Model" align:#left
		EditText wwmt_gibmodel_ui "" type:#string
		DropDownList wwmt_spawnobject_ui "Spawn On Break" type:#string items:#("Nothing")
		on wwmt_spawnobject_ui selected i do
		(
			spawnobject = propMapspawnobject[i]
		)
		Label wwmt_label_explodemagnitude_ui "Explode Magnitude (0=none)" align:#left
		Spinner wwmt_explodemagnitude_ui "" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_size_ui "Hull Size" type:#string items:#("Point size", "Player size", "Big Size", "Player duck") height:3
		on wwmt_size_ui selected i do
		(
			size = propMapsize[i]
		)
		on wwmt_size_ui entered tex do
		(
			size = trimLeft(trimRight(tex))
			if propMapsize != undefined AND findItem propMapsize tex == 0 then
			(
				append propMapsize tex
				sort propMapsize
				wwmt_size_ui.items = propMapsize
				wwmt_size_ui.selection = findItem wwmt_size_ui.items tex
			)
		)
		Label wwmt_label_friction_ui "Friction (0-400)" align:#left
		Spinner wwmt_friction_ui "" type:#integer range:[-10000, 10000, 50]
		Spinner wwmt_buoyancy_ui "Buoyancy" type:#integer range:[-10000, 10000, 20]
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_128_ui "Breakable" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_pushable" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_pushable_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_pushable&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_pushable" address:"https://developer.valvesoftware.com/wiki/func_pushable?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if wwmt_material != undefined then
			(
				if findItem propMapmaterial wwmt_material == 0 then
				(
					append propMapmaterial wwmt_material
					local tmp = wwmt_material_ui.items
					append tmp wwmt_material
					wwmt_material_ui.items = tmp
					wwmt_material_ui.selection = propMapmaterial.count
				)
				else
				(
					wwmt_material_ui.selection = (findItem propMapmaterial wwmt_material)
				)
			)
			if explosion != undefined then
			(
				if findItem propMapexplosion explosion == 0 then
				(
					append propMapexplosion explosion
					local tmp = wwmt_explosion_ui.items
					append tmp explosion
					wwmt_explosion_ui.items = tmp
					wwmt_explosion_ui.selection = propMapexplosion.count
				)
				else
				(
					wwmt_explosion_ui.selection = (findItem propMapexplosion explosion)
				)
			)
			if spawnobject != undefined then
			(
				if findItem propMapspawnobject spawnobject == 0 then
				(
					append propMapspawnobject spawnobject
					local tmp = wwmt_spawnobject_ui.items
					append tmp spawnobject
					wwmt_spawnobject_ui.items = tmp
					wwmt_spawnobject_ui.selection = propMapspawnobject.count
				)
				else
				(
					wwmt_spawnobject_ui.selection = (findItem propMapspawnobject spawnobject)
				)
			)
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if size != undefined then
			(
				if findItem propMapsize size == 0 then
				(
					append propMapsize size
					local tmp = wwmt_size_ui.items
					append tmp size
					wwmt_size_ui.items = tmp
					wwmt_size_ui.selection = propMapsize.count
				)
				else
				(
					wwmt_size_ui.selection = (findItem propMapsize size)
				)
			)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_rot_button_CA = attributes "WW Entity func_rot_button" version: 78 attribID:#(-70763294L,-1009942767L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_rot_button"
	local isWWPRO = true
	local description = "RotatingButton"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "wwmt_target", "changetarget", "master", "speed", "health", "sounds", "wait", "delay", "distance", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValsounds = 21
	local propMapsounds = #("21", "22", "23", "24", "25")
	local propValwait = 3
	local propMapwait = #("-1")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		wwmt_target type:#string ui:wwmt_target_ui
		changetarget type:#string ui:wwmt_changetarget_ui
		master type:#string ui:wwmt_master_ui
		speed type:#integer ui:wwmt_speed_ui default:50
		health type:#integer ui:wwmt_health_ui
		sounds type:#string ui:wwmt_sounds_ui default:"21"
		wait type:#string ui:wwmt_wait_ui default:"3"
		delay type:#string ui:wwmt_delay_ui default:"0"
		distance type:#integer ui:wwmt_distance_ui default:90
		_minlight type:#integer ui:wwmt__minlight_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_rot_button"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_target_ui_label "Targetted object" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Targetted object" message:"Pick Target Entity for Targetted object" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_changetarget_ui_label "ChangeTarget Name" align:#left
		EditText wwmt_changetarget_ui "" type:#string
		PickButton wwmt_changetarget_pickme_ui "Pick ChangeTarget Name" message:"Pick Target Entity for ChangeTarget Name" filter:target_name_filter
		on wwmt_changetarget_pickme_ui picked obj do
		(
			changetarget = obj.targetname
		)
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 50]
		Label wwmt_label_health_ui "Health (shootable if > 0)" align:#left
		Spinner wwmt_health_ui "" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_sounds_ui "Sounds" type:#string items:#("Squeaky", "Squeaky Pneumatic", "Ratchet Groan", "Clean Ratchet", "Gas Clunk") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		DropDownList wwmt_wait_ui "Delay before reset" type:#string items:#("Stays pressed")
		on wwmt_wait_ui selected i do
		(
			wait = propMapwait[i]
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Spinner wwmt_distance_ui "Distance (deg)" type:#integer range:[-10000, 10000, 90]
		Spinner wwmt__minlight_ui "_minlight" type:#integer range:[-10000, 10000, 0]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Not solid" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Reverse Dir" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Toggle" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "X Axis" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Y Axis" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Touch Activates" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_rot_button" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_rot_button_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_rot_button&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_rot_button" address:"https://developer.valvesoftware.com/wiki/func_rot_button?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			if wait != undefined then
			(
				if findItem propMapwait wait == 0 then
				(
					append propMapwait wait
					local tmp = wwmt_wait_ui.items
					append tmp wait
					wwmt_wait_ui.items = tmp
					wwmt_wait_ui.selection = propMapwait.count
				)
				else
				(
					wwmt_wait_ui.selection = (findItem propMapwait wait)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_rotating_CA = attributes "WW Entity func_rotating" version: 78 attribID:#(-1964947721L,-487807204L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_rotating"
	local isWWPRO = true
	local description = "Rotating Object"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "speed", "volume", "fanfriction", "sounds", "message", "_minlight", "spawnorigin", "dmg")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValsounds = 0
	local propMapsounds = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		speed type:#integer ui:wwmt_speed_ui default:0
		volume type:#integer ui:wwmt_volume_ui default:10
		fanfriction type:#integer ui:wwmt_fanfriction_ui default:20
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		message type:#string ui:wwmt_message_ui
		_minlight type:#integer ui:wwmt__minlight_ui
		spawnorigin type:#string ui:wwmt_spawnorigin_ui default:"0 0 0"
		dmg type:#integer ui:wwmt_dmg_ui default:0
		spawnflags type:#integer default:512
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_rotating"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Spinner wwmt_speed_ui "Rotation Speed" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_volume_ui "Volume (10 = loudest)" align:#left
		Spinner wwmt_volume_ui "" type:#integer range:[-10000, 10000, 10]
		Label wwmt_label_fanfriction_ui "Friction (0 - 100%)" align:#left
		Spinner wwmt_fanfriction_ui "" type:#integer range:[-10000, 10000, 20]
		ComboBox wwmt_sounds_ui "Fan Sounds" type:#string items:#("No Sound", "Fast Whine", "Slow Rush", "Medium Rickety", "Fast Beating", "Slow Smooth") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		Label wwmt_message_ui_label "WAV Name" align:#left
		EditText wwmt_message_ui "" type:#string
		Spinner wwmt__minlight_ui "_minlight" type:#integer range:[-10000, 10000, 0]
		Label wwmt_spawnorigin_ui_label "X Y Z - Move here after lighting" align:#left
		EditText wwmt_spawnorigin_ui "" type:#string
		Label wwmt_label_dmg_ui "Damage inflicted when blocked" align:#left
		Spinner wwmt_dmg_ui "" type:#integer range:[-10000, 10000, 0]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			if params.flag_512_ui.checked == true then
			(
				sfs += 512
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Start ON" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Reverse Direction" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "X Axis" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Y Axis" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Acc/Dcc" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Fan Pain" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "Not Solid" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Small Radius" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Medium Radius" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_512_ui "Large Radius" type:#integer
			on flag_512_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_rotating" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_rotating_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_rotating&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_rotating" address:"https://developer.valvesoftware.com/wiki/func_rotating?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			flag_512_ui.checked = (bit.and (getProperty this #spawnflags) 512 == 512)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_tank_CA = attributes "WW Entity func_tank" version: 78 attribID:#(533770476L,-535527541L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_tank"
	local isWWPRO = true
	local description = "Brush Gun Turret"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "yawrate", "yawrange", "yawtolerance", "pitchrate", "pitchrange", "pitchtolerance", "barrel", "barrely", "barrelz", "spritesmoke", "spriteflash", "spritescale", "rotatesound", "firerate", "bullet_damage", "persistence", "firespread", "minRange", "maxRange", "_minlight", "bullet")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValfirespread = 0
	local propMapfirespread = #("0", "1", "2", "3", "4")
	local propValbullet = 0
	local propMapbullet = #("0", "1", "2", "3")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		yawrate type:#string ui:wwmt_yawrate_ui default:"30"
		yawrange type:#string ui:wwmt_yawrange_ui default:"180"
		yawtolerance type:#string ui:wwmt_yawtolerance_ui default:"15"
		pitchrate type:#string ui:wwmt_pitchrate_ui default:"0"
		pitchrange type:#string ui:wwmt_pitchrange_ui default:"0"
		pitchtolerance type:#string ui:wwmt_pitchtolerance_ui default:"5"
		barrel type:#string ui:wwmt_barrel_ui default:"0"
		barrely type:#string ui:wwmt_barrely_ui default:"0"
		barrelz type:#string ui:wwmt_barrelz_ui default:"0"
		spritesmoke type:#string ui:wwmt_spritesmoke_ui
		spriteflash type:#string ui:wwmt_spriteflash_ui
		spritescale type:#string ui:wwmt_spritescale_ui default:"1"
		rotatesound type:#string ui:wwmt_rotatesound_ui
		firerate type:#string ui:wwmt_firerate_ui default:"1"
		bullet_damage type:#string ui:wwmt_bullet_damage_ui default:"0"
		persistence type:#string ui:wwmt_persistence_ui default:"1"
		firespread type:#string ui:wwmt_firespread_ui default:"0"
		minRange type:#string ui:wwmt_minRange_ui default:"0"
		maxRange type:#string ui:wwmt_maxRange_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		bullet type:#string ui:wwmt_bullet_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_tank"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_yawrate_ui_label "Yaw rate" align:#left
		EditText wwmt_yawrate_ui "" type:#string
		Label wwmt_yawrange_ui_label "Yaw range" align:#left
		EditText wwmt_yawrange_ui "" type:#string
		Label wwmt_yawtolerance_ui_label "Yaw tolerance" align:#left
		EditText wwmt_yawtolerance_ui "" type:#string
		Label wwmt_pitchrate_ui_label "Pitch rate" align:#left
		EditText wwmt_pitchrate_ui "" type:#string
		Label wwmt_pitchrange_ui_label "Pitch range" align:#left
		EditText wwmt_pitchrange_ui "" type:#string
		Label wwmt_pitchtolerance_ui_label "Pitch tolerance" align:#left
		EditText wwmt_pitchtolerance_ui "" type:#string
		Label wwmt_barrel_ui_label "Barrel Length" align:#left
		EditText wwmt_barrel_ui "" type:#string
		Label wwmt_barrely_ui_label "Barrel Horizontal" align:#left
		EditText wwmt_barrely_ui "" type:#string
		Label wwmt_barrelz_ui_label "Barrel Vertical" align:#left
		EditText wwmt_barrelz_ui "" type:#string
		Label wwmt_spritesmoke_ui_label "Smoke Sprite" align:#left
		EditText wwmt_spritesmoke_ui "" type:#string
		Label wwmt_spriteflash_ui_label "Flash Sprite" align:#left
		EditText wwmt_spriteflash_ui "" type:#string
		Label wwmt_spritescale_ui_label "Sprite scale" align:#left
		EditText wwmt_spritescale_ui "" type:#string
		Label wwmt_rotatesound_ui_label "Rotate Sound" align:#left
		EditText wwmt_rotatesound_ui "" type:#string
		Label wwmt_firerate_ui_label "Rate of Fire" align:#left
		EditText wwmt_firerate_ui "" type:#string
		Label wwmt_bullet_damage_ui_label "Damage Per Bullet" align:#left
		EditText wwmt_bullet_damage_ui "" type:#string
		Label wwmt_persistence_ui_label "Firing persistence" align:#left
		EditText wwmt_persistence_ui "" type:#string
		ComboBox wwmt_firespread_ui "Bullet accuracy" type:#string items:#("Perfect Shot", "Small cone", "Medium cone", "Large cone", "Extra-large cone") height:3
		on wwmt_firespread_ui selected i do
		(
			firespread = propMapfirespread[i]
		)
		on wwmt_firespread_ui entered tex do
		(
			firespread = trimLeft(trimRight(tex))
			if propMapfirespread != undefined AND findItem propMapfirespread tex == 0 then
			(
				append propMapfirespread tex
				sort propMapfirespread
				wwmt_firespread_ui.items = propMapfirespread
				wwmt_firespread_ui.selection = findItem wwmt_firespread_ui.items tex
			)
		)
		Label wwmt_minRange_ui_label "Minmum target range" align:#left
		EditText wwmt_minRange_ui "" type:#string
		Label wwmt_maxRange_ui_label "Maximum target range" align:#left
		EditText wwmt_maxRange_ui "" type:#string
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		ComboBox wwmt_bullet_ui "Bullets" type:#string items:#("None", "9mm", "MP5", "12mm") height:3
		on wwmt_bullet_ui selected i do
		(
			bullet = propMapbullet[i]
		)
		on wwmt_bullet_ui entered tex do
		(
			bullet = trimLeft(trimRight(tex))
			if propMapbullet != undefined AND findItem propMapbullet tex == 0 then
			(
				append propMapbullet tex
				sort propMapbullet
				wwmt_bullet_ui.items = propMapbullet
				wwmt_bullet_ui.selection = findItem wwmt_bullet_ui.items tex
			)
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Active" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Only Direct" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Controllable" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_tank" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_tank_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_tank&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_tank" address:"https://developer.valvesoftware.com/wiki/func_tank?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if firespread != undefined then
			(
				if findItem propMapfirespread firespread == 0 then
				(
					append propMapfirespread firespread
					local tmp = wwmt_firespread_ui.items
					append tmp firespread
					wwmt_firespread_ui.items = tmp
					wwmt_firespread_ui.selection = propMapfirespread.count
				)
				else
				(
					wwmt_firespread_ui.selection = (findItem propMapfirespread firespread)
				)
			)
			if bullet != undefined then
			(
				if findItem propMapbullet bullet == 0 then
				(
					append propMapbullet bullet
					local tmp = wwmt_bullet_ui.items
					append tmp bullet
					wwmt_bullet_ui.items = tmp
					wwmt_bullet_ui.selection = propMapbullet.count
				)
				else
				(
					wwmt_bullet_ui.selection = (findItem propMapbullet bullet)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_tankcontrols_CA = attributes "WW Entity func_tankcontrols" version: 78 attribID:#(690331584L,128744087L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_tankcontrols"
	local isWWPRO = true
	local description = "Tank controls"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		wwmt_target type:#string ui:wwmt_target_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_tankcontrols"
		Label wwmt_target_ui_label "Tank entity name" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Tank entity name" message:"Pick Target Entity for Tank entity name" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_tankcontrols" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_tankcontrols_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_tankcontrols&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_tankcontrols" address:"https://developer.valvesoftware.com/wiki/func_tankcontrols?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_tankmortar_CA = attributes "WW Entity func_tankmortar" version: 78 attribID:#(735805750L,-243104968L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_tankmortar"
	local isWWPRO = true
	local description = "Brush Mortar Turret"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "yawrate", "yawrange", "yawtolerance", "pitchrate", "pitchrange", "pitchtolerance", "barrel", "barrely", "barrelz", "spritesmoke", "spriteflash", "spritescale", "rotatesound", "firerate", "bullet_damage", "persistence", "firespread", "minRange", "maxRange", "_minlight", "iMagnitude")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValfirespread = 0
	local propMapfirespread = #("0", "1", "2", "3", "4")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		yawrate type:#string ui:wwmt_yawrate_ui default:"30"
		yawrange type:#string ui:wwmt_yawrange_ui default:"180"
		yawtolerance type:#string ui:wwmt_yawtolerance_ui default:"15"
		pitchrate type:#string ui:wwmt_pitchrate_ui default:"0"
		pitchrange type:#string ui:wwmt_pitchrange_ui default:"0"
		pitchtolerance type:#string ui:wwmt_pitchtolerance_ui default:"5"
		barrel type:#string ui:wwmt_barrel_ui default:"0"
		barrely type:#string ui:wwmt_barrely_ui default:"0"
		barrelz type:#string ui:wwmt_barrelz_ui default:"0"
		spritesmoke type:#string ui:wwmt_spritesmoke_ui
		spriteflash type:#string ui:wwmt_spriteflash_ui
		spritescale type:#string ui:wwmt_spritescale_ui default:"1"
		rotatesound type:#string ui:wwmt_rotatesound_ui
		firerate type:#string ui:wwmt_firerate_ui default:"1"
		bullet_damage type:#string ui:wwmt_bullet_damage_ui default:"0"
		persistence type:#string ui:wwmt_persistence_ui default:"1"
		firespread type:#string ui:wwmt_firespread_ui default:"0"
		minRange type:#string ui:wwmt_minRange_ui default:"0"
		maxRange type:#string ui:wwmt_maxRange_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		iMagnitude type:#integer ui:wwmt_iMagnitude_ui default:100
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_tankmortar"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_yawrate_ui_label "Yaw rate" align:#left
		EditText wwmt_yawrate_ui "" type:#string
		Label wwmt_yawrange_ui_label "Yaw range" align:#left
		EditText wwmt_yawrange_ui "" type:#string
		Label wwmt_yawtolerance_ui_label "Yaw tolerance" align:#left
		EditText wwmt_yawtolerance_ui "" type:#string
		Label wwmt_pitchrate_ui_label "Pitch rate" align:#left
		EditText wwmt_pitchrate_ui "" type:#string
		Label wwmt_pitchrange_ui_label "Pitch range" align:#left
		EditText wwmt_pitchrange_ui "" type:#string
		Label wwmt_pitchtolerance_ui_label "Pitch tolerance" align:#left
		EditText wwmt_pitchtolerance_ui "" type:#string
		Label wwmt_barrel_ui_label "Barrel Length" align:#left
		EditText wwmt_barrel_ui "" type:#string
		Label wwmt_barrely_ui_label "Barrel Horizontal" align:#left
		EditText wwmt_barrely_ui "" type:#string
		Label wwmt_barrelz_ui_label "Barrel Vertical" align:#left
		EditText wwmt_barrelz_ui "" type:#string
		Label wwmt_spritesmoke_ui_label "Smoke Sprite" align:#left
		EditText wwmt_spritesmoke_ui "" type:#string
		Label wwmt_spriteflash_ui_label "Flash Sprite" align:#left
		EditText wwmt_spriteflash_ui "" type:#string
		Label wwmt_spritescale_ui_label "Sprite scale" align:#left
		EditText wwmt_spritescale_ui "" type:#string
		Label wwmt_rotatesound_ui_label "Rotate Sound" align:#left
		EditText wwmt_rotatesound_ui "" type:#string
		Label wwmt_firerate_ui_label "Rate of Fire" align:#left
		EditText wwmt_firerate_ui "" type:#string
		Label wwmt_bullet_damage_ui_label "Damage Per Bullet" align:#left
		EditText wwmt_bullet_damage_ui "" type:#string
		Label wwmt_persistence_ui_label "Firing persistence" align:#left
		EditText wwmt_persistence_ui "" type:#string
		ComboBox wwmt_firespread_ui "Bullet accuracy" type:#string items:#("Perfect Shot", "Small cone", "Medium cone", "Large cone", "Extra-large cone") height:3
		on wwmt_firespread_ui selected i do
		(
			firespread = propMapfirespread[i]
		)
		on wwmt_firespread_ui entered tex do
		(
			firespread = trimLeft(trimRight(tex))
			if propMapfirespread != undefined AND findItem propMapfirespread tex == 0 then
			(
				append propMapfirespread tex
				sort propMapfirespread
				wwmt_firespread_ui.items = propMapfirespread
				wwmt_firespread_ui.selection = findItem wwmt_firespread_ui.items tex
			)
		)
		Label wwmt_minRange_ui_label "Minmum target range" align:#left
		EditText wwmt_minRange_ui "" type:#string
		Label wwmt_maxRange_ui_label "Maximum target range" align:#left
		EditText wwmt_maxRange_ui "" type:#string
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		Label wwmt_label_iMagnitude_ui "Explosion Magnitude" align:#left
		Spinner wwmt_iMagnitude_ui "" type:#integer range:[-10000, 10000, 100]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Active" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Only Direct" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Controllable" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_tankmortar" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_tankmortar_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_tankmortar&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_tankmortar" address:"https://developer.valvesoftware.com/wiki/func_tankmortar?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if firespread != undefined then
			(
				if findItem propMapfirespread firespread == 0 then
				(
					append propMapfirespread firespread
					local tmp = wwmt_firespread_ui.items
					append tmp firespread
					wwmt_firespread_ui.items = tmp
					wwmt_firespread_ui.selection = propMapfirespread.count
				)
				else
				(
					wwmt_firespread_ui.selection = (findItem propMapfirespread firespread)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_tankrocket_CA = attributes "WW Entity func_tankrocket" version: 78 attribID:#(735805750L,-1533756459L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_tankrocket"
	local isWWPRO = true
	local description = "Brush Rocket Turret"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "yawrate", "yawrange", "yawtolerance", "pitchrate", "pitchrange", "pitchtolerance", "barrel", "barrely", "barrelz", "spritesmoke", "spriteflash", "spritescale", "rotatesound", "firerate", "bullet_damage", "persistence", "firespread", "minRange", "maxRange", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValfirespread = 0
	local propMapfirespread = #("0", "1", "2", "3", "4")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		yawrate type:#string ui:wwmt_yawrate_ui default:"30"
		yawrange type:#string ui:wwmt_yawrange_ui default:"180"
		yawtolerance type:#string ui:wwmt_yawtolerance_ui default:"15"
		pitchrate type:#string ui:wwmt_pitchrate_ui default:"0"
		pitchrange type:#string ui:wwmt_pitchrange_ui default:"0"
		pitchtolerance type:#string ui:wwmt_pitchtolerance_ui default:"5"
		barrel type:#string ui:wwmt_barrel_ui default:"0"
		barrely type:#string ui:wwmt_barrely_ui default:"0"
		barrelz type:#string ui:wwmt_barrelz_ui default:"0"
		spritesmoke type:#string ui:wwmt_spritesmoke_ui
		spriteflash type:#string ui:wwmt_spriteflash_ui
		spritescale type:#string ui:wwmt_spritescale_ui default:"1"
		rotatesound type:#string ui:wwmt_rotatesound_ui
		firerate type:#string ui:wwmt_firerate_ui default:"1"
		bullet_damage type:#string ui:wwmt_bullet_damage_ui default:"0"
		persistence type:#string ui:wwmt_persistence_ui default:"1"
		firespread type:#string ui:wwmt_firespread_ui default:"0"
		minRange type:#string ui:wwmt_minRange_ui default:"0"
		maxRange type:#string ui:wwmt_maxRange_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_tankrocket"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_yawrate_ui_label "Yaw rate" align:#left
		EditText wwmt_yawrate_ui "" type:#string
		Label wwmt_yawrange_ui_label "Yaw range" align:#left
		EditText wwmt_yawrange_ui "" type:#string
		Label wwmt_yawtolerance_ui_label "Yaw tolerance" align:#left
		EditText wwmt_yawtolerance_ui "" type:#string
		Label wwmt_pitchrate_ui_label "Pitch rate" align:#left
		EditText wwmt_pitchrate_ui "" type:#string
		Label wwmt_pitchrange_ui_label "Pitch range" align:#left
		EditText wwmt_pitchrange_ui "" type:#string
		Label wwmt_pitchtolerance_ui_label "Pitch tolerance" align:#left
		EditText wwmt_pitchtolerance_ui "" type:#string
		Label wwmt_barrel_ui_label "Barrel Length" align:#left
		EditText wwmt_barrel_ui "" type:#string
		Label wwmt_barrely_ui_label "Barrel Horizontal" align:#left
		EditText wwmt_barrely_ui "" type:#string
		Label wwmt_barrelz_ui_label "Barrel Vertical" align:#left
		EditText wwmt_barrelz_ui "" type:#string
		Label wwmt_spritesmoke_ui_label "Smoke Sprite" align:#left
		EditText wwmt_spritesmoke_ui "" type:#string
		Label wwmt_spriteflash_ui_label "Flash Sprite" align:#left
		EditText wwmt_spriteflash_ui "" type:#string
		Label wwmt_spritescale_ui_label "Sprite scale" align:#left
		EditText wwmt_spritescale_ui "" type:#string
		Label wwmt_rotatesound_ui_label "Rotate Sound" align:#left
		EditText wwmt_rotatesound_ui "" type:#string
		Label wwmt_firerate_ui_label "Rate of Fire" align:#left
		EditText wwmt_firerate_ui "" type:#string
		Label wwmt_bullet_damage_ui_label "Damage Per Bullet" align:#left
		EditText wwmt_bullet_damage_ui "" type:#string
		Label wwmt_persistence_ui_label "Firing persistence" align:#left
		EditText wwmt_persistence_ui "" type:#string
		ComboBox wwmt_firespread_ui "Bullet accuracy" type:#string items:#("Perfect Shot", "Small cone", "Medium cone", "Large cone", "Extra-large cone") height:3
		on wwmt_firespread_ui selected i do
		(
			firespread = propMapfirespread[i]
		)
		on wwmt_firespread_ui entered tex do
		(
			firespread = trimLeft(trimRight(tex))
			if propMapfirespread != undefined AND findItem propMapfirespread tex == 0 then
			(
				append propMapfirespread tex
				sort propMapfirespread
				wwmt_firespread_ui.items = propMapfirespread
				wwmt_firespread_ui.selection = findItem wwmt_firespread_ui.items tex
			)
		)
		Label wwmt_minRange_ui_label "Minmum target range" align:#left
		EditText wwmt_minRange_ui "" type:#string
		Label wwmt_maxRange_ui_label "Maximum target range" align:#left
		EditText wwmt_maxRange_ui "" type:#string
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Active" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Only Direct" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Controllable" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_tankrocket" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_tankrocket_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_tankrocket&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_tankrocket" address:"https://developer.valvesoftware.com/wiki/func_tankrocket?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if firespread != undefined then
			(
				if findItem propMapfirespread firespread == 0 then
				(
					append propMapfirespread firespread
					local tmp = wwmt_firespread_ui.items
					append tmp firespread
					wwmt_firespread_ui.items = tmp
					wwmt_firespread_ui.selection = propMapfirespread.count
				)
				else
				(
					wwmt_firespread_ui.selection = (findItem propMapfirespread firespread)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_trackautochange_CA = attributes "WW Entity func_trackautochange" version: 78 attribID:#(-1059899516L,-1832384351L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_trackautochange"
	local isWWPRO = true
	local description = "Automatic track changing platform"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "movesnd", "stopsnd", "volume", "height", "rotation", "train", "toptrack", "bottomtrack", "speed", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		volume type:#string ui:wwmt_volume_ui default:"0.85"
		height type:#integer ui:wwmt_height_ui default:0
		rotation type:#integer ui:wwmt_rotation_ui default:0
		train type:#string ui:wwmt_train_ui
		toptrack type:#string ui:wwmt_toptrack_ui
		bottomtrack type:#string ui:wwmt_bottomtrack_ui
		speed type:#integer ui:wwmt_speed_ui default:0
		_minlight type:#string ui:wwmt__minlight_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_trackautochange"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "big elev 1", "big elev 2", "tech elev 1", "tech elev 2", "tech elev 3", "freight elev 1", "freight elev 2", "heavy elev", "rack elev", "rail elev", "squeek elev", "odd elev 1", "odd elev 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "big elev stop1", "big elev stop2", "freight elev stop", "heavy elev stop", "rack stop", "rail stop", "squeek stop", "quick stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_volume_ui_label "Sound Volume 0.0 - 1.0" align:#left
		EditText wwmt_volume_ui "" type:#string
		Spinner wwmt_height_ui "Travel altitude" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt_rotation_ui "Spin amount" type:#integer range:[-10000, 10000, 0]
		Label wwmt_train_ui_label "Train to switch" align:#left
		EditText wwmt_train_ui "" type:#string
		PickButton wwmt_train_pickme_ui "Pick Train to switch" message:"Pick Target Entity for Train to switch" filter:target_name_filter
		on wwmt_train_pickme_ui picked obj do
		(
			train = obj.targetname
		)
		Label wwmt_toptrack_ui_label "Top track" align:#left
		EditText wwmt_toptrack_ui "" type:#string
		PickButton wwmt_toptrack_pickme_ui "Pick Top track" message:"Pick Target Entity for Top track" filter:target_name_filter
		on wwmt_toptrack_pickme_ui picked obj do
		(
			toptrack = obj.targetname
		)
		Label wwmt_bottomtrack_ui_label "Bottom track" align:#left
		EditText wwmt_bottomtrack_ui "" type:#string
		PickButton wwmt_bottomtrack_pickme_ui "Pick Bottom track" message:"Pick Target Entity for Bottom track" filter:target_name_filter
		on wwmt_bottomtrack_pickme_ui picked obj do
		(
			bottomtrack = obj.targetname
		)
		Label wwmt_label_speed_ui "Move/Rotate speed" align:#left
		Spinner wwmt_speed_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Auto Activate train" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Relink track" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Start at Bottom" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Rotate Only" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "X Axis" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Y Axis" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_trackautochange" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_trackautochange_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_trackautochange&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_trackautochange" address:"https://developer.valvesoftware.com/wiki/func_trackautochange?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_trackchange_CA = attributes "WW Entity func_trackchange" version: 78 attribID:#(287047038L,-316083132L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_trackchange"
	local isWWPRO = true
	local description = "Train track changing platform"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "movesnd", "stopsnd", "volume", "height", "rotation", "train", "toptrack", "bottomtrack", "speed", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		volume type:#string ui:wwmt_volume_ui default:"0.85"
		height type:#integer ui:wwmt_height_ui default:0
		rotation type:#integer ui:wwmt_rotation_ui default:0
		train type:#string ui:wwmt_train_ui
		toptrack type:#string ui:wwmt_toptrack_ui
		bottomtrack type:#string ui:wwmt_bottomtrack_ui
		speed type:#integer ui:wwmt_speed_ui default:0
		_minlight type:#string ui:wwmt__minlight_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_trackchange"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "big elev 1", "big elev 2", "tech elev 1", "tech elev 2", "tech elev 3", "freight elev 1", "freight elev 2", "heavy elev", "rack elev", "rail elev", "squeek elev", "odd elev 1", "odd elev 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "big elev stop1", "big elev stop2", "freight elev stop", "heavy elev stop", "rack stop", "rail stop", "squeek stop", "quick stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_volume_ui_label "Sound Volume 0.0 - 1.0" align:#left
		EditText wwmt_volume_ui "" type:#string
		Spinner wwmt_height_ui "Travel altitude" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt_rotation_ui "Spin amount" type:#integer range:[-10000, 10000, 0]
		Label wwmt_train_ui_label "Train to switch" align:#left
		EditText wwmt_train_ui "" type:#string
		PickButton wwmt_train_pickme_ui "Pick Train to switch" message:"Pick Target Entity for Train to switch" filter:target_name_filter
		on wwmt_train_pickme_ui picked obj do
		(
			train = obj.targetname
		)
		Label wwmt_toptrack_ui_label "Top track" align:#left
		EditText wwmt_toptrack_ui "" type:#string
		PickButton wwmt_toptrack_pickme_ui "Pick Top track" message:"Pick Target Entity for Top track" filter:target_name_filter
		on wwmt_toptrack_pickme_ui picked obj do
		(
			toptrack = obj.targetname
		)
		Label wwmt_bottomtrack_ui_label "Bottom track" align:#left
		EditText wwmt_bottomtrack_ui "" type:#string
		PickButton wwmt_bottomtrack_pickme_ui "Pick Bottom track" message:"Pick Target Entity for Bottom track" filter:target_name_filter
		on wwmt_bottomtrack_pickme_ui picked obj do
		(
			bottomtrack = obj.targetname
		)
		Label wwmt_label_speed_ui "Move/Rotate speed" align:#left
		Spinner wwmt_speed_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Auto Activate train" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Relink track" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Start at Bottom" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Rotate Only" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "X Axis" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Y Axis" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_trackchange" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_trackchange_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_trackchange&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_trackchange" address:"https://developer.valvesoftware.com/wiki/func_trackchange?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_tracktrain_CA = attributes "WW Entity func_tracktrain" version: 78 attribID:#(735805731L,1754041765L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_tracktrain"
	local isWWPRO = true
	local description = "Track Train"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "wwmt_target", "sounds", "wheels", "height", "startspeed", "speed", "dmg", "volume", "bank", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValsounds = 0
	local propMapsounds = #("0", "1", "2", "3", "4", "5", "6")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		wwmt_target type:#string ui:wwmt_target_ui
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		wheels type:#integer ui:wwmt_wheels_ui default:50
		height type:#integer ui:wwmt_height_ui default:4
		startspeed type:#integer ui:wwmt_startspeed_ui default:0
		speed type:#integer ui:wwmt_speed_ui default:64
		dmg type:#integer ui:wwmt_dmg_ui default:0
		volume type:#integer ui:wwmt_volume_ui default:10
		bank type:#string ui:wwmt_bank_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_tracktrain"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_target_ui_label "First stop target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick First stop target" message:"Pick Target Entity for First stop target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		ComboBox wwmt_sounds_ui "Sound" type:#string items:#("None", "Rail 1", "Rail 2", "Rail 3", "Rail 4", "Rail 6", "Rail 7") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		Label wwmt_label_wheels_ui "Distance between the wheels" align:#left
		Spinner wwmt_wheels_ui "" type:#integer range:[-10000, 10000, 50]
		Label wwmt_label_height_ui "Height above track" align:#left
		Spinner wwmt_height_ui "" type:#integer range:[-10000, 10000, 4]
		Spinner wwmt_startspeed_ui "Initial speed" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_speed_ui "Speed (units per second)" align:#left
		Spinner wwmt_speed_ui "" type:#integer range:[-10000, 10000, 64]
		Spinner wwmt_dmg_ui "Damage on crush" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_volume_ui "Volume (10 = loudest)" align:#left
		Spinner wwmt_volume_ui "" type:#integer range:[-10000, 10000, 10]
		Label wwmt_bank_ui_label "Bank angle on turns" align:#left
		EditText wwmt_bank_ui "" type:#string
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "No Pitch (X-rot)" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "No User Control" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Passable" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_tracktrain" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_tracktrain_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_tracktrain&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_tracktrain" address:"https://developer.valvesoftware.com/wiki/func_tracktrain?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_train_CA = attributes "WW Entity func_train" version: 78 attribID:#(721320529L,828994452L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_train"
	local isWWPRO = true
	local description = "Moving platform"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "wwmt_target", "movesnd", "stopsnd", "speed", "dmg", "skin", "volume", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		wwmt_target type:#string ui:wwmt_target_ui
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		speed type:#integer ui:wwmt_speed_ui default:64
		dmg type:#integer ui:wwmt_dmg_ui default:0
		skin type:#integer ui:wwmt_skin_ui default:0
		volume type:#string ui:wwmt_volume_ui default:"0.85"
		_minlight type:#string ui:wwmt__minlight_ui
		spawnflags type:#integer default:0
		on skin set val do
		(
			getNode()
			if (isValidNode thisNode AND classof thisNode != ::WallWormMDL AND val != undefined) then
			(
				if ::WallWormHelperOps != undefined then
				(
					::WallWormHelperOps.setProxySkin thisNode  val
				)
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_train"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_target_ui_label "First stop target" align:#left
		EditText wwmt_target_ui "" type:#string
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "big elev 1", "big elev 2", "tech elev 1", "tech elev 2", "tech elev 3", "freight elev 1", "freight elev 2", "heavy elev", "rack elev", "rail elev", "squeek elev", "odd elev 1", "odd elev 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "big elev stop1", "big elev stop2", "freight elev stop", "heavy elev stop", "rack stop", "rail stop", "squeek stop", "quick stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_label_speed_ui "Speed (units per second)" align:#left
		Spinner wwmt_speed_ui "" type:#integer range:[-10000, 10000, 64]
		Spinner wwmt_dmg_ui "Damage on crush" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt_skin_ui "Contents" type:#integer range:[-10000, 10000, 0]
		Label wwmt_volume_ui_label "Sound Volume 0.0 - 1.0" align:#left
		EditText wwmt_volume_ui "" type:#string
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_8_ui "Not solid" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_train" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_train_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_train&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_train" address:"https://developer.valvesoftware.com/wiki/func_train?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_traincontrols_CA = attributes "WW Entity func_traincontrols" version: 78 attribID:#(-1629377049L,122952090L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_traincontrols"
	local isWWPRO = true
	local description = "Train Controls"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		wwmt_target type:#string ui:wwmt_target_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_traincontrols"
		Label wwmt_target_ui_label "Train Name" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Train Name" message:"Pick Target Entity for Train Name" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_traincontrols" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_traincontrols_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_traincontrols&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_traincontrols" address:"https://developer.valvesoftware.com/wiki/func_traincontrols?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_wall_CA = attributes "WW Entity func_wall" version: 78 attribID:#(533770476L,808840333L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_wall"
	local isWWPRO = true
	local description = "Wall"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_wall"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_wall" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_wall_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_wall&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_wall" address:"https://developer.valvesoftware.com/wiki/func_wall?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_wall_toggle_CA = attributes "WW Entity func_wall_toggle" version: 78 attribID:#(1953887547L,1060694057L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_wall_toggle"
	local isWWPRO = true
	local description = "Toggleable geometry"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "zhlt_lightflags", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValzhlt_lightflags = 0
	local propMapzhlt_lightflags = #("0", "1", "2", "3")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_wall_toggle"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		ComboBox wwmt_zhlt_lightflags_ui "Light Flags (Zhlt 2.2+)" type:#string items:#("Normal", "Embedded Fix", "Opaque (Blocks Light)", "Opaque + Embedded Fix") height:3
		on wwmt_zhlt_lightflags_ui selected i do
		(
			zhlt_lightflags = propMapzhlt_lightflags[i]
		)
		on wwmt_zhlt_lightflags_ui entered tex do
		(
			zhlt_lightflags = trimLeft(trimRight(tex))
			if propMapzhlt_lightflags != undefined AND findItem propMapzhlt_lightflags tex == 0 then
			(
				append propMapzhlt_lightflags tex
				sort propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.items = propMapzhlt_lightflags
				wwmt_zhlt_lightflags_ui.selection = findItem wwmt_zhlt_lightflags_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Starts Invisible" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_wall_toggle" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_wall_toggle_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_wall_toggle&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_wall_toggle" address:"https://developer.valvesoftware.com/wiki/func_wall_toggle?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if zhlt_lightflags != undefined then
			(
				if findItem propMapzhlt_lightflags zhlt_lightflags == 0 then
				(
					append propMapzhlt_lightflags zhlt_lightflags
					local tmp = wwmt_zhlt_lightflags_ui.items
					append tmp zhlt_lightflags
					wwmt_zhlt_lightflags_ui.items = tmp
					wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
				)
				else
				(
					wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_water_CA = attributes "WW Entity func_water" version: 78 attribID:#(721320529L,-1779180711L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_water"
	local isWWPRO = true
	local description = "Liquid"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "killtarget", "speed", "master", "movesnd", "stopsnd", "wait", "lip", "dmg", "message", "wwmt_target", "delay", "netname", "health", "locked_sound", "unlocked_sound", "locked_sentence", "unlocked_sentence", "_minlight", "skin", "WaveHeight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propVallocked_sound = 0
	local propMaplocked_sound = #("0", "2", "8", "10", "11", "12")
	local propValunlocked_sound = 0
	local propMapunlocked_sound = #("0", "1", "3", "4", "5", "6", "7", "8", "9", "10", "13")
	local propVallocked_sentence = 0
	local propMaplocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
	local propValunlocked_sentence = 0
	local propMapunlocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propValskin = -3
	local propMapskin = #("-3", "-4", "-5")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		killtarget type:#string ui:wwmt_killtarget_ui
		speed type:#integer ui:wwmt_speed_ui default:100
		master type:#string ui:wwmt_master_ui
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		wait type:#integer ui:wwmt_wait_ui default:4
		lip type:#integer ui:wwmt_lip_ui
		dmg type:#integer ui:wwmt_dmg_ui default:0
		message type:#string ui:wwmt_message_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#integer ui:wwmt_delay_ui
		netname type:#string ui:wwmt_netname_ui
		health type:#integer ui:wwmt_health_ui default:0
		locked_sound type:#string ui:wwmt_locked_sound_ui default:"0"
		unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:"0"
		locked_sentence type:#string ui:wwmt_locked_sentence_ui default:"0"
		unlocked_sentence type:#string ui:wwmt_unlocked_sentence_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		skin type:#string ui:wwmt_skin_ui default:"-3"
		WaveHeight type:#string ui:wwmt_WaveHeight_ui default:"3.2"
		spawnflags type:#integer default:0
		on skin set val do
		(
			getNode()
			if (isValidNode thisNode AND classof thisNode != ::WallWormMDL AND val != undefined) then
			(
				if ::WallWormHelperOps != undefined then
				(
					::WallWormHelperOps.setProxySkin thisNode  val
				)
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_water"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 100]
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "Servo (Sliding)", "Pneumatic (Sliding)", "Pneumatic (Rolling)", "Vacuum", "Power Hydraulic", "Large Rollers", "Track Door", "Snappy Metal Door", "Squeaky 1", "Squeaky 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "Clang with brake", "Clang reverb", "Ratchet Stop", "Chunk", "Light airbrake", "Metal Slide Stop", "Metal Lock Stop", "Snappy Metal Stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_label_wait_ui "delay before close, -1 stay open " align:#left
		Spinner wwmt_wait_ui "" type:#integer range:[-10000, 10000, 4]
		Spinner wwmt_lip_ui "Lip" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_dmg_ui "Damage inflicted when blocked" align:#left
		Spinner wwmt_dmg_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_message_ui_label "Message if triggered" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_label_delay_ui "Delay before fire" align:#left
		Spinner wwmt_delay_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_netname_ui_label "Fire on Close" align:#left
		EditText wwmt_netname_ui "" type:#string
		Label wwmt_label_health_ui "Health (shoot open)" align:#left
		Spinner wwmt_health_ui "" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_locked_sound_ui "Locked Sound" type:#string items:#("None", "Access Denied", "Small zap", "Buzz", "Buzz Off", "Latch Locked") height:3
		on wwmt_locked_sound_ui selected i do
		(
			locked_sound = propMaplocked_sound[i]
		)
		on wwmt_locked_sound_ui entered tex do
		(
			locked_sound = trimLeft(trimRight(tex))
			if propMaplocked_sound != undefined AND findItem propMaplocked_sound tex == 0 then
			(
				append propMaplocked_sound tex
				sort propMaplocked_sound
				wwmt_locked_sound_ui.items = propMaplocked_sound
				wwmt_locked_sound_ui.selection = findItem wwmt_locked_sound_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sound_ui "Unlocked Sound" type:#string items:#("None", "Big zap & Warmup", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Latch Unlocked") height:3
		on wwmt_unlocked_sound_ui selected i do
		(
			unlocked_sound = propMapunlocked_sound[i]
		)
		on wwmt_unlocked_sound_ui entered tex do
		(
			unlocked_sound = trimLeft(trimRight(tex))
			if propMapunlocked_sound != undefined AND findItem propMapunlocked_sound tex == 0 then
			(
				append propMapunlocked_sound tex
				sort propMapunlocked_sound
				wwmt_unlocked_sound_ui.items = propMapunlocked_sound
				wwmt_unlocked_sound_ui.selection = findItem wwmt_unlocked_sound_ui.items tex
			)
		)
		ComboBox wwmt_locked_sentence_ui "Locked Sentence" type:#string items:#("None", "Gen. Access Denied", "Security Lockout", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance Door", "Broken Shut Door") height:3
		on wwmt_locked_sentence_ui selected i do
		(
			locked_sentence = propMaplocked_sentence[i]
		)
		on wwmt_locked_sentence_ui entered tex do
		(
			locked_sentence = trimLeft(trimRight(tex))
			if propMaplocked_sentence != undefined AND findItem propMaplocked_sentence tex == 0 then
			(
				append propMaplocked_sentence tex
				sort propMaplocked_sentence
				wwmt_locked_sentence_ui.items = propMaplocked_sentence
				wwmt_locked_sentence_ui.selection = findItem wwmt_locked_sentence_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sentence_ui "Unlocked Sentence" type:#string items:#("None", "Gen. Access Granted", "Security Disengaged", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance area") height:3
		on wwmt_unlocked_sentence_ui selected i do
		(
			unlocked_sentence = propMapunlocked_sentence[i]
		)
		on wwmt_unlocked_sentence_ui entered tex do
		(
			unlocked_sentence = trimLeft(trimRight(tex))
			if propMapunlocked_sentence != undefined AND findItem propMapunlocked_sentence tex == 0 then
			(
				append propMapunlocked_sentence tex
				sort propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.items = propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.selection = findItem wwmt_unlocked_sentence_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		DropDownList wwmt_skin_ui "Contents" type:#string items:#("Water", "Slime", "Lava")
		on wwmt_skin_ui selected i do
		(
			skin = propMapskin[i]
		)
		Label wwmt_WaveHeight_ui_label "Wave Height" align:#left
		EditText wwmt_WaveHeight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Starts Open" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Don't link" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Passable" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Toggle" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Use Only" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_water" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_water_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_water&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_water" address:"https://developer.valvesoftware.com/wiki/func_water?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			if locked_sound != undefined then
			(
				if findItem propMaplocked_sound locked_sound == 0 then
				(
					append propMaplocked_sound locked_sound
					local tmp = wwmt_locked_sound_ui.items
					append tmp locked_sound
					wwmt_locked_sound_ui.items = tmp
					wwmt_locked_sound_ui.selection = propMaplocked_sound.count
				)
				else
				(
					wwmt_locked_sound_ui.selection = (findItem propMaplocked_sound locked_sound)
				)
			)
			if unlocked_sound != undefined then
			(
				if findItem propMapunlocked_sound unlocked_sound == 0 then
				(
					append propMapunlocked_sound unlocked_sound
					local tmp = wwmt_unlocked_sound_ui.items
					append tmp unlocked_sound
					wwmt_unlocked_sound_ui.items = tmp
					wwmt_unlocked_sound_ui.selection = propMapunlocked_sound.count
				)
				else
				(
					wwmt_unlocked_sound_ui.selection = (findItem propMapunlocked_sound unlocked_sound)
				)
			)
			if locked_sentence != undefined then
			(
				if findItem propMaplocked_sentence locked_sentence == 0 then
				(
					append propMaplocked_sentence locked_sentence
					local tmp = wwmt_locked_sentence_ui.items
					append tmp locked_sentence
					wwmt_locked_sentence_ui.items = tmp
					wwmt_locked_sentence_ui.selection = propMaplocked_sentence.count
				)
				else
				(
					wwmt_locked_sentence_ui.selection = (findItem propMaplocked_sentence locked_sentence)
				)
			)
			if unlocked_sentence != undefined then
			(
				if findItem propMapunlocked_sentence unlocked_sentence == 0 then
				(
					append propMapunlocked_sentence unlocked_sentence
					local tmp = wwmt_unlocked_sentence_ui.items
					append tmp unlocked_sentence
					wwmt_unlocked_sentence_ui.items = tmp
					wwmt_unlocked_sentence_ui.selection = propMapunlocked_sentence.count
				)
				else
				(
					wwmt_unlocked_sentence_ui.selection = (findItem propMapunlocked_sentence unlocked_sentence)
				)
			)
			if skin != undefined then
			(
				if findItem propMapskin skin == 0 then
				(
					append propMapskin skin
					local tmp = wwmt_skin_ui.items
					append tmp skin
					wwmt_skin_ui.items = tmp
					wwmt_skin_ui.selection = propMapskin.count
				)
				else
				(
					wwmt_skin_ui.selection = (findItem propMapskin skin)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_infodecal_CA = attributes "WW Entity infodecal" version: 78 attribID:#(-1502854914L,-374486733L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "infodecal"
	local isWWPRO = true
	local description = "Decal"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "texture")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		texture type:#string ui:wwmt_texture_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "infodecal"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_texture_ui_label "" align:#left
		EditText wwmt_texture_ui "" type:#string
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=infodecal&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: infodecal" address:"https://developer.valvesoftware.com/wiki/infodecal?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_null_CA = attributes "WW Entity info_null" version: 78 attribID:#(-1502854914L,-911961274L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_null"
	local isWWPRO = true
	local description = "info_null (spotlight target)"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "info_null"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_null&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: info_null" address:"https://developer.valvesoftware.com/wiki/info_null?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_player_deathmatch_CA = attributes "WW Entity info_player_deathmatch" version: 78 attribID:#(2136950434L,-1255139572L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_player_deathmatch"
	local isWWPRO = true
	local description = "Terrorist start"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("angles")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/Terrorist.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "info_player_deathmatch"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_player_deathmatch&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: info_player_deathmatch" address:"https://developer.valvesoftware.com/wiki/info_player_deathmatch?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_player_start_CA = attributes "WW Entity info_player_start" version: 78 attribID:#(1951066434L,747920517L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_player_start"
	local isWWPRO = true
	local description = "Counter-terrorist start"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("angles")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/CT.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "info_player_start"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_player_start&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: info_player_start" address:"https://developer.valvesoftware.com/wiki/info_player_start?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_vip_start_CA = attributes "WW Entity info_vip_start" version: 78 attribID:#(1420106230L,-790477345L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_vip_start"
	local isWWPRO = true
	local description = "VIP start"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("angles")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/VIP.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "info_vip_start"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_vip_start&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: info_vip_start" address:"https://developer.valvesoftware.com/wiki/info_vip_start?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_target_CA = attributes "WW Entity info_target" version: 78 attribID:#(-1315297783L,1081251833L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_target"
	local isWWPRO = true
	local description = "Beam Target"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local entcolor = (Color 200 100 50)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "info_target"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_target&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: info_target" address:"https://developer.valvesoftware.com/wiki/info_target?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_light_CA = attributes "WW Entity light" version: 78 attribID:#(334115653L,1905882967L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "light"
	local isWWPRO = true
	local description = "Invisible lightsource"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target", "targetname", "_light", "style", "pattern")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/lightbulb.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValstyle = 0
	local propMapstyle = #("0", "10", "2", "11", "5", "1", "6", "3", "7", "8", "4", "9")
	parameters main rollout:params
	(
		wwmt_target type:#string ui:wwmt_target_ui
		targetname type:#string ui:wwmt_targetname_ui
		_light type:#color ui:wwmt__light_ui default:(Color 255 255 128)
		_light_intensity type:#integer ui:wwmt__light_intensity_ui default:200
		style type:#string ui:wwmt_style_ui default:"0"
		pattern type:#string ui:wwmt_pattern_ui
		spawnflags type:#integer default:0
		on _light set val do
		(
			if (val != undefined) AND (isValidNode (getNode())) AND (isProperty thisNode #color) then
			(
				thisNode.color = _light
			)
		)
		on _light_intensity set val do
		(
			if (val != undefined) AND (isValidNode (getNode())) AND (isProperty thisNode #multiplier) then
			(
				if ::WallWormHelperOps != undefined then ::WallWormHelperOps.setLightMultiplier thisNode val
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "light"
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ColorPicker wwmt__light_ui "_light" color:(Color 255 255 128)
		Spinner wwmt__light_intensity_ui "Brightness Intensity" type:#integer range:[-16000, 16000, 200] tooltip:"Intensity for Brightness"
		ComboBox wwmt_style_ui "Appearance" type:#string items:#("Normal", "Fluorescent flicker", "Slow, strong pulse", "Slow pulse, noblack", "Gentle pulse", "Flicker A", "Flicker B", "Candle A", "Candle B", "Candle C", "Fast strobe", "Slow strobe") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_pattern_ui_label "Custom Appearance" align:#left
		EditText wwmt_pattern_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Initially dark" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=light&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: light" address:"https://developer.valvesoftware.com/wiki/light?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_light_environment_CA = attributes "WW Entity light_environment" version: 78 attribID:#(1044210184L,-888099970L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "light_environment"
	local isWWPRO = true
	local description = "Environment"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("angles", "pitch", "_light")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/lightbulb.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		pitch type:#float ui:wwmt_pitch_ui default:0
		_light type:#color ui:wwmt__light_ui default:(Color 255 255 128)
		_light_intensity type:#integer ui:wwmt__light_intensity_ui default:200
		on _light set val do
		(
			if (val != undefined) AND (isValidNode (getNode())) AND (isProperty thisNode #color) then
			(
				thisNode.color = _light
			)
		)
		on _light_intensity set val do
		(
			if (val != undefined) AND (isValidNode (getNode())) AND (isProperty thisNode #multiplier) then
			(
				if ::WallWormHelperOps != undefined then ::WallWormHelperOps.setLightMultiplier thisNode val
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "light_environment"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Spinner wwmt_pitch_ui "Pitch" type:#float scale:1.0 range:[-10000, 10000, 0]
		ColorPicker wwmt__light_ui "_light" color:(Color 255 255 128)
		Spinner wwmt__light_intensity_ui "Brightness Intensity" type:#integer range:[-16000, 16000, 200] tooltip:"Intensity for Brightness"
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=light_environment&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: light_environment" address:"https://developer.valvesoftware.com/wiki/light_environment?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_light_spot_CA = attributes "WW Entity light_spot" version: 78 attribID:#(109618542L,163636283L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "light_spot"
	local isWWPRO = true
	local description = "Spotlight"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "angles", "_cone", "_cone2", "pitch", "_light", "_sky", "style", "pattern")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/lightbulb.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propVal_sky = 0
	local propMap_sky = #("0", "1")
	local propValstyle = 0
	local propMapstyle = #("0", "10", "2", "11", "5", "1", "6", "3", "7", "8", "4", "9")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		_cone type:#integer ui:wwmt__cone_ui default:30
		_cone2 type:#integer ui:wwmt__cone2_ui default:45
		pitch type:#float ui:wwmt_pitch_ui default:-90
		_light type:#color ui:wwmt__light_ui default:(Color 255 255 128)
		_light_intensity type:#integer ui:wwmt__light_intensity_ui default:200
		_sky type:#string ui:wwmt__sky_ui default:"0"
		style type:#string ui:wwmt_style_ui default:"0"
		pattern type:#string ui:wwmt_pattern_ui
		spawnflags type:#integer default:0
		on _cone set val do
		(
			if (val != undefined AND val as Integer != undefined) AND (getNode()) != undefined AND (isProperty thisNode #falloff) then
			(
				thisNode.falloff = (_cone as Float) * 2.0
			)
		)
		on _light set val do
		(
			if (val != undefined) AND (isValidNode (getNode())) AND (isProperty thisNode #color) then
			(
				thisNode.color = _light
			)
		)
		on _light_intensity set val do
		(
			if (val != undefined) AND (isValidNode (getNode())) AND (isProperty thisNode #multiplier) then
			(
				if ::WallWormHelperOps != undefined then ::WallWormHelperOps.setLightMultiplier thisNode val
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "light_spot"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_label__cone_ui "Inner (bright) angle" align:#left
		Spinner wwmt__cone_ui "" type:#integer range:[-10000, 10000, 30]
		Label wwmt_label__cone2_ui "Outer (fading) angle" align:#left
		Spinner wwmt__cone2_ui "" type:#integer range:[-10000, 10000, 45]
		Spinner wwmt_pitch_ui "Pitch" type:#float scale:1.0 range:[-10000, 10000, -90]
		ColorPicker wwmt__light_ui "_light" color:(Color 255 255 128)
		Spinner wwmt__light_intensity_ui "Brightness Intensity" type:#integer range:[-16000, 16000, 200] tooltip:"Intensity for Brightness"
		DropDownList wwmt__sky_ui "Is Sky" type:#string items:#("No", "Yes")
		on wwmt__sky_ui selected i do
		(
			_sky = propMap_sky[i]
		)
		ComboBox wwmt_style_ui "Appearance" type:#string items:#("Normal", "Fluorescent flicker", "Slow, strong pulse", "Slow pulse, noblack", "Gentle pulse", "Flicker A", "Flicker B", "Candle A", "Candle B", "Candle C", "Fast strobe", "Slow strobe") height:3
		on wwmt_style_ui selected i do
		(
			style = propMapstyle[i]
		)
		on wwmt_style_ui entered tex do
		(
			style = trimLeft(trimRight(tex))
			if propMapstyle != undefined AND findItem propMapstyle tex == 0 then
			(
				append propMapstyle tex
				sort propMapstyle
				wwmt_style_ui.items = propMapstyle
				wwmt_style_ui.selection = findItem wwmt_style_ui.items tex
			)
		)
		Label wwmt_pattern_ui_label "Custom Appearance" align:#left
		EditText wwmt_pattern_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Initially dark" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=light_spot&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: light_spot" address:"https://developer.valvesoftware.com/wiki/light_spot?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if _sky != undefined then
			(
				if findItem propMap_sky _sky == 0 then
				(
					append propMap_sky _sky
					local tmp = wwmt__sky_ui.items
					append tmp _sky
					wwmt__sky_ui.items = tmp
					wwmt__sky_ui.selection = propMap_sky.count
				)
				else
				(
					wwmt__sky_ui.selection = (findItem propMap_sky _sky)
				)
			)
			if style != undefined then
			(
				if findItem propMapstyle style == 0 then
				(
					append propMapstyle style
					local tmp = wwmt_style_ui.items
					append tmp style
					wwmt_style_ui.items = tmp
					wwmt_style_ui.selection = propMapstyle.count
				)
				else
				(
					wwmt_style_ui.selection = (findItem propMapstyle style)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_auto_CA = attributes "WW Entity trigger_auto" version: 78 attribID:#(-1618386072L,2134089762L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "trigger_auto"
	local isWWPRO = true
	local description = "AutoTrigger"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target", "delay", "killtarget", "triggerstate")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValtriggerstate = 0
	local propMaptriggerstate = #("0", "1", "2")
	parameters main rollout:params
	(
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		triggerstate type:#string ui:wwmt_triggerstate_ui default:"0"
		spawnflags type:#integer default:1
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_auto"
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		DropDownList wwmt_triggerstate_ui "Trigger State" type:#string items:#("Off", "On", "Toggle")
		on wwmt_triggerstate_ui selected i do
		(
			triggerstate = propMaptriggerstate[i]
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Remove On fire" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_auto&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_auto" address:"https://developer.valvesoftware.com/wiki/trigger_auto?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if triggerstate != undefined then
			(
				if findItem propMaptriggerstate triggerstate == 0 then
				(
					append propMaptriggerstate triggerstate
					local tmp = wwmt_triggerstate_ui.items
					append tmp triggerstate
					wwmt_triggerstate_ui.items = tmp
					wwmt_triggerstate_ui.selection = propMaptriggerstate.count
				)
				else
				(
					wwmt_triggerstate_ui.selection = (findItem propMaptriggerstate triggerstate)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_camera_CA = attributes "WW Entity trigger_camera" version: 78 attribID:#(276153110L,1743274620L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "trigger_camera"
	local isWWPRO = true
	local description = "Trigger Camera"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target", "delay", "killtarget", "targetname", "wait", "moveto", "speed", "acceleration", "deceleration")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		targetname type:#string ui:wwmt_targetname_ui
		wait type:#integer ui:wwmt_wait_ui default:10
		moveto type:#string ui:wwmt_moveto_ui
		speed type:#string ui:wwmt_speed_ui default:"0"
		acceleration type:#string ui:wwmt_acceleration_ui default:"500"
		deceleration type:#string ui:wwmt_deceleration_ui default:"500"
		spawnflags type:#integer default:3
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_camera"
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Spinner wwmt_wait_ui "Hold time" type:#integer range:[-10000, 10000, 10]
		Label wwmt_moveto_ui_label "Path Corner" align:#left
		EditText wwmt_moveto_ui "" type:#string
		Label wwmt_speed_ui_label "Initial Speed" align:#left
		EditText wwmt_speed_ui "" type:#string
		Label wwmt_acceleration_ui_label "Acceleration units/sec^2" align:#left
		EditText wwmt_acceleration_ui "" type:#string
		Label wwmt_deceleration_ui_label "Stop Deceleration units/sec^2" align:#left
		EditText wwmt_deceleration_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Start At Player" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Follow Player" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Freeze Player" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_camera&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_camera" address:"https://developer.valvesoftware.com/wiki/trigger_camera?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_changetarget_CA = attributes "WW Entity trigger_changetarget" version: 78 attribID:#(-1701943912L,279935596L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "trigger_changetarget"
	local isWWPRO = true
	local description = "Trigger Change Target"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target", "delay", "killtarget", "targetname", "m_iszNewTarget")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		targetname type:#string ui:wwmt_targetname_ui
		m_iszNewTarget type:#string ui:wwmt_m_iszNewTarget_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_changetarget"
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_m_iszNewTarget_ui_label "New Target" align:#left
		EditText wwmt_m_iszNewTarget_ui "" type:#string
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_changetarget&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_changetarget" address:"https://developer.valvesoftware.com/wiki/trigger_changetarget?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_counter_CA = attributes "WW Entity trigger_counter" version: 78 attribID:#(276153110L,-1040629305L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "trigger_counter"
	local isWWPRO = true
	local description = "Trigger counter"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target", "targetname", "killtarget", "netname", "style", "master", "sounds", "delay", "message", "count")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValsounds = 0
	local propMapsounds = #("0")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		wwmt_target type:#string ui:wwmt_target_ui
		targetname type:#string ui:wwmt_targetname_ui
		killtarget type:#string ui:wwmt_killtarget_ui
		netname type:#string ui:wwmt_netname_ui
		style type:#integer ui:wwmt_style_ui default:32
		master type:#string ui:wwmt_master_ui
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		delay type:#string ui:wwmt_delay_ui default:"0"
		message type:#string ui:wwmt_message_ui
		count type:#integer ui:wwmt_count_ui default:2
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_counter"
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_killtarget_ui_label "Kill target" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick Kill target" message:"Pick Target Entity for Kill target" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Label wwmt_netname_ui_label "Target Path" align:#left
		EditText wwmt_netname_ui "" type:#string
		PickButton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter
		on wwmt_netname_pickme_ui picked obj do
		(
			netname = obj.targetname
		)
		Spinner wwmt_style_ui "Style" type:#integer range:[-10000, 10000, 32]
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		DropDownList wwmt_sounds_ui "Sound style" type:#string items:#("No Sound")
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_message_ui_label "Message (set sound too)" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_label_count_ui "Count before activation" align:#left
		Spinner wwmt_count_ui "" type:#integer range:[-10000, 10000, 2]
		function addFlags =
		(
			local sfs = 0
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_4_ui "Pushables" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_1_ui "No Message" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with trigger_counter" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"trigger_counter_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_counter&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_counter" address:"https://developer.valvesoftware.com/wiki/trigger_counter?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_hurt_CA = attributes "WW Entity trigger_hurt" version: 78 attribID:#(-1618386072L,1468683444L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "trigger_hurt"
	local isWWPRO = true
	local description = "Trigger player hurt"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "master", "dmg", "delay", "damagetype")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValdamagetype = 0
	local propMapdamagetype = #("0", "1", "2", "4", "8", "16", "32", "64", "128", "256", "512", "1024", "16384", "32768", "65536", "131072", "262144", "524288", "1048576", "2097152", "4194304")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		master type:#string ui:wwmt_master_ui
		dmg type:#integer ui:wwmt_dmg_ui default:10
		delay type:#string ui:wwmt_delay_ui default:"0"
		damagetype type:#string ui:wwmt_damagetype_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_hurt"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		Spinner wwmt_dmg_ui "Damage" type:#integer range:[-10000, 10000, 10]
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		ComboBox wwmt_damagetype_ui "Damage Type" type:#string items:#("GENERIC", "CRUSH", "BULLET", "SLASH", "BURN", "FREEZE", "FALL", "BLAST", "CLUB", "SHOCK", "SONIC", "ENERGYBEAM", "DROWN", "PARALYSE", "NERVEGAS", "POISON", "RADIATION", "DROWNRECOVER", "CHEMICAL", "SLOWBURN", "SLOWFREEZE") height:3
		on wwmt_damagetype_ui selected i do
		(
			damagetype = propMapdamagetype[i]
		)
		on wwmt_damagetype_ui entered tex do
		(
			damagetype = trimLeft(trimRight(tex))
			if propMapdamagetype != undefined AND findItem propMapdamagetype tex == 0 then
			(
				append propMapdamagetype tex
				sort propMapdamagetype
				wwmt_damagetype_ui.items = propMapdamagetype
				wwmt_damagetype_ui.selection = findItem wwmt_damagetype_ui.items tex
			)
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Target Once" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Start Off" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "FireClientOnly" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "TouchClientOnly" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with trigger_hurt" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"trigger_hurt_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_hurt&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_hurt" address:"https://developer.valvesoftware.com/wiki/trigger_hurt?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if damagetype != undefined then
			(
				if findItem propMapdamagetype damagetype == 0 then
				(
					append propMapdamagetype damagetype
					local tmp = wwmt_damagetype_ui.items
					append tmp damagetype
					wwmt_damagetype_ui.items = tmp
					wwmt_damagetype_ui.selection = propMapdamagetype.count
				)
				else
				(
					wwmt_damagetype_ui.selection = (findItem propMapdamagetype damagetype)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_multiple_CA = attributes "WW Entity trigger_multiple" version: 78 attribID:#(935655839L,-492899498L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "trigger_multiple"
	local isWWPRO = true
	local description = "Trigger: Activate multiple"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target", "targetname", "killtarget", "netname", "style", "master", "sounds", "delay", "message", "wait")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValsounds = 0
	local propMapsounds = #("0")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		wwmt_target type:#string ui:wwmt_target_ui
		targetname type:#string ui:wwmt_targetname_ui
		killtarget type:#string ui:wwmt_killtarget_ui
		netname type:#string ui:wwmt_netname_ui
		style type:#integer ui:wwmt_style_ui default:32
		master type:#string ui:wwmt_master_ui
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		delay type:#string ui:wwmt_delay_ui default:"0"
		message type:#string ui:wwmt_message_ui
		wait type:#integer ui:wwmt_wait_ui default:10
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_multiple"
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_killtarget_ui_label "Kill target" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick Kill target" message:"Pick Target Entity for Kill target" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Label wwmt_netname_ui_label "Target Path" align:#left
		EditText wwmt_netname_ui "" type:#string
		PickButton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter
		on wwmt_netname_pickme_ui picked obj do
		(
			netname = obj.targetname
		)
		Spinner wwmt_style_ui "Style" type:#integer range:[-10000, 10000, 32]
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		DropDownList wwmt_sounds_ui "Sound style" type:#string items:#("No Sound")
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_message_ui_label "Message (set sound too)" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_label_wait_ui "Delay before reset" align:#left
		Spinner wwmt_wait_ui "" type:#integer range:[-10000, 10000, 10]
		function addFlags =
		(
			local sfs = 0
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_4_ui "Pushables" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with trigger_multiple" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"trigger_multiple_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_multiple&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_multiple" address:"https://developer.valvesoftware.com/wiki/trigger_multiple?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_once_CA = attributes "WW Entity trigger_once" version: 78 attribID:#(-1618386072L,-1287051376L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "trigger_once"
	local isWWPRO = true
	local description = "Trigger: Activate once"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target", "targetname", "killtarget", "netname", "style", "master", "sounds", "delay", "message")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValsounds = 0
	local propMapsounds = #("0")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		wwmt_target type:#string ui:wwmt_target_ui
		targetname type:#string ui:wwmt_targetname_ui
		killtarget type:#string ui:wwmt_killtarget_ui
		netname type:#string ui:wwmt_netname_ui
		style type:#integer ui:wwmt_style_ui default:32
		master type:#string ui:wwmt_master_ui
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		delay type:#string ui:wwmt_delay_ui default:"0"
		message type:#string ui:wwmt_message_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_once"
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_killtarget_ui_label "Kill target" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick Kill target" message:"Pick Target Entity for Kill target" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Label wwmt_netname_ui_label "Target Path" align:#left
		EditText wwmt_netname_ui "" type:#string
		PickButton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter
		on wwmt_netname_pickme_ui picked obj do
		(
			netname = obj.targetname
		)
		Spinner wwmt_style_ui "Style" type:#integer range:[-10000, 10000, 32]
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		DropDownList wwmt_sounds_ui "Sound style" type:#string items:#("No Sound")
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_message_ui_label "Message (set sound too)" align:#left
		EditText wwmt_message_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_4_ui "Pushables" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with trigger_once" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"trigger_once_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_once&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_once" address:"https://developer.valvesoftware.com/wiki/trigger_once?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_push_CA = attributes "WW Entity trigger_push" version: 78 attribID:#(-1618386072L,211774935L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "trigger_push"
	local isWWPRO = true
	local description = "Trigger player push"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target", "targetname", "killtarget", "netname", "style", "master", "sounds", "delay", "message", "angles", "speed")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValsounds = 0
	local propMapsounds = #("0")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		wwmt_target type:#string ui:wwmt_target_ui
		targetname type:#string ui:wwmt_targetname_ui
		killtarget type:#string ui:wwmt_killtarget_ui
		netname type:#string ui:wwmt_netname_ui
		style type:#integer ui:wwmt_style_ui default:32
		master type:#string ui:wwmt_master_ui
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		delay type:#string ui:wwmt_delay_ui default:"0"
		message type:#string ui:wwmt_message_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		speed type:#integer ui:wwmt_speed_ui default:40
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_push"
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_killtarget_ui_label "Kill target" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick Kill target" message:"Pick Target Entity for Kill target" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Label wwmt_netname_ui_label "Target Path" align:#left
		EditText wwmt_netname_ui "" type:#string
		PickButton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter
		on wwmt_netname_pickme_ui picked obj do
		(
			netname = obj.targetname
		)
		Spinner wwmt_style_ui "Style" type:#integer range:[-10000, 10000, 32]
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		DropDownList wwmt_sounds_ui "Sound style" type:#string items:#("No Sound")
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_message_ui_label "Message (set sound too)" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Spinner wwmt_speed_ui "Speed of push" type:#integer range:[-10000, 10000, 40]
		function addFlags =
		(
			local sfs = 0
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_4_ui "Pushables" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_1_ui "Once Only" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Start Off" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with trigger_push" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"trigger_push_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_push&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_push" address:"https://developer.valvesoftware.com/wiki/trigger_push?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_relay_CA = attributes "WW Entity trigger_relay" version: 78 attribID:#(-1618386072L,-1852055962L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "trigger_relay"
	local isWWPRO = true
	local description = "Trigger Relay"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "delay", "killtarget", "triggerstate")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValtriggerstate = 0
	local propMaptriggerstate = #("0", "1", "2")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#string ui:wwmt_delay_ui default:"0"
		killtarget type:#string ui:wwmt_killtarget_ui
		triggerstate type:#string ui:wwmt_triggerstate_ui default:"0"
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_relay"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		DropDownList wwmt_triggerstate_ui "Trigger State" type:#string items:#("Off", "On", "Toggle")
		on wwmt_triggerstate_ui selected i do
		(
			triggerstate = propMaptriggerstate[i]
		)
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Remove On fire" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_relay&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_relay" address:"https://developer.valvesoftware.com/wiki/trigger_relay?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if triggerstate != undefined then
			(
				if findItem propMaptriggerstate triggerstate == 0 then
				(
					append propMaptriggerstate triggerstate
					local tmp = wwmt_triggerstate_ui.items
					append tmp triggerstate
					wwmt_triggerstate_ui.items = tmp
					wwmt_triggerstate_ui.selection = propMaptriggerstate.count
				)
				else
				(
					wwmt_triggerstate_ui.selection = (findItem propMaptriggerstate triggerstate)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_trigger_teleport_CA = attributes "WW Entity trigger_teleport" version: 78 attribID:#(935655839L,1008780661L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "trigger_teleport"
	local isWWPRO = true
	local description = "Trigger teleport"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target", "targetname", "killtarget", "netname", "style", "master", "sounds", "delay", "message")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValsounds = 0
	local propMapsounds = #("0")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		wwmt_target type:#string ui:wwmt_target_ui
		targetname type:#string ui:wwmt_targetname_ui
		killtarget type:#string ui:wwmt_killtarget_ui
		netname type:#string ui:wwmt_netname_ui
		style type:#integer ui:wwmt_style_ui default:32
		master type:#string ui:wwmt_master_ui
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		delay type:#string ui:wwmt_delay_ui default:"0"
		message type:#string ui:wwmt_message_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "trigger_teleport"
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_killtarget_ui_label "Kill target" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick Kill target" message:"Pick Target Entity for Kill target" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Label wwmt_netname_ui_label "Target Path" align:#left
		EditText wwmt_netname_ui "" type:#string
		PickButton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter
		on wwmt_netname_pickme_ui picked obj do
		(
			netname = obj.targetname
		)
		Spinner wwmt_style_ui "Style" type:#integer range:[-10000, 10000, 32]
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		DropDownList wwmt_sounds_ui "Sound style" type:#string items:#("No Sound")
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		Label wwmt_delay_ui_label "Delay before trigger" align:#left
		EditText wwmt_delay_ui "" type:#string
		Label wwmt_message_ui_label "Message (set sound too)" align:#left
		EditText wwmt_message_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_4_ui "Pushables" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with trigger_teleport" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"trigger_teleport_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_teleport&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: trigger_teleport" address:"https://developer.valvesoftware.com/wiki/trigger_teleport?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_ambient_generic_CA = attributes "WW Entity ambient_generic" version: 78 attribID:#(-114829662L,324374276L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "ambient_generic"
	local isWWPRO = true
	local description = "Universal Ambient"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "message", "health", "preset", "volstart", "fadein", "fadeout", "pitch", "pitchstart", "spinup", "spindown", "lfotype", "lforate", "lfomodpitch", "lfomodvol", "cspinup")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/speaker.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValpreset = 0
	local propMappreset = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27")
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		message type:#string ui:wwmt_message_ui
		health type:#integer ui:wwmt_health_ui default:10
		preset type:#string ui:wwmt_preset_ui default:"0"
		volstart type:#integer ui:wwmt_volstart_ui default:0
		fadein type:#integer ui:wwmt_fadein_ui default:0
		fadeout type:#integer ui:wwmt_fadeout_ui default:0
		pitch type:#float ui:wwmt_pitch_ui default:100
		pitchstart type:#integer ui:wwmt_pitchstart_ui default:100
		spinup type:#integer ui:wwmt_spinup_ui default:0
		spindown type:#integer ui:wwmt_spindown_ui default:0
		lfotype type:#integer ui:wwmt_lfotype_ui default:0
		lforate type:#integer ui:wwmt_lforate_ui default:0
		lfomodpitch type:#integer ui:wwmt_lfomodpitch_ui default:0
		lfomodvol type:#integer ui:wwmt_lfomodvol_ui default:0
		cspinup type:#integer ui:wwmt_cspinup_ui default:0
		spawnflags type:#integer default:4
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "ambient_generic"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_message_ui_label "Path/filename.wav of WAV" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_label_health_ui "Volume (10 = loudest)" align:#left
		Spinner wwmt_health_ui "" type:#integer range:[-10000, 10000, 10]
		ComboBox wwmt_preset_ui "Dynamic Presets" type:#string items:#("None", "Huge Machine", "Big Machine", "Machine", "Slow Fade in", "Fade in", "Quick Fade in", "Slow Pulse", "Pulse", "Quick pulse", "Slow Oscillator", "Oscillator", "Quick Oscillator", "Grunge pitch", "Very low pitch", "Low pitch", "High pitch", "Very high pitch", "Screaming pitch", "Oscillate spinup/down", "Pulse spinup/down", "Random pitch", "Random pitch fast", "Incremental Spinup", "Alien", "Bizzare", "Planet X", "Haunted") height:3
		on wwmt_preset_ui selected i do
		(
			preset = propMappreset[i]
		)
		on wwmt_preset_ui entered tex do
		(
			preset = trimLeft(trimRight(tex))
			if propMappreset != undefined AND findItem propMappreset tex == 0 then
			(
				append propMappreset tex
				sort propMappreset
				wwmt_preset_ui.items = propMappreset
				wwmt_preset_ui.selection = findItem wwmt_preset_ui.items tex
			)
		)
		Spinner wwmt_volstart_ui "Start Volume" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_fadein_ui "Fade in time (0-100)" align:#left
		Spinner wwmt_fadein_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_fadeout_ui "Fade out time (0-100)" align:#left
		Spinner wwmt_fadeout_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_pitch_ui "Pitch (> 100 = higher)" align:#left
		Spinner wwmt_pitch_ui "" type:#float scale:1.0 range:[-10000, 10000, 100]
		Spinner wwmt_pitchstart_ui "Start Pitch" type:#integer range:[-10000, 10000, 100]
		Label wwmt_label_spinup_ui "Spin up time (0-100)" align:#left
		Spinner wwmt_spinup_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_spindown_ui "Spin down time (0-100)" align:#left
		Spinner wwmt_spindown_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_lfotype_ui "LFO type 0)off 1)sqr 2)tri 3)rnd" align:#left
		Spinner wwmt_lfotype_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_lforate_ui "LFO rate (0-1000)" align:#left
		Spinner wwmt_lforate_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_lfomodpitch_ui "LFO mod pitch (0-100)" align:#left
		Spinner wwmt_lfomodpitch_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_lfomodvol_ui "LFO mod vol (0-100)" align:#left
		Spinner wwmt_lfomodvol_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_cspinup_ui "Incremental spinup count" align:#left
		Spinner wwmt_cspinup_ui "" type:#integer range:[-10000, 10000, 0]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Play Everywhere" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Small Radius" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Medium Radius" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Large Radius" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Start Silent" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Is NOT Looped" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=ambient_generic&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: ambient_generic" address:"https://developer.valvesoftware.com/wiki/ambient_generic?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if preset != undefined then
			(
				if findItem propMappreset preset == 0 then
				(
					append propMappreset preset
					local tmp = wwmt_preset_ui.items
					append tmp preset
					wwmt_preset_ui.items = tmp
					wwmt_preset_ui.selection = propMappreset.count
				)
				else
				(
					wwmt_preset_ui.selection = (findItem propMappreset preset)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_button_target_CA = attributes "WW Entity button_target" version: 78 attribID:#(1993738382L,232959494L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "button_target"
	local isWWPRO = true
	local description = "Target Button"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target", "angles", "master", "renderfx", "rendermode", "renderamt", "rendercolor")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		wwmt_target type:#string ui:wwmt_target_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		master type:#string ui:wwmt_master_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		spawnflags type:#integer default:1
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "button_target"
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Use Activates" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Start On" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with button_target" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"button_target_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=button_target&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: button_target" address:"https://developer.valvesoftware.com/wiki/button_target?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_momentary_door_CA = attributes "WW Entity momentary_door" version: 78 attribID:#(62814769L,-1583901336L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "momentary_door"
	local isWWPRO = true
	local description = "Momentary/Continuous door"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "killtarget", "speed", "master", "movesnd", "stopsnd", "wait", "lip", "dmg", "message", "wwmt_target", "delay", "netname", "health", "locked_sound", "unlocked_sound", "locked_sentence", "unlocked_sentence", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValmovesnd = 0
	local propMapmovesnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10")
	local propValstopsnd = 0
	local propMapstopsnd = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	local propVallocked_sound = 0
	local propMaplocked_sound = #("0", "2", "8", "10", "11", "12")
	local propValunlocked_sound = 0
	local propMapunlocked_sound = #("0", "1", "3", "4", "5", "6", "7", "8", "9", "10", "13")
	local propVallocked_sentence = 0
	local propMaplocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9")
	local propValunlocked_sentence = 0
	local propMapunlocked_sentence = #("0", "1", "2", "3", "4", "5", "6", "7", "8")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		killtarget type:#string ui:wwmt_killtarget_ui
		speed type:#integer ui:wwmt_speed_ui default:100
		master type:#string ui:wwmt_master_ui
		movesnd type:#string ui:wwmt_movesnd_ui default:"0"
		stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
		wait type:#integer ui:wwmt_wait_ui default:4
		lip type:#integer ui:wwmt_lip_ui
		dmg type:#integer ui:wwmt_dmg_ui default:0
		message type:#string ui:wwmt_message_ui
		wwmt_target type:#string ui:wwmt_target_ui
		delay type:#integer ui:wwmt_delay_ui
		netname type:#string ui:wwmt_netname_ui
		health type:#integer ui:wwmt_health_ui default:0
		locked_sound type:#string ui:wwmt_locked_sound_ui default:"0"
		unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:"0"
		locked_sentence type:#string ui:wwmt_locked_sentence_ui default:"0"
		unlocked_sentence type:#string ui:wwmt_unlocked_sentence_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "momentary_door"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_killtarget_ui_label "KillTarget" align:#left
		EditText wwmt_killtarget_ui "" type:#string
		PickButton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter
		on wwmt_killtarget_pickme_ui picked obj do
		(
			killtarget = obj.targetname
		)
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 100]
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		ComboBox wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound", "Servo (Sliding)", "Pneumatic (Sliding)", "Pneumatic (Rolling)", "Vacuum", "Power Hydraulic", "Large Rollers", "Track Door", "Snappy Metal Door", "Squeaky 1", "Squeaky 2") height:3
		on wwmt_movesnd_ui selected i do
		(
			movesnd = propMapmovesnd[i]
		)
		on wwmt_movesnd_ui entered tex do
		(
			movesnd = trimLeft(trimRight(tex))
			if propMapmovesnd != undefined AND findItem propMapmovesnd tex == 0 then
			(
				append propMapmovesnd tex
				sort propMapmovesnd
				wwmt_movesnd_ui.items = propMapmovesnd
				wwmt_movesnd_ui.selection = findItem wwmt_movesnd_ui.items tex
			)
		)
		ComboBox wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound", "Clang with brake", "Clang reverb", "Ratchet Stop", "Chunk", "Light airbrake", "Metal Slide Stop", "Metal Lock Stop", "Snappy Metal Stop") height:3
		on wwmt_stopsnd_ui selected i do
		(
			stopsnd = propMapstopsnd[i]
		)
		on wwmt_stopsnd_ui entered tex do
		(
			stopsnd = trimLeft(trimRight(tex))
			if propMapstopsnd != undefined AND findItem propMapstopsnd tex == 0 then
			(
				append propMapstopsnd tex
				sort propMapstopsnd
				wwmt_stopsnd_ui.items = propMapstopsnd
				wwmt_stopsnd_ui.selection = findItem wwmt_stopsnd_ui.items tex
			)
		)
		Label wwmt_label_wait_ui "delay before close, -1 stay open " align:#left
		Spinner wwmt_wait_ui "" type:#integer range:[-10000, 10000, 4]
		Spinner wwmt_lip_ui "Lip" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_dmg_ui "Damage inflicted when blocked" align:#left
		Spinner wwmt_dmg_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_message_ui_label "Message if triggered" align:#left
		EditText wwmt_message_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_label_delay_ui "Delay before fire" align:#left
		Spinner wwmt_delay_ui "" type:#integer range:[-10000, 10000, 0]
		Label wwmt_netname_ui_label "Fire on Close" align:#left
		EditText wwmt_netname_ui "" type:#string
		Label wwmt_label_health_ui "Health (shoot open)" align:#left
		Spinner wwmt_health_ui "" type:#integer range:[-10000, 10000, 0]
		ComboBox wwmt_locked_sound_ui "Locked Sound" type:#string items:#("None", "Access Denied", "Small zap", "Buzz", "Buzz Off", "Latch Locked") height:3
		on wwmt_locked_sound_ui selected i do
		(
			locked_sound = propMaplocked_sound[i]
		)
		on wwmt_locked_sound_ui entered tex do
		(
			locked_sound = trimLeft(trimRight(tex))
			if propMaplocked_sound != undefined AND findItem propMaplocked_sound tex == 0 then
			(
				append propMaplocked_sound tex
				sort propMaplocked_sound
				wwmt_locked_sound_ui.items = propMaplocked_sound
				wwmt_locked_sound_ui.selection = findItem wwmt_locked_sound_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sound_ui "Unlocked Sound" type:#string items:#("None", "Big zap & Warmup", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Buzz", "Latch Unlocked") height:3
		on wwmt_unlocked_sound_ui selected i do
		(
			unlocked_sound = propMapunlocked_sound[i]
		)
		on wwmt_unlocked_sound_ui entered tex do
		(
			unlocked_sound = trimLeft(trimRight(tex))
			if propMapunlocked_sound != undefined AND findItem propMapunlocked_sound tex == 0 then
			(
				append propMapunlocked_sound tex
				sort propMapunlocked_sound
				wwmt_unlocked_sound_ui.items = propMapunlocked_sound
				wwmt_unlocked_sound_ui.selection = findItem wwmt_unlocked_sound_ui.items tex
			)
		)
		ComboBox wwmt_locked_sentence_ui "Locked Sentence" type:#string items:#("None", "Gen. Access Denied", "Security Lockout", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance Door", "Broken Shut Door") height:3
		on wwmt_locked_sentence_ui selected i do
		(
			locked_sentence = propMaplocked_sentence[i]
		)
		on wwmt_locked_sentence_ui entered tex do
		(
			locked_sentence = trimLeft(trimRight(tex))
			if propMaplocked_sentence != undefined AND findItem propMaplocked_sentence tex == 0 then
			(
				append propMaplocked_sentence tex
				sort propMaplocked_sentence
				wwmt_locked_sentence_ui.items = propMaplocked_sentence
				wwmt_locked_sentence_ui.selection = findItem wwmt_locked_sentence_ui.items tex
			)
		)
		ComboBox wwmt_unlocked_sentence_ui "Unlocked Sentence" type:#string items:#("None", "Gen. Access Granted", "Security Disengaged", "Blast Door", "Fire Door", "Chemical Door", "Radiation Door", "Gen. Containment", "Maintenance area") height:3
		on wwmt_unlocked_sentence_ui selected i do
		(
			unlocked_sentence = propMapunlocked_sentence[i]
		)
		on wwmt_unlocked_sentence_ui entered tex do
		(
			unlocked_sentence = trimLeft(trimRight(tex))
			if propMapunlocked_sentence != undefined AND findItem propMapunlocked_sentence tex == 0 then
			(
				append propMapunlocked_sentence tex
				sort propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.items = propMapunlocked_sentence
				wwmt_unlocked_sentence_ui.selection = findItem wwmt_unlocked_sentence_ui.items tex
			)
		)
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			if params.flag_32_ui.checked == true then
			(
				sfs += 32
			)
			if params.flag_256_ui.checked == true then
			(
				sfs += 256
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Starts Open" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Don't link" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Passable" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_32_ui "Toggle" type:#integer
			on flag_32_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_256_ui "Use Only" type:#integer
			on flag_256_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with momentary_door" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"momentary_door_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=momentary_door&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: momentary_door" address:"https://developer.valvesoftware.com/wiki/momentary_door?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if movesnd != undefined then
			(
				if findItem propMapmovesnd movesnd == 0 then
				(
					append propMapmovesnd movesnd
					local tmp = wwmt_movesnd_ui.items
					append tmp movesnd
					wwmt_movesnd_ui.items = tmp
					wwmt_movesnd_ui.selection = propMapmovesnd.count
				)
				else
				(
					wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
				)
			)
			if stopsnd != undefined then
			(
				if findItem propMapstopsnd stopsnd == 0 then
				(
					append propMapstopsnd stopsnd
					local tmp = wwmt_stopsnd_ui.items
					append tmp stopsnd
					wwmt_stopsnd_ui.items = tmp
					wwmt_stopsnd_ui.selection = propMapstopsnd.count
				)
				else
				(
					wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
				)
			)
			if locked_sound != undefined then
			(
				if findItem propMaplocked_sound locked_sound == 0 then
				(
					append propMaplocked_sound locked_sound
					local tmp = wwmt_locked_sound_ui.items
					append tmp locked_sound
					wwmt_locked_sound_ui.items = tmp
					wwmt_locked_sound_ui.selection = propMaplocked_sound.count
				)
				else
				(
					wwmt_locked_sound_ui.selection = (findItem propMaplocked_sound locked_sound)
				)
			)
			if unlocked_sound != undefined then
			(
				if findItem propMapunlocked_sound unlocked_sound == 0 then
				(
					append propMapunlocked_sound unlocked_sound
					local tmp = wwmt_unlocked_sound_ui.items
					append tmp unlocked_sound
					wwmt_unlocked_sound_ui.items = tmp
					wwmt_unlocked_sound_ui.selection = propMapunlocked_sound.count
				)
				else
				(
					wwmt_unlocked_sound_ui.selection = (findItem propMapunlocked_sound unlocked_sound)
				)
			)
			if locked_sentence != undefined then
			(
				if findItem propMaplocked_sentence locked_sentence == 0 then
				(
					append propMaplocked_sentence locked_sentence
					local tmp = wwmt_locked_sentence_ui.items
					append tmp locked_sentence
					wwmt_locked_sentence_ui.items = tmp
					wwmt_locked_sentence_ui.selection = propMaplocked_sentence.count
				)
				else
				(
					wwmt_locked_sentence_ui.selection = (findItem propMaplocked_sentence locked_sentence)
				)
			)
			if unlocked_sentence != undefined then
			(
				if findItem propMapunlocked_sentence unlocked_sentence == 0 then
				(
					append propMapunlocked_sentence unlocked_sentence
					local tmp = wwmt_unlocked_sentence_ui.items
					append tmp unlocked_sentence
					wwmt_unlocked_sentence_ui.items = tmp
					wwmt_unlocked_sentence_ui.selection = propMapunlocked_sentence.count
				)
				else
				(
					wwmt_unlocked_sentence_ui.selection = (findItem propMapunlocked_sentence unlocked_sentence)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			flag_32_ui.checked = (bit.and (getProperty this #spawnflags) 32 == 32)
			flag_256_ui.checked = (bit.and (getProperty this #spawnflags) 256 == 256)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_momentary_rot_button_CA = attributes "WW Entity momentary_rot_button" version: 78 attribID:#(1150846017L,-748493796L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "momentary_rot_button"
	local isWWPRO = true
	local description = "Direct wheel control"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("renderfx", "rendermode", "renderamt", "rendercolor", "targetname", "angles", "wwmt_target", "speed", "master", "sounds", "distance", "returnspeed", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValsounds = 0
	local propMapsounds = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "21", "22", "23", "24", "25")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		wwmt_target type:#string ui:wwmt_target_ui
		speed type:#integer ui:wwmt_speed_ui default:50
		master type:#string ui:wwmt_master_ui
		sounds type:#string ui:wwmt_sounds_ui default:"0"
		distance type:#integer ui:wwmt_distance_ui default:90
		returnspeed type:#integer ui:wwmt_returnspeed_ui default:0
		_minlight type:#integer ui:wwmt__minlight_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "momentary_rot_button"
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_target_ui_label "Targetted object" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Targetted object" message:"Pick Target Entity for Targetted object" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Spinner wwmt_speed_ui "Speed" type:#integer range:[-10000, 10000, 50]
		Label wwmt_master_ui_label "Master" align:#left
		EditText wwmt_master_ui "" type:#string
		ComboBox wwmt_sounds_ui "Sounds" type:#string items:#("None", "Big zap & Warmup", "Access Denied", "Access Granted", "Quick Combolock", "Power Deadbolt 1", "Power Deadbolt 2", "Plunger", "Small zap", "Keycard Sound", "Squeaky", "Squeaky Pneumatic", "Ratchet Groan", "Clean Ratchet", "Gas Clunk") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		Spinner wwmt_distance_ui "Distance (deg)" type:#integer range:[-10000, 10000, 90]
		Label wwmt_label_returnspeed_ui "Auto-return speed" align:#left
		Spinner wwmt_returnspeed_ui "" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt__minlight_ui "_minlight" type:#integer range:[-10000, 10000, 0]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_16_ui.checked == true then
			(
				sfs += 16
			)
			if params.flag_64_ui.checked == true then
			(
				sfs += 64
			)
			if params.flag_128_ui.checked == true then
			(
				sfs += 128
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Door Hack" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Not useable" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_16_ui "Auto Return" type:#integer
			on flag_16_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_64_ui "X Axis" type:#integer
			on flag_64_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_128_ui "Y Axis" type:#integer
			on flag_128_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with momentary_rot_button" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"momentary_rot_button_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=momentary_rot_button&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: momentary_rot_button" address:"https://developer.valvesoftware.com/wiki/momentary_rot_button?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_16_ui.checked = (bit.and (getProperty this #spawnflags) 16 == 16)
			flag_64_ui.checked = (bit.and (getProperty this #spawnflags) 64 == 64)
			flag_128_ui.checked = (bit.and (getProperty this #spawnflags) 128 == 128)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_multi_manager_CA = attributes "WW Entity multi_manager" version: 78 attribID:#(1422438612L,-129794957L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "multi_manager"
	local isWWPRO = true
	local description = "MultiTarget Manager"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "multi_manager"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "multithreaded" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=multi_manager&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: multi_manager" address:"https://developer.valvesoftware.com/wiki/multi_manager?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_multisource_CA = attributes "WW Entity multisource" version: 78 attribID:#(-1295099135L,-83792495L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "multisource"
	local isWWPRO = true
	local description = "Multisource"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "globalstate")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		globalstate type:#string ui:wwmt_globalstate_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "multisource"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_globalstate_ui_label "Global State Master" align:#left
		EditText wwmt_globalstate_ui "" type:#string
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=multisource&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: multisource" address:"https://developer.valvesoftware.com/wiki/multisource?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_path_corner_CA = attributes "WW Entity path_corner" version: 78 attribID:#(-1732129830L,272163135L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "path_corner"
	local isWWPRO = true
	local description = "Moving platform stop"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "angles", "wwmt_target", "message", "wait", "speed", "yaw_speed")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local entcolor = (Color 247 181 82)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		wwmt_target type:#string ui:wwmt_target_ui
		message type:#string ui:wwmt_message_ui
		wait type:#integer ui:wwmt_wait_ui default:0
		speed type:#integer ui:wwmt_speed_ui default:0
		yaw_speed type:#integer ui:wwmt_yaw_speed_ui default:0
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "path_corner"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_target_ui_label "Next stop target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Next stop target" message:"Pick Target Entity for Next stop target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_message_ui_label "Fire On Pass" align:#left
		EditText wwmt_message_ui "" type:#string
		PickButton wwmt_message_pickme_ui "Pick Fire On Pass" message:"Pick Target Entity for Fire On Pass" filter:target_name_filter
		on wwmt_message_pickme_ui picked obj do
		(
			message = obj.targetname
		)
		Label wwmt_label_wait_ui "Wait here (secs)" align:#left
		Spinner wwmt_wait_ui "" type:#integer range:[-10000, 10000, 0]
		Spinner wwmt_speed_ui "New Train Speed" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_yaw_speed_ui "New Train rot. Speed" align:#left
		Spinner wwmt_yaw_speed_ui "" type:#integer range:[-10000, 10000, 0]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Wait for retrigger" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Teleport" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Fire once" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=path_corner&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: path_corner" address:"https://developer.valvesoftware.com/wiki/path_corner?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_path_track_CA = attributes "WW Entity path_track" version: 78 attribID:#(-1732129830L,-1946943073L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "path_track"
	local isWWPRO = true
	local description = "Train Track Path"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "wwmt_target", "message", "altpath", "netname", "speed")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	parameters main rollout:params
	(
		targetname type:#string ui:wwmt_targetname_ui
		wwmt_target type:#string ui:wwmt_target_ui
		message type:#string ui:wwmt_message_ui
		altpath type:#string ui:wwmt_altpath_ui
		netname type:#string ui:wwmt_netname_ui
		speed type:#integer ui:wwmt_speed_ui default:0
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "path_track"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		Label wwmt_target_ui_label "Next stop target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Next stop target" message:"Pick Target Entity for Next stop target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Label wwmt_message_ui_label "Fire On Pass" align:#left
		EditText wwmt_message_ui "" type:#string
		PickButton wwmt_message_pickme_ui "Pick Fire On Pass" message:"Pick Target Entity for Fire On Pass" filter:target_name_filter
		on wwmt_message_pickme_ui picked obj do
		(
			message = obj.targetname
		)
		Label wwmt_altpath_ui_label "Branch Path" align:#left
		EditText wwmt_altpath_ui "" type:#string
		PickButton wwmt_altpath_pickme_ui "Pick Branch Path" message:"Pick Target Entity for Branch Path" filter:target_name_filter
		on wwmt_altpath_pickme_ui picked obj do
		(
			altpath = obj.targetname
		)
		Label wwmt_netname_ui_label "Fire on dead end" align:#left
		EditText wwmt_netname_ui "" type:#string
		PickButton wwmt_netname_pickme_ui "Pick Fire on dead end" message:"Pick Target Entity for Fire on dead end" filter:target_name_filter
		on wwmt_netname_pickme_ui picked obj do
		(
			netname = obj.targetname
		)
		Spinner wwmt_speed_ui "New Train Speed" type:#integer range:[-10000, 10000, 0]
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_4_ui.checked == true then
			(
				sfs += 4
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "Disabled" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "Fire once" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_4_ui "Branch Reverse" type:#integer
			on flag_4_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Disable train" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=path_track&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: path_track" address:"https://developer.valvesoftware.com/wiki/path_track?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_4_ui.checked = (bit.and (getProperty this #spawnflags) 4 == 4)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_hostage_entity_CA = attributes "WW Entity hostage_entity" version: 78 attribID:#(-1523082217L,529278052L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "hostage_entity"
	local isWWPRO = true
	local description = "Hostage"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("angles", "model", "skin")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/Hostage.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	function target_wwmt_filter obj =
	(
		if ((isProperty obj #wwmt_ca OR isProperty obj #wallwormProxy) AND isProperty obj #wallworm) then
		(
			true
		)
		else
		(
			false
		)
	)
	parameters main rollout:params
	(
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		model type:#string ui:wwmt_model_ui default:"models/hostage.mdl"
		skin type:#integer ui:wwmt_skin_ui default:0
		on skin set val do
		(
			getNode()
			if (isValidNode thisNode AND classof thisNode != ::WallWormMDL AND val != undefined) then
			(
				if ::WallWormHelperOps != undefined then
				(
					::WallWormHelperOps.setProxySkin thisNode  val
				)
			)
		)
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "hostage_entity"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_model_ui_label "Model" align:#left
		EditText wwmt_model_ui "" type:#string
		PickButton wwmt_model_pickwwmt_ui "wwmt" align:#left across:3 message:"Pick WWMT OR Proxy from scene Model" filter:target_wwmt_filter tooltip:"Create a proxy from a model in the scene."
		on wwmt_model_pickwwmt_ui picked obj do
		(
			local wwmt = obj.getWWMT()
			if wwmt != undefined AND (getNode()) != undefined then
			(
				wwmt.updateObjectAsProxy thisNode useRotation:false
			)
		)
		Button wwmt_model_importwmt_ui "import" tooltip:"Import a QC AND create a proxy."
		on wwmt_model_importwmt_ui pressed do with undo label:"Import QC" on
		(
			::wallworm_import_qc_from_filename
			if ::wallworm_import_qc_from_filename == undefined then
			(
				fileIn (::wallworm_installation_path + "/WallWorm.com/importers/Mario_Kart_SMD_Importer.ms")
			)
			local fsource = GetOpenFileName historyCategory:"Wall Worm SMD Exporter" types: "QC File (*.qc)|*.QC|All files (*.*)|*.*|"
			if fsource != undefined AND wallworm_import_qc_from_filename != undefined then
			(
				wwmt = ::wallworm_import_qc_from_filename fsource saveToLib:true tnoVMF:true skipLODS:true deepSearchMaterials:false
				if wwmt != undefined then
				(
					if (getNode()) != undefined then
					(
						wwmt.updateObjectAsProxy thisNode
					)
				)
			)
		)
		Button wwmt_model_libwmt_ui "library" tooltip:"Use a prop in the prop library. Right-click to load the mesh rotated 90 degrees."
		on wwmt_model_libwmt_ui pressed do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:false
		)
		on wwmt_model_libwmt_ui rightClick do with undo label:"Load From Model Library" on
		(
			loadMeshFromLibrary doRotate:true
		)
		Spinner wwmt_skin_ui "Skin" type:#integer range:[-10000, 10000, 0]
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=hostage_entity&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: hostage_entity" address:"https://developer.valvesoftware.com/wiki/hostage_entity?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_hostage_rescue_CA = attributes "WW Entity info_hostage_rescue" version: 78 attribID:#(1332759817L,1774392075L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_hostage_rescue"
	local isWWPRO = true
	local description = "Hostage rescue point"
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/HostageRescue.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function resetThis = (thisNode = undefined)
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_hostage_rescue_CA = attributes "WW Entity func_hostage_rescue" version: 78 attribID:#(-1225833327L,1774392075L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_hostage_rescue"
	local isWWPRO = true
	local description = "Hostage rescue zone"
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_hostage_rescue"
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_hostage_rescue" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_hostage_rescue_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_hostage_rescue&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_hostage_rescue" address:"https://developer.valvesoftware.com/wiki/func_hostage_rescue?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined)
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_bomb_target_CA = attributes "WW Entity info_bomb_target" version: 78 attribID:#(-946088943L,-97655604L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_bomb_target"
	local isWWPRO = true
	local description = "Bomb target point"
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/BombTarget.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function resetThis = (thisNode = undefined)
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_bomb_target_CA = attributes "WW Entity func_bomb_target" version: 78 attribID:#(1907091721L,-97655604L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_bomb_target"
	local isWWPRO = true
	local description = "Bomb target zone"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		wwmt_target type:#string ui:wwmt_target_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_bomb_target"
		Label wwmt_target_ui_label "Target (when bomb blows)" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Target (when bomb blows)" message:"Pick Target Entity for Target (when bomb blows)" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_bomb_target" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_bomb_target_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_bomb_target&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_bomb_target" address:"https://developer.valvesoftware.com/wiki/func_bomb_target?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_buyzone_CA = attributes "WW Entity func_buyzone" version: 78 attribID:#(1617558855L,-770119022L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_buyzone"
	local isWWPRO = true
	local description = "Buy zone"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("team")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValteam = 0
	local propMapteam = #("0", "1", "2")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		team type:#string ui:wwmt_team_ui default:"0"
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_buyzone"
		DropDownList wwmt_team_ui "Team" type:#string items:#("All teams (unassigned)", "Terrorist", "Counter-terrorist")
		on wwmt_team_ui selected i do
		(
			team = propMapteam[i]
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_buyzone" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_buyzone_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_buyzone&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_buyzone" address:"https://developer.valvesoftware.com/wiki/func_buyzone?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if team != undefined then
			(
				if findItem propMapteam team == 0 then
				(
					append propMapteam team
					local tmp = wwmt_team_ui.items
					append tmp team
					wwmt_team_ui.items = tmp
					wwmt_team_ui.selection = propMapteam.count
				)
				else
				(
					wwmt_team_ui.selection = (findItem propMapteam team)
				)
			)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_escapezone_CA = attributes "WW Entity func_escapezone" version: 78 attribID:#(-1542738929L,-1705924103L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_escapezone"
	local isWWPRO = true
	local description = "Terrorist escape zone"
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_escapezone"
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_escapezone" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_escapezone_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_escapezone&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_escapezone" address:"https://developer.valvesoftware.com/wiki/func_escapezone?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined)
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_vip_safetyzone_CA = attributes "WW Entity func_vip_safetyzone" version: 78 attribID:#(1832170701L,-598038102L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_vip_safetyzone"
	local isWWPRO = true
	local description = "VIP safety zone"
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_vip_safetyzone"
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_vip_safetyzone" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_vip_safetyzone_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_vip_safetyzone&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_vip_safetyzone" address:"https://developer.valvesoftware.com/wiki/func_vip_safetyzone?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined)
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_armoury_entity_CA = attributes "WW Entity armoury_entity" version: 78 attribID:#(1714225879L,529278052L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "armoury_entity"
	local isWWPRO = true
	local description = "Items in the armoury"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("item", "count")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/Armoury.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValitem = 0
	local propMapitem = #("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18")
	parameters main rollout:params
	(
		item type:#string ui:wwmt_item_ui default:"0"
		count type:#integer ui:wwmt_count_ui default:1
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "armoury_entity"
		ComboBox wwmt_item_ui "Item" type:#string items:#("weapon_mp5", "weapon_tmp", "weapon_p90", "weapon_mac10", "weapon_ak47", "weapon_sg552", "weapon_m4a1", "weapon_aug", "weapon_scout", "weapon_g3sg1", "weapon_awp", "weapon_m3", "weapon_xm1014", "weapon_m249", "weapon_flashbang", "weapon_hegrenade", "item_kevlar", "item_assaultsuit", "weapon_smokegrenade") height:3
		on wwmt_item_ui selected i do
		(
			item = propMapitem[i]
		)
		on wwmt_item_ui entered tex do
		(
			item = trimLeft(trimRight(tex))
			if propMapitem != undefined AND findItem propMapitem tex == 0 then
			(
				append propMapitem tex
				sort propMapitem
				wwmt_item_ui.items = propMapitem
				wwmt_item_ui.selection = findItem wwmt_item_ui.items tex
			)
		)
		Spinner wwmt_count_ui "Count" type:#integer range:[-10000, 10000, 1]
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=armoury_entity&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: armoury_entity" address:"https://developer.valvesoftware.com/wiki/armoury_entity?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if item != undefined then
			(
				if findItem propMapitem item == 0 then
				(
					append propMapitem item
					local tmp = wwmt_item_ui.items
					append tmp item
					wwmt_item_ui.items = tmp
					wwmt_item_ui.selection = propMapitem.count
				)
				else
				(
					wwmt_item_ui.selection = (findItem propMapitem item)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_info_map_parameters_CA = attributes "WW Entity info_map_parameters" version: 78 attribID:#(-939136664L,877801146L)
(
	local wallworm = true
	local entityType = "PointClass"
	local thisNode = undefined
	local entname = "info_map_parameters"
	local isWWPRO = true
	local description = "Miscellaneous mapping parameters"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("buying", "bombradius")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,2}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	local iconsprite = "sprites/CS/MapParams.spr"
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function deleteProxyCA =
	(
		::wallworm_entityFunction_deleteProxyCA this
	)
	function updateMeshFromObj newProp deleteAfter:true doRotate:false =
	(
		::wallworm_entityFunctions_updateMeshFromObj this newProp deleteAfter:deleteAfter doRotate:doRotate
	)
	function loadMeshFromLibrary doRotate:false =
	(
		::wallworm_entityFunctions_loadMeshFromLibrary this params doRotate:doRotate
	)
	local propValbuying = 0
	local propMapbuying = #("0", "1", "2", "3")
	parameters main rollout:params
	(
		buying type:#string ui:wwmt_buying_ui default:"0"
		bombradius type:#integer ui:wwmt_bombradius_ui default:500
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "info_map_parameters"
		ComboBox wwmt_buying_ui "Weapon_Buying" type:#string items:#("Both teams can buy guns", "Only CT's can buy guns", "Only T's can buy guns", "Neither CT's nor T's can buy guns") height:3
		on wwmt_buying_ui selected i do
		(
			buying = propMapbuying[i]
		)
		on wwmt_buying_ui entered tex do
		(
			buying = trimLeft(trimRight(tex))
			if propMapbuying != undefined AND findItem propMapbuying tex == 0 then
			(
				append propMapbuying tex
				sort propMapbuying
				wwmt_buying_ui.items = propMapbuying
				wwmt_buying_ui.selection = findItem wwmt_buying_ui.items tex
			)
		)
		Spinner wwmt_bombradius_ui "Bomb Radius" type:#integer range:[-10000, 10000, 500]
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_map_parameters&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: info_map_parameters" address:"https://developer.valvesoftware.com/wiki/info_map_parameters?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if buying != undefined then
			(
				if findItem propMapbuying buying == 0 then
				(
					append propMapbuying buying
					local tmp = wwmt_buying_ui.items
					append tmp buying
					wwmt_buying_ui.items = tmp
					wwmt_buying_ui.selection = propMapbuying.count
				)
				else
				(
					wwmt_buying_ui.selection = (findItem propMapbuying buying)
				)
			)
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_vehicle_CA = attributes "WW Entity func_vehicle" version: 78 attribID:#(4420747L,-360788196L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_vehicle"
	local isWWPRO = true
	local description = "Drivable Vehicles"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("targetname", "renderfx", "rendermode", "renderamt", "rendercolor", "angles", "wwmt_target", "sounds", "length", "width", "height", "startspeed", "speed", "acceleration", "dmg", "volume", "bank", "_minlight")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	local propValrenderfx = 0
	local propMaprenderfx = #("0", "1", "2", "3", "4", "9", "10", "11", "12", "13", "5", "6", "7", "8", "14", "15", "16")
	local propValrendermode = 0
	local propMaprendermode = #("0", "1", "2", "3", "4", "5")
	local propValsounds = 1
	local propMapsounds = #("0", "1", "2", "3", "4", "5", "6")
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		targetname type:#string ui:wwmt_targetname_ui
		renderfx type:#string ui:wwmt_renderfx_ui default:"0"
		rendermode type:#string ui:wwmt_rendermode_ui default:"0"
		renderamt type:#integer ui:wwmt_renderamt_ui
		rendercolor type:#color ui:wwmt_rendercolor_ui default:(Color 0 0 0)
		rendercolor_intensity type:#integer ui:wwmt_rendercolor_intensity_ui default:20
		angles type:#string ui:wwmt_angles_ui default:"0 0 0"
		wwmt_target type:#string ui:wwmt_target_ui
		sounds type:#string ui:wwmt_sounds_ui default:"1"
		length type:#integer ui:wwmt_length_ui default:256
		width type:#integer ui:wwmt_width_ui default:128
		height type:#integer ui:wwmt_height_ui default:16
		startspeed type:#integer ui:wwmt_startspeed_ui default:0
		speed type:#integer ui:wwmt_speed_ui default:64
		acceleration type:#integer ui:wwmt_acceleration_ui default:5
		dmg type:#integer ui:wwmt_dmg_ui default:0
		volume type:#integer ui:wwmt_volume_ui default:10
		bank type:#string ui:wwmt_bank_ui default:"0"
		_minlight type:#string ui:wwmt__minlight_ui
		spawnflags type:#integer default:0
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_vehicle"
		Label wwmt_targetname_ui_label "Name" align:#left
		EditText wwmt_targetname_ui "" type:#string
		ComboBox wwmt_renderfx_ui "Render FX" type:#string items:#("Normal", "Slow Pulse", "Fast Pulse", "Slow Wide Pulse", "Fast Wide Pulse", "Slow Strobe", "Fast Strobe", "Faster Strobe", "Slow Flicker", "Fast Flicker", "Slow Fade Away", "Fast Fade Away", "Slow Become Solid", "Fast Become Solid", "Constant Glow", "Distort", "Hologram (Distort + fade)") height:3
		on wwmt_renderfx_ui selected i do
		(
			renderfx = propMaprenderfx[i]
		)
		on wwmt_renderfx_ui entered tex do
		(
			renderfx = trimLeft(trimRight(tex))
			if propMaprenderfx != undefined AND findItem propMaprenderfx tex == 0 then
			(
				append propMaprenderfx tex
				sort propMaprenderfx
				wwmt_renderfx_ui.items = propMaprenderfx
				wwmt_renderfx_ui.selection = findItem wwmt_renderfx_ui.items tex
			)
		)
		ComboBox wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal", "Color", "Texture", "Glow", "Solid", "Additive") height:3
		on wwmt_rendermode_ui selected i do
		(
			rendermode = propMaprendermode[i]
		)
		on wwmt_rendermode_ui entered tex do
		(
			rendermode = trimLeft(trimRight(tex))
			if propMaprendermode != undefined AND findItem propMaprendermode tex == 0 then
			(
				append propMaprendermode tex
				sort propMaprendermode
				wwmt_rendermode_ui.items = propMaprendermode
				wwmt_rendermode_ui.selection = findItem wwmt_rendermode_ui.items tex
			)
		)
		Label wwmt_label_renderamt_ui "FX Amount (1 - 255)" align:#left
		Spinner wwmt_renderamt_ui "" type:#integer range:[-10000, 10000, 0]
		ColorPicker wwmt_rendercolor_ui "rendercolor" color:(Color 0 0 0)
		Spinner wwmt_rendercolor_intensity_ui "FX Color (R G B) Intensity" type:#integer range:[-16000, 16000, 20] tooltip:"Intensity for FX Color (R G B)"
		Label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" align:#left
		EditText wwmt_angles_ui "" type:#string
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
		Label wwmt_target_ui_label "First stop target" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick First stop target" message:"Pick Target Entity for First stop target" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		ComboBox wwmt_sounds_ui "Sound" type:#string items:#("None", "Car 1", "Car 2", "Truck 1", "Truck 2", "Boat 1", "Boat 2") height:3
		on wwmt_sounds_ui selected i do
		(
			sounds = propMapsounds[i]
		)
		on wwmt_sounds_ui entered tex do
		(
			sounds = trimLeft(trimRight(tex))
			if propMapsounds != undefined AND findItem propMapsounds tex == 0 then
			(
				append propMapsounds tex
				sort propMapsounds
				wwmt_sounds_ui.items = propMapsounds
				wwmt_sounds_ui.selection = findItem wwmt_sounds_ui.items tex
			)
		)
		Label wwmt_label_length_ui "Length of the vehicle" align:#left
		Spinner wwmt_length_ui "" type:#integer range:[-10000, 10000, 256]
		Label wwmt_label_width_ui "Width of the vehicle" align:#left
		Spinner wwmt_width_ui "" type:#integer range:[-10000, 10000, 128]
		Label wwmt_label_height_ui "Height above track" align:#left
		Spinner wwmt_height_ui "" type:#integer range:[-10000, 10000, 16]
		Spinner wwmt_startspeed_ui "Initial speed" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_speed_ui "Speed (units per second)" align:#left
		Spinner wwmt_speed_ui "" type:#integer range:[-10000, 10000, 64]
		Label wwmt_label_acceleration_ui "Acceleration (1-10)" align:#left
		Spinner wwmt_acceleration_ui "" type:#integer range:[-10000, 10000, 5]
		Spinner wwmt_dmg_ui "Damage on crush" type:#integer range:[-10000, 10000, 0]
		Label wwmt_label_volume_ui "Volume (10 = loudest)" align:#left
		Spinner wwmt_volume_ui "" type:#integer range:[-10000, 10000, 10]
		Label wwmt_bank_ui_label "Bank angle on turns" align:#left
		EditText wwmt_bank_ui "" type:#string
		Label wwmt__minlight_ui_label "Minimum light level" align:#left
		EditText wwmt__minlight_ui "" type:#string
		function addFlags =
		(
			local sfs = 0
			if params.flag_1_ui.checked == true then
			(
				sfs += 1
			)
			if params.flag_2_ui.checked == true then
			(
				sfs += 2
			)
			if params.flag_8_ui.checked == true then
			(
				sfs += 8
			)
			setProperty this #spawnflags sfs
		)
		Group "Spawn Flags"
		(
			CheckBox flag_1_ui "No Pitch (X-rot)" type:#integer
			on flag_1_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_2_ui "No User Control" type:#integer
			on flag_2_ui changed theState do
			(
				addFlags()
			)
			CheckBox flag_8_ui "Passable" type:#integer
			on flag_8_ui changed theState do
			(
				addFlags()
			)
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_vehicle" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_vehicle_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_vehicle&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_vehicle" address:"https://developer.valvesoftware.com/wiki/func_vehicle?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if renderfx != undefined then
			(
				if findItem propMaprenderfx renderfx == 0 then
				(
					append propMaprenderfx renderfx
					local tmp = wwmt_renderfx_ui.items
					append tmp renderfx
					wwmt_renderfx_ui.items = tmp
					wwmt_renderfx_ui.selection = propMaprenderfx.count
				)
				else
				(
					wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
				)
			)
			if rendermode != undefined then
			(
				if findItem propMaprendermode rendermode == 0 then
				(
					append propMaprendermode rendermode
					local tmp = wwmt_rendermode_ui.items
					append tmp rendermode
					wwmt_rendermode_ui.items = tmp
					wwmt_rendermode_ui.selection = propMaprendermode.count
				)
				else
				(
					wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
				)
			)
			if sounds != undefined then
			(
				if findItem propMapsounds sounds == 0 then
				(
					append propMapsounds sounds
					local tmp = wwmt_sounds_ui.items
					append tmp sounds
					wwmt_sounds_ui.items = tmp
					wwmt_sounds_ui.selection = propMapsounds.count
				)
				else
				(
					wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
				)
			)
			flag_1_ui.checked = (bit.and (getProperty this #spawnflags) 1 == 1)
			flag_2_ui.checked = (bit.and (getProperty this #spawnflags) 2 == 2)
			flag_8_ui.checked = (bit.and (getProperty this #spawnflags) 8 == 8)
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
::wallworm_func_vehiclecontrols_CA = attributes "WW Entity func_vehiclecontrols" version: 78 attribID:#(-393459068L,1014015997L)
(
	local wallworm = true
	local entityType = "SolidClass"
	local thisNode = undefined
	local entname = "func_vehiclecontrols"
	local isWWPRO = true
	local description = "Vehicle Controls"
	local exportProps = #()
	function resetExportProps =
	(
		exportProps = #("wwmt_target")
		exportProps
	)
	local hasOutputs = false
	local hasInputs = false
	local wallworm_classes = #{1,3}
	function getNode =
	(
		if NOT isValidNode thisNode then
		(
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on
		)
		thisNode
	)
	local verge3d_exportable = true
	function verge3d_extraDataFunction =
	(
		getNode()
		::WallWormHelperOps.getEntityExtraData thisNode
	)
	function hasOutputFor obj =
	(
		::wallworm_entityFunctions_hasOutputFor this obj
	)
	function getMyInputs =
	(
		if hasInputs == true AND ::wallwormHelperOps != undefined then
		(
			currentInputs = ::wallwormHelperOps.getEntityInputs this
		)
		currentInputs
	)
	function target_name_filter obj =
	(
		if ::wallwormHelperOps != undefined then
		(
			::wallwormHelperOps.getEntityInputs obj
		)
		else
		(
			false
		)
	)
	function updateBrushNodeList nodelist =
	(
		if nodelist != undefined then
		(
			for obj in nodelist collect obj.name
		)
	)
	function target_node_filter obj =
	(
		superClassOf obj == GeometryClass
	)
	parameters main rollout:params
	(
		brushNodes type:#nodeTab tabSizeVariable:true
		wwmt_target type:#string ui:wwmt_target_ui
	)
	rollout params "Entity Properties"
	(
		Label entityLabel "func_vehiclecontrols"
		Label wwmt_target_ui_label "Vehicle Name" align:#left
		EditText wwmt_target_ui "" type:#string
		PickButton wwmt_target_pickme_ui "Pick Vehicle Name" message:"Pick Target Entity for Vehicle Name" filter:target_name_filter
		on wwmt_target_pickme_ui picked obj do
		(
			wwmt_target = obj.targetname
		)
		Group "Included Nodes"
		(
			PickButton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick Node to include with func_vehiclecontrols" filter:target_node_filter
			ListBox entityGroupList "Included Objects"
			on wwmt_add_brush_entity picked obj do
			(
				if brushNodes == undefined then
				(
					brushNodes = #()
				)
				appendifUnique brushNodes obj
				entityGroupList.items = (updateBrushNodeList brushNodes)
			)
			on entityGroupList selected ind do
			(
				if ind != 0 then
				(
					flashnodes (#(brushNodes[ind]))
				)
			)
			Button removeBrushNode "Remove Selected Object"
			Button groupBrushNode "Group Nodes"
			on groupBrushNode pressed do
			(
				if brushNodes != undefined AND brushNodes.count > 0 then
				(
					objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
					join objList brushNodes
					group objList prefix:"func_vehiclecontrols_"
				)
			)
			on removeBrushNode pressed do
			(
				if entityGroupList.selection != 0 then
				(
					deleteItem brushNodes entityGroupList.selection
					entityGroupList.items = updateBrushNodeList brushNodes
				)
			)
		)
		Hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_vehiclecontrols&f7_submit=Search" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		Hyperlink valvewikie "Wiki: func_vehiclecontrols" address:"https://developer.valvesoftware.com/wiki/func_vehiclecontrols?from=3ds+max+and+wallworm" color:(Color 0 0 255) hovercolor:(Color 255 0 0) visitedcolor:(Color 0 0 255)
		on params open do
		(
			if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
			if brushNodes != undefined AND brushNodes.count > 0 then
			(
				for i = brushNodes.count to 1 by -1 do
				(
					if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then
					(
						deleteItem brushNodes i
					)
				)
			)
			entityGroupList.items = updateBrushNodeList brushNodes
		)
	)
	function resetThis = (thisNode = undefined;resetExportProps())
	on create do (resetThis())
	on clone orig do (orig.resetThis();resetThis())
	on update do 
	(
		if isValidNode (getNode()) then
		(
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
		)
	)
)
