global wallworm_mapsize = [-16384,16384]
global wallworm_point_entity_list = #("info_player_teamspawn","i_p_t","info_tf_teamset","info_areadef","item_armor1","info_tfgoal_timer","i_t_t","_halflife_entities_below_","cycler","cycler_sprite","env_beam","env_beverage","env_blood","env_explosion","env_global","env_glow","env_fade","env_funnel","env_laser","env_message","env_render","env_shake","env_shooter","env_sound","env_spark","env_sprite","gibshooter","info_intermission","light_spot","light_environment","monster_miniturret","monster_turret","monster_sentry","multisource","path_corner","path_track","player_weaponstrip","trigger_auto","trigger_camera","trigger_changetarget","trigger_relay","xen_tree")
global wallworm_brush_entity_list = #("worldspawn","func_nobuild","i_t_g","button_target","env_bubbles","func_breakable","func_button","func_door","func_friction","func_guntarget","func_healthcharger","func_illusionary","func_ladder","func_pendulum","func_plat","func_platrot","func_pushable","func_recharge","func_rot_button","func_rotating","func_tank","func_tankcontrols","func_tanklaser","func_tankrocket","func_trackautochange","func_traincontrols","func_train","func_wall","func_water","momentary_door","momentary_rot_button","trigger_cdaudio","trigger_counter","trigger_gravity","trigger_hurt","trigger_multiple","trigger_once","trigger_teleport")
global wallworm_info_player_teamspawn_CA = attributes "WW Entity info_player_teamspawn" version:78 attribID:#(699994736L,-1643958617L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="info_player_teamspawn"
local hasOutputs = false
local hasInputs = false
local description = "TF Team Spawnpoint"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 255.0 128.0 0.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValg_a="3"
local propMapg_a=#("0","1","2","3")
local propValg_e="0"
local propMapg_e=#("0","1")
local propValgoal_result="0"
local propMapgoal_result=#("0","2")
local propValgoal_state="0"
local propMapgoal_state=#("0","1")
local propValteam_no="1"
local propMapteam_no=#("1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValowned_by="0"
local propMapowned_by=#("0","1","2","3","4")
local exportProps=#()	
function resetExportProps = ( exportProps=#("g_a","g_e","goal_result","netname","goal_no","group_no","goal_state","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","wait","delay_time","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","wwmt_target","killtarget","noise","owned_by","owned_by_teamcheck","deathtype","b_b","message","b_t","b_n","b_o","non_owners_team_broadcast","n_b","n_t","n_n","n_o","speak","ap_speak","team_speak","non_team_speak","owners_team_speak","non_owners_team_speak","angles"))

parameters main rollout:params
(
g_a type:#string ui:wwmt_g_a_ui default:"3"
g_e type:#string ui:wwmt_g_e_ui default:"0"
goal_result type:#string ui:wwmt_goal_result_ui default:"0"
netname type:#string ui:wwmt_netname_ui default:""
goal_no type:#integer ui:wwmt_goal_no_ui
group_no type:#integer ui:wwmt_group_no_ui
goal_state type:#string ui:wwmt_goal_state_ui default:"0"
team_no type:#string ui:wwmt_team_no_ui default:"1"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
wait type:#integer ui:wwmt_wait_ui default:0
delay_time type:#integer ui:wwmt_delay_time_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
wwmt_target type:#string ui:wwmt_target_ui default:""
killtarget type:#string ui:wwmt_killtarget_ui default:""
noise type:#string ui:wwmt_noise_ui default:""
owned_by type:#string ui:wwmt_owned_by_ui default:"0"
owned_by_teamcheck type:#string ui:wwmt_owned_by_teamcheck_ui default:""
deathtype type:#string ui:wwmt_deathtype_ui default:""
b_b type:#string ui:wwmt_b_b_ui default:""
message type:#string ui:wwmt_message_ui default:""
b_t type:#string ui:wwmt_b_t_ui default:""
b_n type:#string ui:wwmt_b_n_ui default:""
b_o type:#string ui:wwmt_b_o_ui default:""
non_owners_team_broadcast type:#string ui:wwmt_non_owners_team_broadcast_ui default:""
n_b type:#string ui:wwmt_n_b_ui default:""
n_t type:#string ui:wwmt_n_t_ui default:""
n_n type:#string ui:wwmt_n_n_ui default:""
n_o type:#string ui:wwmt_n_o_ui default:""
speak type:#string ui:wwmt_speak_ui default:""
ap_speak type:#string ui:wwmt_ap_speak_ui default:""
team_speak type:#string ui:wwmt_team_speak_ui default:""
non_team_speak type:#string ui:wwmt_non_team_speak_ui default:""
owners_team_speak type:#string ui:wwmt_owners_team_speak_ui default:""
non_owners_team_speak type:#string ui:wwmt_non_owners_team_speak_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"

)

rollout params "Entity Properties"
(
label entityLabel "info_player_teamspawn"
dropdownlist wwmt_g_a_ui "Goal activation" type:#string items:#("0 - only first gets...","1 - all get item","2 - all get message","3 - all get item/messages")
on wwmt_g_a_ui selected i do g_a = propMapg_a[i] 
dropdownlist wwmt_g_e_ui "Remove after spawn?" type:#string items:#("no","yes")
on wwmt_g_e_ui selected i do g_e = propMapg_e[i] 
dropdownlist wwmt_goal_result_ui "Pass AP to Activated Goals?" type:#string items:#("No","Yes")
on wwmt_goal_result_ui selected i do goal_result = propMapgoal_result[i] 
label wwmt_netname_ui_label "Entity reference name (for logging)" 
editText wwmt_netname_ui "" type:#string
spinner wwmt_goal_no_ui "Spawn #" type:#integer range:[-10000,10000,0]
spinner wwmt_group_no_ui "Spawn Group #" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_goal_state_ui "Initial State" type:#string items:#("Ready to use","Removed")
on wwmt_goal_state_ui selected i do goal_state = propMapgoal_state[i] 
dropdownlist wwmt_team_no_ui "Team allowed to spawn here" type:#string items:#("Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to spawn here" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
spinner wwmt_wait_ui "Stay active(s" type:#integer range:[-10000,10000,0]
spinner wwmt_delay_time_ui "Delay before " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
label wwmt_target_ui_label "Target entity with this targetname" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target entity with this targetname" message:"Pick Target Entity for Target entity with this targetname" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_killtarget_ui_label "Remove entity with this targetname" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick Remove entity with this targetname" message:"Pick Target Entity for Remove entity with this targetname" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
label wwmt_noise_ui_label "Play Sound Path/name.wav" 
editText wwmt_noise_ui "" type:#string
dropdownlist wwmt_owned_by_ui "Owned by-for msg & item glow" type:#string items:#("Not Owned","Blue","Red","Yellow","Green")
on wwmt_owned_by_ui selected i do owned_by = propMapowned_by[i] 
label wwmt_owned_by_teamcheck_ui_label "Owned by teamcheck" 
editText wwmt_owned_by_teamcheck_ui "" type:#string
label wwmt_deathtype_ui_label "Goal death message" 
editText wwmt_deathtype_ui "" type:#string
label wwmt_b_b_ui_label "Message to all" 
editText wwmt_b_b_ui "" type:#string
label wwmt_message_ui_label "Message to AP" 
editText wwmt_message_ui "" type:#string
label wwmt_b_t_ui_label "Message to AP team" 
editText wwmt_b_t_ui "" type:#string
label wwmt_b_n_ui_label "Message to non-AP team" 
editText wwmt_b_n_ui "" type:#string
label wwmt_b_o_ui_label "Message to owner team" 
editText wwmt_b_o_ui "" type:#string
label wwmt_non_owners_team_broadcast_ui_label "Message to non-owner team(s)" 
editText wwmt_non_owners_team_broadcast_ui "" type:#string
label wwmt_n_b_ui_label "Console msg. to all,  percents = AP name" 
editText wwmt_n_b_ui "" type:#string
label wwmt_n_t_ui_label "Console msg to AP team" 
editText wwmt_n_t_ui "" type:#string
label wwmt_n_n_ui_label "Console msg. to non-AP team" 
editText wwmt_n_n_ui "" type:#string
label wwmt_n_o_ui_label "Console msg. to owner team" 
editText wwmt_n_o_ui "" type:#string
label wwmt_speak_ui_label "Speak (global)" 
editText wwmt_speak_ui "" type:#string
label wwmt_ap_speak_ui_label "Speak (AP)" 
editText wwmt_ap_speak_ui "" type:#string
label wwmt_team_speak_ui_label "Speak (AP team)" 
editText wwmt_team_speak_ui "" type:#string
label wwmt_non_team_speak_ui_label "Speak (non-AP team)" 
editText wwmt_non_team_speak_ui "" type:#string
label wwmt_owners_team_speak_ui_label "Speak (owner team)" 
editText wwmt_owners_team_speak_ui "" type:#string
label wwmt_non_owners_team_speak_ui_label "Speak (non-owner teams)" 
editText wwmt_non_owners_team_speak_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_player_teamspawn&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: info_player_teamspawn" address:"https://developer.valvesoftware.com/wiki/info_player_teamspawn?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if g_a != undefined AND findItem propMapg_a g_a == 0 then (
 append propMapg_a g_a
tmp = wwmt_g_a_ui.items
 append tmp g_a
wwmt_g_a_ui.items = tmp
wwmt_g_a_ui.selection = propMapg_a.count
) else ( 
 if g_a != undefined then (
wwmt_g_a_ui.selection = (findItem propMapg_a g_a)
)
)
 if g_e != undefined AND findItem propMapg_e g_e == 0 then (
 append propMapg_e g_e
tmp = wwmt_g_e_ui.items
 append tmp g_e
wwmt_g_e_ui.items = tmp
wwmt_g_e_ui.selection = propMapg_e.count
) else ( 
 if g_e != undefined then (
wwmt_g_e_ui.selection = (findItem propMapg_e g_e)
)
)
 if goal_result != undefined AND findItem propMapgoal_result goal_result == 0 then (
 append propMapgoal_result goal_result
tmp = wwmt_goal_result_ui.items
 append tmp goal_result
wwmt_goal_result_ui.items = tmp
wwmt_goal_result_ui.selection = propMapgoal_result.count
) else ( 
 if goal_result != undefined then (
wwmt_goal_result_ui.selection = (findItem propMapgoal_result goal_result)
)
)
 if goal_state != undefined AND findItem propMapgoal_state goal_state == 0 then (
 append propMapgoal_state goal_state
tmp = wwmt_goal_state_ui.items
 append tmp goal_state
wwmt_goal_state_ui.items = tmp
wwmt_goal_state_ui.selection = propMapgoal_state.count
) else ( 
 if goal_state != undefined then (
wwmt_goal_state_ui.selection = (findItem propMapgoal_state goal_state)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if owned_by != undefined AND findItem propMapowned_by owned_by == 0 then (
 append propMapowned_by owned_by
tmp = wwmt_owned_by_ui.items
 append tmp owned_by
wwmt_owned_by_ui.items = tmp
wwmt_owned_by_ui.selection = propMapowned_by.count
) else ( 
 if owned_by != undefined then (
wwmt_owned_by_ui.selection = (findItem propMapowned_by owned_by)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_i_p_t_CA = attributes "WW Entity i_p_t" version:78 attribID:#(-640467090L,-634783325L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="i_p_t"
local hasOutputs = false
local hasInputs = false
local description = "TF Team Spawnpoint"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 255.0 128.0 0.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValteam_no="1"
local propMapteam_no=#("1","2","3","4")
local propValg_a="3"
local propMapg_a=#("0","1","2","3")
local propValg_e="0"
local propMapg_e=#("0","1")
local propValgoal_result="0"
local propMapgoal_result=#("0","2")
local propValgoal_state="0"
local propMapgoal_state=#("0","1")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValowned_by="0"
local propMapowned_by=#("0","1","2","3","4")
local exportProps=#()	
function resetExportProps = ( exportProps=#("targetname","team_no","g_a","g_e","goal_result","netname","goal_no","group_no","goal_state","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","wait","delay_time","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","wwmt_target","killtarget","noise","owned_by","owned_by_teamcheck","deathtype","b_b","message","b_t","b_n","b_o","non_owners_team_broadcast","n_b","n_t","n_n","n_o","speak","ap_speak","team_speak","non_team_speak","owners_team_speak","non_owners_team_speak","angles"))

parameters main rollout:params
(
targetname type:#string ui:wwmt_targetname_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"1"
g_a type:#string ui:wwmt_g_a_ui default:"3"
g_e type:#string ui:wwmt_g_e_ui default:"0"
goal_result type:#string ui:wwmt_goal_result_ui default:"0"
netname type:#string ui:wwmt_netname_ui default:""
goal_no type:#integer ui:wwmt_goal_no_ui
group_no type:#integer ui:wwmt_group_no_ui
goal_state type:#string ui:wwmt_goal_state_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
wait type:#integer ui:wwmt_wait_ui default:0
delay_time type:#integer ui:wwmt_delay_time_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
wwmt_target type:#string ui:wwmt_target_ui default:""
killtarget type:#string ui:wwmt_killtarget_ui default:""
noise type:#string ui:wwmt_noise_ui default:""
owned_by type:#string ui:wwmt_owned_by_ui default:"0"
owned_by_teamcheck type:#string ui:wwmt_owned_by_teamcheck_ui default:""
deathtype type:#string ui:wwmt_deathtype_ui default:""
b_b type:#string ui:wwmt_b_b_ui default:""
message type:#string ui:wwmt_message_ui default:""
b_t type:#string ui:wwmt_b_t_ui default:""
b_n type:#string ui:wwmt_b_n_ui default:""
b_o type:#string ui:wwmt_b_o_ui default:""
non_owners_team_broadcast type:#string ui:wwmt_non_owners_team_broadcast_ui default:""
n_b type:#string ui:wwmt_n_b_ui default:""
n_t type:#string ui:wwmt_n_t_ui default:""
n_n type:#string ui:wwmt_n_n_ui default:""
n_o type:#string ui:wwmt_n_o_ui default:""
speak type:#string ui:wwmt_speak_ui default:""
ap_speak type:#string ui:wwmt_ap_speak_ui default:""
team_speak type:#string ui:wwmt_team_speak_ui default:""
non_team_speak type:#string ui:wwmt_non_team_speak_ui default:""
owners_team_speak type:#string ui:wwmt_owners_team_speak_ui default:""
non_owners_team_speak type:#string ui:wwmt_non_owners_team_speak_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"

)

rollout params "Entity Properties"
(
label entityLabel "i_p_t"
label wwmt_targetname_ui_label "Name to target this entity by" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_team_no_ui "Starting Team" type:#string items:#("Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
dropdownlist wwmt_g_a_ui "Goal activation" type:#string items:#("0 - only first gets...","1 - all get item","2 - all get message","3 - all get item/messages")
on wwmt_g_a_ui selected i do g_a = propMapg_a[i] 
dropdownlist wwmt_g_e_ui "Remove after spawn?" type:#string items:#("no","yes")
on wwmt_g_e_ui selected i do g_e = propMapg_e[i] 
dropdownlist wwmt_goal_result_ui "Pass AP to Activated Goals?" type:#string items:#("No","Yes")
on wwmt_goal_result_ui selected i do goal_result = propMapgoal_result[i] 
label wwmt_netname_ui_label "Entity reference name (for logging)" 
editText wwmt_netname_ui "" type:#string
spinner wwmt_goal_no_ui "Spawn #" type:#integer range:[-10000,10000,0]
spinner wwmt_group_no_ui "Spawn Group #" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_goal_state_ui "Initial State" type:#string items:#("Ready to use","Removed")
on wwmt_goal_state_ui selected i do goal_state = propMapgoal_state[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to spawn here" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
spinner wwmt_wait_ui "Stay active(s" type:#integer range:[-10000,10000,0]
spinner wwmt_delay_time_ui "Delay before " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
label wwmt_target_ui_label "Target entity with this targetname" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target entity with this targetname" message:"Pick Target Entity for Target entity with this targetname" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_killtarget_ui_label "Remove entity with this targetname" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick Remove entity with this targetname" message:"Pick Target Entity for Remove entity with this targetname" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
label wwmt_noise_ui_label "Play Sound Path/name.wav" 
editText wwmt_noise_ui "" type:#string
dropdownlist wwmt_owned_by_ui "Owned by-for msg & item glow" type:#string items:#("Not Owned","Blue","Red","Yellow","Green")
on wwmt_owned_by_ui selected i do owned_by = propMapowned_by[i] 
label wwmt_owned_by_teamcheck_ui_label "Owned by teamcheck" 
editText wwmt_owned_by_teamcheck_ui "" type:#string
label wwmt_deathtype_ui_label "Goal death message" 
editText wwmt_deathtype_ui "" type:#string
label wwmt_b_b_ui_label "Message to all" 
editText wwmt_b_b_ui "" type:#string
label wwmt_message_ui_label "Message to AP" 
editText wwmt_message_ui "" type:#string
label wwmt_b_t_ui_label "Message to AP team" 
editText wwmt_b_t_ui "" type:#string
label wwmt_b_n_ui_label "Message to non-AP team" 
editText wwmt_b_n_ui "" type:#string
label wwmt_b_o_ui_label "Message to owner team" 
editText wwmt_b_o_ui "" type:#string
label wwmt_non_owners_team_broadcast_ui_label "Message to non-owner team(s)" 
editText wwmt_non_owners_team_broadcast_ui "" type:#string
label wwmt_n_b_ui_label "Console msg. to all,  percents = AP name" 
editText wwmt_n_b_ui "" type:#string
label wwmt_n_t_ui_label "Console msg to AP team" 
editText wwmt_n_t_ui "" type:#string
label wwmt_n_n_ui_label "Console msg. to non-AP team" 
editText wwmt_n_n_ui "" type:#string
label wwmt_n_o_ui_label "Console msg. to owner team" 
editText wwmt_n_o_ui "" type:#string
label wwmt_speak_ui_label "Speak (global)" 
editText wwmt_speak_ui "" type:#string
label wwmt_ap_speak_ui_label "Speak (AP)" 
editText wwmt_ap_speak_ui "" type:#string
label wwmt_team_speak_ui_label "Speak (AP team)" 
editText wwmt_team_speak_ui "" type:#string
label wwmt_non_team_speak_ui_label "Speak (non-AP team)" 
editText wwmt_non_team_speak_ui "" type:#string
label wwmt_owners_team_speak_ui_label "Speak (owner team)" 
editText wwmt_owners_team_speak_ui "" type:#string
label wwmt_non_owners_team_speak_ui_label "Speak (non-owner teams)" 
editText wwmt_non_owners_team_speak_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=i_p_t&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: i_p_t" address:"https://developer.valvesoftware.com/wiki/i_p_t?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if g_a != undefined AND findItem propMapg_a g_a == 0 then (
 append propMapg_a g_a
tmp = wwmt_g_a_ui.items
 append tmp g_a
wwmt_g_a_ui.items = tmp
wwmt_g_a_ui.selection = propMapg_a.count
) else ( 
 if g_a != undefined then (
wwmt_g_a_ui.selection = (findItem propMapg_a g_a)
)
)
 if g_e != undefined AND findItem propMapg_e g_e == 0 then (
 append propMapg_e g_e
tmp = wwmt_g_e_ui.items
 append tmp g_e
wwmt_g_e_ui.items = tmp
wwmt_g_e_ui.selection = propMapg_e.count
) else ( 
 if g_e != undefined then (
wwmt_g_e_ui.selection = (findItem propMapg_e g_e)
)
)
 if goal_result != undefined AND findItem propMapgoal_result goal_result == 0 then (
 append propMapgoal_result goal_result
tmp = wwmt_goal_result_ui.items
 append tmp goal_result
wwmt_goal_result_ui.items = tmp
wwmt_goal_result_ui.selection = propMapgoal_result.count
) else ( 
 if goal_result != undefined then (
wwmt_goal_result_ui.selection = (findItem propMapgoal_result goal_result)
)
)
 if goal_state != undefined AND findItem propMapgoal_state goal_state == 0 then (
 append propMapgoal_state goal_state
tmp = wwmt_goal_state_ui.items
 append tmp goal_state
wwmt_goal_state_ui.items = tmp
wwmt_goal_state_ui.selection = propMapgoal_state.count
) else ( 
 if goal_state != undefined then (
wwmt_goal_state_ui.selection = (findItem propMapgoal_state goal_state)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if owned_by != undefined AND findItem propMapowned_by owned_by == 0 then (
 append propMapowned_by owned_by
tmp = wwmt_owned_by_ui.items
 append tmp owned_by
wwmt_owned_by_ui.items = tmp
wwmt_owned_by_ui.selection = propMapowned_by.count
) else ( 
 if owned_by != undefined then (
wwmt_owned_by_ui.selection = (findItem propMapowned_by owned_by)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_info_tf_teamset_CA = attributes "WW Entity info_tf_teamset" version:78 attribID:#(-1712061661L,-1158048598L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="info_tf_teamset"
local hasOutputs = false
local hasInputs = false
local description = "Team set"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 255.0 128.0 0.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local exportProps=#()	
function resetExportProps = ( exportProps=#("targetname","wwmt_target","team_no"))

parameters main rollout:params
(
targetname type:#string ui:wwmt_targetname_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"

)

rollout params "Entity Properties"
(
label entityLabel "info_tf_teamset"
label wwmt_targetname_ui_label "Name to target this entity by" 
editText wwmt_targetname_ui "" type:#string
label wwmt_target_ui_label "Teamcheck to target" 
editText wwmt_target_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team" type:#string items:#("Alternate","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_tf_teamset&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: info_tf_teamset" address:"https://developer.valvesoftware.com/wiki/info_tf_teamset?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_info_areadef_CA = attributes "WW Entity info_areadef" version:78 attribID:#(641433422L,-1205737987L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="info_areadef"
local hasOutputs = false
local hasInputs = false
local description = "Area definition"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 255.0 128.0 0.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local exportProps=#()	
function resetExportProps = ( exportProps=#("areaname","mins","maxs"))

parameters main rollout:params
(
areaname type:#string ui:wwmt_areaname_ui default:""
mins type:#string ui:wwmt_mins_ui default:"0 0 0"
maxs type:#string ui:wwmt_maxs_ui default:"0 0 0"

)

rollout params "Entity Properties"
(
label entityLabel "info_areadef"
label wwmt_areaname_ui_label "Name of area" 
editText wwmt_areaname_ui "" type:#string
label wwmt_mins_ui_label "(# # #)" 
editText wwmt_mins_ui "" type:#string
label wwmt_maxs_ui_label "(# # #)" 
editText wwmt_maxs_ui "" type:#string
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_areadef&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: info_areadef" address:"https://developer.valvesoftware.com/wiki/info_areadef?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_item_armor1_CA = attributes "WW Entity item_armor1" version:78 attribID:#(-938864478L,-300881624L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="item_armor1"
local hasOutputs = false
local hasInputs = false
local description = "Green Armor"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValg_a="0"
local propMapg_a=#("0","1","2","4","2048")
local propValg_e="0"
local propMapg_e=#("1","2","4","8","16","32","64")
local propValgoal_result="0"
local propMapgoal_result=#("0","1","2","4","8","16","32","64")
local propValgoal_state="2"
local propMapgoal_state=#("1","2","3")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("g_a","g_e","goal_result","netname","goal_no","group_no","targetname","goal_state","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","respawn_delay","armorclass","angles","avelocity"))

parameters main rollout:params
(
g_a type:#string ui:wwmt_g_a_ui default:"0"
g_e type:#string ui:wwmt_g_e_ui default:"0"
goal_result type:#string ui:wwmt_goal_result_ui default:"0"
netname type:#string ui:wwmt_netname_ui default:""
goal_no type:#integer ui:wwmt_goal_no_ui
group_no type:#integer ui:wwmt_group_no_ui
targetname type:#string ui:wwmt_targetname_ui default:""
goal_state type:#string ui:wwmt_goal_state_ui default:"2"
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
respawn_delay type:#integer ui:wwmt_respawn_delay_ui default:5
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
avelocity type:#string ui:wwmt_avelocity_ui default:""

)

rollout params "Entity Properties"
(
label entityLabel "item_armor1"
dropdownlist wwmt_g_a_ui "Goal Activation bitfields" type:#string items:#("0 - none","1 - player touch","2 - detpack explosion","4 - when criteria fails","2048 - drop model to ground on spawn")
on wwmt_g_a_ui selected i do g_a = propMapg_a[i] 
dropdownlist wwmt_g_e_ui "Goal Effects bitfields" type:#string items:#("1 - Activating Player(AP)","2 - APs team","4 - Not on APs team","8 - All except AP","16 - Walls obstruct radius","32 - Same environment only","64 - Check APA criteria individually")
on wwmt_g_e_ui selected i do g_e = propMapg_e[i] 
dropdownlist wwmt_goal_result_ui "Goal Result bitfields" type:#string items:#("none","1 - remove immediately","2 - Sub-Goals apply mods","4 - scores, intermission, end","8 - Sub-goals don't apply mods","16 - Prevent Spy disguise","32 - Force respawn, no die","64 - Remove SG & dispensers")
on wwmt_goal_result_ui selected i do goal_result = propMapgoal_result[i] 
label wwmt_netname_ui_label "Entity reference name (for logging)" 
editText wwmt_netname_ui "" type:#string
spinner wwmt_goal_no_ui "Goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_group_no_ui "Goal Group #" type:#integer range:[-10000,10000,0]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_goal_state_ui "Goal Initial State" type:#string items:#("Active","Inactive","Removed")
on wwmt_goal_state_ui selected i do goal_state = propMapgoal_state[i] 
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
spinner wwmt_respawn_delay_ui "Respawn delay" type:#integer range:[-10000,10000,5]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
label wwmt_avelocity_ui_label "Angular Velocity (PYR)" 
editText wwmt_avelocity_ui "" type:#string
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=item_armor1&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: item_armor1" address:"https://developer.valvesoftware.com/wiki/item_armor1?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if g_a != undefined AND findItem propMapg_a g_a == 0 then (
 append propMapg_a g_a
tmp = wwmt_g_a_ui.items
 append tmp g_a
wwmt_g_a_ui.items = tmp
wwmt_g_a_ui.selection = propMapg_a.count
) else ( 
 if g_a != undefined then (
wwmt_g_a_ui.selection = (findItem propMapg_a g_a)
)
)
 if g_e != undefined AND findItem propMapg_e g_e == 0 then (
 append propMapg_e g_e
tmp = wwmt_g_e_ui.items
 append tmp g_e
wwmt_g_e_ui.items = tmp
wwmt_g_e_ui.selection = propMapg_e.count
) else ( 
 if g_e != undefined then (
wwmt_g_e_ui.selection = (findItem propMapg_e g_e)
)
)
 if goal_result != undefined AND findItem propMapgoal_result goal_result == 0 then (
 append propMapgoal_result goal_result
tmp = wwmt_goal_result_ui.items
 append tmp goal_result
wwmt_goal_result_ui.items = tmp
wwmt_goal_result_ui.selection = propMapgoal_result.count
) else ( 
 if goal_result != undefined then (
wwmt_goal_result_ui.selection = (findItem propMapgoal_result goal_result)
)
)
 if goal_state != undefined AND findItem propMapgoal_state goal_state == 0 then (
 append propMapgoal_state goal_state
tmp = wwmt_goal_state_ui.items
 append tmp goal_state
wwmt_goal_state_ui.items = tmp
wwmt_goal_state_ui.selection = propMapgoal_state.count
) else ( 
 if goal_state != undefined then (
wwmt_goal_state_ui.selection = (findItem propMapgoal_state goal_state)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_info_tfgoal_timer_CA = attributes "WW Entity info_tfgoal_timer" version:78 attribID:#(-2101981818L,336099424L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="info_tfgoal_timer"
local hasOutputs = false
local hasInputs = false
local description = "Goal Timer"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 255.0 255.0 0.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValgoal_state="2"
local propMapgoal_state=#("1","2","3")
local propValg_e="0"
local propMapg_e=#("0","16","32","64")
local propValgoal_result="0"
local propMapgoal_result=#("0","1","2","4","8","16","32","64")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local propValowned_by="0"
local propMapowned_by=#("0","1","2","3","4")
local exportProps=#()	
function resetExportProps = ( exportProps=#("goal_state","search_time","g_e","goal_result","netname","goal_no","group_no","targetname","mdl","skin","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","wait","delay_time","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","wwmt_target","killtarget","noise","frags","lives","health","armorvalue","armorclass","a_s","a_n","a_r","a_c","ammo_detpack","no_grenades_1","no_grenades_2","invincible_finished","invisible_finished","super_damage_finished","radsuit_finished","count","increase_team","increase_team1","increase_team2","increase_team3","increase_team4","endround_time","endround_owned_by","endround_non_owned_by","endround_team1","endround_team2","endround_team3","endround_team4","owned_by","owned_by_teamcheck","deathtype","b_b","message","b_t","b_n","b_o","non_owners_team_broadcast","n_b","n_t","n_n","n_o","speak","ap_speak","team_speak","non_team_speak","owners_team_speak","non_owners_team_speak","angles"))

parameters main rollout:params
(
goal_state type:#string ui:wwmt_goal_state_ui default:"2"
search_time type:#integer ui:wwmt_search_time_ui
g_e type:#string ui:wwmt_g_e_ui default:"0"
goal_result type:#string ui:wwmt_goal_result_ui default:"0"
netname type:#string ui:wwmt_netname_ui default:""
goal_no type:#integer ui:wwmt_goal_no_ui
group_no type:#integer ui:wwmt_group_no_ui
targetname type:#string ui:wwmt_targetname_ui default:""
mdl type:#string ui:wwmt_mdl_ui default:""
skin type:#integer ui:wwmt_skin_ui
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
wait type:#integer ui:wwmt_wait_ui default:0
delay_time type:#integer ui:wwmt_delay_time_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
wwmt_target type:#string ui:wwmt_target_ui default:""
killtarget type:#string ui:wwmt_killtarget_ui default:""
noise type:#string ui:wwmt_noise_ui default:""
frags type:#integer ui:wwmt_frags_ui
lives type:#integer ui:wwmt_lives_ui
health type:#integer ui:wwmt_health_ui
armorvalue type:#integer ui:wwmt_armorvalue_ui
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
a_s type:#integer ui:wwmt_a_s_ui
a_n type:#integer ui:wwmt_a_n_ui
a_r type:#integer ui:wwmt_a_r_ui
a_c type:#integer ui:wwmt_a_c_ui
ammo_detpack type:#integer ui:wwmt_ammo_detpack_ui
no_grenades_1 type:#integer ui:wwmt_no_grenades_1_ui
no_grenades_2 type:#integer ui:wwmt_no_grenades_2_ui
invincible_finished type:#integer ui:wwmt_invincible_finished_ui
invisible_finished type:#integer ui:wwmt_invisible_finished_ui
super_damage_finished type:#integer ui:wwmt_super_damage_finished_ui
radsuit_finished type:#integer ui:wwmt_radsuit_finished_ui
count type:#integer ui:wwmt_count_ui
increase_team type:#integer ui:wwmt_increase_team_ui
increase_team1 type:#integer ui:wwmt_increase_team1_ui
increase_team2 type:#integer ui:wwmt_increase_team2_ui
increase_team3 type:#integer ui:wwmt_increase_team3_ui
increase_team4 type:#integer ui:wwmt_increase_team4_ui
endround_time type:#integer ui:wwmt_endround_time_ui
endround_owned_by type:#string ui:wwmt_endround_owned_by_ui default:""
endround_non_owned_by type:#string ui:wwmt_endround_non_owned_by_ui default:""
endround_team1 type:#string ui:wwmt_endround_team1_ui default:""
endround_team2 type:#string ui:wwmt_endround_team2_ui default:""
endround_team3 type:#string ui:wwmt_endround_team3_ui default:""
endround_team4 type:#string ui:wwmt_endround_team4_ui default:""
owned_by type:#string ui:wwmt_owned_by_ui default:"0"
owned_by_teamcheck type:#string ui:wwmt_owned_by_teamcheck_ui default:""
deathtype type:#string ui:wwmt_deathtype_ui default:""
b_b type:#string ui:wwmt_b_b_ui default:""
message type:#string ui:wwmt_message_ui default:""
b_t type:#string ui:wwmt_b_t_ui default:""
b_n type:#string ui:wwmt_b_n_ui default:""
b_o type:#string ui:wwmt_b_o_ui default:""
non_owners_team_broadcast type:#string ui:wwmt_non_owners_team_broadcast_ui default:""
n_b type:#string ui:wwmt_n_b_ui default:""
n_t type:#string ui:wwmt_n_t_ui default:""
n_n type:#string ui:wwmt_n_n_ui default:""
n_o type:#string ui:wwmt_n_o_ui default:""
speak type:#string ui:wwmt_speak_ui default:""
ap_speak type:#string ui:wwmt_ap_speak_ui default:""
team_speak type:#string ui:wwmt_team_speak_ui default:""
non_team_speak type:#string ui:wwmt_non_team_speak_ui default:""
owners_team_speak type:#string ui:wwmt_owners_team_speak_ui default:""
non_owners_team_speak type:#string ui:wwmt_non_owners_team_speak_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"

		on skin set val do (
			getNode()
			if ::WallWormHelperOps != undefined then ::WallWormHelperOps.setProxySkin thisNode val
		)

)

rollout params "Entity Properties"
(
label entityLabel "info_tfgoal_timer"
dropdownlist wwmt_goal_state_ui "Goal Initial State" type:#string items:#("Active","Inactive","Removed")
on wwmt_goal_state_ui selected i do goal_state = propMapgoal_state[i] 
spinner wwmt_search_time_ui "Time between " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_g_e_ui "Goal Effects bitfields" type:#string items:#("None","16 - Walls obstruct radius","32 - Same environment only","64 - Check APA criteria individually")
on wwmt_g_e_ui selected i do g_e = propMapg_e[i] 
dropdownlist wwmt_goal_result_ui "Goal Result bitfields" type:#string items:#("None","1 - remove after activating","2 - Sub-Goals apply mod APA","4 - Display scores, end level","8 - Sub-goals don't apply mods","16 - Prevent Spy disguise","32 - Force respawn, no die","64 - If APA fails criteria")
on wwmt_goal_result_ui selected i do goal_result = propMapgoal_result[i] 
label wwmt_netname_ui_label "Entity reference name (for logging)" 
editText wwmt_netname_ui "" type:#string
spinner wwmt_goal_no_ui "Goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_group_no_ui "Goal Group #" type:#integer range:[-10000,10000,0]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_mdl_ui_label "Model Path/name.mdl" 
editText wwmt_mdl_ui "" type:#string
spinner wwmt_skin_ui "Model skin-va" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
spinner wwmt_wait_ui "Stay active(s" type:#integer range:[-10000,10000,0]
spinner wwmt_delay_time_ui "Delay before " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
label wwmt_target_ui_label "Target entity with this targetname" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target entity with this targetname" message:"Pick Target Entity for Target entity with this targetname" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_killtarget_ui_label "Remove entity with this targetname" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick Remove entity with this targetname" message:"Pick Target Entity for Remove entity with this targetname" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
label wwmt_noise_ui_label "Play Sound Path/name.wav" 
editText wwmt_noise_ui "" type:#string
spinner wwmt_frags_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_lives_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_health_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_armorvalue_ui "Armor Value  " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
spinner wwmt_a_s_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_n_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_r_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_c_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_ammo_detpack_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_1_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_2_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_invincible_finished_ui "Invincibility" type:#integer range:[-10000,10000,0]
spinner wwmt_invisible_finished_ui "Invisibility " type:#integer range:[-10000,10000,0]
spinner wwmt_super_damage_finished_ui "Quad Duration" type:#integer range:[-10000,10000,0]
spinner wwmt_radsuit_finished_ui "Rad Suit Dura" type:#integer range:[-10000,10000,0]
spinner wwmt_count_ui "Score to AP T" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team_ui "Teamcheck tea" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team1_ui "Blue point ga" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team2_ui "Red point gai" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team3_ui "Yellow point " type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team4_ui "Green point g" type:#integer range:[-10000,10000,0]
spinner wwmt_endround_time_ui "Length of end" type:#integer range:[-10000,10000,0]
label wwmt_endround_owned_by_ui_label "Owners endround message" 
editText wwmt_endround_owned_by_ui "" type:#string
label wwmt_endround_non_owned_by_ui_label "Non-owners endround message" 
editText wwmt_endround_non_owned_by_ui "" type:#string
label wwmt_endround_team1_ui_label "Endround message for team 1" 
editText wwmt_endround_team1_ui "" type:#string
label wwmt_endround_team2_ui_label "Endround message for team 2" 
editText wwmt_endround_team2_ui "" type:#string
label wwmt_endround_team3_ui_label "Endround message for team 3" 
editText wwmt_endround_team3_ui "" type:#string
label wwmt_endround_team4_ui_label "Endround message for team 4" 
editText wwmt_endround_team4_ui "" type:#string
dropdownlist wwmt_owned_by_ui "Owned by-for msg & item glow" type:#string items:#("Not Owned","Blue","Red","Yellow","Green")
on wwmt_owned_by_ui selected i do owned_by = propMapowned_by[i] 
label wwmt_owned_by_teamcheck_ui_label "Owned by teamcheck" 
editText wwmt_owned_by_teamcheck_ui "" type:#string
label wwmt_deathtype_ui_label "Goal death message" 
editText wwmt_deathtype_ui "" type:#string
label wwmt_b_b_ui_label "Message to all" 
editText wwmt_b_b_ui "" type:#string
label wwmt_message_ui_label "Message to AP" 
editText wwmt_message_ui "" type:#string
label wwmt_b_t_ui_label "Message to AP team" 
editText wwmt_b_t_ui "" type:#string
label wwmt_b_n_ui_label "Message to non-AP team" 
editText wwmt_b_n_ui "" type:#string
label wwmt_b_o_ui_label "Message to owner team" 
editText wwmt_b_o_ui "" type:#string
label wwmt_non_owners_team_broadcast_ui_label "Message to non-owner team(s)" 
editText wwmt_non_owners_team_broadcast_ui "" type:#string
label wwmt_n_b_ui_label "Console msg. to all,  percents = AP name" 
editText wwmt_n_b_ui "" type:#string
label wwmt_n_t_ui_label "Console msg to AP team" 
editText wwmt_n_t_ui "" type:#string
label wwmt_n_n_ui_label "Console msg. to non-AP team" 
editText wwmt_n_n_ui "" type:#string
label wwmt_n_o_ui_label "Console msg. to owner team" 
editText wwmt_n_o_ui "" type:#string
label wwmt_speak_ui_label "Speak (global)" 
editText wwmt_speak_ui "" type:#string
label wwmt_ap_speak_ui_label "Speak (AP)" 
editText wwmt_ap_speak_ui "" type:#string
label wwmt_team_speak_ui_label "Speak (AP team)" 
editText wwmt_team_speak_ui "" type:#string
label wwmt_non_team_speak_ui_label "Speak (non-AP team)" 
editText wwmt_non_team_speak_ui "" type:#string
label wwmt_owners_team_speak_ui_label "Speak (owner team)" 
editText wwmt_owners_team_speak_ui "" type:#string
label wwmt_non_owners_team_speak_ui_label "Speak (non-owner teams)" 
editText wwmt_non_owners_team_speak_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_tfgoal_timer&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: info_tfgoal_timer" address:"https://developer.valvesoftware.com/wiki/info_tfgoal_timer?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if goal_state != undefined AND findItem propMapgoal_state goal_state == 0 then (
 append propMapgoal_state goal_state
tmp = wwmt_goal_state_ui.items
 append tmp goal_state
wwmt_goal_state_ui.items = tmp
wwmt_goal_state_ui.selection = propMapgoal_state.count
) else ( 
 if goal_state != undefined then (
wwmt_goal_state_ui.selection = (findItem propMapgoal_state goal_state)
)
)
 if g_e != undefined AND findItem propMapg_e g_e == 0 then (
 append propMapg_e g_e
tmp = wwmt_g_e_ui.items
 append tmp g_e
wwmt_g_e_ui.items = tmp
wwmt_g_e_ui.selection = propMapg_e.count
) else ( 
 if g_e != undefined then (
wwmt_g_e_ui.selection = (findItem propMapg_e g_e)
)
)
 if goal_result != undefined AND findItem propMapgoal_result goal_result == 0 then (
 append propMapgoal_result goal_result
tmp = wwmt_goal_result_ui.items
 append tmp goal_result
wwmt_goal_result_ui.items = tmp
wwmt_goal_result_ui.selection = propMapgoal_result.count
) else ( 
 if goal_result != undefined then (
wwmt_goal_result_ui.selection = (findItem propMapgoal_result goal_result)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)
 if owned_by != undefined AND findItem propMapowned_by owned_by == 0 then (
 append propMapowned_by owned_by
tmp = wwmt_owned_by_ui.items
 append tmp owned_by
wwmt_owned_by_ui.items = tmp
wwmt_owned_by_ui.selection = propMapowned_by.count
) else ( 
 if owned_by != undefined then (
wwmt_owned_by_ui.selection = (findItem propMapowned_by owned_by)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_i_t_t_CA = attributes "WW Entity i_t_t" version:78 attribID:#(-640467090L,-634783449L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="i_t_t"
local hasOutputs = false
local hasInputs = false
local description = "Goal Timer"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 255.0 255.0 0.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValg_a="0"
local propMapg_a=#("0","1","2","4","8","16","32","64","128","256","512","1024","2048","4096","8192")
local propValg_e="1"
local propMapg_e=#("1","2","4","8","16","32","64")
local propValgoal_result="0"
local propMapgoal_result=#("0","1","2","4","8","16","32","64")
local propValitems="0"
local propMapitems=#("0","131072","262144","16777216","33554432")
local propValreplacement_model_flags="0"
local propMapreplacement_model_flags=#("1")
local propValgoal_state="2"
local propMapgoal_state=#("1","2","3")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local propValowned_by="0"
local propMapowned_by=#("0","1","2","3","4")
local exportProps=#()	
function resetExportProps = ( exportProps=#("g_a","g_e","speed_reduction","pausetime","distance","pain_finished","speed","attack_finished","impulse","goal_result","team_drop","non_team_drop","netname_team_drop","netname_non_team_drop","noise3","noise4","items","replacement_model","replacement_model_body","replacement_model_skin","replacement_model_flags","goal_state","search_time","netname","goal_no","group_no","targetname","mdl","skin","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","wait","delay_time","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","axhitme","return_item_no","r_i_g","wwmt_target","killtarget","noise","frags","lives","health","armorvalue","armorclass","a_s","a_n","a_r","a_c","ammo_detpack","no_grenades_1","no_grenades_2","invincible_finished","invisible_finished","super_damage_finished","radsuit_finished","count","increase_team","increase_team1","increase_team2","increase_team3","increase_team4","endround_time","endround_owned_by","endround_non_owned_by","endround_team1","endround_team2","endround_team3","endround_team4","owned_by","owned_by_teamcheck","deathtype","b_b","message","b_t","b_n","b_o","non_owners_team_broadcast","n_b","n_t","n_n","n_o","speak","ap_speak","team_speak","non_team_speak","owners_team_speak","non_owners_team_speak","angles"))

parameters main rollout:params
(
g_a type:#string ui:wwmt_g_a_ui default:"0"
g_e type:#string ui:wwmt_g_e_ui default:"1"
speed_reduction type:#integer ui:wwmt_speed_reduction_ui
pausetime type:#integer ui:wwmt_pausetime_ui
distance type:#integer ui:wwmt_distance_ui
pain_finished type:#integer ui:wwmt_pain_finished_ui
speed type:#integer ui:wwmt_speed_ui
attack_finished type:#integer ui:wwmt_attack_finished_ui
impulse type:#integer ui:wwmt_impulse_ui
goal_result type:#string ui:wwmt_goal_result_ui default:"0"
team_drop type:#string ui:wwmt_team_drop_ui default:""
non_team_drop type:#string ui:wwmt_non_team_drop_ui default:""
netname_team_drop type:#string ui:wwmt_netname_team_drop_ui default:""
netname_non_team_drop type:#string ui:wwmt_netname_non_team_drop_ui default:""
noise3 type:#string ui:wwmt_noise3_ui default:""
noise4 type:#string ui:wwmt_noise4_ui default:""
items type:#string ui:wwmt_items_ui default:"0"
replacement_model type:#string ui:wwmt_replacement_model_ui default:""
replacement_model_body type:#integer ui:wwmt_replacement_model_body_ui
replacement_model_skin type:#integer ui:wwmt_replacement_model_skin_ui
replacement_model_flags type:#string ui:wwmt_replacement_model_flags_ui default:"0"
goal_state type:#string ui:wwmt_goal_state_ui default:"2"
search_time type:#integer ui:wwmt_search_time_ui
netname type:#string ui:wwmt_netname_ui default:""
goal_no type:#integer ui:wwmt_goal_no_ui
group_no type:#integer ui:wwmt_group_no_ui
targetname type:#string ui:wwmt_targetname_ui default:""
mdl type:#string ui:wwmt_mdl_ui default:""
skin type:#integer ui:wwmt_skin_ui
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
wait type:#integer ui:wwmt_wait_ui default:0
delay_time type:#integer ui:wwmt_delay_time_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
wwmt_target type:#string ui:wwmt_target_ui default:""
killtarget type:#string ui:wwmt_killtarget_ui default:""
noise type:#string ui:wwmt_noise_ui default:""
frags type:#integer ui:wwmt_frags_ui
lives type:#integer ui:wwmt_lives_ui
health type:#integer ui:wwmt_health_ui
armorvalue type:#integer ui:wwmt_armorvalue_ui
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
a_s type:#integer ui:wwmt_a_s_ui
a_n type:#integer ui:wwmt_a_n_ui
a_r type:#integer ui:wwmt_a_r_ui
a_c type:#integer ui:wwmt_a_c_ui
ammo_detpack type:#integer ui:wwmt_ammo_detpack_ui
no_grenades_1 type:#integer ui:wwmt_no_grenades_1_ui
no_grenades_2 type:#integer ui:wwmt_no_grenades_2_ui
invincible_finished type:#integer ui:wwmt_invincible_finished_ui
invisible_finished type:#integer ui:wwmt_invisible_finished_ui
super_damage_finished type:#integer ui:wwmt_super_damage_finished_ui
radsuit_finished type:#integer ui:wwmt_radsuit_finished_ui
count type:#integer ui:wwmt_count_ui
increase_team type:#integer ui:wwmt_increase_team_ui
increase_team1 type:#integer ui:wwmt_increase_team1_ui
increase_team2 type:#integer ui:wwmt_increase_team2_ui
increase_team3 type:#integer ui:wwmt_increase_team3_ui
increase_team4 type:#integer ui:wwmt_increase_team4_ui
endround_time type:#integer ui:wwmt_endround_time_ui
endround_owned_by type:#string ui:wwmt_endround_owned_by_ui default:""
endround_non_owned_by type:#string ui:wwmt_endround_non_owned_by_ui default:""
endround_team1 type:#string ui:wwmt_endround_team1_ui default:""
endround_team2 type:#string ui:wwmt_endround_team2_ui default:""
endround_team3 type:#string ui:wwmt_endround_team3_ui default:""
endround_team4 type:#string ui:wwmt_endround_team4_ui default:""
owned_by type:#string ui:wwmt_owned_by_ui default:"0"
owned_by_teamcheck type:#string ui:wwmt_owned_by_teamcheck_ui default:""
deathtype type:#string ui:wwmt_deathtype_ui default:""
b_b type:#string ui:wwmt_b_b_ui default:""
message type:#string ui:wwmt_message_ui default:""
b_t type:#string ui:wwmt_b_t_ui default:""
b_n type:#string ui:wwmt_b_n_ui default:""
b_o type:#string ui:wwmt_b_o_ui default:""
non_owners_team_broadcast type:#string ui:wwmt_non_owners_team_broadcast_ui default:""
n_b type:#string ui:wwmt_n_b_ui default:""
n_t type:#string ui:wwmt_n_t_ui default:""
n_n type:#string ui:wwmt_n_n_ui default:""
n_o type:#string ui:wwmt_n_o_ui default:""
speak type:#string ui:wwmt_speak_ui default:""
ap_speak type:#string ui:wwmt_ap_speak_ui default:""
team_speak type:#string ui:wwmt_team_speak_ui default:""
non_team_speak type:#string ui:wwmt_non_team_speak_ui default:""
owners_team_speak type:#string ui:wwmt_owners_team_speak_ui default:""
non_owners_team_speak type:#string ui:wwmt_non_owners_team_speak_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"

		on skin set val do (
			getNode()
			if ::WallWormHelperOps != undefined then ::WallWormHelperOps.setProxySkin thisNode val
		)

)

rollout params "Entity Properties"
(
label entityLabel "i_t_t"
dropdownlist wwmt_g_a_ui "Goal Activation Bitfields" type:#string items:#("0 - none","1 - player glows","2 - move at half-speed","4 - drop item on death","8 - return upon death-drop","16 - return if removed by goal","32 - return if (128) is set","64 - if AP fails criteria","128 - remove after pause","256 - keep item when player dies","512 - glows when not carried","1024 - player keeps effects","2048 - drop to ground at spawn","4096 - is droppable","8192 - is solid")
on wwmt_g_a_ui selected i do g_a = propMapg_a[i] 
dropdownlist wwmt_g_e_ui "Goal Effects bitfields" type:#string items:#("1 - AP is affected","2 - APs team","4 - Not on APs team","8 - Everyone except AP","16 - Walls obstruct radius","32 - Same environment only","64 - Check APA individually")
on wwmt_g_e_ui selected i do g_e = propMapg_e[i] 
spinner wwmt_speed_reduction_ui "Percentage of" type:#integer range:[-10000,10000,0]
spinner wwmt_pausetime_ui "Pause (stays " type:#integer range:[-10000,10000,0]
spinner wwmt_distance_ui "All in group#" type:#integer range:[-10000,10000,0]
spinner wwmt_pain_finished_ui "...activate t" type:#integer range:[-10000,10000,0]
spinner wwmt_speed_ui "All in group " type:#integer range:[-10000,10000,0]
spinner wwmt_attack_finished_ui "...activate t" type:#integer range:[-10000,10000,0]
spinner wwmt_impulse_ui "Activate/Rest" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_goal_result_ui "Goal Result bitfields" type:#string items:#("None","1 - remove after activating","2 - Sub-Goals apply mod AP","4 - Display scores, end level","8 - Sub-goals don't apply results to APA","16 - Prevent Spy disguise","32 - Force respawn, no die","64 - Remove SG & dispensers")
on wwmt_goal_result_ui selected i do goal_result = propMapgoal_result[i] 
label wwmt_team_drop_ui_label "Center msg, death drop, owner team" 
editText wwmt_team_drop_ui "" type:#string
label wwmt_non_team_drop_ui_label "Center msg, death drop, non owners" 
editText wwmt_non_team_drop_ui "" type:#string
label wwmt_netname_team_drop_ui_label "Console msg, death drop, owner team" 
editText wwmt_netname_team_drop_ui "" type:#string
label wwmt_netname_non_team_drop_ui_label "Console msg, death drop, non owners" 
editText wwmt_netname_non_team_drop_ui "" type:#string
label wwmt_noise3_ui_label "Return to start msg, team" 
editText wwmt_noise3_ui "" type:#string
label wwmt_noise4_ui_label "Return to start msg, owners" 
editText wwmt_noise4_ui "" type:#string
dropdownlist wwmt_items_ui "Highlight HUD items bitvalue" type:#string items:#("No Highlighting","Blue logo","Red logo","Yellow logo","Green logo")
on wwmt_items_ui selected i do items = propMapitems[i] 
label wwmt_replacement_model_ui_label "Replacement model" 
editText wwmt_replacement_model_ui "" type:#string
spinner wwmt_replacement_model_body_ui "Replacement m" type:#integer range:[-10000,10000,0]
spinner wwmt_replacement_model_skin_ui "Replacement m" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_replacement_model_flags_ui "0 =" type:#string items:#("1 - hide player's weapon model")
on wwmt_replacement_model_flags_ui selected i do replacement_model_flags = propMapreplacement_model_flags[i] 
dropdownlist wwmt_goal_state_ui "Goal Initial State" type:#string items:#("Active","Inactive","Removed")
on wwmt_goal_state_ui selected i do goal_state = propMapgoal_state[i] 
spinner wwmt_search_time_ui "Time between " type:#integer range:[-10000,10000,0]
label wwmt_netname_ui_label "Entity reference name (for logging)" 
editText wwmt_netname_ui "" type:#string
spinner wwmt_goal_no_ui "Goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_group_no_ui "Goal Group #" type:#integer range:[-10000,10000,0]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_mdl_ui_label "Model Path/name.mdl" 
editText wwmt_mdl_ui "" type:#string
spinner wwmt_skin_ui "Model skin-va" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
spinner wwmt_wait_ui "Stay active(s" type:#integer range:[-10000,10000,0]
spinner wwmt_delay_time_ui "Delay before " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
label wwmt_target_ui_label "Target entity with this targetname" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target entity with this targetname" message:"Pick Target Entity for Target entity with this targetname" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_killtarget_ui_label "Remove entity with this targetname" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick Remove entity with this targetname" message:"Pick Target Entity for Remove entity with this targetname" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
label wwmt_noise_ui_label "Play Sound Path/name.wav" 
editText wwmt_noise_ui "" type:#string
spinner wwmt_frags_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_lives_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_health_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_armorvalue_ui "Armor Value  " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
spinner wwmt_a_s_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_n_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_r_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_c_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_ammo_detpack_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_1_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_2_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_invincible_finished_ui "Invincibility" type:#integer range:[-10000,10000,0]
spinner wwmt_invisible_finished_ui "Invisibility " type:#integer range:[-10000,10000,0]
spinner wwmt_super_damage_finished_ui "Quad Duration" type:#integer range:[-10000,10000,0]
spinner wwmt_radsuit_finished_ui "Rad Suit Dura" type:#integer range:[-10000,10000,0]
spinner wwmt_count_ui "Score to AP T" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team_ui "Teamcheck tea" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team1_ui "Blue point ga" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team2_ui "Red point gai" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team3_ui "Yellow point " type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team4_ui "Green point g" type:#integer range:[-10000,10000,0]
spinner wwmt_endround_time_ui "Length of end" type:#integer range:[-10000,10000,0]
label wwmt_endround_owned_by_ui_label "Owners endround message" 
editText wwmt_endround_owned_by_ui "" type:#string
label wwmt_endround_non_owned_by_ui_label "Non-owners endround message" 
editText wwmt_endround_non_owned_by_ui "" type:#string
label wwmt_endround_team1_ui_label "Endround message for team 1" 
editText wwmt_endround_team1_ui "" type:#string
label wwmt_endround_team2_ui_label "Endround message for team 2" 
editText wwmt_endround_team2_ui "" type:#string
label wwmt_endround_team3_ui_label "Endround message for team 3" 
editText wwmt_endround_team3_ui "" type:#string
label wwmt_endround_team4_ui_label "Endround message for team 4" 
editText wwmt_endround_team4_ui "" type:#string
dropdownlist wwmt_owned_by_ui "Owned by-for msg & item glow" type:#string items:#("Not Owned","Blue","Red","Yellow","Green")
on wwmt_owned_by_ui selected i do owned_by = propMapowned_by[i] 
label wwmt_owned_by_teamcheck_ui_label "Owned by teamcheck" 
editText wwmt_owned_by_teamcheck_ui "" type:#string
label wwmt_deathtype_ui_label "Goal death message" 
editText wwmt_deathtype_ui "" type:#string
label wwmt_b_b_ui_label "Message to all" 
editText wwmt_b_b_ui "" type:#string
label wwmt_message_ui_label "Message to AP" 
editText wwmt_message_ui "" type:#string
label wwmt_b_t_ui_label "Message to AP team" 
editText wwmt_b_t_ui "" type:#string
label wwmt_b_n_ui_label "Message to non-AP team" 
editText wwmt_b_n_ui "" type:#string
label wwmt_b_o_ui_label "Message to owner team" 
editText wwmt_b_o_ui "" type:#string
label wwmt_non_owners_team_broadcast_ui_label "Message to non-owner team(s)" 
editText wwmt_non_owners_team_broadcast_ui "" type:#string
label wwmt_n_b_ui_label "Console msg. to all,  percents = AP name" 
editText wwmt_n_b_ui "" type:#string
label wwmt_n_t_ui_label "Console msg to AP team" 
editText wwmt_n_t_ui "" type:#string
label wwmt_n_n_ui_label "Console msg. to non-AP team" 
editText wwmt_n_n_ui "" type:#string
label wwmt_n_o_ui_label "Console msg. to owner team" 
editText wwmt_n_o_ui "" type:#string
label wwmt_speak_ui_label "Speak (global)" 
editText wwmt_speak_ui "" type:#string
label wwmt_ap_speak_ui_label "Speak (AP)" 
editText wwmt_ap_speak_ui "" type:#string
label wwmt_team_speak_ui_label "Speak (AP team)" 
editText wwmt_team_speak_ui "" type:#string
label wwmt_non_team_speak_ui_label "Speak (non-AP team)" 
editText wwmt_non_team_speak_ui "" type:#string
label wwmt_owners_team_speak_ui_label "Speak (owner team)" 
editText wwmt_owners_team_speak_ui "" type:#string
label wwmt_non_owners_team_speak_ui_label "Speak (non-owner teams)" 
editText wwmt_non_owners_team_speak_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=i_t_t&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: i_t_t" address:"https://developer.valvesoftware.com/wiki/i_t_t?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if g_a != undefined AND findItem propMapg_a g_a == 0 then (
 append propMapg_a g_a
tmp = wwmt_g_a_ui.items
 append tmp g_a
wwmt_g_a_ui.items = tmp
wwmt_g_a_ui.selection = propMapg_a.count
) else ( 
 if g_a != undefined then (
wwmt_g_a_ui.selection = (findItem propMapg_a g_a)
)
)
 if g_e != undefined AND findItem propMapg_e g_e == 0 then (
 append propMapg_e g_e
tmp = wwmt_g_e_ui.items
 append tmp g_e
wwmt_g_e_ui.items = tmp
wwmt_g_e_ui.selection = propMapg_e.count
) else ( 
 if g_e != undefined then (
wwmt_g_e_ui.selection = (findItem propMapg_e g_e)
)
)
 if goal_result != undefined AND findItem propMapgoal_result goal_result == 0 then (
 append propMapgoal_result goal_result
tmp = wwmt_goal_result_ui.items
 append tmp goal_result
wwmt_goal_result_ui.items = tmp
wwmt_goal_result_ui.selection = propMapgoal_result.count
) else ( 
 if goal_result != undefined then (
wwmt_goal_result_ui.selection = (findItem propMapgoal_result goal_result)
)
)
 if items != undefined AND findItem propMapitems items == 0 then (
 append propMapitems items
tmp = wwmt_items_ui.items
 append tmp items
wwmt_items_ui.items = tmp
wwmt_items_ui.selection = propMapitems.count
) else ( 
 if items != undefined then (
wwmt_items_ui.selection = (findItem propMapitems items)
)
)
 if replacement_model_flags != undefined AND findItem propMapreplacement_model_flags replacement_model_flags == 0 then (
 append propMapreplacement_model_flags replacement_model_flags
tmp = wwmt_replacement_model_flags_ui.items
 append tmp replacement_model_flags
wwmt_replacement_model_flags_ui.items = tmp
wwmt_replacement_model_flags_ui.selection = propMapreplacement_model_flags.count
) else ( 
 if replacement_model_flags != undefined then (
wwmt_replacement_model_flags_ui.selection = (findItem propMapreplacement_model_flags replacement_model_flags)
)
)
 if goal_state != undefined AND findItem propMapgoal_state goal_state == 0 then (
 append propMapgoal_state goal_state
tmp = wwmt_goal_state_ui.items
 append tmp goal_state
wwmt_goal_state_ui.items = tmp
wwmt_goal_state_ui.selection = propMapgoal_state.count
) else ( 
 if goal_state != undefined then (
wwmt_goal_state_ui.selection = (findItem propMapgoal_state goal_state)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)
 if owned_by != undefined AND findItem propMapowned_by owned_by == 0 then (
 append propMapowned_by owned_by
tmp = wwmt_owned_by_ui.items
 append tmp owned_by
wwmt_owned_by_ui.items = tmp
wwmt_owned_by_ui.selection = propMapowned_by.count
) else ( 
 if owned_by != undefined then (
wwmt_owned_by_ui.selection = (findItem propMapowned_by owned_by)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm__halflife_entities_below__CA = attributes "WW Entity _halflife_entities_below_" version:78 attribID:#(1122246390L,-151516811L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="_halflife_entities_below_"
local hasOutputs = false
local hasInputs = false
local description = "This is not an entity!"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValpreset="0"
local propMappreset=#("0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27")
local exportProps=#()	
function resetExportProps = ( exportProps=#("message","health","preset","volstart","fadein","fadeout","pitch","pitchstart","spinup","spindown","lfotype","lforate","lfomodpitch","lfomodvol","cspinup"))

parameters main rollout:params
(
message type:#string ui:wwmt_message_ui default:""
health type:#integer ui:wwmt_health_ui default:10
preset type:#string ui:wwmt_preset_ui default:"0"
volstart type:#integer ui:wwmt_volstart_ui default:0
fadein type:#integer ui:wwmt_fadein_ui default:0
fadeout type:#integer ui:wwmt_fadeout_ui default:0
pitch type:#float ui:wwmt_pitch_ui default:100
pitchstart type:#integer ui:wwmt_pitchstart_ui default:100
spinup type:#integer ui:wwmt_spinup_ui default:0
spindown type:#integer ui:wwmt_spindown_ui default:0
lfotype type:#integer ui:wwmt_lfotype_ui default:0
lforate type:#integer ui:wwmt_lforate_ui default:0
lfomodpitch type:#integer ui:wwmt_lfomodpitch_ui default:0
lfomodvol type:#integer ui:wwmt_lfomodvol_ui default:0
cspinup type:#integer ui:wwmt_cspinup_ui default:0
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "_halflife_entities_below_"
label wwmt_message_ui_label "WAV Name" 
editText wwmt_message_ui "" type:#string
spinner wwmt_health_ui "Volume (10 = " type:#integer range:[-10000,10000,10]
dropdownlist wwmt_preset_ui "Dynamic Presets" type:#string items:#("None","Huge Machine","Big Machine","Machine","Slow Fade in","Fade in","Quick Fade in","Slow Pulse","Pulse","Quick pulse","Slow Oscillator","Oscillator","Quick Oscillator","Grunge pitch","Very low pitch","Low pitch","High pitch","Very high pitch","Screaming pitch","Oscillate spinup/down","Pulse spinup/down","Random pitch","Random pitch fast","Incremental Spinup","Alien","Bizzare","Planet X","Haunted")
on wwmt_preset_ui selected i do preset = propMappreset[i] 
spinner wwmt_volstart_ui "Start Volume" type:#integer range:[-10000,10000,0]
spinner wwmt_fadein_ui "Fade in time " type:#integer range:[-10000,10000,0]
spinner wwmt_fadeout_ui "Fade out time" type:#integer range:[-10000,10000,0]
spinner wwmt_pitch_ui "Pitch (> 100 " type:#float scale:0.001 range:[-10000.000,10000.000,100]
spinner wwmt_pitchstart_ui "Start Pitch" type:#integer range:[-10000,10000,100]
spinner wwmt_spinup_ui "Spin up time " type:#integer range:[-10000,10000,0]
spinner wwmt_spindown_ui "Spin down tim" type:#integer range:[-10000,10000,0]
spinner wwmt_lfotype_ui "LFO type 0)of" type:#integer range:[-10000,10000,0]
spinner wwmt_lforate_ui "LFO rate (0-1" type:#integer range:[-10000,10000,0]
spinner wwmt_lfomodpitch_ui "LFO mod pitch" type:#integer range:[-10000,10000,0]
spinner wwmt_lfomodvol_ui "LFO mod vol (" type:#integer range:[-10000,10000,0]
spinner wwmt_cspinup_ui "Incremental s" type:#integer range:[-10000,10000,0]

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Play Everywhere" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Small Radius" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Medium Radius" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Large Radius" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Start Silent" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Is NOT Looped" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=_halflife_entities_below_&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: _halflife_entities_below_" address:"https://developer.valvesoftware.com/wiki/_halflife_entities_below_?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if preset != undefined AND findItem propMappreset preset == 0 then (
 append propMappreset preset
tmp = wwmt_preset_ui.items
 append tmp preset
wwmt_preset_ui.items = tmp
wwmt_preset_ui.selection = propMappreset.count
) else ( 
 if preset != undefined then (
wwmt_preset_ui.selection = (findItem propMappreset preset)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_cycler_CA = attributes "WW Entity cycler" version:78 attribID:#(-372661583L,-1273339045L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="cycler"
local hasOutputs = false
local hasInputs = false
local description = "Model Cycler"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 

fn target_wwmt_filter obj = (
if (isProperty obj "wallworm" == true AND   (isProperty obj "wwmt_ca" == true OR isProperty obj "wallwormProxy" == true )) then  (true) else ( false))
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local exportProps=#()	
function resetExportProps = ( exportProps=#("model","renderfx","rendermode","renderamt","rendercolor","targetname","angles","avelocity"))

parameters main rollout:params
(
model type:#string ui:wwmt_model_ui default:""
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
avelocity type:#string ui:wwmt_avelocity_ui default:""

)

rollout params "Entity Properties"
(
label entityLabel "cycler"
label wwmt_model_ui_label "Model" 
editText wwmt_model_ui "" type:#string
pickbutton wwmt_model_pickwwmt_ui "wwmt" align:#left across:3 message:"Pick WWMT or Proxy from scene Model" filter:target_wwmt_filter tooltip:"Create a proxy from a model in the scene."
on wwmt_model_pickwwmt_ui picked obj do (
  local wwmt = obj.getWWMT() ; if wwmt != undefined AND (getNode())!= undefined  then (
  wwmt.updateObjectAsProxy thisNode useRotation:false
  )     
) 
button wwmt_model_importwmt_ui "import" tooltip:"Import a QC and create a proxy."  
on wwmt_model_importwmt_ui pressed  do with undo label:"Import QC" on  (

 global wallworm_import_qc_from_filename
 if wallworm_import_qc_from_filename == undefined then (fileIn (::wallworm_installation_path+"/WallWorm.com/importers/Mario_Kart_SMD_Importer.ms"))  local fsource = GetOpenFileName historyCategory:"Wall Worm SMD Exporter" types: "QC File (*.qc)|*.QC|All files (*.*)|*.*|" 
 if fsource != undefined AND wallworm_import_qc_from_filename != undefined then (   wwmt = wallworm_import_qc_from_filename fsource saveToLib:true noVMF:true  skipLODS:true  deepSearchMaterials:false 
 if wwmt != undefined then (
  if  (getNode())!= undefined  then (
  wwmt.updateObjectAsProxy thisNode
  )       
)  )  
) 
button wwmt_model_libwmt_ui "library"  tooltip:"Use a prop in the prop library. Right-click to load the mesh rotated 90 degrees."
on wwmt_model_libwmt_ui pressed  do with undo label:"Load From Model Library" on (
 loadMeshFromLibrary doRotate:false  ) 
on wwmt_model_libwmt_ui rightClick  do with undo label:"Load From Model Library" on  (
 loadMeshFromLibrary doRotate:true  ) 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
label wwmt_avelocity_ui_label "Angular Velocity (PYR)" 
editText wwmt_avelocity_ui "" type:#string
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=cycler&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: cycler" address:"https://developer.valvesoftware.com/wiki/cycler?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_cycler_sprite_CA = attributes "WW Entity cycler_sprite" version:78 attribID:#(802606826L,-266448266L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="cycler_sprite"
local hasOutputs = false
local hasInputs = false
local description = "Sprite Cycler"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 

fn target_wwmt_filter obj = (
if (isProperty obj "wallworm" == true AND   (isProperty obj "wwmt_ca" == true OR isProperty obj "wallwormProxy" == true )) then  (true) else ( false))
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("model","framerate","targetname","angles","rendermode","renderamt","rendercolor","renderfx"))

parameters main rollout:params
(
model type:#string ui:wwmt_model_ui default:""
framerate type:#integer ui:wwmt_framerate_ui default:10
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"

)

rollout params "Entity Properties"
(
label entityLabel "cycler_sprite"
label wwmt_model_ui_label "Sprite" 
editText wwmt_model_ui "" type:#string
pickbutton wwmt_model_pickwwmt_ui "wwmt" align:#left across:3 message:"Pick WWMT or Proxy from scene Sprite" filter:target_wwmt_filter tooltip:"Create a proxy from a model in the scene."
on wwmt_model_pickwwmt_ui picked obj do (
  local wwmt = obj.getWWMT() ; if wwmt != undefined AND (getNode())!= undefined  then (
  wwmt.updateObjectAsProxy thisNode useRotation:false
  )     
) 
button wwmt_model_importwmt_ui "import" tooltip:"Import a QC and create a proxy."  
on wwmt_model_importwmt_ui pressed  do with undo label:"Import QC" on  (

 global wallworm_import_qc_from_filename
 if wallworm_import_qc_from_filename == undefined then (fileIn (::wallworm_installation_path+"/WallWorm.com/importers/Mario_Kart_SMD_Importer.ms"))  local fsource = GetOpenFileName historyCategory:"Wall Worm SMD Exporter" types: "QC File (*.qc)|*.QC|All files (*.*)|*.*|" 
 if fsource != undefined AND wallworm_import_qc_from_filename != undefined then (   wwmt = wallworm_import_qc_from_filename fsource saveToLib:true noVMF:true  skipLODS:true  deepSearchMaterials:false 
 if wwmt != undefined then (
  if  (getNode())!= undefined  then (
  wwmt.updateObjectAsProxy thisNode
  )       
)  )  
) 
button wwmt_model_libwmt_ui "library"  tooltip:"Use a prop in the prop library. Right-click to load the mesh rotated 90 degrees."
on wwmt_model_libwmt_ui pressed  do with undo label:"Load From Model Library" on (
 loadMeshFromLibrary doRotate:false  ) 
on wwmt_model_libwmt_ui rightClick  do with undo label:"Load From Model Library" on  (
 loadMeshFromLibrary doRotate:true  ) 
spinner wwmt_framerate_ui "Frames per se" type:#integer range:[-10000,10000,10]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=cycler_sprite&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: cycler_sprite" address:"https://developer.valvesoftware.com/wiki/cycler_sprite?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_beam_CA = attributes "WW Entity env_beam" version:78 attribID:#(654729850L,1051108103L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_beam"
local hasOutputs = false
local hasInputs = false
local description = "Energy Beam Effect"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("lightningstart","lightningend","renderamt","rendercolor","radius","life","boltwidth","noiseamplitude","texture","texturescroll","framerate","framestart","striketime","damage","targetname","renderfx"))

parameters main rollout:params
(
lightningstart type:#string ui:wwmt_lightningstart_ui default:""
lightningend type:#string ui:wwmt_lightningend_ui default:""
renderamt type:#integer ui:wwmt_renderamt_ui default:100
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
radius type:#integer ui:wwmt_radius_ui default:256
life type:#string ui:wwmt_life_ui default:"1"
boltwidth type:#integer ui:wwmt_boltwidth_ui default:20
noiseamplitude type:#integer ui:wwmt_noiseamplitude_ui default:0
texture type:#string ui:wwmt_texture_ui default:"sprites/laserbeam.spr"
texturescroll type:#integer ui:wwmt_texturescroll_ui default:35
framerate type:#integer ui:wwmt_framerate_ui default:0
framestart type:#integer ui:wwmt_framestart_ui default:0
striketime type:#string ui:wwmt_striketime_ui default:"1"
damage type:#string ui:wwmt_damage_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "env_beam"
label wwmt_lightningstart_ui_label "Start Entity" 
editText wwmt_lightningstart_ui "" type:#string
pickbutton wwmt_lightningstart_pickme_ui "Pick Start Entity" message:"Pick Target Entity for Start Entity" filter:target_name_filter 
on wwmt_lightningstart_pickme_ui picked obj do (
lightningstart = obj.targetname
) 
label wwmt_lightningend_ui_label "Ending Entity" 
editText wwmt_lightningend_ui "" type:#string
pickbutton wwmt_lightningend_pickme_ui "Pick Ending Entity" message:"Pick Target Entity for Ending Entity" filter:target_name_filter 
on wwmt_lightningend_pickme_ui picked obj do (
lightningend = obj.targetname
) 
spinner wwmt_renderamt_ui "Brightness (1" type:#integer range:[-10000,10000,100]
colorPicker wwmt_rendercolor_ui "Beam Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "Beam Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for Beam Color (R G B)"
spinner wwmt_radius_ui "Radius" type:#integer range:[-10000,10000,256]
label wwmt_life_ui_label "Life (seconds 0 = infinite)" 
editText wwmt_life_ui "" type:#string
spinner wwmt_boltwidth_ui "Width of beam" type:#integer range:[-10000,10000,20]
spinner wwmt_noiseamplitude_ui "Amount of noi" type:#integer range:[-10000,10000,0]
label wwmt_texture_ui_label "Sprite Name" 
editText wwmt_texture_ui "" type:#string
spinner wwmt_texturescroll_ui "Texture Scrol" type:#integer range:[-10000,10000,35]
spinner wwmt_framerate_ui "Frames per 10" type:#integer range:[-10000,10000,0]
spinner wwmt_framestart_ui "Starting Fram" type:#integer range:[-10000,10000,0]
label wwmt_striketime_ui_label "Strike again time (secs)" 
editText wwmt_striketime_ui "" type:#string
label wwmt_damage_ui_label "Damage / second" 
editText wwmt_damage_ui "" type:#string
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Start On" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Toggle" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Random Strike" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Ring" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "StartSparks" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "EndSparks" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Decal End" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "Shade Start" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Shade End" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_beam&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_beam" address:"https://developer.valvesoftware.com/wiki/env_beam?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_beverage_CA = attributes "WW Entity env_beverage" version:78 attribID:#(-292239031L,461097402L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_beverage"
local hasOutputs = false
local hasInputs = false
local description = "Beverage Dispenser"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValskin="0"
local propMapskin=#("0","1","2","3","4","5","6")
local exportProps=#()	
function resetExportProps = ( exportProps=#("health","skin","targetname","angles"))

parameters main rollout:params
(
health type:#integer ui:wwmt_health_ui default:10
skin type:#string ui:wwmt_skin_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"

		on skin set val do (
			getNode()
			if ::WallWormHelperOps != undefined then ::WallWormHelperOps.setProxySkin thisNode val
		)

)

rollout params "Entity Properties"
(
label entityLabel "env_beverage"
spinner wwmt_health_ui "Capacity" type:#integer range:[-10000,10000,10]
dropdownlist wwmt_skin_ui "Beverage Type" type:#string items:#("Coca-Cola","Sprite","Diet Coke","Orange","Surge","Moxie","Random")
on wwmt_skin_ui selected i do skin = propMapskin[i] 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_beverage&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_beverage" address:"https://developer.valvesoftware.com/wiki/env_beverage?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if skin != undefined AND findItem propMapskin skin == 0 then (
 append propMapskin skin
tmp = wwmt_skin_ui.items
 append tmp skin
wwmt_skin_ui.items = tmp
wwmt_skin_ui.selection = propMapskin.count
) else ( 
 if skin != undefined then (
wwmt_skin_ui.selection = (findItem propMapskin skin)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_blood_CA = attributes "WW Entity env_blood" version:78 attribID:#(654729850L,1776460938L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_blood"
local hasOutputs = false
local hasInputs = false
local description = "Blood Effects"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 255.0 0.0 0.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValcolor="0"
local propMapcolor=#("0","1")
local exportProps=#()	
function resetExportProps = ( exportProps=#("wwmt_color","amount","targetname","angles"))

parameters main rollout:params
(
wwmt_color type:#string ui:wwmt_color_ui default:"0"
amount type:#string ui:wwmt_amount_ui default:"100"
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "env_blood"
dropdownlist wwmt_color_ui "Blood Color" type:#string items:#("Red (Human)","Yellow (Alien)")
on wwmt_color_ui selected i do wwmt_color = propMapcolor[i] 
label wwmt_amount_ui_label "Amount of blood (damage to simulate)" 
editText wwmt_amount_ui "" type:#string
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Random Direction" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Blood Stream" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "On Player" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Spray decals" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_blood&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_blood" address:"https://developer.valvesoftware.com/wiki/env_blood?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if wwmt_color != undefined AND findItem propMapcolor wwmt_color == 0 then (
 append propMapcolor wwmt_color
tmp = wwmt_color_ui.items
 append tmp wwmt_color
wwmt_color_ui.items = tmp
wwmt_color_ui.selection = propMapcolor.count
) else ( 
 if wwmt_color != undefined then (
wwmt_color_ui.selection = (findItem propMapcolor wwmt_color)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_explosion_CA = attributes "WW Entity env_explosion" version:78 attribID:#(467275855L,-793244314L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_explosion"
local hasOutputs = false
local hasInputs = false
local description = "Explosion"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local exportProps=#()	
function resetExportProps = ( exportProps=#("imagnitude","targetname"))

parameters main rollout:params
(
imagnitude type:#string ui:wwmt_imagnitude_ui default:"100"
targetname type:#string ui:wwmt_targetname_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "env_explosion"
label wwmt_imagnitude_ui_label "Magnitude" 
editText wwmt_imagnitude_ui "" type:#string
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "No Damage" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Repeatable" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "No Fireball" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "No Smoke" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "No Decal" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "No Sparks" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_explosion&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_explosion" address:"https://developer.valvesoftware.com/wiki/env_explosion?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_global_CA = attributes "WW Entity env_global" version:78 attribID:#(842275029L,-367571522L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_global"
local hasOutputs = false
local hasInputs = false
local description = "Global State"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 255.0 255.0 128.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValtriggermode="0"
local propMaptriggermode=#("0","1","2","3")
local propValinitialstate="0"
local propMapinitialstate=#("0","1","2")
local exportProps=#()	
function resetExportProps = ( exportProps=#("globalstate","triggermode","initialstate","targetname"))

parameters main rollout:params
(
globalstate type:#string ui:wwmt_globalstate_ui default:""
triggermode type:#string ui:wwmt_triggermode_ui default:"0"
initialstate type:#string ui:wwmt_initialstate_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "env_global"
label wwmt_globalstate_ui_label "Global State to Set" 
editText wwmt_globalstate_ui "" type:#string
dropdownlist wwmt_triggermode_ui "Trigger Mode" type:#string items:#("Off","On","Dead","Toggle")
on wwmt_triggermode_ui selected i do triggermode = propMaptriggermode[i] 
dropdownlist wwmt_initialstate_ui "Initial State" type:#string items:#("Off","On","Dead")
on wwmt_initialstate_ui selected i do initialstate = propMapinitialstate[i] 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Set Initial State" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_global&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_global" address:"https://developer.valvesoftware.com/wiki/env_global?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if triggermode != undefined AND findItem propMaptriggermode triggermode == 0 then (
 append propMaptriggermode triggermode
tmp = wwmt_triggermode_ui.items
 append tmp triggermode
wwmt_triggermode_ui.items = tmp
wwmt_triggermode_ui.selection = propMaptriggermode.count
) else ( 
 if triggermode != undefined then (
wwmt_triggermode_ui.selection = (findItem propMaptriggermode triggermode)
)
)
 if initialstate != undefined AND findItem propMapinitialstate initialstate == 0 then (
 append propMapinitialstate initialstate
tmp = wwmt_initialstate_ui.items
 append tmp initialstate
wwmt_initialstate_ui.items = tmp
wwmt_initialstate_ui.selection = propMapinitialstate.count
) else ( 
 if initialstate != undefined then (
wwmt_initialstate_ui.selection = (findItem propMapinitialstate initialstate)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_glow_CA = attributes "WW Entity env_glow" version:78 attribID:#(654729850L,520215747L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_glow"
local hasOutputs = false
local hasInputs = false
local description = "Light Glow/Haze"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 30.0 100.0 0.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 

fn target_wwmt_filter obj = (
if (isProperty obj "wallworm" == true AND   (isProperty obj "wwmt_ca" == true OR isProperty obj "wallwormProxy" == true )) then  (true) else ( false))
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("model","wwmt_scale","targetname","rendermode","renderamt","rendercolor","renderfx"))

parameters main rollout:params
(
model type:#string ui:wwmt_model_ui default:"sprites/glow01.spr"
wwmt_scale type:#integer ui:wwmt_scale_ui default:1
targetname type:#string ui:wwmt_targetname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"

)

rollout params "Entity Properties"
(
label entityLabel "env_glow"
label wwmt_model_ui_label "Sprite Name" 
editText wwmt_model_ui "" type:#string
pickbutton wwmt_model_pickwwmt_ui "wwmt" align:#left across:3 message:"Pick WWMT or Proxy from scene Sprite Name" filter:target_wwmt_filter tooltip:"Create a proxy from a model in the scene."
on wwmt_model_pickwwmt_ui picked obj do (
  local wwmt = obj.getWWMT() ; if wwmt != undefined AND (getNode())!= undefined  then (
  wwmt.updateObjectAsProxy thisNode useRotation:false
  )     
) 
button wwmt_model_importwmt_ui "import" tooltip:"Import a QC and create a proxy."  
on wwmt_model_importwmt_ui pressed  do with undo label:"Import QC" on  (

 global wallworm_import_qc_from_filename
 if wallworm_import_qc_from_filename == undefined then (fileIn (::wallworm_installation_path+"/WallWorm.com/importers/Mario_Kart_SMD_Importer.ms"))  local fsource = GetOpenFileName historyCategory:"Wall Worm SMD Exporter" types: "QC File (*.qc)|*.QC|All files (*.*)|*.*|" 
 if fsource != undefined AND wallworm_import_qc_from_filename != undefined then (   wwmt = wallworm_import_qc_from_filename fsource saveToLib:true noVMF:true  skipLODS:true  deepSearchMaterials:false 
 if wwmt != undefined then (
  if  (getNode())!= undefined  then (
  wwmt.updateObjectAsProxy thisNode
  )       
)  )  
) 
button wwmt_model_libwmt_ui "library"  tooltip:"Use a prop in the prop library. Right-click to load the mesh rotated 90 degrees."
on wwmt_model_libwmt_ui pressed  do with undo label:"Load From Model Library" on (
 loadMeshFromLibrary doRotate:false  ) 
on wwmt_model_libwmt_ui rightClick  do with undo label:"Load From Model Library" on  (
 loadMeshFromLibrary doRotate:true  ) 
spinner wwmt_scale_ui "Scale" type:#integer range:[-10000,10000,1]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_glow&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_glow" address:"https://developer.valvesoftware.com/wiki/env_glow?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_fade_CA = attributes "WW Entity env_fade" version:78 attribID:#(654729850L,-1966748596L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_fade"
local hasOutputs = false
local hasInputs = false
local description = "Screen Fade"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local exportProps=#()	
function resetExportProps = ( exportProps=#("duration","holdtime","renderamt","rendercolor","targetname"))

parameters main rollout:params
(
duration type:#string ui:wwmt_duration_ui default:"2"
holdtime type:#string ui:wwmt_holdtime_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
targetname type:#string ui:wwmt_targetname_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "env_fade"
label wwmt_duration_ui_label "Duration (seconds)" 
editText wwmt_duration_ui "" type:#string
label wwmt_holdtime_ui_label "Hold Fade (seconds)" 
editText wwmt_holdtime_ui "" type:#string
spinner wwmt_renderamt_ui "Fade Alpha" type:#integer range:[-10000,10000,255]
colorPicker wwmt_rendercolor_ui "Fade Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "Fade Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for Fade Color (R G B)"
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Fade From" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Modulate" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Activator Only" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_fade&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_fade" address:"https://developer.valvesoftware.com/wiki/env_fade?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_funnel_CA = attributes "WW Entity env_funnel" version:78 attribID:#(842275028L,1460644568L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_funnel"
local hasOutputs = false
local hasInputs = false
local description = "Large Portal Funnel"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local exportProps=#()	
function resetExportProps = ( exportProps=#("targetname"))

parameters main rollout:params
(
targetname type:#string ui:wwmt_targetname_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "env_funnel"
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Reverse" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_funnel&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_funnel" address:"https://developer.valvesoftware.com/wiki/env_funnel?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_laser_CA = attributes "WW Entity env_laser" version:78 attribID:#(654729850L,-1779195987L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_laser"
local hasOutputs = false
local hasInputs = false
local description = "Laser Beam Effect"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("lasertarget","renderamt","rendercolor","width","noiseamplitude","texture","endsprite","texturescroll","framestart","damage","targetname","renderfx","angles"))

parameters main rollout:params
(
lasertarget type:#string ui:wwmt_lasertarget_ui default:""
renderamt type:#integer ui:wwmt_renderamt_ui default:100
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
width type:#integer ui:wwmt_width_ui default:20
noiseamplitude type:#integer ui:wwmt_noiseamplitude_ui default:0
texture type:#string ui:wwmt_texture_ui default:"sprites/laserbeam.spr"
endsprite type:#string ui:wwmt_endsprite_ui default:""
texturescroll type:#integer ui:wwmt_texturescroll_ui default:35
framestart type:#integer ui:wwmt_framestart_ui default:0
damage type:#string ui:wwmt_damage_ui default:"100"
targetname type:#string ui:wwmt_targetname_ui default:""
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "env_laser"
label wwmt_lasertarget_ui_label "Target of Laser" 
editText wwmt_lasertarget_ui "" type:#string
pickbutton wwmt_lasertarget_pickme_ui "Pick Target of Laser" message:"Pick Target Entity for Target of Laser" filter:target_name_filter 
on wwmt_lasertarget_pickme_ui picked obj do (
lasertarget = obj.targetname
) 
spinner wwmt_renderamt_ui "Brightness (1" type:#integer range:[-10000,10000,100]
colorPicker wwmt_rendercolor_ui "Beam Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "Beam Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for Beam Color (R G B)"
spinner wwmt_width_ui "Width of beam" type:#integer range:[-10000,10000,20]
spinner wwmt_noiseamplitude_ui "Amount of noi" type:#integer range:[-10000,10000,0]
label wwmt_texture_ui_label "Sprite Name" 
editText wwmt_texture_ui "" type:#string
label wwmt_endsprite_ui_label "End Sprite" 
editText wwmt_endsprite_ui "" type:#string
spinner wwmt_texturescroll_ui "Texture Scrol" type:#integer range:[-10000,10000,35]
spinner wwmt_framestart_ui "Starting Fram" type:#integer range:[-10000,10000,0]
label wwmt_damage_ui_label "Damage / second" 
editText wwmt_damage_ui "" type:#string
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Start On" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "StartSparks" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "EndSparks" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Decal End" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_laser&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_laser" address:"https://developer.valvesoftware.com/wiki/env_laser?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_message_CA = attributes "WW Entity env_message" version:78 attribID:#(842275039L,1110997934L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_message"
local hasOutputs = false
local hasInputs = false
local description = "HUD Text Message"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValmessageattenuation="0"
local propMapmessageattenuation=#("0","1","2","3")
local exportProps=#()	
function resetExportProps = ( exportProps=#("message","messagesound","messagevolume","messageattenuation","targetname","wwmt_target"))

parameters main rollout:params
(
message type:#string ui:wwmt_message_ui default:""
messagesound type:#string ui:wwmt_messagesound_ui default:""
messagevolume type:#string ui:wwmt_messagevolume_ui default:"10"
messageattenuation type:#string ui:wwmt_messageattenuation_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "env_message"
label wwmt_message_ui_label "Message Name" 
editText wwmt_message_ui "" type:#string
label wwmt_messagesound_ui_label "Sound Effect" 
editText wwmt_messagesound_ui "" type:#string
label wwmt_messagevolume_ui_label "Volume 0-10" 
editText wwmt_messagevolume_ui "" type:#string
dropdownlist wwmt_messageattenuation_ui "Sound Radius" type:#string items:#("Small Radius","Medium Radius","Large Radius","Play Everywhere")
on wwmt_messageattenuation_ui selected i do messageattenuation = propMapmessageattenuation[i] 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Play Once" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "All Clients" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_message&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_message" address:"https://developer.valvesoftware.com/wiki/env_message?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if messageattenuation != undefined AND findItem propMapmessageattenuation messageattenuation == 0 then (
 append propMapmessageattenuation messageattenuation
tmp = wwmt_messageattenuation_ui.items
 append tmp messageattenuation
wwmt_messageattenuation_ui.items = tmp
wwmt_messageattenuation_ui.selection = propMapmessageattenuation.count
) else ( 
 if messageattenuation != undefined then (
wwmt_messageattenuation_ui.selection = (findItem propMapmessageattenuation messageattenuation)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_render_CA = attributes "WW Entity env_render" version:78 attribID:#(842275016L,1460626972L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_render"
local hasOutputs = false
local hasInputs = false
local description = "Render Controls"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 100.0 100.0 0.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("targetname","wwmt_target","rendermode","renderamt","rendercolor","renderfx"))

parameters main rollout:params
(
targetname type:#string ui:wwmt_targetname_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "env_render"
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "No Renderfx" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "No Renderamt" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "No Rendermode" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "No Rendercolor" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_render&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_render" address:"https://developer.valvesoftware.com/wiki/env_render?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_shake_CA = attributes "WW Entity env_shake" version:78 attribID:#(654729850L,371760912L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_shake"
local hasOutputs = false
local hasInputs = false
local description = "Screen Shake"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local exportProps=#()	
function resetExportProps = ( exportProps=#("amplitude","radius","duration","frequency","targetname"))

parameters main rollout:params
(
amplitude type:#string ui:wwmt_amplitude_ui default:"4"
radius type:#string ui:wwmt_radius_ui default:"500"
duration type:#string ui:wwmt_duration_ui default:"1"
frequency type:#string ui:wwmt_frequency_ui default:"2.5"
targetname type:#string ui:wwmt_targetname_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "env_shake"
label wwmt_amplitude_ui_label "Amplitude 0-16" 
editText wwmt_amplitude_ui "" type:#string
label wwmt_radius_ui_label "Effect radius" 
editText wwmt_radius_ui "" type:#string
label wwmt_duration_ui_label "Duration (seconds)" 
editText wwmt_duration_ui "" type:#string
label wwmt_frequency_ui_label "0.1 = jerk, 255.0 = rumble" 
editText wwmt_frequency_ui "" type:#string
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Global Shake" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_shake&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_shake" address:"https://developer.valvesoftware.com/wiki/env_shake?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_shooter_CA = attributes "WW Entity env_shooter" version:78 attribID:#(842275017L,1993223203L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_shooter"
local hasOutputs = false
local hasInputs = false
local description = "Model Shooter"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValshootsounds="-1"
local propMapshootsounds=#("-1","0","1","2","3","4")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("shootmodel","shootsounds","wwmt_scale","skin","targetname","angles","m_igibs","delay","m_flvelocity","m_flvariance","m_flgiblife","rendermode","renderamt","rendercolor","renderfx"))

parameters main rollout:params
(
shootmodel type:#string ui:wwmt_shootmodel_ui default:""
shootsounds type:#string ui:wwmt_shootsounds_ui default:"-1"
wwmt_scale type:#string ui:wwmt_scale_ui default:""
skin type:#integer ui:wwmt_skin_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
m_igibs type:#integer ui:wwmt_m_igibs_ui default:3
delay type:#string ui:wwmt_delay_ui default:"0"
m_flvelocity type:#integer ui:wwmt_m_flvelocity_ui default:200
m_flvariance type:#string ui:wwmt_m_flvariance_ui default:"0.15"
m_flgiblife type:#string ui:wwmt_m_flgiblife_ui default:"4"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
spawnflags type:#integer default:0

		on skin set val do (
			getNode()
			if ::WallWormHelperOps != undefined then ::WallWormHelperOps.setProxySkin thisNode val
		)

)

rollout params "Entity Properties"
(
label entityLabel "env_shooter"
label wwmt_shootmodel_ui_label "Model or Sprite name" 
editText wwmt_shootmodel_ui "" type:#string
dropdownlist wwmt_shootsounds_ui "Material Sound" type:#string items:#("None","Glass","Wood","Metal","Flesh","Concrete")
on wwmt_shootsounds_ui selected i do shootsounds = propMapshootsounds[i] 
label wwmt_scale_ui_label "Gib Sprite Scale" 
editText wwmt_scale_ui "" type:#string
spinner wwmt_skin_ui "Gib Skin" type:#integer range:[-10000,10000,0]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
spinner wwmt_m_igibs_ui "Number of Gib" type:#integer range:[-10000,10000,3]
label wwmt_delay_ui_label "Delay between shots" 
editText wwmt_delay_ui "" type:#string
spinner wwmt_m_flvelocity_ui "Gib Velocity" type:#integer range:[-10000,10000,200]
label wwmt_m_flvariance_ui_label "Course Variance" 
editText wwmt_m_flvariance_ui "" type:#string
label wwmt_m_flgiblife_ui_label "Gib Life" 
editText wwmt_m_flgiblife_ui "" type:#string
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Repeatable" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_shooter&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_shooter" address:"https://developer.valvesoftware.com/wiki/env_shooter?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if shootsounds != undefined AND findItem propMapshootsounds shootsounds == 0 then (
 append propMapshootsounds shootsounds
tmp = wwmt_shootsounds_ui.items
 append tmp shootsounds
wwmt_shootsounds_ui.items = tmp
wwmt_shootsounds_ui.selection = propMapshootsounds.count
) else ( 
 if shootsounds != undefined then (
wwmt_shootsounds_ui.selection = (findItem propMapshootsounds shootsounds)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_sound_CA = attributes "WW Entity env_sound" version:78 attribID:#(654729850L,1554762651L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_sound"
local hasOutputs = false
local hasInputs = false
local description = "DSP Sound"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local iconsprite="sprites/speaker.spr"

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValroomtype="0"
local propMaproomtype=#("0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28")
local exportProps=#()	
function resetExportProps = ( exportProps=#("radius","roomtype"))

parameters main rollout:params
(
radius type:#integer ui:wwmt_radius_ui default:128
roomtype type:#string ui:wwmt_roomtype_ui default:"0"

)

rollout params "Entity Properties"
(
label entityLabel "env_sound"
spinner wwmt_radius_ui "Radius" type:#integer range:[-10000,10000,128]
dropdownlist wwmt_roomtype_ui "Room Type" type:#string items:#("Normal (off)","Generic","Metal Small","Metal Medium","Metal Large","Tunnel Small","Tunnel Medium","Tunnel Large","Chamber Small","Chamber Medium","Chamber Large","Bright Small","Bright Medium","Bright Large","Water 1","Water 2","Water 3","Concrete Small","Concrete Medium","Concrete Large","Big 1","Big 2","Big 3","Cavern Small","Cavern Medium","Cavern Large","Weirdo 1","Weirdo 2","Weirdo 3")
on wwmt_roomtype_ui selected i do roomtype = propMaproomtype[i] 
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_sound&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_sound" address:"https://developer.valvesoftware.com/wiki/env_sound?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if roomtype != undefined AND findItem propMaproomtype roomtype == 0 then (
 append propMaproomtype roomtype
tmp = wwmt_roomtype_ui.items
 append tmp roomtype
wwmt_roomtype_ui.items = tmp
wwmt_roomtype_ui.selection = propMaproomtype.count
) else ( 
 if roomtype != undefined then (
wwmt_roomtype_ui.selection = (findItem propMaproomtype roomtype)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_spark_CA = attributes "WW Entity env_spark" version:78 attribID:#(654729850L,-871592065L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_spark"
local hasOutputs = false
local hasInputs = false
local description = "Spark"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local exportProps=#()	
function resetExportProps = ( exportProps=#("maxdelay","targetname","angles"))

parameters main rollout:params
(
maxdelay type:#string ui:wwmt_maxdelay_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "env_spark"
label wwmt_maxdelay_ui_label "Max Delay" 
editText wwmt_maxdelay_ui "" type:#string
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)

function addFlags = (
 local sfs = 0

if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_32_ui "Toggle" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Start ON" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_spark&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_spark" address:"https://developer.valvesoftware.com/wiki/env_spark?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_sprite_CA = attributes "WW Entity env_sprite" version:78 attribID:#(842275017L,1494405608L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_sprite"
local hasOutputs = false
local hasInputs = false
local description = "Sprite Effect"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 

fn target_wwmt_filter obj = (
if (isProperty obj "wallworm" == true AND   (isProperty obj "wwmt_ca" == true OR isProperty obj "wallwormProxy" == true )) then  (true) else ( false))
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("framerate","model","wwmt_scale","angles","targetname","rendermode","renderamt","rendercolor","renderfx"))

parameters main rollout:params
(
framerate type:#string ui:wwmt_framerate_ui default:"10.0"
model type:#string ui:wwmt_model_ui default:"sprites/glow01.spr"
wwmt_scale type:#string ui:wwmt_scale_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
targetname type:#string ui:wwmt_targetname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "env_sprite"
label wwmt_framerate_ui_label "Framerate" 
editText wwmt_framerate_ui "" type:#string
label wwmt_model_ui_label "Sprite Name" 
editText wwmt_model_ui "" type:#string
pickbutton wwmt_model_pickwwmt_ui "wwmt" align:#left across:3 message:"Pick WWMT or Proxy from scene Sprite Name" filter:target_wwmt_filter tooltip:"Create a proxy from a model in the scene."
on wwmt_model_pickwwmt_ui picked obj do (
  local wwmt = obj.getWWMT() ; if wwmt != undefined AND (getNode())!= undefined  then (
  wwmt.updateObjectAsProxy thisNode useRotation:false
  )     
) 
button wwmt_model_importwmt_ui "import" tooltip:"Import a QC and create a proxy."  
on wwmt_model_importwmt_ui pressed  do with undo label:"Import QC" on  (

 global wallworm_import_qc_from_filename
 if wallworm_import_qc_from_filename == undefined then (fileIn (::wallworm_installation_path+"/WallWorm.com/importers/Mario_Kart_SMD_Importer.ms"))  local fsource = GetOpenFileName historyCategory:"Wall Worm SMD Exporter" types: "QC File (*.qc)|*.QC|All files (*.*)|*.*|" 
 if fsource != undefined AND wallworm_import_qc_from_filename != undefined then (   wwmt = wallworm_import_qc_from_filename fsource saveToLib:true noVMF:true  skipLODS:true  deepSearchMaterials:false 
 if wwmt != undefined then (
  if  (getNode())!= undefined  then (
  wwmt.updateObjectAsProxy thisNode
  )       
)  )  
) 
button wwmt_model_libwmt_ui "library"  tooltip:"Use a prop in the prop library. Right-click to load the mesh rotated 90 degrees."
on wwmt_model_libwmt_ui pressed  do with undo label:"Load From Model Library" on (
 loadMeshFromLibrary doRotate:false  ) 
on wwmt_model_libwmt_ui rightClick  do with undo label:"Load From Model Library" on  (
 loadMeshFromLibrary doRotate:true  ) 
label wwmt_scale_ui_label "Scale" 
editText wwmt_scale_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Start ON" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Play Once" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_sprite&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_sprite" address:"https://developer.valvesoftware.com/wiki/env_sprite?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_gibshooter_CA = attributes "WW Entity gibshooter" version:78 attribID:#(-555789597L,1601805079L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="gibshooter"
local hasOutputs = false
local hasInputs = false
local description = "Gib Shooter"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local exportProps=#()	
function resetExportProps = ( exportProps=#("targetname","angles","m_igibs","delay","m_flvelocity","m_flvariance","m_flgiblife"))

parameters main rollout:params
(
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
m_igibs type:#integer ui:wwmt_m_igibs_ui default:3
delay type:#string ui:wwmt_delay_ui default:"0"
m_flvelocity type:#integer ui:wwmt_m_flvelocity_ui default:200
m_flvariance type:#string ui:wwmt_m_flvariance_ui default:"0.15"
m_flgiblife type:#string ui:wwmt_m_flgiblife_ui default:"4"
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "gibshooter"
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
spinner wwmt_m_igibs_ui "Number of Gib" type:#integer range:[-10000,10000,3]
label wwmt_delay_ui_label "Delay between shots" 
editText wwmt_delay_ui "" type:#string
spinner wwmt_m_flvelocity_ui "Gib Velocity" type:#integer range:[-10000,10000,200]
label wwmt_m_flvariance_ui_label "Course Variance" 
editText wwmt_m_flvariance_ui "" type:#string
label wwmt_m_flgiblife_ui_label "Gib Life" 
editText wwmt_m_flgiblife_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Repeatable" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=gibshooter&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: gibshooter" address:"https://developer.valvesoftware.com/wiki/gibshooter?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_info_intermission_CA = attributes "WW Entity info_intermission" version:78 attribID:#(-435141320L,-945586621L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="info_intermission"
local hasOutputs = false
local hasInputs = false
local description = "Intermission Spot"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 0.0 255.0 0.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValstyle="0"
local propMapstyle=#("0","10","2","11","5","1","6","3","7","8","4","9")
local exportProps=#()	
function resetExportProps = ( exportProps=#("_light","style","pattern","wwmt_target","angles","avelocity"))

parameters main rollout:params
(
_light type:#color ui:wwmt__light_ui default:( color 255 255 128 200 )
_light_intensity type:#integer ui:wwmt__light_inensity_ui default:200
style type:#string ui:wwmt_style_ui default:"0"
pattern type:#string ui:wwmt_pattern_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
avelocity type:#string ui:wwmt_avelocity_ui default:""

		on _light set val do (
if (val != undefined  ) AND (getNode()) != undefined AND (isProperty thisNode #color) then (
		
 thisNode.color = _light  		
)
)

							on _light_intensity set val do (
								if (val != undefined) AND (isValidNode thisNode) AND (isProperty thisNode #multiplier) then (
									if ::WallWormHelperOps != undefined then ::WallWormHelperOps.setLightMultiplier thisNode val
								)
							)

)

rollout params "Entity Properties"
(
label entityLabel "info_intermission"
colorPicker wwmt__light_ui "Brightness" color:( color 255 255 128 200 )
spinner wwmt__light_inensity_ui "Brightness Intensity"  type:#integer range:[-16000,16000,200] tooltip:"Intensity for Brightness"
dropdownlist wwmt_style_ui "Appearance" type:#string items:#("Normal","Fluorescent flicker","Slow, strong pulse","Slow pulse, noblack","Gentle pulse","Flicker A","Flicker B","Candle A","Candle B","Candle C","Fast strobe","Slow strobe")
on wwmt_style_ui selected i do style = propMapstyle[i] 
label wwmt_pattern_ui_label "Custom Appearance" 
editText wwmt_pattern_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
label wwmt_avelocity_ui_label "Angular Velocity (PYR)" 
editText wwmt_avelocity_ui "" type:#string
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=info_intermission&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: info_intermission" address:"https://developer.valvesoftware.com/wiki/info_intermission?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if style != undefined AND findItem propMapstyle style == 0 then (
 append propMapstyle style
tmp = wwmt_style_ui.items
 append tmp style
wwmt_style_ui.items = tmp
wwmt_style_ui.selection = propMapstyle.count
) else ( 
 if style != undefined then (
wwmt_style_ui.selection = (findItem propMapstyle style)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_light_spot_CA = attributes "WW Entity light_spot" version:78 attribID:#(109618542L,163636283L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="light_spot"
local hasOutputs = false
local hasInputs = false
local description = "Spotlight"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local iconsprite="sprites/lightbulb.spr"

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propVal_sky="0"
local propMap_sky=#("0","1")
local propValstyle="0"
local propMapstyle=#("0","10","2","11","5","1","6","3","7","8","4","9")
local exportProps=#()	
function resetExportProps = ( exportProps=#("_cone","_cone2","pitch","_light","_sky","style","pattern","targetname","wwmt_target","angles"))

parameters main rollout:params
(
_cone type:#integer ui:wwmt__cone_ui default:30
_cone2 type:#integer ui:wwmt__cone2_ui default:45
pitch type:#float ui:wwmt_pitch_ui default:-90
_light type:#color ui:wwmt__light_ui default:( color 255 255 128 200 )
_light_intensity type:#integer ui:wwmt__light_inensity_ui default:200
_sky type:#string ui:wwmt__sky_ui default:"0"
style type:#string ui:wwmt_style_ui default:"0"
pattern type:#string ui:wwmt_pattern_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"

		on _cone set val do (
if (val != undefined AND val as integer != undefined  ) AND (getNode()) != undefined AND (isProperty thisNode #falloff) then (
		
 thisNode.falloff = (_cone as integer) * 2  		
)
)

		on _light set val do (
if (val != undefined  ) AND (getNode()) != undefined AND (isProperty thisNode #color) then (
		
 thisNode.color = _light  		
)
)

							on _light_intensity set val do (
								if (val != undefined) AND (isValidNode thisNode) AND (isProperty thisNode #multiplier) then (
									if ::WallWormHelperOps != undefined then ::WallWormHelperOps.setLightMultiplier thisNode val
								)
							)

)

rollout params "Entity Properties"
(
label entityLabel "light_spot"
spinner wwmt__cone_ui "Inner (bright" type:#integer range:[-10000,10000,30]
spinner wwmt__cone2_ui "Outer (fading" type:#integer range:[-10000,10000,45]
colorPicker wwmt__light_ui "Brightness" color:( color 255 255 128 200 )
spinner wwmt__light_inensity_ui "Brightness Intensity"  type:#integer range:[-16000,16000,200] tooltip:"Intensity for Brightness"
dropdownlist wwmt__sky_ui "Is Sky" type:#string items:#("No","Yes")
on wwmt__sky_ui selected i do _sky = propMap_sky[i] 
dropdownlist wwmt_style_ui "Appearance" type:#string items:#("Normal","Fluorescent flicker","Slow, strong pulse","Slow pulse, noblack","Gentle pulse","Flicker A","Flicker B","Candle A","Candle B","Candle C","Fast strobe","Slow strobe")
on wwmt_style_ui selected i do style = propMapstyle[i] 
label wwmt_pattern_ui_label "Custom Appearance" 
editText wwmt_pattern_ui "" type:#string
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		Spinner wwmt_pitch_ui "Pitch" type:#float range:[-90,90,0] tooltip:"The angle from the horizon. -90 is straight down, 90 is straight up and 0 is at the horizon."

		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=light_spot&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: light_spot" address:"https://developer.valvesoftware.com/wiki/light_spot?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if _sky != undefined AND findItem propMap_sky _sky == 0 then (
 append propMap_sky _sky
tmp = wwmt__sky_ui.items
 append tmp _sky
wwmt__sky_ui.items = tmp
wwmt__sky_ui.selection = propMap_sky.count
) else ( 
 if _sky != undefined then (
wwmt__sky_ui.selection = (findItem propMap_sky _sky)
)
)
 if style != undefined AND findItem propMapstyle style == 0 then (
 append propMapstyle style
tmp = wwmt_style_ui.items
 append tmp style
wwmt_style_ui.items = tmp
wwmt_style_ui.selection = propMapstyle.count
) else ( 
 if style != undefined then (
wwmt_style_ui.selection = (findItem propMapstyle style)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_light_environment_CA = attributes "WW Entity light_environment" version:78 attribID:#(1044210184L,-888099970L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="light_environment"
local hasOutputs = false
local hasInputs = false
local description = "Environmental Light"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local iconsprite="sprites/lightbulb.spr"

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local exportProps=#()	
function resetExportProps = ( exportProps=#("pitch","_light","angles"))

parameters main rollout:params
(
pitch type:#float ui:wwmt_pitch_ui default:0
_light type:#color ui:wwmt__light_ui default:( color 255 255 128 200 )
_light_intensity type:#integer ui:wwmt__light_inensity_ui default:200
angles type:#string ui:wwmt_angles_ui default:"0 0 0"

		on _light set val do (
if (val != undefined  ) AND (getNode()) != undefined AND (isProperty thisNode #color) then (
		
 thisNode.color = _light  		
)
)

							on _light_intensity set val do (
								if (val != undefined) AND (isValidNode thisNode) AND (isProperty thisNode #multiplier) then (
									if ::WallWormHelperOps != undefined then ::WallWormHelperOps.setLightMultiplier thisNode val
								)
							)

)

rollout params "Entity Properties"
(
label entityLabel "light_environment"
colorPicker wwmt__light_ui "Brightness" color:( color 255 255 128 200 )
spinner wwmt__light_inensity_ui "Brightness Intensity"  type:#integer range:[-16000,16000,200] tooltip:"Intensity for Brightness"
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		Spinner wwmt_pitch_ui "Pitch" type:#float range:[-90,90,0] tooltip:"The angle from the horizon. -90 is straight down, 90 is straight up and 0 is at the horizon."

		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=light_environment&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: light_environment" address:"https://developer.valvesoftware.com/wiki/light_environment?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_monster_miniturret_CA = attributes "WW Entity monster_miniturret" version:78 attribID:#(-912208356L,1802003486L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="monster_miniturret"
local hasOutputs = false
local hasInputs = false
local description = "Mini Auto Turret"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 0.0 200.0 200.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValorientation="0"
local propMaporientation=#("0","1")
local propValg_a="0"
local propMapg_a=#("4")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValtriggercondition="0"
local propMaptriggercondition=#("0","1","2","3","4","7","8","9","10","11")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("orientation","g_a","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","triggertarget","triggercondition","wwmt_target","targetname","angles","rendermode","renderamt","rendercolor","renderfx"))

parameters main rollout:params
(
orientation type:#string ui:wwmt_orientation_ui default:"0"
g_a type:#string ui:wwmt_g_a_ui default:"0"
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
triggertarget type:#string ui:wwmt_triggertarget_ui default:""
triggercondition type:#string ui:wwmt_triggercondition_ui default:"0"
wwmt_target type:#string ui:wwmt_target_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "monster_miniturret"
dropdownlist wwmt_orientation_ui "Orientation" type:#string items:#("Floor Mount","Ceiling Mount")
on wwmt_orientation_ui selected i do orientation = propMaporientation[i] 
dropdownlist wwmt_g_a_ui "Goal Activation bitfields" type:#string items:#("4 - if AP fails criteria")
on wwmt_g_a_ui selected i do g_a = propMapg_a[i] 
dropdownlist wwmt_team_no_ui "Team to shoot at" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class to shoot at" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
label wwmt_triggertarget_ui_label "AI Trigger Target" 
editText wwmt_triggertarget_ui "" type:#string
dropdownlist wwmt_triggercondition_ui "AI Trigger Condition" type:#string items:#("No Trigger","See Player, Mad at Player","Take Damage","50% Health Remaining","Death","Hear World","Hear Player","Hear Combat","See Player Unconditional","See Player, Not In Combat")
on wwmt_triggercondition_ui selected i do triggercondition = propMaptriggercondition[i] 
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 

function addFlags = (
 local sfs = 0

if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_32_ui "Autostart" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Start Inactive" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=monster_miniturret&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: monster_miniturret" address:"https://developer.valvesoftware.com/wiki/monster_miniturret?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if orientation != undefined AND findItem propMaporientation orientation == 0 then (
 append propMaporientation orientation
tmp = wwmt_orientation_ui.items
 append tmp orientation
wwmt_orientation_ui.items = tmp
wwmt_orientation_ui.selection = propMaporientation.count
) else ( 
 if orientation != undefined then (
wwmt_orientation_ui.selection = (findItem propMaporientation orientation)
)
)
 if g_a != undefined AND findItem propMapg_a g_a == 0 then (
 append propMapg_a g_a
tmp = wwmt_g_a_ui.items
 append tmp g_a
wwmt_g_a_ui.items = tmp
wwmt_g_a_ui.selection = propMapg_a.count
) else ( 
 if g_a != undefined then (
wwmt_g_a_ui.selection = (findItem propMapg_a g_a)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if triggercondition != undefined AND findItem propMaptriggercondition triggercondition == 0 then (
 append propMaptriggercondition triggercondition
tmp = wwmt_triggercondition_ui.items
 append tmp triggercondition
wwmt_triggercondition_ui.items = tmp
wwmt_triggercondition_ui.selection = propMaptriggercondition.count
) else ( 
 if triggercondition != undefined then (
wwmt_triggercondition_ui.selection = (findItem propMaptriggercondition triggercondition)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_monster_turret_CA = attributes "WW Entity monster_turret" version:78 attribID:#(-1140133236L,232946791L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="monster_turret"
local hasOutputs = false
local hasInputs = false
local description = "Auto Turret"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 0.0 200.0 200.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValorientation="0"
local propMaporientation=#("0","1")
local propValg_a="0"
local propMapg_a=#("4")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValtriggercondition="0"
local propMaptriggercondition=#("0","1","2","3","4","7","8","9","10","11")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("orientation","g_a","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","triggertarget","triggercondition","wwmt_target","targetname","angles","rendermode","renderamt","rendercolor","renderfx"))

parameters main rollout:params
(
orientation type:#string ui:wwmt_orientation_ui default:"0"
g_a type:#string ui:wwmt_g_a_ui default:"0"
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
triggertarget type:#string ui:wwmt_triggertarget_ui default:""
triggercondition type:#string ui:wwmt_triggercondition_ui default:"0"
wwmt_target type:#string ui:wwmt_target_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "monster_turret"
dropdownlist wwmt_orientation_ui "Orientation" type:#string items:#("Floor Mount","Ceiling Mount")
on wwmt_orientation_ui selected i do orientation = propMaporientation[i] 
dropdownlist wwmt_g_a_ui "Goal Activation bitfields" type:#string items:#("4 - if AP fails criteria")
on wwmt_g_a_ui selected i do g_a = propMapg_a[i] 
dropdownlist wwmt_team_no_ui "Team to shoot at" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class to shoot at" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
label wwmt_triggertarget_ui_label "AI Trigger Target" 
editText wwmt_triggertarget_ui "" type:#string
dropdownlist wwmt_triggercondition_ui "AI Trigger Condition" type:#string items:#("No Trigger","See Player, Mad at Player","Take Damage","50% Health Remaining","Death","Hear World","Hear Player","Hear Combat","See Player Unconditional","See Player, Not In Combat")
on wwmt_triggercondition_ui selected i do triggercondition = propMaptriggercondition[i] 
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 

function addFlags = (
 local sfs = 0

if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_32_ui "Autostart" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Start Inactive" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=monster_turret&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: monster_turret" address:"https://developer.valvesoftware.com/wiki/monster_turret?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if orientation != undefined AND findItem propMaporientation orientation == 0 then (
 append propMaporientation orientation
tmp = wwmt_orientation_ui.items
 append tmp orientation
wwmt_orientation_ui.items = tmp
wwmt_orientation_ui.selection = propMaporientation.count
) else ( 
 if orientation != undefined then (
wwmt_orientation_ui.selection = (findItem propMaporientation orientation)
)
)
 if g_a != undefined AND findItem propMapg_a g_a == 0 then (
 append propMapg_a g_a
tmp = wwmt_g_a_ui.items
 append tmp g_a
wwmt_g_a_ui.items = tmp
wwmt_g_a_ui.selection = propMapg_a.count
) else ( 
 if g_a != undefined then (
wwmt_g_a_ui.selection = (findItem propMapg_a g_a)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if triggercondition != undefined AND findItem propMaptriggercondition triggercondition == 0 then (
 append propMaptriggercondition triggercondition
tmp = wwmt_triggercondition_ui.items
 append tmp triggercondition
wwmt_triggercondition_ui.items = tmp
wwmt_triggercondition_ui.selection = propMaptriggercondition.count
) else ( 
 if triggercondition != undefined then (
wwmt_triggercondition_ui.selection = (findItem propMaptriggercondition triggercondition)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_monster_sentry_CA = attributes "WW Entity monster_sentry" version:78 attribID:#(-1140133236L,493345348L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="monster_sentry"
local hasOutputs = false
local hasInputs = false
local description = "Sentry Turret Gun"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 0.0 200.0 200.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValg_a="0"
local propMapg_a=#("4")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValtriggercondition="0"
local propMaptriggercondition=#("0","1","2","3","4","7","8","9","10","11")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("g_a","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","triggertarget","triggercondition","wwmt_target","targetname","angles","rendermode","renderamt","rendercolor","renderfx"))

parameters main rollout:params
(
g_a type:#string ui:wwmt_g_a_ui default:"0"
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
triggertarget type:#string ui:wwmt_triggertarget_ui default:""
triggercondition type:#string ui:wwmt_triggercondition_ui default:"0"
wwmt_target type:#string ui:wwmt_target_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "monster_sentry"
dropdownlist wwmt_g_a_ui "Goal Activation bitfields" type:#string items:#("4 - if AP fails criteria")
on wwmt_g_a_ui selected i do g_a = propMapg_a[i] 
dropdownlist wwmt_team_no_ui "Team to shoot at" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class to shoot at" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
label wwmt_triggertarget_ui_label "AI Trigger Target" 
editText wwmt_triggertarget_ui "" type:#string
dropdownlist wwmt_triggercondition_ui "AI Trigger Condition" type:#string items:#("No Trigger","See Player, Mad at Player","Take Damage","50% Health Remaining","Death","Hear World","Hear Player","Hear Combat","See Player Unconditional","See Player, Not In Combat")
on wwmt_triggercondition_ui selected i do triggercondition = propMaptriggercondition[i] 
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Multithreaded" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Autostart" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Start Inactive" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=monster_sentry&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: monster_sentry" address:"https://developer.valvesoftware.com/wiki/monster_sentry?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if g_a != undefined AND findItem propMapg_a g_a == 0 then (
 append propMapg_a g_a
tmp = wwmt_g_a_ui.items
 append tmp g_a
wwmt_g_a_ui.items = tmp
wwmt_g_a_ui.selection = propMapg_a.count
) else ( 
 if g_a != undefined then (
wwmt_g_a_ui.selection = (findItem propMapg_a g_a)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if triggercondition != undefined AND findItem propMaptriggercondition triggercondition == 0 then (
 append propMaptriggercondition triggercondition
tmp = wwmt_triggercondition_ui.items
 append tmp triggercondition
wwmt_triggercondition_ui.items = tmp
wwmt_triggercondition_ui.selection = propMaptriggercondition.count
) else ( 
 if triggercondition != undefined then (
wwmt_triggercondition_ui.selection = (findItem propMaptriggercondition triggercondition)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_multisource_CA = attributes "WW Entity multisource" version:78 attribID:#(-1295099135L,-83792495L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="multisource"
local hasOutputs = false
local hasInputs = false
local description = "Multisource"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 128.0 255.0 128.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local exportProps=#()	
function resetExportProps = ( exportProps=#("globalstate","targetname","wwmt_target"))

parameters main rollout:params
(
globalstate type:#string ui:wwmt_globalstate_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""

)

rollout params "Entity Properties"
(
label entityLabel "multisource"
label wwmt_globalstate_ui_label "Global State Master" 
editText wwmt_globalstate_ui "" type:#string
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=multisource&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: multisource" address:"https://developer.valvesoftware.com/wiki/multisource?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_path_corner_CA = attributes "WW Entity path_corner" version:78 attribID:#(-1732129830L,272163135L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="path_corner"
local hasOutputs = false
local hasInputs = false
local description = "Moving platform stop"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 247.0 181.0 82.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local exportProps=#()	
function resetExportProps = ( exportProps=#("wwmt_target","message","wait","speed","yaw_speed","targetname","angles"))

parameters main rollout:params
(
wwmt_target type:#string ui:wwmt_target_ui default:""
message type:#string ui:wwmt_message_ui default:""
wait type:#integer ui:wwmt_wait_ui default:0
speed type:#integer ui:wwmt_speed_ui default:0
yaw_speed type:#integer ui:wwmt_yaw_speed_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "path_corner"
label wwmt_target_ui_label "Next stop target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Next stop target" message:"Pick Target Entity for Next stop target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_message_ui_label "Fire On Pass" 
editText wwmt_message_ui "" type:#string
pickbutton wwmt_message_pickme_ui "Pick Fire On Pass" message:"Pick Target Entity for Fire On Pass" filter:target_name_filter 
on wwmt_message_pickme_ui picked obj do (
message = obj.targetname
) 
spinner wwmt_wait_ui "Wait here (se" type:#integer range:[-10000,10000,0]
spinner wwmt_speed_ui "New Train Spe" type:#integer range:[-10000,10000,0]
spinner wwmt_yaw_speed_ui "New Train Rot" type:#integer range:[-10000,10000,0]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Wait for retrigger" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Teleport" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Fire once" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=path_corner&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: path_corner" address:"https://developer.valvesoftware.com/wiki/path_corner?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_path_track_CA = attributes "WW Entity path_track" version:78 attribID:#(-1732129830L,-1946943073L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="path_track"
local hasOutputs = false
local hasInputs = false
local description = "Train Track Path"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local exportProps=#()	
function resetExportProps = ( exportProps=#("wwmt_target","message","altpath","netname","speed","targetname","angles"))

parameters main rollout:params
(
wwmt_target type:#string ui:wwmt_target_ui default:""
message type:#string ui:wwmt_message_ui default:""
altpath type:#string ui:wwmt_altpath_ui default:""
netname type:#string ui:wwmt_netname_ui default:""
speed type:#integer ui:wwmt_speed_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "path_track"
label wwmt_target_ui_label "Next stop target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Next stop target" message:"Pick Target Entity for Next stop target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_message_ui_label "Fire On Pass" 
editText wwmt_message_ui "" type:#string
pickbutton wwmt_message_pickme_ui "Pick Fire On Pass" message:"Pick Target Entity for Fire On Pass" filter:target_name_filter 
on wwmt_message_pickme_ui picked obj do (
message = obj.targetname
) 
label wwmt_altpath_ui_label "Branch Path" 
editText wwmt_altpath_ui "" type:#string
pickbutton wwmt_altpath_pickme_ui "Pick Branch Path" message:"Pick Target Entity for Branch Path" filter:target_name_filter 
on wwmt_altpath_pickme_ui picked obj do (
altpath = obj.targetname
) 
label wwmt_netname_ui_label "Fire on dead end" 
editText wwmt_netname_ui "" type:#string
pickbutton wwmt_netname_pickme_ui "Pick Fire on dead end" message:"Pick Target Entity for Fire on dead end" filter:target_name_filter 
on wwmt_netname_pickme_ui picked obj do (
netname = obj.targetname
) 
spinner wwmt_speed_ui "New Train Spe" type:#integer range:[-10000,10000,0]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Disabled" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Fire once" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Branch Reverse" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Disable train" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=path_track&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: path_track" address:"https://developer.valvesoftware.com/wiki/path_track?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_player_weaponstrip_CA = attributes "WW Entity player_weaponstrip" version:78 attribID:#(-1861946124L,-619340136L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="player_weaponstrip"
local hasOutputs = false
local hasInputs = false
local description = "Strips player's weapons"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValhealth="-1"
local propMaphealth=#("-1","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30")
local exportProps=#()	
function resetExportProps = ( exportProps=#("health","radius","targetname"))

parameters main rollout:params
(
health type:#string ui:wwmt_health_ui default:"-1"
radius type:#string ui:wwmt_radius_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""

)

rollout params "Entity Properties"
(
label entityLabel "player_weaponstrip"
dropdownlist wwmt_health_ui "Track #" type:#string items:#("Stop","Track 1","Track 2","Track 3","Track 4","Track 5","Track 6","Track 7","Track 8","Track 9","Track 10","Track 11","Track 12","Track 13","Track 14","Track 15","Track 16","Track 17","Track 18","Track 19","Track 20","Track 21","Track 22","Track 23","Track 24","Track 25","Track 26","Track 27","Track 28","Track 29","Track 30")
on wwmt_health_ui selected i do health = propMaphealth[i] 
label wwmt_radius_ui_label "Player Radius" 
editText wwmt_radius_ui "" type:#string
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=player_weaponstrip&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: player_weaponstrip" address:"https://developer.valvesoftware.com/wiki/player_weaponstrip?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if health != undefined AND findItem propMaphealth health == 0 then (
 append propMaphealth health
tmp = wwmt_health_ui.items
 append tmp health
wwmt_health_ui.items = tmp
wwmt_health_ui.selection = propMaphealth.count
) else ( 
 if health != undefined then (
wwmt_health_ui.selection = (findItem propMaphealth health)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_trigger_auto_CA = attributes "WW Entity trigger_auto" version:78 attribID:#(-1618386072L,2134089762L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_auto"
local hasOutputs = false
local hasInputs = false
local description = "AutoTrigger"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValtriggerstate="0"
local propMaptriggerstate=#("0","1","2")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("globalstate","triggerstate","wwmt_target","delay","killtarget","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","frags","lives","health","armorvalue","armorclass","a_s","a_n","a_r","a_c","ammo_detpack","no_grenades_1","no_grenades_2","invincible_finished","invisible_finished","super_damage_finished","radsuit_finished","count","increase_team","increase_team1","increase_team2","increase_team3","increase_team4"))

parameters main rollout:params
(
globalstate type:#string ui:wwmt_globalstate_ui default:""
triggerstate type:#string ui:wwmt_triggerstate_ui default:"0"
wwmt_target type:#string ui:wwmt_target_ui default:""
delay type:#string ui:wwmt_delay_ui default:"0"
killtarget type:#string ui:wwmt_killtarget_ui default:""
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
frags type:#integer ui:wwmt_frags_ui
lives type:#integer ui:wwmt_lives_ui
health type:#integer ui:wwmt_health_ui
armorvalue type:#integer ui:wwmt_armorvalue_ui
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
a_s type:#integer ui:wwmt_a_s_ui
a_n type:#integer ui:wwmt_a_n_ui
a_r type:#integer ui:wwmt_a_r_ui
a_c type:#integer ui:wwmt_a_c_ui
ammo_detpack type:#integer ui:wwmt_ammo_detpack_ui
no_grenades_1 type:#integer ui:wwmt_no_grenades_1_ui
no_grenades_2 type:#integer ui:wwmt_no_grenades_2_ui
invincible_finished type:#integer ui:wwmt_invincible_finished_ui
invisible_finished type:#integer ui:wwmt_invisible_finished_ui
super_damage_finished type:#integer ui:wwmt_super_damage_finished_ui
radsuit_finished type:#integer ui:wwmt_radsuit_finished_ui
count type:#integer ui:wwmt_count_ui
increase_team type:#integer ui:wwmt_increase_team_ui
increase_team1 type:#integer ui:wwmt_increase_team1_ui
increase_team2 type:#integer ui:wwmt_increase_team2_ui
increase_team3 type:#integer ui:wwmt_increase_team3_ui
increase_team4 type:#integer ui:wwmt_increase_team4_ui
spawnflags type:#integer default:1

)

rollout params "Entity Properties"
(
label entityLabel "trigger_auto"
label wwmt_globalstate_ui_label "Global State to Read" 
editText wwmt_globalstate_ui "" type:#string
dropdownlist wwmt_triggerstate_ui "Trigger State" type:#string items:#("Off","On","Toggle")
on wwmt_triggerstate_ui selected i do triggerstate = propMaptriggerstate[i] 
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_delay_ui_label "Delay before trigger" 
editText wwmt_delay_ui "" type:#string
label wwmt_killtarget_ui_label "KillTarget" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
spinner wwmt_frags_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_lives_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_health_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_armorvalue_ui "Armor Value  " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
spinner wwmt_a_s_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_n_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_r_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_c_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_ammo_detpack_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_1_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_2_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_invincible_finished_ui "Invincibility" type:#integer range:[-10000,10000,0]
spinner wwmt_invisible_finished_ui "Invisibility " type:#integer range:[-10000,10000,0]
spinner wwmt_super_damage_finished_ui "Quad Duration" type:#integer range:[-10000,10000,0]
spinner wwmt_radsuit_finished_ui "Rad Suit Dura" type:#integer range:[-10000,10000,0]
spinner wwmt_count_ui "Score to AP T" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team_ui "Teamcheck tea" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team1_ui "Blue point ga" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team2_ui "Red point gai" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team3_ui "Yellow point " type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team4_ui "Green point g" type:#integer range:[-10000,10000,0]

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Remove On fire" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_auto&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_auto" address:"https://developer.valvesoftware.com/wiki/trigger_auto?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if triggerstate != undefined AND findItem propMaptriggerstate triggerstate == 0 then (
 append propMaptriggerstate triggerstate
tmp = wwmt_triggerstate_ui.items
 append tmp triggerstate
wwmt_triggerstate_ui.items = tmp
wwmt_triggerstate_ui.selection = propMaptriggerstate.count
) else ( 
 if triggerstate != undefined then (
wwmt_triggerstate_ui.selection = (findItem propMaptriggerstate triggerstate)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_trigger_camera_CA = attributes "WW Entity trigger_camera" version:78 attribID:#(276153110L,1743274620L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_camera"
local hasOutputs = false
local hasInputs = false
local description = "Trigger Camera"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local exportProps=#()	
function resetExportProps = ( exportProps=#("wait","moveto","speed","acceleration","deceleration","wwmt_target","delay","killtarget","targetname","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed"))

parameters main rollout:params
(
wait type:#integer ui:wwmt_wait_ui default:10
moveto type:#string ui:wwmt_moveto_ui default:""
speed type:#string ui:wwmt_speed_ui default:"0"
acceleration type:#string ui:wwmt_acceleration_ui default:"500"
deceleration type:#string ui:wwmt_deceleration_ui default:"500"
wwmt_target type:#string ui:wwmt_target_ui default:""
delay type:#string ui:wwmt_delay_ui default:"0"
killtarget type:#string ui:wwmt_killtarget_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
spawnflags type:#integer default:3

)

rollout params "Entity Properties"
(
label entityLabel "trigger_camera"
spinner wwmt_wait_ui "Hold time" type:#integer range:[-10000,10000,10]
label wwmt_moveto_ui_label "Path Corner" 
editText wwmt_moveto_ui "" type:#string
label wwmt_speed_ui_label "Initial Speed" 
editText wwmt_speed_ui "" type:#string
label wwmt_acceleration_ui_label "Acceleration units/sec^2" 
editText wwmt_acceleration_ui "" type:#string
label wwmt_deceleration_ui_label "Stop Deceleration units/sec^2" 
editText wwmt_deceleration_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_delay_ui_label "Delay before trigger" 
editText wwmt_delay_ui "" type:#string
label wwmt_killtarget_ui_label "KillTarget" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Start At Player" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Follow Player" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Freeze Player" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_camera&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_camera" address:"https://developer.valvesoftware.com/wiki/trigger_camera?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_trigger_changetarget_CA = attributes "WW Entity trigger_changetarget" version:78 attribID:#(-1701943912L,279935596L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_changetarget"
local hasOutputs = false
local hasInputs = false
local description = "Trigger Change Target"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("m_isznewtarget","wwmt_target","delay","killtarget","targetname","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","frags","lives","health","armorvalue","armorclass","a_s","a_n","a_r","a_c","ammo_detpack","no_grenades_1","no_grenades_2","invincible_finished","invisible_finished","super_damage_finished","radsuit_finished","count","increase_team","increase_team1","increase_team2","increase_team3","increase_team4"))

parameters main rollout:params
(
m_isznewtarget type:#string ui:wwmt_m_isznewtarget_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
delay type:#string ui:wwmt_delay_ui default:"0"
killtarget type:#string ui:wwmt_killtarget_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
frags type:#integer ui:wwmt_frags_ui
lives type:#integer ui:wwmt_lives_ui
health type:#integer ui:wwmt_health_ui
armorvalue type:#integer ui:wwmt_armorvalue_ui
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
a_s type:#integer ui:wwmt_a_s_ui
a_n type:#integer ui:wwmt_a_n_ui
a_r type:#integer ui:wwmt_a_r_ui
a_c type:#integer ui:wwmt_a_c_ui
ammo_detpack type:#integer ui:wwmt_ammo_detpack_ui
no_grenades_1 type:#integer ui:wwmt_no_grenades_1_ui
no_grenades_2 type:#integer ui:wwmt_no_grenades_2_ui
invincible_finished type:#integer ui:wwmt_invincible_finished_ui
invisible_finished type:#integer ui:wwmt_invisible_finished_ui
super_damage_finished type:#integer ui:wwmt_super_damage_finished_ui
radsuit_finished type:#integer ui:wwmt_radsuit_finished_ui
count type:#integer ui:wwmt_count_ui
increase_team type:#integer ui:wwmt_increase_team_ui
increase_team1 type:#integer ui:wwmt_increase_team1_ui
increase_team2 type:#integer ui:wwmt_increase_team2_ui
increase_team3 type:#integer ui:wwmt_increase_team3_ui
increase_team4 type:#integer ui:wwmt_increase_team4_ui

)

rollout params "Entity Properties"
(
label entityLabel "trigger_changetarget"
label wwmt_m_isznewtarget_ui_label "New Target" 
editText wwmt_m_isznewtarget_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_delay_ui_label "Delay before trigger" 
editText wwmt_delay_ui "" type:#string
label wwmt_killtarget_ui_label "KillTarget" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
spinner wwmt_frags_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_lives_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_health_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_armorvalue_ui "Armor Value  " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
spinner wwmt_a_s_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_n_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_r_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_c_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_ammo_detpack_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_1_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_2_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_invincible_finished_ui "Invincibility" type:#integer range:[-10000,10000,0]
spinner wwmt_invisible_finished_ui "Invisibility " type:#integer range:[-10000,10000,0]
spinner wwmt_super_damage_finished_ui "Quad Duration" type:#integer range:[-10000,10000,0]
spinner wwmt_radsuit_finished_ui "Rad Suit Dura" type:#integer range:[-10000,10000,0]
spinner wwmt_count_ui "Score to AP T" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team_ui "Teamcheck tea" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team1_ui "Blue point ga" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team2_ui "Red point gai" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team3_ui "Yellow point " type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team4_ui "Green point g" type:#integer range:[-10000,10000,0]
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_changetarget&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_changetarget" address:"https://developer.valvesoftware.com/wiki/trigger_changetarget?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_trigger_relay_CA = attributes "WW Entity trigger_relay" version:78 attribID:#(-1618386072L,-1852055962L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_relay"
local hasOutputs = false
local hasInputs = false
local description = "Trigger Relay"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValtriggerstate="0"
local propMaptriggerstate=#("0","1","2")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("triggerstate","wwmt_target","targetname","delay","killtarget","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","frags","lives","health","armorvalue","armorclass","a_s","a_n","a_r","a_c","ammo_detpack","no_grenades_1","no_grenades_2","invincible_finished","invisible_finished","super_damage_finished","radsuit_finished","count","increase_team","increase_team1","increase_team2","increase_team3","increase_team4"))

parameters main rollout:params
(
triggerstate type:#string ui:wwmt_triggerstate_ui default:"0"
wwmt_target type:#string ui:wwmt_target_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
delay type:#string ui:wwmt_delay_ui default:"0"
killtarget type:#string ui:wwmt_killtarget_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
frags type:#integer ui:wwmt_frags_ui
lives type:#integer ui:wwmt_lives_ui
health type:#integer ui:wwmt_health_ui
armorvalue type:#integer ui:wwmt_armorvalue_ui
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
a_s type:#integer ui:wwmt_a_s_ui
a_n type:#integer ui:wwmt_a_n_ui
a_r type:#integer ui:wwmt_a_r_ui
a_c type:#integer ui:wwmt_a_c_ui
ammo_detpack type:#integer ui:wwmt_ammo_detpack_ui
no_grenades_1 type:#integer ui:wwmt_no_grenades_1_ui
no_grenades_2 type:#integer ui:wwmt_no_grenades_2_ui
invincible_finished type:#integer ui:wwmt_invincible_finished_ui
invisible_finished type:#integer ui:wwmt_invisible_finished_ui
super_damage_finished type:#integer ui:wwmt_super_damage_finished_ui
radsuit_finished type:#integer ui:wwmt_radsuit_finished_ui
count type:#integer ui:wwmt_count_ui
increase_team type:#integer ui:wwmt_increase_team_ui
increase_team1 type:#integer ui:wwmt_increase_team1_ui
increase_team2 type:#integer ui:wwmt_increase_team2_ui
increase_team3 type:#integer ui:wwmt_increase_team3_ui
increase_team4 type:#integer ui:wwmt_increase_team4_ui
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "trigger_relay"
dropdownlist wwmt_triggerstate_ui "Trigger State" type:#string items:#("Off","On","Toggle")
on wwmt_triggerstate_ui selected i do triggerstate = propMaptriggerstate[i] 
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_delay_ui_label "Delay before trigger" 
editText wwmt_delay_ui "" type:#string
label wwmt_killtarget_ui_label "KillTarget" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
spinner wwmt_frags_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_lives_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_health_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_armorvalue_ui "Armor Value  " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
spinner wwmt_a_s_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_n_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_r_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_c_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_ammo_detpack_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_1_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_2_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_invincible_finished_ui "Invincibility" type:#integer range:[-10000,10000,0]
spinner wwmt_invisible_finished_ui "Invisibility " type:#integer range:[-10000,10000,0]
spinner wwmt_super_damage_finished_ui "Quad Duration" type:#integer range:[-10000,10000,0]
spinner wwmt_radsuit_finished_ui "Rad Suit Dura" type:#integer range:[-10000,10000,0]
spinner wwmt_count_ui "Score to AP T" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team_ui "Teamcheck tea" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team1_ui "Blue point ga" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team2_ui "Red point gai" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team3_ui "Yellow point " type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team4_ui "Green point g" type:#integer range:[-10000,10000,0]

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Remove On fire" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_relay&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_relay" address:"https://developer.valvesoftware.com/wiki/trigger_relay?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if triggerstate != undefined AND findItem propMaptriggerstate triggerstate == 0 then (
 append propMaptriggerstate triggerstate
tmp = wwmt_triggerstate_ui.items
 append tmp triggerstate
wwmt_triggerstate_ui.items = tmp
wwmt_triggerstate_ui.selection = propMaptriggerstate.count
) else ( 
 if triggerstate != undefined then (
wwmt_triggerstate_ui.selection = (findItem propMaptriggerstate triggerstate)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_xen_tree_CA = attributes "WW Entity xen_tree" version:78 attribID:#(600769998L,-971704210L)
(
local wallworm=true
local entityType="PointClass"
local isWWPRO = false
local thisNode = undefined
local entname="xen_tree"
local hasOutputs = false
local hasInputs = false
local description = "Xen Tree"
local wallworm_classes = #{1,2}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
 
function deleteProxyCA = (
if isProperty thisNode "WWMTProxy" then (
 setUserProp thisNode "wwmt_proxie_source" undefined 
local c = custAttributes.count thisNode
if c > 0 then (
for i = c to 1 by -1 do (
def = custAttributes.getDef thisNode  i 
if   def.name  == "WWMTProxy"  then (
custAttributes.delete thisNode i
)
)
)
)
)
 function updateMeshFromObj newProp deleteAfter:true doRotate:false = (
 newProp.transform = thisNode.transform
local wwmtR = getUserProp newProp "wwmt_rotateRefsystem"
 if  doRotate then (
 convertToMesh newProp
 in coordsys world rotate newProp.mesh (angleaxis -90 [0,0,1])
update newProp.mesh
 update newProp 
 convertToPoly newProp 
)  
 convertToMesh thisNode
 thisNode.mesh = copy newProp.mesh
convertToPoly thisNode
 if newProp.mat != undefined then thisNode.mat = newProp.mat 
 local modelNamePath = getUserProp newProp #wallworm_model_path 
 if modelNamePath != undefined then (
thisNode.model = modelNamePath
)
if deleteAfter then (
delete newProp
)
update thisNode.mesh
    
)
 
function loadMeshFromLibrary doRotate:false = (
	if ::wallworm_load_library_prop == undefined AND ::wallworm_installation_path != undefined then (
		fileIn (::wallworm_installation_path+"/WallWorm.com/importers/importer_functions.ms")
	)
	if ::wallworm_load_library_prop != undefined AND isValidNode (getNode())  then (
		local newProp = wallworm_load_library_prop()
		if NOT isValidNode newProp then (
			false
		) else (
			deleteProxyCA()
			updateMeshFromObj newProp doRotate:doRotate 
		)
	)
) 
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("targetname","rendermode","renderamt","rendercolor","renderfx","angles","avelocity"))

parameters main rollout:params
(
targetname type:#string ui:wwmt_targetname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
avelocity type:#string ui:wwmt_avelocity_ui default:""

)

rollout params "Entity Properties"
(
label entityLabel "xen_tree"
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
label wwmt_avelocity_ui_label "Angular Velocity (PYR)" 
editText wwmt_avelocity_ui "" type:#string
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=xen_tree&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: xen_tree" address:"https://developer.valvesoftware.com/wiki/xen_tree?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_worldspawn_CA = attributes "WW Entity worldspawn" version:78 attribID:#(391958850L,-112077181L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="worldspawn"
local hasOutputs = false
local hasInputs = false
local description = "World entity"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdark="0"
local propMapstartdark=#("0","1")
local exportProps=#()	
function resetExportProps = ( exportProps=#("skyname","sounds","light","waveheight","maxrange","startdark"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
skyname type:#string ui:wwmt_skyname_ui default:"2desert"
sounds type:#integer ui:wwmt_sounds_ui default:0
light type:#integer ui:wwmt_light_ui
waveheight type:#string ui:wwmt_waveheight_ui default:"0"
maxrange type:#string ui:wwmt_maxrange_ui default:"4096"
startdark type:#string ui:wwmt_startdark_ui default:"0"

)

rollout params "Entity Properties"
(
label entityLabel "worldspawn"
label wwmt_skyname_ui_label "Environment map (sky box)" 
editText wwmt_skyname_ui "" type:#string
spinner wwmt_sounds_ui "CD track to p" type:#integer range:[-10000,10000,0]
spinner wwmt_light_ui "Default light" type:#integer range:[-10000,10000,0]
label wwmt_waveheight_ui_label "Default Wave Height" 
editText wwmt_waveheight_ui "" type:#string
label wwmt_maxrange_ui_label "Max viewable distance" 
editText wwmt_maxrange_ui "" type:#string
dropdownlist wwmt_startdark_ui "Level Fade In" type:#string items:#("No","Yes")
on wwmt_startdark_ui selected i do startdark = propMapstartdark[i] 
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=worldspawn&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: worldspawn" address:"https://developer.valvesoftware.com/wiki/worldspawn?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if startdark != undefined AND findItem propMapstartdark startdark == 0 then (
 append propMapstartdark startdark
tmp = wwmt_startdark_ui.items
 append tmp startdark
wwmt_startdark_ui.items = tmp
wwmt_startdark_ui.selection = propMapstartdark.count
) else ( 
 if startdark != undefined then (
wwmt_startdark_ui.selection = (findItem propMapstartdark startdark)
)
)

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_nobuild_CA = attributes "WW Entity func_nobuild" version:78 attribID:#(-1064270333L,518926725L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_nobuild"
local hasOutputs = false
local hasInputs = false
local description = "Engineer no-build area"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","-1","1","2","4","8","16","32","64","128","256","512")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","-1","1","2","4","8","16","32","64","128","256","512")
local propValmaxammo_rockets="0"
local propMapmaxammo_rockets=#("0","-1","1","2","4","8","16","32","64","128","256","512")
local propValmaxammo_cells="0"
local propMapmaxammo_cells=#("0","-1","1","2","4","8","16","32","64","128","256","512")
local propValammo_medikit="0"
local propMapammo_medikit=#("0")
local propValammo_detpack="0"
local propMapammo_detpack=#("0")
local propValmaxammo_medikit="0"
local propMapmaxammo_medikit=#("0")
local propValmaxammo_detpack="0"
local propMapmaxammo_detpack=#("0")
local propValteam1_allies="0"
local propMapteam1_allies=#("0","2","4","8")
local propValteam2_allies="0"
local propMapteam2_allies=#("0","1","4","8")
local propValteam3_allies="0"
local propMapteam3_allies=#("0","1","2","8")
local propValteam4_allies="0"
local propMapteam4_allies=#("0","1","2","4")
local exportProps=#()	
function resetExportProps = ( exportProps=#("broadcast","number_of_teams","team1_name","team2_name","team3_name","team4_name","impulse","message","ammo_shells","ammo_nails","ammo_rockets","ammo_cells","maxammo_shells","maxammo_nails","maxammo_rockets","maxammo_cells","ammo_medikit","ammo_detpack","maxammo_medikit","maxammo_detpack","team1_allies","team2_allies","team3_allies","team4_allies","targetname"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
broadcast type:#string ui:wwmt_broadcast_ui default:""
number_of_teams type:#integer ui:wwmt_number_of_teams_ui
team1_name type:#string ui:wwmt_team1_name_ui default:""
team2_name type:#string ui:wwmt_team2_name_ui default:""
team3_name type:#string ui:wwmt_team3_name_ui default:""
team4_name type:#string ui:wwmt_team4_name_ui default:""
impulse type:#integer ui:wwmt_impulse_ui
message type:#string ui:wwmt_message_ui default:""
ammo_shells type:#string ui:wwmt_ammo_shells_ui default:"0"
ammo_nails type:#string ui:wwmt_ammo_nails_ui default:"0"
ammo_rockets type:#string ui:wwmt_ammo_rockets_ui default:"0"
ammo_cells type:#string ui:wwmt_ammo_cells_ui default:"0"
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
maxammo_rockets type:#string ui:wwmt_maxammo_rockets_ui default:"0"
maxammo_cells type:#string ui:wwmt_maxammo_cells_ui default:"0"
ammo_medikit type:#string ui:wwmt_ammo_medikit_ui default:"0"
ammo_detpack type:#string ui:wwmt_ammo_detpack_ui default:"0"
maxammo_medikit type:#string ui:wwmt_maxammo_medikit_ui default:"0"
maxammo_detpack type:#string ui:wwmt_maxammo_detpack_ui default:"0"
team1_allies type:#string ui:wwmt_team1_allies_ui default:"0"
team2_allies type:#string ui:wwmt_team2_allies_ui default:"0"
team3_allies type:#string ui:wwmt_team3_allies_ui default:"0"
team4_allies type:#string ui:wwmt_team4_allies_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""

)

rollout params "Entity Properties"
(
label entityLabel "func_nobuild"
label wwmt_broadcast_ui_label "Version String" 
editText wwmt_broadcast_ui "" type:#string
spinner wwmt_number_of_teams_ui "No. of teams-" type:#integer range:[-10000,10000,0]
label wwmt_team1_name_ui_label "Team 1 VGUI menu name" 
editText wwmt_team1_name_ui "" type:#string
label wwmt_team2_name_ui_label "Team 2 VGUI menu name" 
editText wwmt_team2_name_ui "" type:#string
label wwmt_team3_name_ui_label "Team 3 VGUI menu name" 
editText wwmt_team3_name_ui "" type:#string
label wwmt_team4_name_ui_label "Team 4 VGUI menu name" 
editText wwmt_team4_name_ui "" type:#string
spinner wwmt_impulse_ui "Game Settings" type:#integer range:[-10000,10000,0]
label wwmt_message_ui_label "LocalCmd String" 
editText wwmt_message_ui "" type:#string
dropdownlist wwmt_ammo_shells_ui "Blue Lives" type:#string toolTip:"Blue Lives: infinite ]"
dropdownlist wwmt_ammo_nails_ui "Red Lives" type:#string toolTip:"Red Lives: infinite ]"
dropdownlist wwmt_ammo_rockets_ui "Yellow Lives" type:#string toolTip:"Yellow Lives: infinite ]"
dropdownlist wwmt_ammo_cells_ui "Green Lives" type:#string toolTip:"Green Lives: infinite ]"
dropdownlist wwmt_maxammo_shells_ui "Blue class limits toggleflags" type:#string items:#("no limits","civilian only","1 - no scout","2 - no sniper","4 - no soldier","8 - no demo man","16 - no combat medic","32 - no heavy weapons guy","64 - no pyro","128 - no random playerclass","256 - no spy","512 - no engineer")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Red class limits toggleflags" type:#string items:#("no limits","civilian only","1 - no scout","2 - no sniper","4 - no soldier","8 - no demo man","16 - no combat medic","32 - no heavy weapons guy","64 - no pyro","128 - no random playerclass","256 - no spy","512 - no engineer")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
dropdownlist wwmt_maxammo_rockets_ui "Yellow class limits toggleflags" type:#string items:#("no limits","civilian only","1 - no scout","2 - no sniper","4 - no soldier","8 - no demo man","16 - no combat medic","32 - no heavy weapons guy","64 - no pyro","128 - no random playerclass","256 - no spy","512 - no engineer")
on wwmt_maxammo_rockets_ui selected i do maxammo_rockets = propMapmaxammo_rockets[i] 
dropdownlist wwmt_maxammo_cells_ui "Green class limits toggleflags" type:#string items:#("no limits","civilian only","1 - no scout","2 - no sniper","4 - no soldier","8 - no demo man","16 - no combat medic","32 - no heavy weapons guy","64 - no pyro","128 - no random playerclass","256 - no spy","512 - no engineer")
on wwmt_maxammo_cells_ui selected i do maxammo_cells = propMapmaxammo_cells[i] 
dropdownlist wwmt_ammo_medikit_ui "Max Players, Blue" type:#string items:#("0 - Unlimited")
on wwmt_ammo_medikit_ui selected i do ammo_medikit = propMapammo_medikit[i] 
dropdownlist wwmt_ammo_detpack_ui "Max Players, Red" type:#string items:#("0 - Unlimited")
on wwmt_ammo_detpack_ui selected i do ammo_detpack = propMapammo_detpack[i] 
dropdownlist wwmt_maxammo_medikit_ui "Max Players, Yellow" type:#string items:#("0 - Unlimited")
on wwmt_maxammo_medikit_ui selected i do maxammo_medikit = propMapmaxammo_medikit[i] 
dropdownlist wwmt_maxammo_detpack_ui "Max Players, Green" type:#string items:#("0 - Unlimited")
on wwmt_maxammo_detpack_ui selected i do maxammo_detpack = propMapmaxammo_detpack[i] 
dropdownlist wwmt_team1_allies_ui "Blue Allies" type:#string items:#("No Allies","2 - Red","4 - Yellow","8 - Green")
on wwmt_team1_allies_ui selected i do team1_allies = propMapteam1_allies[i] 
dropdownlist wwmt_team2_allies_ui "Red Allies" type:#string items:#("No Allies","1 - Blue","4 - Yellow","8 - Green")
on wwmt_team2_allies_ui selected i do team2_allies = propMapteam2_allies[i] 
dropdownlist wwmt_team3_allies_ui "Yellow Allies" type:#string items:#("No Allies","1 - Blue","2 - Red","8 - Green")
on wwmt_team3_allies_ui selected i do team3_allies = propMapteam3_allies[i] 
dropdownlist wwmt_team4_allies_ui "Green Allies" type:#string items:#("No Allies","1 - Blue","2 - Red","4 - Yellow")
on wwmt_team4_allies_ui selected i do team4_allies = propMapteam4_allies[i] 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_nobuild" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_nobuild_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_nobuild&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_nobuild" address:"https://developer.valvesoftware.com/wiki/func_nobuild?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if maxammo_rockets != undefined AND findItem propMapmaxammo_rockets maxammo_rockets == 0 then (
 append propMapmaxammo_rockets maxammo_rockets
tmp = wwmt_maxammo_rockets_ui.items
 append tmp maxammo_rockets
wwmt_maxammo_rockets_ui.items = tmp
wwmt_maxammo_rockets_ui.selection = propMapmaxammo_rockets.count
) else ( 
 if maxammo_rockets != undefined then (
wwmt_maxammo_rockets_ui.selection = (findItem propMapmaxammo_rockets maxammo_rockets)
)
)
 if maxammo_cells != undefined AND findItem propMapmaxammo_cells maxammo_cells == 0 then (
 append propMapmaxammo_cells maxammo_cells
tmp = wwmt_maxammo_cells_ui.items
 append tmp maxammo_cells
wwmt_maxammo_cells_ui.items = tmp
wwmt_maxammo_cells_ui.selection = propMapmaxammo_cells.count
) else ( 
 if maxammo_cells != undefined then (
wwmt_maxammo_cells_ui.selection = (findItem propMapmaxammo_cells maxammo_cells)
)
)
 if ammo_medikit != undefined AND findItem propMapammo_medikit ammo_medikit == 0 then (
 append propMapammo_medikit ammo_medikit
tmp = wwmt_ammo_medikit_ui.items
 append tmp ammo_medikit
wwmt_ammo_medikit_ui.items = tmp
wwmt_ammo_medikit_ui.selection = propMapammo_medikit.count
) else ( 
 if ammo_medikit != undefined then (
wwmt_ammo_medikit_ui.selection = (findItem propMapammo_medikit ammo_medikit)
)
)
 if ammo_detpack != undefined AND findItem propMapammo_detpack ammo_detpack == 0 then (
 append propMapammo_detpack ammo_detpack
tmp = wwmt_ammo_detpack_ui.items
 append tmp ammo_detpack
wwmt_ammo_detpack_ui.items = tmp
wwmt_ammo_detpack_ui.selection = propMapammo_detpack.count
) else ( 
 if ammo_detpack != undefined then (
wwmt_ammo_detpack_ui.selection = (findItem propMapammo_detpack ammo_detpack)
)
)
 if maxammo_medikit != undefined AND findItem propMapmaxammo_medikit maxammo_medikit == 0 then (
 append propMapmaxammo_medikit maxammo_medikit
tmp = wwmt_maxammo_medikit_ui.items
 append tmp maxammo_medikit
wwmt_maxammo_medikit_ui.items = tmp
wwmt_maxammo_medikit_ui.selection = propMapmaxammo_medikit.count
) else ( 
 if maxammo_medikit != undefined then (
wwmt_maxammo_medikit_ui.selection = (findItem propMapmaxammo_medikit maxammo_medikit)
)
)
 if maxammo_detpack != undefined AND findItem propMapmaxammo_detpack maxammo_detpack == 0 then (
 append propMapmaxammo_detpack maxammo_detpack
tmp = wwmt_maxammo_detpack_ui.items
 append tmp maxammo_detpack
wwmt_maxammo_detpack_ui.items = tmp
wwmt_maxammo_detpack_ui.selection = propMapmaxammo_detpack.count
) else ( 
 if maxammo_detpack != undefined then (
wwmt_maxammo_detpack_ui.selection = (findItem propMapmaxammo_detpack maxammo_detpack)
)
)
 if team1_allies != undefined AND findItem propMapteam1_allies team1_allies == 0 then (
 append propMapteam1_allies team1_allies
tmp = wwmt_team1_allies_ui.items
 append tmp team1_allies
wwmt_team1_allies_ui.items = tmp
wwmt_team1_allies_ui.selection = propMapteam1_allies.count
) else ( 
 if team1_allies != undefined then (
wwmt_team1_allies_ui.selection = (findItem propMapteam1_allies team1_allies)
)
)
 if team2_allies != undefined AND findItem propMapteam2_allies team2_allies == 0 then (
 append propMapteam2_allies team2_allies
tmp = wwmt_team2_allies_ui.items
 append tmp team2_allies
wwmt_team2_allies_ui.items = tmp
wwmt_team2_allies_ui.selection = propMapteam2_allies.count
) else ( 
 if team2_allies != undefined then (
wwmt_team2_allies_ui.selection = (findItem propMapteam2_allies team2_allies)
)
)
 if team3_allies != undefined AND findItem propMapteam3_allies team3_allies == 0 then (
 append propMapteam3_allies team3_allies
tmp = wwmt_team3_allies_ui.items
 append tmp team3_allies
wwmt_team3_allies_ui.items = tmp
wwmt_team3_allies_ui.selection = propMapteam3_allies.count
) else ( 
 if team3_allies != undefined then (
wwmt_team3_allies_ui.selection = (findItem propMapteam3_allies team3_allies)
)
)
 if team4_allies != undefined AND findItem propMapteam4_allies team4_allies == 0 then (
 append propMapteam4_allies team4_allies
tmp = wwmt_team4_allies_ui.items
 append tmp team4_allies
wwmt_team4_allies_ui.items = tmp
wwmt_team4_allies_ui.selection = propMapteam4_allies.count
) else ( 
 if team4_allies != undefined then (
wwmt_team4_allies_ui.selection = (findItem propMapteam4_allies team4_allies)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_i_t_g_CA = attributes "WW Entity i_t_g" version:78 attribID:#(-640467090L,-634783432L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="i_t_g"
local hasOutputs = false
local hasInputs = false
local description = "TFC Goal shortcut, solid"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 255.0 255.0 0.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValg_a="1"
local propMapg_a=#("0","1","2","4")
local propValg_e="1"
local propMapg_e=#("1","2","4","8","16","32","64")
local propValgoal_result="0"
local propMapgoal_result=#("0","1","2","4","8","16","32","64")
local propValgoal_state="2"
local propMapgoal_state=#("1","2","3")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local propValowned_by="0"
local propMapowned_by=#("0","1","2","3","4")
local exportProps=#()	
function resetExportProps = ( exportProps=#("g_a","g_e","goal_result","netname","goal_no","group_no","targetname","goal_state","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","wait","delay_time","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","wwmt_target","killtarget","noise","frags","lives","health","armorvalue","armorclass","a_s","a_n","a_r","a_c","ammo_detpack","no_grenades_1","no_grenades_2","invincible_finished","invisible_finished","super_damage_finished","radsuit_finished","count","increase_team","increase_team1","increase_team2","increase_team3","increase_team4","endround_time","endround_owned_by","endround_non_owned_by","endround_team1","endround_team2","endround_team3","endround_team4","owned_by","owned_by_teamcheck","deathtype","b_b","message","b_t","b_n","b_o","non_owners_team_broadcast","n_b","n_t","n_n","n_o","speak","ap_speak","team_speak","non_team_speak","owners_team_speak","non_owners_team_speak"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
g_a type:#string ui:wwmt_g_a_ui default:"1"
g_e type:#string ui:wwmt_g_e_ui default:"1"
goal_result type:#string ui:wwmt_goal_result_ui default:"0"
netname type:#string ui:wwmt_netname_ui default:""
goal_no type:#integer ui:wwmt_goal_no_ui
group_no type:#integer ui:wwmt_group_no_ui
targetname type:#string ui:wwmt_targetname_ui default:""
goal_state type:#string ui:wwmt_goal_state_ui default:"2"
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
wait type:#integer ui:wwmt_wait_ui default:0
delay_time type:#integer ui:wwmt_delay_time_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
wwmt_target type:#string ui:wwmt_target_ui default:""
killtarget type:#string ui:wwmt_killtarget_ui default:""
noise type:#string ui:wwmt_noise_ui default:""
frags type:#integer ui:wwmt_frags_ui
lives type:#integer ui:wwmt_lives_ui
health type:#integer ui:wwmt_health_ui
armorvalue type:#integer ui:wwmt_armorvalue_ui
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
a_s type:#integer ui:wwmt_a_s_ui
a_n type:#integer ui:wwmt_a_n_ui
a_r type:#integer ui:wwmt_a_r_ui
a_c type:#integer ui:wwmt_a_c_ui
ammo_detpack type:#integer ui:wwmt_ammo_detpack_ui
no_grenades_1 type:#integer ui:wwmt_no_grenades_1_ui
no_grenades_2 type:#integer ui:wwmt_no_grenades_2_ui
invincible_finished type:#integer ui:wwmt_invincible_finished_ui
invisible_finished type:#integer ui:wwmt_invisible_finished_ui
super_damage_finished type:#integer ui:wwmt_super_damage_finished_ui
radsuit_finished type:#integer ui:wwmt_radsuit_finished_ui
count type:#integer ui:wwmt_count_ui
increase_team type:#integer ui:wwmt_increase_team_ui
increase_team1 type:#integer ui:wwmt_increase_team1_ui
increase_team2 type:#integer ui:wwmt_increase_team2_ui
increase_team3 type:#integer ui:wwmt_increase_team3_ui
increase_team4 type:#integer ui:wwmt_increase_team4_ui
endround_time type:#integer ui:wwmt_endround_time_ui
endround_owned_by type:#string ui:wwmt_endround_owned_by_ui default:""
endround_non_owned_by type:#string ui:wwmt_endround_non_owned_by_ui default:""
endround_team1 type:#string ui:wwmt_endround_team1_ui default:""
endround_team2 type:#string ui:wwmt_endround_team2_ui default:""
endround_team3 type:#string ui:wwmt_endround_team3_ui default:""
endround_team4 type:#string ui:wwmt_endround_team4_ui default:""
owned_by type:#string ui:wwmt_owned_by_ui default:"0"
owned_by_teamcheck type:#string ui:wwmt_owned_by_teamcheck_ui default:""
deathtype type:#string ui:wwmt_deathtype_ui default:""
b_b type:#string ui:wwmt_b_b_ui default:""
message type:#string ui:wwmt_message_ui default:""
b_t type:#string ui:wwmt_b_t_ui default:""
b_n type:#string ui:wwmt_b_n_ui default:""
b_o type:#string ui:wwmt_b_o_ui default:""
non_owners_team_broadcast type:#string ui:wwmt_non_owners_team_broadcast_ui default:""
n_b type:#string ui:wwmt_n_b_ui default:""
n_t type:#string ui:wwmt_n_t_ui default:""
n_n type:#string ui:wwmt_n_n_ui default:""
n_o type:#string ui:wwmt_n_o_ui default:""
speak type:#string ui:wwmt_speak_ui default:""
ap_speak type:#string ui:wwmt_ap_speak_ui default:""
team_speak type:#string ui:wwmt_team_speak_ui default:""
non_team_speak type:#string ui:wwmt_non_team_speak_ui default:""
owners_team_speak type:#string ui:wwmt_owners_team_speak_ui default:""
non_owners_team_speak type:#string ui:wwmt_non_owners_team_speak_ui default:""

)

rollout params "Entity Properties"
(
label entityLabel "i_t_g"
dropdownlist wwmt_g_a_ui "Goal Activation bitfields" type:#string items:#("0 - none","1 - player touch","2 - detpack explosion","4 - if Criteria fails")
on wwmt_g_a_ui selected i do g_a = propMapg_a[i] 
dropdownlist wwmt_g_e_ui "Goal Effects bitfields" type:#string items:#("1 - Activating Player(AP)","2 - APs team","4 - Not on APs team","8 - All except AP","16 - Walls obstruct radius","32 - Same environment only","64 - Check APA individually")
on wwmt_g_e_ui selected i do g_e = propMapg_e[i] 
dropdownlist wwmt_goal_result_ui "Goal Result bitfields" type:#string items:#("none","1 - remove immediately","2 - Sub-Goals apply mods","4 - scores, intermission, end","8 - Sub-goals don't apply mods","16 - Prevent Spy disguise","32 - Force respawn, no die","64 - Remove SG & dispensers")
on wwmt_goal_result_ui selected i do goal_result = propMapgoal_result[i] 
label wwmt_netname_ui_label "Entity reference name (for logging)" 
editText wwmt_netname_ui "" type:#string
spinner wwmt_goal_no_ui "Goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_group_no_ui "Goal Group #" type:#integer range:[-10000,10000,0]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_goal_state_ui "Goal Initial State" type:#string items:#("Active","Inactive","Removed")
on wwmt_goal_state_ui selected i do goal_state = propMapgoal_state[i] 
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
spinner wwmt_wait_ui "Stay active(s" type:#integer range:[-10000,10000,0]
spinner wwmt_delay_time_ui "Delay before " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
label wwmt_target_ui_label "Target entity with this targetname" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target entity with this targetname" message:"Pick Target Entity for Target entity with this targetname" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_killtarget_ui_label "Remove entity with this targetname" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick Remove entity with this targetname" message:"Pick Target Entity for Remove entity with this targetname" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
label wwmt_noise_ui_label "Play Sound Path/name.wav" 
editText wwmt_noise_ui "" type:#string
spinner wwmt_frags_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_lives_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_health_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_armorvalue_ui "Armor Value  " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
spinner wwmt_a_s_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_n_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_r_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_c_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_ammo_detpack_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_1_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_2_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_invincible_finished_ui "Invincibility" type:#integer range:[-10000,10000,0]
spinner wwmt_invisible_finished_ui "Invisibility " type:#integer range:[-10000,10000,0]
spinner wwmt_super_damage_finished_ui "Quad Duration" type:#integer range:[-10000,10000,0]
spinner wwmt_radsuit_finished_ui "Rad Suit Dura" type:#integer range:[-10000,10000,0]
spinner wwmt_count_ui "Score to AP T" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team_ui "Teamcheck tea" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team1_ui "Blue point ga" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team2_ui "Red point gai" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team3_ui "Yellow point " type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team4_ui "Green point g" type:#integer range:[-10000,10000,0]
spinner wwmt_endround_time_ui "Length of end" type:#integer range:[-10000,10000,0]
label wwmt_endround_owned_by_ui_label "Owners endround message" 
editText wwmt_endround_owned_by_ui "" type:#string
label wwmt_endround_non_owned_by_ui_label "Non-owners endround message" 
editText wwmt_endround_non_owned_by_ui "" type:#string
label wwmt_endround_team1_ui_label "Endround message for team 1" 
editText wwmt_endround_team1_ui "" type:#string
label wwmt_endround_team2_ui_label "Endround message for team 2" 
editText wwmt_endround_team2_ui "" type:#string
label wwmt_endround_team3_ui_label "Endround message for team 3" 
editText wwmt_endround_team3_ui "" type:#string
label wwmt_endround_team4_ui_label "Endround message for team 4" 
editText wwmt_endround_team4_ui "" type:#string
dropdownlist wwmt_owned_by_ui "Owned by-for msg & item glow" type:#string items:#("Not Owned","Blue","Red","Yellow","Green")
on wwmt_owned_by_ui selected i do owned_by = propMapowned_by[i] 
label wwmt_owned_by_teamcheck_ui_label "Owned by teamcheck" 
editText wwmt_owned_by_teamcheck_ui "" type:#string
label wwmt_deathtype_ui_label "Goal death message" 
editText wwmt_deathtype_ui "" type:#string
label wwmt_b_b_ui_label "Message to all" 
editText wwmt_b_b_ui "" type:#string
label wwmt_message_ui_label "Message to AP" 
editText wwmt_message_ui "" type:#string
label wwmt_b_t_ui_label "Message to AP team" 
editText wwmt_b_t_ui "" type:#string
label wwmt_b_n_ui_label "Message to non-AP team" 
editText wwmt_b_n_ui "" type:#string
label wwmt_b_o_ui_label "Message to owner team" 
editText wwmt_b_o_ui "" type:#string
label wwmt_non_owners_team_broadcast_ui_label "Message to non-owner team(s)" 
editText wwmt_non_owners_team_broadcast_ui "" type:#string
label wwmt_n_b_ui_label "Console msg. to all,  percents = AP name" 
editText wwmt_n_b_ui "" type:#string
label wwmt_n_t_ui_label "Console msg to AP team" 
editText wwmt_n_t_ui "" type:#string
label wwmt_n_n_ui_label "Console msg. to non-AP team" 
editText wwmt_n_n_ui "" type:#string
label wwmt_n_o_ui_label "Console msg. to owner team" 
editText wwmt_n_o_ui "" type:#string
label wwmt_speak_ui_label "Speak (global)" 
editText wwmt_speak_ui "" type:#string
label wwmt_ap_speak_ui_label "Speak (AP)" 
editText wwmt_ap_speak_ui "" type:#string
label wwmt_team_speak_ui_label "Speak (AP team)" 
editText wwmt_team_speak_ui "" type:#string
label wwmt_non_team_speak_ui_label "Speak (non-AP team)" 
editText wwmt_non_team_speak_ui "" type:#string
label wwmt_owners_team_speak_ui_label "Speak (owner team)" 
editText wwmt_owners_team_speak_ui "" type:#string
label wwmt_non_owners_team_speak_ui_label "Speak (non-owner teams)" 
editText wwmt_non_owners_team_speak_ui "" type:#string

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with i_t_g" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"i_t_g_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=i_t_g&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: i_t_g" address:"https://developer.valvesoftware.com/wiki/i_t_g?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if g_a != undefined AND findItem propMapg_a g_a == 0 then (
 append propMapg_a g_a
tmp = wwmt_g_a_ui.items
 append tmp g_a
wwmt_g_a_ui.items = tmp
wwmt_g_a_ui.selection = propMapg_a.count
) else ( 
 if g_a != undefined then (
wwmt_g_a_ui.selection = (findItem propMapg_a g_a)
)
)
 if g_e != undefined AND findItem propMapg_e g_e == 0 then (
 append propMapg_e g_e
tmp = wwmt_g_e_ui.items
 append tmp g_e
wwmt_g_e_ui.items = tmp
wwmt_g_e_ui.selection = propMapg_e.count
) else ( 
 if g_e != undefined then (
wwmt_g_e_ui.selection = (findItem propMapg_e g_e)
)
)
 if goal_result != undefined AND findItem propMapgoal_result goal_result == 0 then (
 append propMapgoal_result goal_result
tmp = wwmt_goal_result_ui.items
 append tmp goal_result
wwmt_goal_result_ui.items = tmp
wwmt_goal_result_ui.selection = propMapgoal_result.count
) else ( 
 if goal_result != undefined then (
wwmt_goal_result_ui.selection = (findItem propMapgoal_result goal_result)
)
)
 if goal_state != undefined AND findItem propMapgoal_state goal_state == 0 then (
 append propMapgoal_state goal_state
tmp = wwmt_goal_state_ui.items
 append tmp goal_state
wwmt_goal_state_ui.items = tmp
wwmt_goal_state_ui.selection = propMapgoal_state.count
) else ( 
 if goal_state != undefined then (
wwmt_goal_state_ui.selection = (findItem propMapgoal_state goal_state)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)
 if owned_by != undefined AND findItem propMapowned_by owned_by == 0 then (
 append propMapowned_by owned_by
tmp = wwmt_owned_by_ui.items
 append tmp owned_by
wwmt_owned_by_ui.items = tmp
wwmt_owned_by_ui.selection = propMapowned_by.count
) else ( 
 if owned_by != undefined then (
wwmt_owned_by_ui.selection = (findItem propMapowned_by owned_by)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_button_target_CA = attributes "WW Entity button_target" version:78 attribID:#(1993738382L,232959494L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="button_target"
local hasOutputs = false
local hasInputs = false
local description = "Target Button"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local propValowned_by="0"
local propMapowned_by=#("0","1","2","3","4")
local exportProps=#()	
function resetExportProps = ( exportProps=#("master","wwmt_target","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","wait","delay_time","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","killtarget","noise","frags","lives","health","armorvalue","armorclass","a_s","a_n","a_r","a_c","ammo_detpack","no_grenades_1","no_grenades_2","invincible_finished","invisible_finished","super_damage_finished","radsuit_finished","count","increase_team","increase_team1","increase_team2","increase_team3","increase_team4","owned_by","owned_by_teamcheck","deathtype","b_b","message","b_t","b_n","b_o","non_owners_team_broadcast","n_b","n_t","n_n","n_o","speak","ap_speak","team_speak","non_team_speak","owners_team_speak","non_owners_team_speak"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
master type:#string ui:wwmt_master_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
wait type:#integer ui:wwmt_wait_ui default:0
delay_time type:#integer ui:wwmt_delay_time_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
killtarget type:#string ui:wwmt_killtarget_ui default:""
noise type:#string ui:wwmt_noise_ui default:""
frags type:#integer ui:wwmt_frags_ui
lives type:#integer ui:wwmt_lives_ui
health type:#integer ui:wwmt_health_ui
armorvalue type:#integer ui:wwmt_armorvalue_ui
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
a_s type:#integer ui:wwmt_a_s_ui
a_n type:#integer ui:wwmt_a_n_ui
a_r type:#integer ui:wwmt_a_r_ui
a_c type:#integer ui:wwmt_a_c_ui
ammo_detpack type:#integer ui:wwmt_ammo_detpack_ui
no_grenades_1 type:#integer ui:wwmt_no_grenades_1_ui
no_grenades_2 type:#integer ui:wwmt_no_grenades_2_ui
invincible_finished type:#integer ui:wwmt_invincible_finished_ui
invisible_finished type:#integer ui:wwmt_invisible_finished_ui
super_damage_finished type:#integer ui:wwmt_super_damage_finished_ui
radsuit_finished type:#integer ui:wwmt_radsuit_finished_ui
count type:#integer ui:wwmt_count_ui
increase_team type:#integer ui:wwmt_increase_team_ui
increase_team1 type:#integer ui:wwmt_increase_team1_ui
increase_team2 type:#integer ui:wwmt_increase_team2_ui
increase_team3 type:#integer ui:wwmt_increase_team3_ui
increase_team4 type:#integer ui:wwmt_increase_team4_ui
owned_by type:#string ui:wwmt_owned_by_ui default:"0"
owned_by_teamcheck type:#string ui:wwmt_owned_by_teamcheck_ui default:""
deathtype type:#string ui:wwmt_deathtype_ui default:""
b_b type:#string ui:wwmt_b_b_ui default:""
message type:#string ui:wwmt_message_ui default:""
b_t type:#string ui:wwmt_b_t_ui default:""
b_n type:#string ui:wwmt_b_n_ui default:""
b_o type:#string ui:wwmt_b_o_ui default:""
non_owners_team_broadcast type:#string ui:wwmt_non_owners_team_broadcast_ui default:""
n_b type:#string ui:wwmt_n_b_ui default:""
n_t type:#string ui:wwmt_n_t_ui default:""
n_n type:#string ui:wwmt_n_n_ui default:""
n_o type:#string ui:wwmt_n_o_ui default:""
speak type:#string ui:wwmt_speak_ui default:""
ap_speak type:#string ui:wwmt_ap_speak_ui default:""
team_speak type:#string ui:wwmt_team_speak_ui default:""
non_team_speak type:#string ui:wwmt_non_team_speak_ui default:""
owners_team_speak type:#string ui:wwmt_owners_team_speak_ui default:""
non_owners_team_speak type:#string ui:wwmt_non_owners_team_speak_ui default:""
spawnflags type:#integer default:1

)

rollout params "Entity Properties"
(
label entityLabel "button_target"
label wwmt_master_ui_label "Master" 
editText wwmt_master_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
spinner wwmt_wait_ui "Stay active(s" type:#integer range:[-10000,10000,0]
spinner wwmt_delay_time_ui "Delay before " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
label wwmt_killtarget_ui_label "Remove entity with this targetname" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick Remove entity with this targetname" message:"Pick Target Entity for Remove entity with this targetname" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
label wwmt_noise_ui_label "Play Sound Path/name.wav" 
editText wwmt_noise_ui "" type:#string
spinner wwmt_frags_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_lives_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_health_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_armorvalue_ui "Armor Value  " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
spinner wwmt_a_s_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_n_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_r_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_c_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_ammo_detpack_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_1_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_2_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_invincible_finished_ui "Invincibility" type:#integer range:[-10000,10000,0]
spinner wwmt_invisible_finished_ui "Invisibility " type:#integer range:[-10000,10000,0]
spinner wwmt_super_damage_finished_ui "Quad Duration" type:#integer range:[-10000,10000,0]
spinner wwmt_radsuit_finished_ui "Rad Suit Dura" type:#integer range:[-10000,10000,0]
spinner wwmt_count_ui "Score to AP T" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team_ui "Teamcheck tea" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team1_ui "Blue point ga" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team2_ui "Red point gai" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team3_ui "Yellow point " type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team4_ui "Green point g" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_owned_by_ui "Owned by-for msg & item glow" type:#string items:#("Not Owned","Blue","Red","Yellow","Green")
on wwmt_owned_by_ui selected i do owned_by = propMapowned_by[i] 
label wwmt_owned_by_teamcheck_ui_label "Owned by teamcheck" 
editText wwmt_owned_by_teamcheck_ui "" type:#string
label wwmt_deathtype_ui_label "Goal death message" 
editText wwmt_deathtype_ui "" type:#string
label wwmt_b_b_ui_label "Message to all" 
editText wwmt_b_b_ui "" type:#string
label wwmt_message_ui_label "Message to AP" 
editText wwmt_message_ui "" type:#string
label wwmt_b_t_ui_label "Message to AP team" 
editText wwmt_b_t_ui "" type:#string
label wwmt_b_n_ui_label "Message to non-AP team" 
editText wwmt_b_n_ui "" type:#string
label wwmt_b_o_ui_label "Message to owner team" 
editText wwmt_b_o_ui "" type:#string
label wwmt_non_owners_team_broadcast_ui_label "Message to non-owner team(s)" 
editText wwmt_non_owners_team_broadcast_ui "" type:#string
label wwmt_n_b_ui_label "Console msg. to all,  percents = AP name" 
editText wwmt_n_b_ui "" type:#string
label wwmt_n_t_ui_label "Console msg to AP team" 
editText wwmt_n_t_ui "" type:#string
label wwmt_n_n_ui_label "Console msg. to non-AP team" 
editText wwmt_n_n_ui "" type:#string
label wwmt_n_o_ui_label "Console msg. to owner team" 
editText wwmt_n_o_ui "" type:#string
label wwmt_speak_ui_label "Speak (global)" 
editText wwmt_speak_ui "" type:#string
label wwmt_ap_speak_ui_label "Speak (AP)" 
editText wwmt_ap_speak_ui "" type:#string
label wwmt_team_speak_ui_label "Speak (AP team)" 
editText wwmt_team_speak_ui "" type:#string
label wwmt_non_team_speak_ui_label "Speak (non-AP team)" 
editText wwmt_non_team_speak_ui "" type:#string
label wwmt_owners_team_speak_ui_label "Speak (owner team)" 
editText wwmt_owners_team_speak_ui "" type:#string
label wwmt_non_owners_team_speak_ui_label "Speak (non-owner teams)" 
editText wwmt_non_owners_team_speak_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Use Activates" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Start On" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with button_target" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"button_target_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=button_target&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: button_target" address:"https://developer.valvesoftware.com/wiki/button_target?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)
 if owned_by != undefined AND findItem propMapowned_by owned_by == 0 then (
 append propMapowned_by owned_by
tmp = wwmt_owned_by_ui.items
 append tmp owned_by
wwmt_owned_by_ui.items = tmp
wwmt_owned_by_ui.selection = propMapowned_by.count
) else ( 
 if owned_by != undefined then (
wwmt_owned_by_ui.selection = (findItem propMapowned_by owned_by)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_env_bubbles_CA = attributes "WW Entity env_bubbles" version:78 attribID:#(842275032L,-496060337L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_bubbles"
local hasOutputs = false
local hasInputs = false
local description = "Bubble Volume"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local exportProps=#()	
function resetExportProps = ( exportProps=#("density","frequency","current","targetname"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
density type:#integer ui:wwmt_density_ui default:2
frequency type:#integer ui:wwmt_frequency_ui default:2
current type:#integer ui:wwmt_current_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "env_bubbles"
spinner wwmt_density_ui "Bubble densit" type:#integer range:[-10000,10000,2]
spinner wwmt_frequency_ui "Bubble freque" type:#integer range:[-10000,10000,2]
spinner wwmt_current_ui "Speed of Curr" type:#integer range:[-10000,10000,0]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Start Off" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with env_bubbles" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"env_bubbles_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_bubbles&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_bubbles" address:"https://developer.valvesoftware.com/wiki/env_bubbles?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_breakable_CA = attributes "WW Entity func_breakable" version:78 attribID:#(-783224043L,1079791769L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_breakable"
local hasOutputs = false
local hasInputs = false
local description = "Breakable Object"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValmaterial="0"
local propMapmaterial=#("0","1","2","3","4","5","6","7","8")
local propValexplosion="0"
local propMapexplosion=#("0","1")
local propValspawnobject="0"
local propMapspawnobject=#("0","1","2")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local exportProps=#()	
function resetExportProps = ( exportProps=#("targetname","wwmt_target","health","wwmt_material","explosion","delay","gibmodel","spawnobject","explodemagnitude","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","avelocity"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
targetname type:#string ui:wwmt_targetname_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
health type:#integer ui:wwmt_health_ui default:1
wwmt_material type:#string ui:wwmt_material_ui default:"0"
explosion type:#string ui:wwmt_explosion_ui default:"0"
delay type:#string ui:wwmt_delay_ui default:"0"
gibmodel type:#string ui:wwmt_gibmodel_ui default:""
spawnobject type:#string ui:wwmt_spawnobject_ui default:"0"
explodemagnitude type:#integer ui:wwmt_explodemagnitude_ui default:0
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
avelocity type:#string ui:wwmt_avelocity_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "func_breakable"
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_target_ui_label "Target on break" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target on break" message:"Pick Target Entity for Target on break" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
spinner wwmt_health_ui "Strength" type:#integer range:[-10000,10000,1]
dropdownlist wwmt_material_ui "Material type" type:#string items:#("Glass","Wood","Metal","Flesh","Cinder Block","Ceiling Tile","Computer","Unbreakable Glass","Rocks")
on wwmt_material_ui selected i do wwmt_material = propMapmaterial[i] 
dropdownlist wwmt_explosion_ui "Gibs Direction" type:#string items:#("Random","Relative to Attack")
on wwmt_explosion_ui selected i do explosion = propMapexplosion[i] 
label wwmt_delay_ui_label "Delay before fire" 
editText wwmt_delay_ui "" type:#string
label wwmt_gibmodel_ui_label "Gib Model" 
editText wwmt_gibmodel_ui "" type:#string
dropdownlist wwmt_spawnobject_ui "Spawn On Break" type:#string items:#("Nothing","Battery","Healthkit")
on wwmt_spawnobject_ui selected i do spawnobject = propMapspawnobject[i] 
spinner wwmt_explodemagnitude_ui "Explode Magni" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
label wwmt_avelocity_ui_label "Angular Velocity (PYR)" 
editText wwmt_avelocity_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Only Trigger" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Touch" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pressure" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Instant Crowbar" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_breakable" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_breakable_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_breakable&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_breakable" address:"https://developer.valvesoftware.com/wiki/func_breakable?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if wwmt_material != undefined AND findItem propMapmaterial wwmt_material == 0 then (
 append propMapmaterial wwmt_material
tmp = wwmt_material_ui.items
 append tmp wwmt_material
wwmt_material_ui.items = tmp
wwmt_material_ui.selection = propMapmaterial.count
) else ( 
 if wwmt_material != undefined then (
wwmt_material_ui.selection = (findItem propMapmaterial wwmt_material)
)
)
 if explosion != undefined AND findItem propMapexplosion explosion == 0 then (
 append propMapexplosion explosion
tmp = wwmt_explosion_ui.items
 append tmp explosion
wwmt_explosion_ui.items = tmp
wwmt_explosion_ui.selection = propMapexplosion.count
) else ( 
 if explosion != undefined then (
wwmt_explosion_ui.selection = (findItem propMapexplosion explosion)
)
)
 if spawnobject != undefined AND findItem propMapspawnobject spawnobject == 0 then (
 append propMapspawnobject spawnobject
tmp = wwmt_spawnobject_ui.items
 append tmp spawnobject
wwmt_spawnobject_ui.items = tmp
wwmt_spawnobject_ui.selection = propMapspawnobject.count
) else ( 
 if spawnobject != undefined then (
wwmt_spawnobject_ui.selection = (findItem propMapspawnobject spawnobject)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_button_CA = attributes "WW Entity func_button" version:78 attribID:#(721320529L,1993738382L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_button"
local hasOutputs = false
local hasInputs = false
local description = "Button"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValg_a="1"
local propMapg_a=#("0","4","8")
local propValg_e="1"
local propMapg_e=#("1","2","4","8","16","32","64")
local propValgoal_result="0"
local propMapgoal_result=#("0","2","4","8","32")
local propValsounds="0"
local propMapsounds=#("0","1","2","3","4","5","6","7","8","9","10","11","14")
local propVallocked_sound="0"
local propMaplocked_sound=#("0","2","8","10","11","12")
local propValunlocked_sound="0"
local propMapunlocked_sound=#("0","1","3","4","5","6","7","8","9","10","13","14")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValowned_by="0"
local propMapowned_by=#("0","1","2","3","4")
local exportProps=#()	
function resetExportProps = ( exportProps=#("speed","targetname","wwmt_target","angles","g_a","g_e","goal_result","health","lip","master","wait","delay","sounds","locked_sound","unlocked_sound","frags","lives","armorvalue","armorclass","a_s","a_n","a_r","a_c","ammo_detpack","no_grenades_1","no_grenades_2","invincible_finished","invisible_finished","super_damage_finished","radsuit_finished","count","increase_team","increase_team1","increase_team2","increase_team3","increase_team4","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","owned_by","owned_by_teamcheck","deathtype","b_b","message","b_t","b_n","b_o","non_owners_team_broadcast","n_b","n_t","n_n","n_o","speak","ap_speak","team_speak","non_team_speak","owners_team_speak","non_owners_team_speak","avelocity"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
speed type:#string ui:wwmt_speed_ui default:"100"
targetname type:#string ui:wwmt_targetname_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
g_a type:#string ui:wwmt_g_a_ui default:"1"
g_e type:#string ui:wwmt_g_e_ui default:"1"
goal_result type:#string ui:wwmt_goal_result_ui default:"0"
health type:#integer ui:wwmt_health_ui
lip type:#integer ui:wwmt_lip_ui
master type:#string ui:wwmt_master_ui default:""
wait type:#integer ui:wwmt_wait_ui default:3
delay type:#string ui:wwmt_delay_ui default:"0"
sounds type:#string ui:wwmt_sounds_ui default:"0"
locked_sound type:#string ui:wwmt_locked_sound_ui default:"0"
unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:"0"
frags type:#integer ui:wwmt_frags_ui
lives type:#integer ui:wwmt_lives_ui
armorvalue type:#integer ui:wwmt_armorvalue_ui
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
a_s type:#integer ui:wwmt_a_s_ui
a_n type:#integer ui:wwmt_a_n_ui
a_r type:#integer ui:wwmt_a_r_ui
a_c type:#integer ui:wwmt_a_c_ui
ammo_detpack type:#integer ui:wwmt_ammo_detpack_ui
no_grenades_1 type:#integer ui:wwmt_no_grenades_1_ui
no_grenades_2 type:#integer ui:wwmt_no_grenades_2_ui
invincible_finished type:#integer ui:wwmt_invincible_finished_ui
invisible_finished type:#integer ui:wwmt_invisible_finished_ui
super_damage_finished type:#integer ui:wwmt_super_damage_finished_ui
radsuit_finished type:#integer ui:wwmt_radsuit_finished_ui
count type:#integer ui:wwmt_count_ui
increase_team type:#integer ui:wwmt_increase_team_ui
increase_team1 type:#integer ui:wwmt_increase_team1_ui
increase_team2 type:#integer ui:wwmt_increase_team2_ui
increase_team3 type:#integer ui:wwmt_increase_team3_ui
increase_team4 type:#integer ui:wwmt_increase_team4_ui
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
owned_by type:#string ui:wwmt_owned_by_ui default:"0"
owned_by_teamcheck type:#string ui:wwmt_owned_by_teamcheck_ui default:""
deathtype type:#string ui:wwmt_deathtype_ui default:""
b_b type:#string ui:wwmt_b_b_ui default:""
message type:#string ui:wwmt_message_ui default:""
b_t type:#string ui:wwmt_b_t_ui default:""
b_n type:#string ui:wwmt_b_n_ui default:""
b_o type:#string ui:wwmt_b_o_ui default:""
non_owners_team_broadcast type:#string ui:wwmt_non_owners_team_broadcast_ui default:""
n_b type:#string ui:wwmt_n_b_ui default:""
n_t type:#string ui:wwmt_n_t_ui default:""
n_n type:#string ui:wwmt_n_n_ui default:""
n_o type:#string ui:wwmt_n_o_ui default:""
speak type:#string ui:wwmt_speak_ui default:""
ap_speak type:#string ui:wwmt_ap_speak_ui default:""
team_speak type:#string ui:wwmt_team_speak_ui default:""
non_team_speak type:#string ui:wwmt_non_team_speak_ui default:""
owners_team_speak type:#string ui:wwmt_owners_team_speak_ui default:""
non_owners_team_speak type:#string ui:wwmt_non_owners_team_speak_ui default:""
avelocity type:#string ui:wwmt_avelocity_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "func_button"
label wwmt_speed_ui_label "Conveyor Speed" 
editText wwmt_speed_ui "" type:#string
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
dropdownlist wwmt_g_a_ui "Goal Activation bitfields" type:#string items:#("0 - none","4 - if AP fails criteria","8 - hit by engin. spanner")
on wwmt_g_a_ui selected i do g_a = propMapg_a[i] 
dropdownlist wwmt_g_e_ui "Goal Effects bitfields" type:#string items:#("1 - Activating Player(AP)","2 - APs team","4 - Not on APs team","8 - Not the AP","16 - Walls obstruct radius","32 - Same environment only","64 - Check APA individually")
on wwmt_g_e_ui selected i do g_e = propMapg_e[i] 
dropdownlist wwmt_goal_result_ui "Goal Result bitfields" type:#string items:#("none","2 - Sub-goals apply AP mods","4 - scores, intermission, end","8 - Sub-Goals don't apply results","32 - Force respawn, no die")
on wwmt_goal_result_ui selected i do goal_result = propMapgoal_result[i] 
spinner wwmt_health_ui "Health (shoot" type:#integer range:[-10000,10000,0]
spinner wwmt_lip_ui "Lip" type:#integer range:[-10000,10000,0]
label wwmt_master_ui_label "Master" 
editText wwmt_master_ui "" type:#string
spinner wwmt_wait_ui "delay before " type:#integer range:[-10000,10000,3]
label wwmt_delay_ui_label "Delay before trigger" 
editText wwmt_delay_ui "" type:#string
dropdownlist wwmt_sounds_ui "Sounds" type:#string items:#("None","Big zap & Warmup","Access Denied","Access Granted","Quick Combolock","Power Deadbolt 1","Power Deadbolt 2","Plunger","Small zap","Keycard Sound","Buzz","Buzz Off","Lightswitch")
on wwmt_sounds_ui selected i do sounds = propMapsounds[i] 
dropdownlist wwmt_locked_sound_ui "Locked Sound" type:#string items:#("None","Access Denied","Small zap","Buzz","Buzz Off","Latch Locked")
on wwmt_locked_sound_ui selected i do locked_sound = propMaplocked_sound[i] 
dropdownlist wwmt_unlocked_sound_ui "Unlocked Sound" type:#string items:#("None","Big zap & Warmup","Access Granted","Quick Combolock","Power Deadbolt 1","Power Deadbolt 2","Plunger","Small zap","Keycard Sound","Buzz","Latch Unlocked","Lightswitch")
on wwmt_unlocked_sound_ui selected i do unlocked_sound = propMapunlocked_sound[i] 
spinner wwmt_frags_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_lives_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_armorvalue_ui "Armor Value  " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
spinner wwmt_a_s_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_n_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_r_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_c_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_ammo_detpack_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_1_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_2_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_invincible_finished_ui "Invincibility" type:#integer range:[-10000,10000,0]
spinner wwmt_invisible_finished_ui "Invisibility " type:#integer range:[-10000,10000,0]
spinner wwmt_super_damage_finished_ui "Quad Duration" type:#integer range:[-10000,10000,0]
spinner wwmt_radsuit_finished_ui "Rad Suit Dura" type:#integer range:[-10000,10000,0]
spinner wwmt_count_ui "Score to AP T" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team_ui "Teamcheck tea" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team1_ui "Blue point ga" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team2_ui "Red point gai" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team3_ui "Yellow point " type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team4_ui "Green point g" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_owned_by_ui "Owned by-for msg & item glow" type:#string items:#("Not Owned","Blue","Red","Yellow","Green")
on wwmt_owned_by_ui selected i do owned_by = propMapowned_by[i] 
label wwmt_owned_by_teamcheck_ui_label "Owned by teamcheck" 
editText wwmt_owned_by_teamcheck_ui "" type:#string
label wwmt_deathtype_ui_label "Goal death message" 
editText wwmt_deathtype_ui "" type:#string
label wwmt_b_b_ui_label "Message to all" 
editText wwmt_b_b_ui "" type:#string
label wwmt_message_ui_label "Message to AP" 
editText wwmt_message_ui "" type:#string
label wwmt_b_t_ui_label "Message to AP team" 
editText wwmt_b_t_ui "" type:#string
label wwmt_b_n_ui_label "Message to non-AP team" 
editText wwmt_b_n_ui "" type:#string
label wwmt_b_o_ui_label "Message to owner team" 
editText wwmt_b_o_ui "" type:#string
label wwmt_non_owners_team_broadcast_ui_label "Message to non-owner team(s)" 
editText wwmt_non_owners_team_broadcast_ui "" type:#string
label wwmt_n_b_ui_label "Console msg. to all,  percents = AP name" 
editText wwmt_n_b_ui "" type:#string
label wwmt_n_t_ui_label "Console msg to AP team" 
editText wwmt_n_t_ui "" type:#string
label wwmt_n_n_ui_label "Console msg. to non-AP team" 
editText wwmt_n_n_ui "" type:#string
label wwmt_n_o_ui_label "Console msg. to owner team" 
editText wwmt_n_o_ui "" type:#string
label wwmt_speak_ui_label "Speak (global)" 
editText wwmt_speak_ui "" type:#string
label wwmt_ap_speak_ui_label "Speak (AP)" 
editText wwmt_ap_speak_ui "" type:#string
label wwmt_team_speak_ui_label "Speak (AP team)" 
editText wwmt_team_speak_ui "" type:#string
label wwmt_non_team_speak_ui_label "Speak (non-AP team)" 
editText wwmt_non_team_speak_ui "" type:#string
label wwmt_owners_team_speak_ui_label "Speak (owner team)" 
editText wwmt_owners_team_speak_ui "" type:#string
label wwmt_non_owners_team_speak_ui_label "Speak (non-owner teams)" 
editText wwmt_non_owners_team_speak_ui "" type:#string
label wwmt_avelocity_ui_label "Angular Velocity (PYR)" 
editText wwmt_avelocity_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "No Push" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Not Solid" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Toggle" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Sparks" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Touch Activates" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_button" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_button_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_button&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_button" address:"https://developer.valvesoftware.com/wiki/func_button?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if g_a != undefined AND findItem propMapg_a g_a == 0 then (
 append propMapg_a g_a
tmp = wwmt_g_a_ui.items
 append tmp g_a
wwmt_g_a_ui.items = tmp
wwmt_g_a_ui.selection = propMapg_a.count
) else ( 
 if g_a != undefined then (
wwmt_g_a_ui.selection = (findItem propMapg_a g_a)
)
)
 if g_e != undefined AND findItem propMapg_e g_e == 0 then (
 append propMapg_e g_e
tmp = wwmt_g_e_ui.items
 append tmp g_e
wwmt_g_e_ui.items = tmp
wwmt_g_e_ui.selection = propMapg_e.count
) else ( 
 if g_e != undefined then (
wwmt_g_e_ui.selection = (findItem propMapg_e g_e)
)
)
 if goal_result != undefined AND findItem propMapgoal_result goal_result == 0 then (
 append propMapgoal_result goal_result
tmp = wwmt_goal_result_ui.items
 append tmp goal_result
wwmt_goal_result_ui.items = tmp
wwmt_goal_result_ui.selection = propMapgoal_result.count
) else ( 
 if goal_result != undefined then (
wwmt_goal_result_ui.selection = (findItem propMapgoal_result goal_result)
)
)
 if sounds != undefined AND findItem propMapsounds sounds == 0 then (
 append propMapsounds sounds
tmp = wwmt_sounds_ui.items
 append tmp sounds
wwmt_sounds_ui.items = tmp
wwmt_sounds_ui.selection = propMapsounds.count
) else ( 
 if sounds != undefined then (
wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
)
)
 if locked_sound != undefined AND findItem propMaplocked_sound locked_sound == 0 then (
 append propMaplocked_sound locked_sound
tmp = wwmt_locked_sound_ui.items
 append tmp locked_sound
wwmt_locked_sound_ui.items = tmp
wwmt_locked_sound_ui.selection = propMaplocked_sound.count
) else ( 
 if locked_sound != undefined then (
wwmt_locked_sound_ui.selection = (findItem propMaplocked_sound locked_sound)
)
)
 if unlocked_sound != undefined AND findItem propMapunlocked_sound unlocked_sound == 0 then (
 append propMapunlocked_sound unlocked_sound
tmp = wwmt_unlocked_sound_ui.items
 append tmp unlocked_sound
wwmt_unlocked_sound_ui.items = tmp
wwmt_unlocked_sound_ui.selection = propMapunlocked_sound.count
) else ( 
 if unlocked_sound != undefined then (
wwmt_unlocked_sound_ui.selection = (findItem propMapunlocked_sound unlocked_sound)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if owned_by != undefined AND findItem propMapowned_by owned_by == 0 then (
 append propMapowned_by owned_by
tmp = wwmt_owned_by_ui.items
 append tmp owned_by
wwmt_owned_by_ui.items = tmp
wwmt_owned_by_ui.selection = propMapowned_by.count
) else ( 
 if owned_by != undefined then (
wwmt_owned_by_ui.selection = (findItem propMapowned_by owned_by)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_door_CA = attributes "WW Entity func_door" version:78 attribID:#(533770476L,-65244531L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_door"
local hasOutputs = false
local hasInputs = false
local description = "Basic door"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValg_a="1"
local propMapg_a=#("0","4","8")
local propValg_e="1"
local propMapg_e=#("1","2","4","8","16","32","64")
local propValgoal_result="0"
local propMapgoal_result=#("0","2","4","8","16","32")
local propValmovesnd="0"
local propMapmovesnd=#("0","1","2","3","4","5","6","7","8","9","10")
local propValstopsnd="0"
local propMapstopsnd=#("0","1","2","3","4","5","6","7","8")
local propVallocked_sound="0"
local propMaplocked_sound=#("0","2","8","10","11","12")
local propValunlocked_sound="0"
local propMapunlocked_sound=#("0","1","3","4","5","6","7","8","9","10","13")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local propValowned_by="0"
local propMapowned_by=#("0","1","2","3","4")
local exportProps=#()	
function resetExportProps = ( exportProps=#("distance","targetname","angles","g_a","g_e","goal_result","wait","lip","dmg","message","wwmt_target","delay","netname","health","killtarget","speed","master","movesnd","stopsnd","locked_sound","unlocked_sound","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","frags","lives","armorvalue","armorclass","a_s","a_n","a_r","a_c","ammo_detpack","no_grenades_1","no_grenades_2","invincible_finished","invisible_finished","super_damage_finished","radsuit_finished","count","increase_team","increase_team1","increase_team2","increase_team3","increase_team4","owned_by","owned_by_teamcheck","deathtype","b_b","b_t","b_n","b_o","non_owners_team_broadcast","n_b","n_t","n_n","n_o","speak","ap_speak","team_speak","non_team_speak","owners_team_speak","non_owners_team_speak","avelocity"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
distance type:#integer ui:wwmt_distance_ui default:90
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
g_a type:#string ui:wwmt_g_a_ui default:"1"
g_e type:#string ui:wwmt_g_e_ui default:"1"
goal_result type:#string ui:wwmt_goal_result_ui default:"0"
wait type:#integer ui:wwmt_wait_ui default:4
lip type:#integer ui:wwmt_lip_ui
dmg type:#integer ui:wwmt_dmg_ui default:0
message type:#string ui:wwmt_message_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
delay type:#integer ui:wwmt_delay_ui
netname type:#string ui:wwmt_netname_ui default:""
health type:#integer ui:wwmt_health_ui default:0
killtarget type:#string ui:wwmt_killtarget_ui default:""
speed type:#integer ui:wwmt_speed_ui default:100
master type:#string ui:wwmt_master_ui default:""
movesnd type:#string ui:wwmt_movesnd_ui default:"0"
stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
locked_sound type:#string ui:wwmt_locked_sound_ui default:"0"
unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:"0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
frags type:#integer ui:wwmt_frags_ui
lives type:#integer ui:wwmt_lives_ui
armorvalue type:#integer ui:wwmt_armorvalue_ui
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
a_s type:#integer ui:wwmt_a_s_ui
a_n type:#integer ui:wwmt_a_n_ui
a_r type:#integer ui:wwmt_a_r_ui
a_c type:#integer ui:wwmt_a_c_ui
ammo_detpack type:#integer ui:wwmt_ammo_detpack_ui
no_grenades_1 type:#integer ui:wwmt_no_grenades_1_ui
no_grenades_2 type:#integer ui:wwmt_no_grenades_2_ui
invincible_finished type:#integer ui:wwmt_invincible_finished_ui
invisible_finished type:#integer ui:wwmt_invisible_finished_ui
super_damage_finished type:#integer ui:wwmt_super_damage_finished_ui
radsuit_finished type:#integer ui:wwmt_radsuit_finished_ui
count type:#integer ui:wwmt_count_ui
increase_team type:#integer ui:wwmt_increase_team_ui
increase_team1 type:#integer ui:wwmt_increase_team1_ui
increase_team2 type:#integer ui:wwmt_increase_team2_ui
increase_team3 type:#integer ui:wwmt_increase_team3_ui
increase_team4 type:#integer ui:wwmt_increase_team4_ui
owned_by type:#string ui:wwmt_owned_by_ui default:"0"
owned_by_teamcheck type:#string ui:wwmt_owned_by_teamcheck_ui default:""
deathtype type:#string ui:wwmt_deathtype_ui default:""
b_b type:#string ui:wwmt_b_b_ui default:""
b_t type:#string ui:wwmt_b_t_ui default:""
b_n type:#string ui:wwmt_b_n_ui default:""
b_o type:#string ui:wwmt_b_o_ui default:""
non_owners_team_broadcast type:#string ui:wwmt_non_owners_team_broadcast_ui default:""
n_b type:#string ui:wwmt_n_b_ui default:""
n_t type:#string ui:wwmt_n_t_ui default:""
n_n type:#string ui:wwmt_n_n_ui default:""
n_o type:#string ui:wwmt_n_o_ui default:""
speak type:#string ui:wwmt_speak_ui default:""
ap_speak type:#string ui:wwmt_ap_speak_ui default:""
team_speak type:#string ui:wwmt_team_speak_ui default:""
non_team_speak type:#string ui:wwmt_non_team_speak_ui default:""
owners_team_speak type:#string ui:wwmt_owners_team_speak_ui default:""
non_owners_team_speak type:#string ui:wwmt_non_owners_team_speak_ui default:""
avelocity type:#string ui:wwmt_avelocity_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "func_door"
spinner wwmt_distance_ui "Distance (deg" type:#integer range:[-10000,10000,90]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
dropdownlist wwmt_g_a_ui "Goal Activation bitfields" type:#string items:#("0 - none","4 - if AP fails criteria","8 - hit by engin. spanner")
on wwmt_g_a_ui selected i do g_a = propMapg_a[i] 
dropdownlist wwmt_g_e_ui "Goal Effects bitfields" type:#string items:#("1 - Activating Player(AP)","2 - APs team","4 - Not on APs team","8 - Not the AP","16 - Walls obstruct radius","32 - Same environment only","64 - Check APA individually")
on wwmt_g_e_ui selected i do g_e = propMapg_e[i] 
dropdownlist wwmt_goal_result_ui "Goal Result bitfields" type:#string items:#("none","2 - Sub-goals apply AP mods","4 - scores, intermission, end","8 - Sub-Goals don't apply results","16 - Prevent Spy disguise","32 - Force respawn, no die")
on wwmt_goal_result_ui selected i do goal_result = propMapgoal_result[i] 
spinner wwmt_wait_ui "delay before " type:#integer range:[-10000,10000,4]
spinner wwmt_lip_ui "Lip" type:#integer range:[-10000,10000,0]
spinner wwmt_dmg_ui "Damage inflic" type:#integer range:[-10000,10000,0]
label wwmt_message_ui_label "Message if triggered" 
editText wwmt_message_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
spinner wwmt_delay_ui "Delay before " type:#integer range:[-10000,10000,0]
label wwmt_netname_ui_label "Fire on Close" 
editText wwmt_netname_ui "" type:#string
spinner wwmt_health_ui "Health (shoot" type:#integer range:[-10000,10000,0]
label wwmt_killtarget_ui_label "KillTarget" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
spinner wwmt_speed_ui "Speed" type:#integer range:[-10000,10000,100]
label wwmt_master_ui_label "Master" 
editText wwmt_master_ui "" type:#string
dropdownlist wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound","Servo (Sliding)","Pneumatic (Sliding)","Pneumatic (Rolling)","Vacuum","Power Hydraulic","Large Rollers","Track Door","Snappy Metal Door","Squeaky 1","Squeaky 2")
on wwmt_movesnd_ui selected i do movesnd = propMapmovesnd[i] 
dropdownlist wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound","Clang with brake","Clang reverb","Ratchet Stop","Chunk","Light airbrake","Metal Slide Stop","Metal Lock Stop","Snappy Metal Stop")
on wwmt_stopsnd_ui selected i do stopsnd = propMapstopsnd[i] 
dropdownlist wwmt_locked_sound_ui "Locked Sound" type:#string items:#("None","Access Denied","Small zap","Buzz","Buzz Off","Latch Locked")
on wwmt_locked_sound_ui selected i do locked_sound = propMaplocked_sound[i] 
dropdownlist wwmt_unlocked_sound_ui "Unlocked Sound" type:#string items:#("None","Big zap & Warmup","Access Granted","Quick Combolock","Power Deadbolt 1","Power Deadbolt 2","Plunger","Small zap","Keycard Sound","Buzz","Latch Unlocked")
on wwmt_unlocked_sound_ui selected i do unlocked_sound = propMapunlocked_sound[i] 
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
spinner wwmt_frags_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_lives_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_armorvalue_ui "Armor Value  " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
spinner wwmt_a_s_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_n_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_r_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_c_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_ammo_detpack_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_1_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_2_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_invincible_finished_ui "Invincibility" type:#integer range:[-10000,10000,0]
spinner wwmt_invisible_finished_ui "Invisibility " type:#integer range:[-10000,10000,0]
spinner wwmt_super_damage_finished_ui "Quad Duration" type:#integer range:[-10000,10000,0]
spinner wwmt_radsuit_finished_ui "Rad Suit Dura" type:#integer range:[-10000,10000,0]
spinner wwmt_count_ui "Score to AP T" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team_ui "Teamcheck tea" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team1_ui "Blue point ga" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team2_ui "Red point gai" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team3_ui "Yellow point " type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team4_ui "Green point g" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_owned_by_ui "Owned by-for msg & item glow" type:#string items:#("Not Owned","Blue","Red","Yellow","Green")
on wwmt_owned_by_ui selected i do owned_by = propMapowned_by[i] 
label wwmt_owned_by_teamcheck_ui_label "Owned by teamcheck" 
editText wwmt_owned_by_teamcheck_ui "" type:#string
label wwmt_deathtype_ui_label "Goal death message" 
editText wwmt_deathtype_ui "" type:#string
label wwmt_b_b_ui_label "Message to all" 
editText wwmt_b_b_ui "" type:#string
label wwmt_b_t_ui_label "Message to AP team" 
editText wwmt_b_t_ui "" type:#string
label wwmt_b_n_ui_label "Message to non-AP team" 
editText wwmt_b_n_ui "" type:#string
label wwmt_b_o_ui_label "Message to owner team" 
editText wwmt_b_o_ui "" type:#string
label wwmt_non_owners_team_broadcast_ui_label "Message to non-owner team(s)" 
editText wwmt_non_owners_team_broadcast_ui "" type:#string
label wwmt_n_b_ui_label "Console msg. to all,  percents = AP name" 
editText wwmt_n_b_ui "" type:#string
label wwmt_n_t_ui_label "Console msg to AP team" 
editText wwmt_n_t_ui "" type:#string
label wwmt_n_n_ui_label "Console msg. to non-AP team" 
editText wwmt_n_n_ui "" type:#string
label wwmt_n_o_ui_label "Console msg. to owner team" 
editText wwmt_n_o_ui "" type:#string
label wwmt_speak_ui_label "Speak (global)" 
editText wwmt_speak_ui "" type:#string
label wwmt_ap_speak_ui_label "Speak (AP)" 
editText wwmt_ap_speak_ui "" type:#string
label wwmt_team_speak_ui_label "Speak (AP team)" 
editText wwmt_team_speak_ui "" type:#string
label wwmt_non_team_speak_ui_label "Speak (non-AP team)" 
editText wwmt_non_team_speak_ui "" type:#string
label wwmt_owners_team_speak_ui_label "Speak (owner team)" 
editText wwmt_owners_team_speak_ui "" type:#string
label wwmt_non_owners_team_speak_ui_label "Speak (non-owner teams)" 
editText wwmt_non_owners_team_speak_ui "" type:#string
label wwmt_avelocity_ui_label "Angular Velocity (PYR)" 
editText wwmt_avelocity_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_2_ui "Reverse Dir" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "One-way" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "X Axis" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "Y Axis" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
checkbox flag_1_ui "Starts Open" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Don't link" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Passable" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Toggle" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Use Only" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_door" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_door_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_door&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_door" address:"https://developer.valvesoftware.com/wiki/func_door?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if g_a != undefined AND findItem propMapg_a g_a == 0 then (
 append propMapg_a g_a
tmp = wwmt_g_a_ui.items
 append tmp g_a
wwmt_g_a_ui.items = tmp
wwmt_g_a_ui.selection = propMapg_a.count
) else ( 
 if g_a != undefined then (
wwmt_g_a_ui.selection = (findItem propMapg_a g_a)
)
)
 if g_e != undefined AND findItem propMapg_e g_e == 0 then (
 append propMapg_e g_e
tmp = wwmt_g_e_ui.items
 append tmp g_e
wwmt_g_e_ui.items = tmp
wwmt_g_e_ui.selection = propMapg_e.count
) else ( 
 if g_e != undefined then (
wwmt_g_e_ui.selection = (findItem propMapg_e g_e)
)
)
 if goal_result != undefined AND findItem propMapgoal_result goal_result == 0 then (
 append propMapgoal_result goal_result
tmp = wwmt_goal_result_ui.items
 append tmp goal_result
wwmt_goal_result_ui.items = tmp
wwmt_goal_result_ui.selection = propMapgoal_result.count
) else ( 
 if goal_result != undefined then (
wwmt_goal_result_ui.selection = (findItem propMapgoal_result goal_result)
)
)
 if movesnd != undefined AND findItem propMapmovesnd movesnd == 0 then (
 append propMapmovesnd movesnd
tmp = wwmt_movesnd_ui.items
 append tmp movesnd
wwmt_movesnd_ui.items = tmp
wwmt_movesnd_ui.selection = propMapmovesnd.count
) else ( 
 if movesnd != undefined then (
wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
)
)
 if stopsnd != undefined AND findItem propMapstopsnd stopsnd == 0 then (
 append propMapstopsnd stopsnd
tmp = wwmt_stopsnd_ui.items
 append tmp stopsnd
wwmt_stopsnd_ui.items = tmp
wwmt_stopsnd_ui.selection = propMapstopsnd.count
) else ( 
 if stopsnd != undefined then (
wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
)
)
 if locked_sound != undefined AND findItem propMaplocked_sound locked_sound == 0 then (
 append propMaplocked_sound locked_sound
tmp = wwmt_locked_sound_ui.items
 append tmp locked_sound
wwmt_locked_sound_ui.items = tmp
wwmt_locked_sound_ui.selection = propMaplocked_sound.count
) else ( 
 if locked_sound != undefined then (
wwmt_locked_sound_ui.selection = (findItem propMaplocked_sound locked_sound)
)
)
 if unlocked_sound != undefined AND findItem propMapunlocked_sound unlocked_sound == 0 then (
 append propMapunlocked_sound unlocked_sound
tmp = wwmt_unlocked_sound_ui.items
 append tmp unlocked_sound
wwmt_unlocked_sound_ui.items = tmp
wwmt_unlocked_sound_ui.selection = propMapunlocked_sound.count
) else ( 
 if unlocked_sound != undefined then (
wwmt_unlocked_sound_ui.selection = (findItem propMapunlocked_sound unlocked_sound)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)
 if owned_by != undefined AND findItem propMapowned_by owned_by == 0 then (
 append propMapowned_by owned_by
tmp = wwmt_owned_by_ui.items
 append tmp owned_by
wwmt_owned_by_ui.items = tmp
wwmt_owned_by_ui.selection = propMapowned_by.count
) else ( 
 if owned_by != undefined then (
wwmt_owned_by_ui.selection = (findItem propMapowned_by owned_by)
)
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_friction_CA = attributes "WW Entity func_friction" version:78 attribID:#(-708039973L,-844677114L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_friction"
local hasOutputs = false
local hasInputs = false
local description = "Surface with a change in friction"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local exportProps=#()	
function resetExportProps = ( exportProps=#("modifier","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
modifier type:#integer ui:wwmt_modifier_ui default:15
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""

)

rollout params "Entity Properties"
(
label entityLabel "func_friction"
spinner wwmt_modifier_ui "Percentage of" type:#integer range:[-10000,10000,15]
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_friction" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_friction_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_friction&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_friction" address:"https://developer.valvesoftware.com/wiki/func_friction?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_guntarget_CA = attributes "WW Entity func_guntarget" version:78 attribID:#(-379939509L,231270615L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_guntarget"
local hasOutputs = false
local hasInputs = false
local description = "Moving target"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local exportProps=#()	
function resetExportProps = ( exportProps=#("speed","wwmt_target","message","health","targetname","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","avelocity"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
speed type:#integer ui:wwmt_speed_ui default:100
wwmt_target type:#string ui:wwmt_target_ui default:""
message type:#string ui:wwmt_message_ui default:""
health type:#integer ui:wwmt_health_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
avelocity type:#string ui:wwmt_avelocity_ui default:""

)

rollout params "Entity Properties"
(
label entityLabel "func_guntarget"
spinner wwmt_speed_ui "Speed (units " type:#integer range:[-10000,10000,100]
label wwmt_target_ui_label "First stop target" 
editText wwmt_target_ui "" type:#string
label wwmt_message_ui_label "Fire on damage" 
editText wwmt_message_ui "" type:#string
spinner wwmt_health_ui "Damage to Tak" type:#integer range:[-10000,10000,0]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
label wwmt_avelocity_ui_label "Angular Velocity (PYR)" 
editText wwmt_avelocity_ui "" type:#string

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_guntarget" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_guntarget_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_guntarget&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_guntarget" address:"https://developer.valvesoftware.com/wiki/func_guntarget?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_healthcharger_CA = attributes "WW Entity func_healthcharger" version:78 attribID:#(1193873533L,-1452723872L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_healthcharger"
local hasOutputs = false
local hasInputs = false
local description = "Wall health recharger"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local exportProps=#()	
function resetExportProps = ( exportProps=#("dmdelay","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
dmdelay type:#integer ui:wwmt_dmdelay_ui default:0
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui

)

rollout params "Entity Properties"
(
label entityLabel "func_healthcharger"
spinner wwmt_dmdelay_ui "Deathmatch re" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_healthcharger" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_healthcharger_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_healthcharger&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_healthcharger" address:"https://developer.valvesoftware.com/wiki/func_healthcharger?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_illusionary_CA = attributes "WW Entity func_illusionary" version:78 attribID:#(-283992820L,-1491237814L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_illusionary"
local hasOutputs = false
local hasInputs = false
local description = "Fake Wall/Light"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValskin="-1"
local propMapskin=#("-1","-7")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local exportProps=#()	
function resetExportProps = ( exportProps=#("skin","targetname","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight","avelocity"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
skin type:#string ui:wwmt_skin_ui default:"-1"
targetname type:#string ui:wwmt_targetname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
avelocity type:#string ui:wwmt_avelocity_ui default:""

		on skin set val do (
			getNode()
			if ::WallWormHelperOps != undefined then ::WallWormHelperOps.setProxySkin thisNode val
		)

)

rollout params "Entity Properties"
(
label entityLabel "func_illusionary"
dropdownlist wwmt_skin_ui "Contents" type:#string items:#("Empty","Volumetric Light")
on wwmt_skin_ui selected i do skin = propMapskin[i] 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string
label wwmt_avelocity_ui_label "Angular Velocity (PYR)" 
editText wwmt_avelocity_ui "" type:#string

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_illusionary" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_illusionary_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_illusionary&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_illusionary" address:"https://developer.valvesoftware.com/wiki/func_illusionary?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if skin != undefined AND findItem propMapskin skin == 0 then (
 append propMapskin skin
tmp = wwmt_skin_ui.items
 append tmp skin
wwmt_skin_ui.items = tmp
wwmt_skin_ui.selection = propMapskin.count
) else ( 
 if skin != undefined then (
wwmt_skin_ui.selection = (findItem propMapskin skin)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_ladder_CA = attributes "WW Entity func_ladder" version:78 attribID:#(721320529L,375431330L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_ladder"
local hasOutputs = false
local hasInputs = false
local description = "Ladder"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValm_fcontrol="0"
local propMapm_fcontrol=#("0","1","2")
local exportProps=#()	
function resetExportProps = ( exportProps=#("m_flspread","m_icount","m_fcontrol","m_iszxcontroller","m_iszycontroller"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
m_flspread type:#integer ui:wwmt_m_flspread_ui default:64
m_icount type:#integer ui:wwmt_m_icount_ui default:1
m_fcontrol type:#string ui:wwmt_m_fcontrol_ui default:"0"
m_iszxcontroller type:#string ui:wwmt_m_iszxcontroller_ui default:""
m_iszycontroller type:#string ui:wwmt_m_iszycontroller_ui default:""

)

rollout params "Entity Properties"
(
label entityLabel "func_ladder"
spinner wwmt_m_flspread_ui "Spread Radius" type:#integer range:[-10000,10000,64]
spinner wwmt_m_icount_ui "Repeat Count" type:#integer range:[-10000,10000,1]
dropdownlist wwmt_m_fcontrol_ui "Targeting" type:#string items:#("Random","Activator","Table")
on wwmt_m_fcontrol_ui selected i do m_fcontrol = propMapm_fcontrol[i] 
label wwmt_m_iszxcontroller_ui_label "X Controller" 
editText wwmt_m_iszxcontroller_ui "" type:#string
pickbutton wwmt_m_iszxcontroller_pickme_ui "Pick X Controller" message:"Pick Target Entity for X Controller" filter:target_name_filter 
on wwmt_m_iszxcontroller_pickme_ui picked obj do (
m_iszxcontroller = obj.targetname
) 
label wwmt_m_iszycontroller_ui_label "Y Controller" 
editText wwmt_m_iszycontroller_ui "" type:#string
pickbutton wwmt_m_iszycontroller_pickme_ui "Pick Y Controller" message:"Pick Target Entity for Y Controller" filter:target_name_filter 
on wwmt_m_iszycontroller_pickme_ui picked obj do (
m_iszycontroller = obj.targetname
) 

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_ladder" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_ladder_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_ladder&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_ladder" address:"https://developer.valvesoftware.com/wiki/func_ladder?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if m_fcontrol != undefined AND findItem propMapm_fcontrol m_fcontrol == 0 then (
 append propMapm_fcontrol m_fcontrol
tmp = wwmt_m_fcontrol_ui.items
 append tmp m_fcontrol
wwmt_m_fcontrol_ui.items = tmp
wwmt_m_fcontrol_ui.selection = propMapm_fcontrol.count
) else ( 
 if m_fcontrol != undefined then (
wwmt_m_fcontrol_ui.selection = (findItem propMapm_fcontrol m_fcontrol)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_pendulum_CA = attributes "WW Entity func_pendulum" version:78 attribID:#(1167220161L,-750938788L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_pendulum"
local hasOutputs = false
local hasInputs = false
local description = "Swings back and forth"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local exportProps=#()	
function resetExportProps = ( exportProps=#("speed","distance","damp","dmg","targetname","angles","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
speed type:#integer ui:wwmt_speed_ui default:100
distance type:#integer ui:wwmt_distance_ui default:90
damp type:#integer ui:wwmt_damp_ui default:0
dmg type:#integer ui:wwmt_dmg_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "func_pendulum"
spinner wwmt_speed_ui "Speed" type:#integer range:[-10000,10000,100]
spinner wwmt_distance_ui "Distance (deg" type:#integer range:[-10000,10000,90]
spinner wwmt_damp_ui "Damping (0-10" type:#integer range:[-10000,10000,0]
spinner wwmt_dmg_ui "Damage inflic" type:#integer range:[-10000,10000,0]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Start ON" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Passable" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Auto-return" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "X Axis" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "Y Axis" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_pendulum" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_pendulum_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_pendulum&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_pendulum" address:"https://developer.valvesoftware.com/wiki/func_pendulum?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_plat_CA = attributes "WW Entity func_plat" version:78 attribID:#(533770476L,-1987300282L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_plat"
local hasOutputs = false
local hasInputs = false
local description = "Moving Platform"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local propValmovesnd="0"
local propMapmovesnd=#("0","1","2","3","4","5","6","7","8","9","10","11","12","13")
local propValstopsnd="0"
local propMapstopsnd=#("0","1","2","3","4","5","6","7","8")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local exportProps=#()	
function resetExportProps = ( exportProps=#("height","speed","targetname","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight","movesnd","stopsnd","volume","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","avelocity"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
height type:#integer ui:wwmt_height_ui default:0
speed type:#integer ui:wwmt_speed_ui default:50
targetname type:#string ui:wwmt_targetname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
movesnd type:#string ui:wwmt_movesnd_ui default:"0"
stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
volume type:#string ui:wwmt_volume_ui default:"0.85"
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
avelocity type:#string ui:wwmt_avelocity_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "func_plat"
spinner wwmt_height_ui "Travel altitu" type:#integer range:[-10000,10000,0]
spinner wwmt_speed_ui "Speed" type:#integer range:[-10000,10000,50]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string
dropdownlist wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound","big elev 1","big elev 2","tech elev 1","tech elev 2","tech elev 3","freight elev 1","freight elev 2","heavy elev","rack elev","rail elev","squeak elev","odd elev 1","odd elev 2")
on wwmt_movesnd_ui selected i do movesnd = propMapmovesnd[i] 
dropdownlist wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound","big elev stop1","big elev stop2","freight elev stop","heavy elev stop","rack stop","rail stop","squeak stop","quick stop")
on wwmt_stopsnd_ui selected i do stopsnd = propMapstopsnd[i] 
label wwmt_volume_ui_label "Sound Volume 0.0 - 1.0" 
editText wwmt_volume_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
label wwmt_avelocity_ui_label "Angular Velocity (PYR)" 
editText wwmt_avelocity_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Toggle" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_plat" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_plat_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_plat&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_plat" address:"https://developer.valvesoftware.com/wiki/func_plat?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)
 if movesnd != undefined AND findItem propMapmovesnd movesnd == 0 then (
 append propMapmovesnd movesnd
tmp = wwmt_movesnd_ui.items
 append tmp movesnd
wwmt_movesnd_ui.items = tmp
wwmt_movesnd_ui.selection = propMapmovesnd.count
) else ( 
 if movesnd != undefined then (
wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
)
)
 if stopsnd != undefined AND findItem propMapstopsnd stopsnd == 0 then (
 append propMapstopsnd stopsnd
tmp = wwmt_stopsnd_ui.items
 append tmp stopsnd
wwmt_stopsnd_ui.items = tmp
wwmt_stopsnd_ui.selection = propMapstopsnd.count
) else ( 
 if stopsnd != undefined then (
wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_platrot_CA = attributes "WW Entity func_platrot" version:78 attribID:#(1167220161L,1209110428L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_platrot"
local hasOutputs = false
local hasInputs = false
local description = "Moving Rotating platform"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local propValmovesnd="0"
local propMapmovesnd=#("0","1","2","3","4","5","6","7","8","9","10","11","12","13")
local propValstopsnd="0"
local propMapstopsnd=#("0","1","2","3","4","5","6","7","8")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local exportProps=#()	
function resetExportProps = ( exportProps=#("speed","height","rotation","targetname","angles","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight","movesnd","stopsnd","volume","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
speed type:#integer ui:wwmt_speed_ui default:50
height type:#integer ui:wwmt_height_ui default:0
rotation type:#integer ui:wwmt_rotation_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
movesnd type:#string ui:wwmt_movesnd_ui default:"0"
stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
volume type:#string ui:wwmt_volume_ui default:"0.85"
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "func_platrot"
spinner wwmt_speed_ui "Speed of rota" type:#integer range:[-10000,10000,50]
spinner wwmt_height_ui "Travel altitu" type:#integer range:[-10000,10000,0]
spinner wwmt_rotation_ui "Spin amount" type:#integer range:[-10000,10000,0]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string
dropdownlist wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound","big elev 1","big elev 2","tech elev 1","tech elev 2","tech elev 3","freight elev 1","freight elev 2","heavy elev","rack elev","rail elev","squeak elev","odd elev 1","odd elev 2")
on wwmt_movesnd_ui selected i do movesnd = propMapmovesnd[i] 
dropdownlist wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound","big elev stop1","big elev stop2","freight elev stop","heavy elev stop","rack stop","rail stop","squeak stop","quick stop")
on wwmt_stopsnd_ui selected i do stopsnd = propMapstopsnd[i] 
label wwmt_volume_ui_label "Sound Volume 0.0 - 1.0" 
editText wwmt_volume_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Toggle" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "X Axis" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "Y Axis" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_platrot" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_platrot_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_platrot&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_platrot" address:"https://developer.valvesoftware.com/wiki/func_platrot?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)
 if movesnd != undefined AND findItem propMapmovesnd movesnd == 0 then (
 append propMapmovesnd movesnd
tmp = wwmt_movesnd_ui.items
 append tmp movesnd
wwmt_movesnd_ui.items = tmp
wwmt_movesnd_ui.selection = propMapmovesnd.count
) else ( 
 if movesnd != undefined then (
wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
)
)
 if stopsnd != undefined AND findItem propMapstopsnd stopsnd == 0 then (
 append propMapstopsnd stopsnd
tmp = wwmt_stopsnd_ui.items
 append tmp stopsnd
wwmt_stopsnd_ui.items = tmp
wwmt_stopsnd_ui.selection = propMapstopsnd.count
) else ( 
 if stopsnd != undefined then (
wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_pushable_CA = attributes "WW Entity func_pushable" version:78 attribID:#(1167220161L,-79527866L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_pushable"
local hasOutputs = false
local hasInputs = false
local description = "Pushable object"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsize="0"
local propMapsize=#("0","1","2","3")
local propValmaterial="0"
local propMapmaterial=#("0","1","2","3","4","5","6","7","8")
local propValexplosion="0"
local propMapexplosion=#("0","1")
local propValspawnobject="0"
local propMapspawnobject=#("0","1","2")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local exportProps=#()	
function resetExportProps = ( exportProps=#("size","friction","buoyancy","targetname","wwmt_target","health","wwmt_material","explosion","delay","gibmodel","spawnobject","explodemagnitude","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
size type:#string ui:wwmt_size_ui default:"0"
friction type:#integer ui:wwmt_friction_ui default:50
buoyancy type:#integer ui:wwmt_buoyancy_ui default:20
targetname type:#string ui:wwmt_targetname_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
health type:#integer ui:wwmt_health_ui default:1
wwmt_material type:#string ui:wwmt_material_ui default:"0"
explosion type:#string ui:wwmt_explosion_ui default:"0"
delay type:#string ui:wwmt_delay_ui default:"0"
gibmodel type:#string ui:wwmt_gibmodel_ui default:""
spawnobject type:#string ui:wwmt_spawnobject_ui default:"0"
explodemagnitude type:#integer ui:wwmt_explodemagnitude_ui default:0
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "func_pushable"
dropdownlist wwmt_size_ui "Hull Size" type:#string items:#("Point size","Player size","Big Size","Player duck")
on wwmt_size_ui selected i do size = propMapsize[i] 
spinner wwmt_friction_ui "Friction (0-4" type:#integer range:[-10000,10000,50]
spinner wwmt_buoyancy_ui "Buoyancy" type:#integer range:[-10000,10000,20]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_target_ui_label "Target on break" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target on break" message:"Pick Target Entity for Target on break" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
spinner wwmt_health_ui "Strength" type:#integer range:[-10000,10000,1]
dropdownlist wwmt_material_ui "Material type" type:#string items:#("Glass","Wood","Metal","Flesh","Cinder Block","Ceiling Tile","Computer","Unbreakable Glass","Rocks")
on wwmt_material_ui selected i do wwmt_material = propMapmaterial[i] 
dropdownlist wwmt_explosion_ui "Gibs Direction" type:#string items:#("Random","Relative to Attack")
on wwmt_explosion_ui selected i do explosion = propMapexplosion[i] 
label wwmt_delay_ui_label "Delay before fire" 
editText wwmt_delay_ui "" type:#string
label wwmt_gibmodel_ui_label "Gib Model" 
editText wwmt_gibmodel_ui "" type:#string
dropdownlist wwmt_spawnobject_ui "Spawn On Break" type:#string items:#("Nothing","Battery","Healthkit")
on wwmt_spawnobject_ui selected i do spawnobject = propMapspawnobject[i] 
spinner wwmt_explodemagnitude_ui "Explode Magni" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_128_ui.checked == true then (
sfs+=128
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_128_ui "Breakable" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_pushable" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_pushable_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_pushable&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_pushable" address:"https://developer.valvesoftware.com/wiki/func_pushable?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if size != undefined AND findItem propMapsize size == 0 then (
 append propMapsize size
tmp = wwmt_size_ui.items
 append tmp size
wwmt_size_ui.items = tmp
wwmt_size_ui.selection = propMapsize.count
) else ( 
 if size != undefined then (
wwmt_size_ui.selection = (findItem propMapsize size)
)
)
 if wwmt_material != undefined AND findItem propMapmaterial wwmt_material == 0 then (
 append propMapmaterial wwmt_material
tmp = wwmt_material_ui.items
 append tmp wwmt_material
wwmt_material_ui.items = tmp
wwmt_material_ui.selection = propMapmaterial.count
) else ( 
 if wwmt_material != undefined then (
wwmt_material_ui.selection = (findItem propMapmaterial wwmt_material)
)
)
 if explosion != undefined AND findItem propMapexplosion explosion == 0 then (
 append propMapexplosion explosion
tmp = wwmt_explosion_ui.items
 append tmp explosion
wwmt_explosion_ui.items = tmp
wwmt_explosion_ui.selection = propMapexplosion.count
) else ( 
 if explosion != undefined then (
wwmt_explosion_ui.selection = (findItem propMapexplosion explosion)
)
)
 if spawnobject != undefined AND findItem propMapspawnobject spawnobject == 0 then (
 append propMapspawnobject spawnobject
tmp = wwmt_spawnobject_ui.items
 append tmp spawnobject
wwmt_spawnobject_ui.items = tmp
wwmt_spawnobject_ui.selection = propMapspawnobject.count
) else ( 
 if spawnobject != undefined then (
wwmt_spawnobject_ui.selection = (findItem propMapspawnobject spawnobject)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_recharge_CA = attributes "WW Entity func_recharge" version:78 attribID:#(-1964947721L,-1646512993L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_recharge"
local hasOutputs = false
local hasInputs = false
local description = "Battery recharger"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local exportProps=#()	
function resetExportProps = ( exportProps=#("dmdelay","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
dmdelay type:#integer ui:wwmt_dmdelay_ui default:0
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui

)

rollout params "Entity Properties"
(
label entityLabel "func_recharge"
spinner wwmt_dmdelay_ui "Deathmatch re" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_recharge" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_recharge_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_recharge&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_recharge" address:"https://developer.valvesoftware.com/wiki/func_recharge?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_rot_button_CA = attributes "WW Entity func_rot_button" version:78 attribID:#(-70763294L,-1009942767L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_rot_button"
local hasOutputs = false
local hasInputs = false
local description = "RotatingButton"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValg_a="1"
local propMapg_a=#("0","4","8")
local propValg_e="1"
local propMapg_e=#("1","2","4","8","16","32")
local propValgoal_result="0"
local propMapgoal_result=#("0","2","4","8","16","32")
local propValsounds="21"
local propMapsounds=#("21","22","23","24","25")
local propValwait="3"
local propMapwait=#("-1")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("g_a","g_e","goal_result","wwmt_target","changetarget","master","speed","health","sounds","wait","delay","distance","targetname","angles","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","frags","lives","armorvalue","armorclass","a_s","a_n","a_r","a_c","ammo_detpack","no_grenades_1","no_grenades_2","invincible_finished","invisible_finished","super_damage_finished","radsuit_finished","count","increase_team","increase_team1","increase_team2","increase_team3","increase_team4"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
g_a type:#string ui:wwmt_g_a_ui default:"1"
g_e type:#string ui:wwmt_g_e_ui default:"1"
goal_result type:#string ui:wwmt_goal_result_ui default:"0"
wwmt_target type:#string ui:wwmt_target_ui default:""
changetarget type:#string ui:wwmt_changetarget_ui default:""
master type:#string ui:wwmt_master_ui default:""
speed type:#integer ui:wwmt_speed_ui default:50
health type:#integer ui:wwmt_health_ui
sounds type:#string ui:wwmt_sounds_ui default:"21"
wait type:#string ui:wwmt_wait_ui default:"3"
delay type:#string ui:wwmt_delay_ui default:"0"
distance type:#integer ui:wwmt_distance_ui default:90
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
frags type:#integer ui:wwmt_frags_ui
lives type:#integer ui:wwmt_lives_ui
armorvalue type:#integer ui:wwmt_armorvalue_ui
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
a_s type:#integer ui:wwmt_a_s_ui
a_n type:#integer ui:wwmt_a_n_ui
a_r type:#integer ui:wwmt_a_r_ui
a_c type:#integer ui:wwmt_a_c_ui
ammo_detpack type:#integer ui:wwmt_ammo_detpack_ui
no_grenades_1 type:#integer ui:wwmt_no_grenades_1_ui
no_grenades_2 type:#integer ui:wwmt_no_grenades_2_ui
invincible_finished type:#integer ui:wwmt_invincible_finished_ui
invisible_finished type:#integer ui:wwmt_invisible_finished_ui
super_damage_finished type:#integer ui:wwmt_super_damage_finished_ui
radsuit_finished type:#integer ui:wwmt_radsuit_finished_ui
count type:#integer ui:wwmt_count_ui
increase_team type:#integer ui:wwmt_increase_team_ui
increase_team1 type:#integer ui:wwmt_increase_team1_ui
increase_team2 type:#integer ui:wwmt_increase_team2_ui
increase_team3 type:#integer ui:wwmt_increase_team3_ui
increase_team4 type:#integer ui:wwmt_increase_team4_ui
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "func_rot_button"
dropdownlist wwmt_g_a_ui "Goal Activation bitfields" type:#string items:#("0 - none","4 - if AP fails criteria","8 - hit by engin. spanner")
on wwmt_g_a_ui selected i do g_a = propMapg_a[i] 
dropdownlist wwmt_g_e_ui "Goal Effects bitfields" type:#string items:#("1 - Activating Player(AP)","2 - APs team","4 - Not on APs team","8 - Not the AP","16 - Walls obstruct radius","32 - Same environment only")
on wwmt_g_e_ui selected i do g_e = propMapg_e[i] 
dropdownlist wwmt_goal_result_ui "Goal Result bitfields" type:#string items:#("none","2 - Sub-goals apply AP mods","4 - scores, intermission, end","8 - Sub-Goals don't apply results","16 - Prevent Spy disguise","32 - Force respawn, no die")
on wwmt_goal_result_ui selected i do goal_result = propMapgoal_result[i] 
label wwmt_target_ui_label "Targetted object" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Targetted object" message:"Pick Target Entity for Targetted object" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_changetarget_ui_label "ChangeTarget Name" 
editText wwmt_changetarget_ui "" type:#string
pickbutton wwmt_changetarget_pickme_ui "Pick ChangeTarget Name" message:"Pick Target Entity for ChangeTarget Name" filter:target_name_filter 
on wwmt_changetarget_pickme_ui picked obj do (
changetarget = obj.targetname
) 
label wwmt_master_ui_label "Master" 
editText wwmt_master_ui "" type:#string
spinner wwmt_speed_ui "Speed" type:#integer range:[-10000,10000,50]
spinner wwmt_health_ui "Health (shoot" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_sounds_ui "Sounds" type:#string items:#("Squeaky","Squeaky Pneumatic","Ratchet Groan","Clean Ratchet","Gas Clunk")
on wwmt_sounds_ui selected i do sounds = propMapsounds[i] 
dropdownlist wwmt_wait_ui "Delay before reset" type:#string items:#("Stays pressed")
on wwmt_wait_ui selected i do wait = propMapwait[i] 
label wwmt_delay_ui_label "Delay before trigger" 
editText wwmt_delay_ui "" type:#string
spinner wwmt_distance_ui "Distance (deg" type:#integer range:[-10000,10000,90]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
spinner wwmt_frags_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_lives_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_armorvalue_ui "Armor Value  " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
spinner wwmt_a_s_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_n_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_r_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_c_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_ammo_detpack_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_1_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_2_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_invincible_finished_ui "Invincibility" type:#integer range:[-10000,10000,0]
spinner wwmt_invisible_finished_ui "Invisibility " type:#integer range:[-10000,10000,0]
spinner wwmt_super_damage_finished_ui "Quad Duration" type:#integer range:[-10000,10000,0]
spinner wwmt_radsuit_finished_ui "Rad Suit Dura" type:#integer range:[-10000,10000,0]
spinner wwmt_count_ui "Score to AP T" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team_ui "Teamcheck tea" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team1_ui "Blue point ga" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team2_ui "Red point gai" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team3_ui "Yellow point " type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team4_ui "Green point g" type:#integer range:[-10000,10000,0]

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Not solid" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Reverse Dir" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Toggle" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "X Axis" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "Y Axis" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Touch Activates" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_rot_button" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_rot_button_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_rot_button&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_rot_button" address:"https://developer.valvesoftware.com/wiki/func_rot_button?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if g_a != undefined AND findItem propMapg_a g_a == 0 then (
 append propMapg_a g_a
tmp = wwmt_g_a_ui.items
 append tmp g_a
wwmt_g_a_ui.items = tmp
wwmt_g_a_ui.selection = propMapg_a.count
) else ( 
 if g_a != undefined then (
wwmt_g_a_ui.selection = (findItem propMapg_a g_a)
)
)
 if g_e != undefined AND findItem propMapg_e g_e == 0 then (
 append propMapg_e g_e
tmp = wwmt_g_e_ui.items
 append tmp g_e
wwmt_g_e_ui.items = tmp
wwmt_g_e_ui.selection = propMapg_e.count
) else ( 
 if g_e != undefined then (
wwmt_g_e_ui.selection = (findItem propMapg_e g_e)
)
)
 if goal_result != undefined AND findItem propMapgoal_result goal_result == 0 then (
 append propMapgoal_result goal_result
tmp = wwmt_goal_result_ui.items
 append tmp goal_result
wwmt_goal_result_ui.items = tmp
wwmt_goal_result_ui.selection = propMapgoal_result.count
) else ( 
 if goal_result != undefined then (
wwmt_goal_result_ui.selection = (findItem propMapgoal_result goal_result)
)
)
 if sounds != undefined AND findItem propMapsounds sounds == 0 then (
 append propMapsounds sounds
tmp = wwmt_sounds_ui.items
 append tmp sounds
wwmt_sounds_ui.items = tmp
wwmt_sounds_ui.selection = propMapsounds.count
) else ( 
 if sounds != undefined then (
wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
)
)
 if wait != undefined AND findItem propMapwait wait == 0 then (
 append propMapwait wait
tmp = wwmt_wait_ui.items
 append tmp wait
wwmt_wait_ui.items = tmp
wwmt_wait_ui.selection = propMapwait.count
) else ( 
 if wait != undefined then (
wwmt_wait_ui.selection = (findItem propMapwait wait)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_rotating_CA = attributes "WW Entity func_rotating" version:78 attribID:#(-1964947721L,-487807204L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_rotating"
local hasOutputs = false
local hasInputs = false
local description = "Rotating Object"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsounds="0"
local propMapsounds=#("0","1","2","3","4","5")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local exportProps=#()	
function resetExportProps = ( exportProps=#("speed","volume","fanfriction","sounds","message","spawnorigin","dmg","targetname","angles","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
speed type:#integer ui:wwmt_speed_ui default:0
volume type:#integer ui:wwmt_volume_ui default:10
fanfriction type:#integer ui:wwmt_fanfriction_ui default:20
sounds type:#string ui:wwmt_sounds_ui default:"0"
message type:#string ui:wwmt_message_ui default:""
spawnorigin type:#string ui:wwmt_spawnorigin_ui default:"0 0 0"
dmg type:#integer ui:wwmt_dmg_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "func_rotating"
spinner wwmt_speed_ui "Rotation Spee" type:#integer range:[-10000,10000,0]
spinner wwmt_volume_ui "Volume (10 = " type:#integer range:[-10000,10000,10]
spinner wwmt_fanfriction_ui "Friction (0 -" type:#integer range:[-10000,10000,20]
dropdownlist wwmt_sounds_ui "Fan Sounds" type:#string items:#("No Sound","Fast Whine","Slow Rush","Medium Rickety","Fast Beating","Slow Smooth")
on wwmt_sounds_ui selected i do sounds = propMapsounds[i] 
label wwmt_message_ui_label "WAV Name" 
editText wwmt_message_ui "" type:#string
label wwmt_spawnorigin_ui_label "X Y Z - Move here after lighting" 
editText wwmt_spawnorigin_ui "" type:#string
spinner wwmt_dmg_ui "Damage inflic" type:#integer range:[-10000,10000,0]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Start ON" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Reverse Direction" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "X Axis" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Y Axis" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Acc/Dcc" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Fan Pain" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Not Solid" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "Small Radius" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Medium Radius" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Large Radius" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_rotating" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_rotating_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_rotating&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_rotating" address:"https://developer.valvesoftware.com/wiki/func_rotating?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if sounds != undefined AND findItem propMapsounds sounds == 0 then (
 append propMapsounds sounds
tmp = wwmt_sounds_ui.items
 append tmp sounds
wwmt_sounds_ui.items = tmp
wwmt_sounds_ui.selection = propMapsounds.count
) else ( 
 if sounds != undefined then (
wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_tank_CA = attributes "WW Entity func_tank" version:78 attribID:#(533770476L,-535527541L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_tank"
local hasOutputs = false
local hasInputs = false
local description = "Brush Gun Turret"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValbullet="0"
local propMapbullet=#("0","1","2","3")
local propValfirespread="0"
local propMapfirespread=#("0","1","2","3","4")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local exportProps=#()	
function resetExportProps = ( exportProps=#("bullet","master","yawrate","yawrange","yawtolerance","pitchrate","pitchrange","pitchtolerance","barrel","barrely","barrelz","spritesmoke","spriteflash","spritescale","rotatesound","firerate","bullet_damage","persistence","firespread","minrange","maxrange","targetname","wwmt_target","angles","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
bullet type:#string ui:wwmt_bullet_ui default:"0"
master type:#string ui:wwmt_master_ui default:""
yawrate type:#string ui:wwmt_yawrate_ui default:"30"
yawrange type:#string ui:wwmt_yawrange_ui default:"180"
yawtolerance type:#string ui:wwmt_yawtolerance_ui default:"15"
pitchrate type:#string ui:wwmt_pitchrate_ui default:"0"
pitchrange type:#string ui:wwmt_pitchrange_ui default:"0"
pitchtolerance type:#string ui:wwmt_pitchtolerance_ui default:"5"
barrel type:#string ui:wwmt_barrel_ui default:"0"
barrely type:#string ui:wwmt_barrely_ui default:"0"
barrelz type:#string ui:wwmt_barrelz_ui default:"0"
spritesmoke type:#string ui:wwmt_spritesmoke_ui default:""
spriteflash type:#string ui:wwmt_spriteflash_ui default:""
spritescale type:#string ui:wwmt_spritescale_ui default:"1"
rotatesound type:#string ui:wwmt_rotatesound_ui default:""
firerate type:#string ui:wwmt_firerate_ui default:"1"
bullet_damage type:#string ui:wwmt_bullet_damage_ui default:"0"
persistence type:#string ui:wwmt_persistence_ui default:"1"
firespread type:#string ui:wwmt_firespread_ui default:"0"
minrange type:#string ui:wwmt_minrange_ui default:"0"
maxrange type:#string ui:wwmt_maxrange_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "func_tank"
dropdownlist wwmt_bullet_ui "Bullets" type:#string items:#("None","9mm","MP5","12mm")
on wwmt_bullet_ui selected i do bullet = propMapbullet[i] 
label wwmt_master_ui_label "(Team) Master" 
editText wwmt_master_ui "" type:#string
label wwmt_yawrate_ui_label "Yaw rate" 
editText wwmt_yawrate_ui "" type:#string
label wwmt_yawrange_ui_label "Yaw range" 
editText wwmt_yawrange_ui "" type:#string
label wwmt_yawtolerance_ui_label "Yaw tolerance" 
editText wwmt_yawtolerance_ui "" type:#string
label wwmt_pitchrate_ui_label "Pitch rate" 
editText wwmt_pitchrate_ui "" type:#string
label wwmt_pitchrange_ui_label "Pitch range" 
editText wwmt_pitchrange_ui "" type:#string
label wwmt_pitchtolerance_ui_label "Pitch tolerance" 
editText wwmt_pitchtolerance_ui "" type:#string
label wwmt_barrel_ui_label "Barrel Length" 
editText wwmt_barrel_ui "" type:#string
label wwmt_barrely_ui_label "Barrel Horizontal" 
editText wwmt_barrely_ui "" type:#string
label wwmt_barrelz_ui_label "Barrel Vertical" 
editText wwmt_barrelz_ui "" type:#string
label wwmt_spritesmoke_ui_label "Smoke Sprite" 
editText wwmt_spritesmoke_ui "" type:#string
label wwmt_spriteflash_ui_label "Flash Sprite" 
editText wwmt_spriteflash_ui "" type:#string
label wwmt_spritescale_ui_label "Sprite scale" 
editText wwmt_spritescale_ui "" type:#string
label wwmt_rotatesound_ui_label "Rotate Sound" 
editText wwmt_rotatesound_ui "" type:#string
label wwmt_firerate_ui_label "Rate of Fire" 
editText wwmt_firerate_ui "" type:#string
label wwmt_bullet_damage_ui_label "Damage Per Bullet" 
editText wwmt_bullet_damage_ui "" type:#string
label wwmt_persistence_ui_label "Firing persistence" 
editText wwmt_persistence_ui "" type:#string
dropdownlist wwmt_firespread_ui "Bullet accuracy" type:#string items:#("Perfect Shot","Small cone","Medium cone","Large cone","Extra-large cone")
on wwmt_firespread_ui selected i do firespread = propMapfirespread[i] 
label wwmt_minrange_ui_label "Minmum target range" 
editText wwmt_minrange_ui "" type:#string
label wwmt_maxrange_ui_label "Maximum target range" 
editText wwmt_maxrange_ui "" type:#string
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Active" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Only Direct" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Controllable" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_tank" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_tank_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_tank&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_tank" address:"https://developer.valvesoftware.com/wiki/func_tank?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if bullet != undefined AND findItem propMapbullet bullet == 0 then (
 append propMapbullet bullet
tmp = wwmt_bullet_ui.items
 append tmp bullet
wwmt_bullet_ui.items = tmp
wwmt_bullet_ui.selection = propMapbullet.count
) else ( 
 if bullet != undefined then (
wwmt_bullet_ui.selection = (findItem propMapbullet bullet)
)
)
 if firespread != undefined AND findItem propMapfirespread firespread == 0 then (
 append propMapfirespread firespread
tmp = wwmt_firespread_ui.items
 append tmp firespread
wwmt_firespread_ui.items = tmp
wwmt_firespread_ui.selection = propMapfirespread.count
) else ( 
 if firespread != undefined then (
wwmt_firespread_ui.selection = (findItem propMapfirespread firespread)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_tankcontrols_CA = attributes "WW Entity func_tankcontrols" version:78 attribID:#(690331584L,128744087L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_tankcontrols"
local hasOutputs = false
local hasInputs = false
local description = "Tank controls"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local exportProps=#()	
function resetExportProps = ( exportProps=#("wwmt_target","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
wwmt_target type:#string ui:wwmt_target_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui

)

rollout params "Entity Properties"
(
label entityLabel "func_tankcontrols"
label wwmt_target_ui_label "Tank entity name" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Tank entity name" message:"Pick Target Entity for Tank entity name" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_tankcontrols" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_tankcontrols_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_tankcontrols&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_tankcontrols" address:"https://developer.valvesoftware.com/wiki/func_tankcontrols?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_tanklaser_CA = attributes "WW Entity func_tanklaser" version:78 attribID:#(735805750L,98301112L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_tanklaser"
local hasOutputs = false
local hasInputs = false
local description = "Brush Laser Turret"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValfirespread="0"
local propMapfirespread=#("0","1","2","3","4")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local exportProps=#()	
function resetExportProps = ( exportProps=#("laserentity","master","yawrate","yawrange","yawtolerance","pitchrate","pitchrange","pitchtolerance","barrel","barrely","barrelz","spritesmoke","spriteflash","spritescale","rotatesound","firerate","bullet_damage","persistence","firespread","minrange","maxrange","targetname","wwmt_target","angles","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
laserentity type:#string ui:wwmt_laserentity_ui default:""
master type:#string ui:wwmt_master_ui default:""
yawrate type:#string ui:wwmt_yawrate_ui default:"30"
yawrange type:#string ui:wwmt_yawrange_ui default:"180"
yawtolerance type:#string ui:wwmt_yawtolerance_ui default:"15"
pitchrate type:#string ui:wwmt_pitchrate_ui default:"0"
pitchrange type:#string ui:wwmt_pitchrange_ui default:"0"
pitchtolerance type:#string ui:wwmt_pitchtolerance_ui default:"5"
barrel type:#string ui:wwmt_barrel_ui default:"0"
barrely type:#string ui:wwmt_barrely_ui default:"0"
barrelz type:#string ui:wwmt_barrelz_ui default:"0"
spritesmoke type:#string ui:wwmt_spritesmoke_ui default:""
spriteflash type:#string ui:wwmt_spriteflash_ui default:""
spritescale type:#string ui:wwmt_spritescale_ui default:"1"
rotatesound type:#string ui:wwmt_rotatesound_ui default:""
firerate type:#string ui:wwmt_firerate_ui default:"1"
bullet_damage type:#string ui:wwmt_bullet_damage_ui default:"0"
persistence type:#string ui:wwmt_persistence_ui default:"1"
firespread type:#string ui:wwmt_firespread_ui default:"0"
minrange type:#string ui:wwmt_minrange_ui default:"0"
maxrange type:#string ui:wwmt_maxrange_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "func_tanklaser"
label wwmt_laserentity_ui_label "env_laser Entity" 
editText wwmt_laserentity_ui "" type:#string
label wwmt_master_ui_label "(Team) Master" 
editText wwmt_master_ui "" type:#string
label wwmt_yawrate_ui_label "Yaw rate" 
editText wwmt_yawrate_ui "" type:#string
label wwmt_yawrange_ui_label "Yaw range" 
editText wwmt_yawrange_ui "" type:#string
label wwmt_yawtolerance_ui_label "Yaw tolerance" 
editText wwmt_yawtolerance_ui "" type:#string
label wwmt_pitchrate_ui_label "Pitch rate" 
editText wwmt_pitchrate_ui "" type:#string
label wwmt_pitchrange_ui_label "Pitch range" 
editText wwmt_pitchrange_ui "" type:#string
label wwmt_pitchtolerance_ui_label "Pitch tolerance" 
editText wwmt_pitchtolerance_ui "" type:#string
label wwmt_barrel_ui_label "Barrel Length" 
editText wwmt_barrel_ui "" type:#string
label wwmt_barrely_ui_label "Barrel Horizontal" 
editText wwmt_barrely_ui "" type:#string
label wwmt_barrelz_ui_label "Barrel Vertical" 
editText wwmt_barrelz_ui "" type:#string
label wwmt_spritesmoke_ui_label "Smoke Sprite" 
editText wwmt_spritesmoke_ui "" type:#string
label wwmt_spriteflash_ui_label "Flash Sprite" 
editText wwmt_spriteflash_ui "" type:#string
label wwmt_spritescale_ui_label "Sprite scale" 
editText wwmt_spritescale_ui "" type:#string
label wwmt_rotatesound_ui_label "Rotate Sound" 
editText wwmt_rotatesound_ui "" type:#string
label wwmt_firerate_ui_label "Rate of Fire" 
editText wwmt_firerate_ui "" type:#string
label wwmt_bullet_damage_ui_label "Damage Per Bullet" 
editText wwmt_bullet_damage_ui "" type:#string
label wwmt_persistence_ui_label "Firing persistence" 
editText wwmt_persistence_ui "" type:#string
dropdownlist wwmt_firespread_ui "Bullet accuracy" type:#string items:#("Perfect Shot","Small cone","Medium cone","Large cone","Extra-large cone")
on wwmt_firespread_ui selected i do firespread = propMapfirespread[i] 
label wwmt_minrange_ui_label "Minmum target range" 
editText wwmt_minrange_ui "" type:#string
label wwmt_maxrange_ui_label "Maximum target range" 
editText wwmt_maxrange_ui "" type:#string
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Active" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Only Direct" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Controllable" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_tanklaser" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_tanklaser_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_tanklaser&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_tanklaser" address:"https://developer.valvesoftware.com/wiki/func_tanklaser?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if firespread != undefined AND findItem propMapfirespread firespread == 0 then (
 append propMapfirespread firespread
tmp = wwmt_firespread_ui.items
 append tmp firespread
wwmt_firespread_ui.items = tmp
wwmt_firespread_ui.selection = propMapfirespread.count
) else ( 
 if firespread != undefined then (
wwmt_firespread_ui.selection = (findItem propMapfirespread firespread)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_tankrocket_CA = attributes "WW Entity func_tankrocket" version:78 attribID:#(735805750L,-1533756459L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_tankrocket"
local hasOutputs = false
local hasInputs = false
local description = "Brush Rocket Turret"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValfirespread="0"
local propMapfirespread=#("0","1","2","3","4")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local exportProps=#()	
function resetExportProps = ( exportProps=#("imagnitude","master","yawrate","yawrange","yawtolerance","pitchrate","pitchrange","pitchtolerance","barrel","barrely","barrelz","spritesmoke","spriteflash","spritescale","rotatesound","firerate","bullet_damage","persistence","firespread","minrange","maxrange","targetname","wwmt_target","angles","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
imagnitude type:#string ui:wwmt_imagnitude_ui default:"100"
master type:#string ui:wwmt_master_ui default:""
yawrate type:#string ui:wwmt_yawrate_ui default:"30"
yawrange type:#string ui:wwmt_yawrange_ui default:"180"
yawtolerance type:#string ui:wwmt_yawtolerance_ui default:"15"
pitchrate type:#string ui:wwmt_pitchrate_ui default:"0"
pitchrange type:#string ui:wwmt_pitchrange_ui default:"0"
pitchtolerance type:#string ui:wwmt_pitchtolerance_ui default:"5"
barrel type:#string ui:wwmt_barrel_ui default:"0"
barrely type:#string ui:wwmt_barrely_ui default:"0"
barrelz type:#string ui:wwmt_barrelz_ui default:"0"
spritesmoke type:#string ui:wwmt_spritesmoke_ui default:""
spriteflash type:#string ui:wwmt_spriteflash_ui default:""
spritescale type:#string ui:wwmt_spritescale_ui default:"1"
rotatesound type:#string ui:wwmt_rotatesound_ui default:""
firerate type:#string ui:wwmt_firerate_ui default:"1"
bullet_damage type:#string ui:wwmt_bullet_damage_ui default:"0"
persistence type:#string ui:wwmt_persistence_ui default:"1"
firespread type:#string ui:wwmt_firespread_ui default:"0"
minrange type:#string ui:wwmt_minrange_ui default:"0"
maxrange type:#string ui:wwmt_maxrange_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "func_tankrocket"
label wwmt_imagnitude_ui_label "Explosion Magnitude" 
editText wwmt_imagnitude_ui "" type:#string
label wwmt_master_ui_label "(Team) Master" 
editText wwmt_master_ui "" type:#string
label wwmt_yawrate_ui_label "Yaw rate" 
editText wwmt_yawrate_ui "" type:#string
label wwmt_yawrange_ui_label "Yaw range" 
editText wwmt_yawrange_ui "" type:#string
label wwmt_yawtolerance_ui_label "Yaw tolerance" 
editText wwmt_yawtolerance_ui "" type:#string
label wwmt_pitchrate_ui_label "Pitch rate" 
editText wwmt_pitchrate_ui "" type:#string
label wwmt_pitchrange_ui_label "Pitch range" 
editText wwmt_pitchrange_ui "" type:#string
label wwmt_pitchtolerance_ui_label "Pitch tolerance" 
editText wwmt_pitchtolerance_ui "" type:#string
label wwmt_barrel_ui_label "Barrel Length" 
editText wwmt_barrel_ui "" type:#string
label wwmt_barrely_ui_label "Barrel Horizontal" 
editText wwmt_barrely_ui "" type:#string
label wwmt_barrelz_ui_label "Barrel Vertical" 
editText wwmt_barrelz_ui "" type:#string
label wwmt_spritesmoke_ui_label "Smoke Sprite" 
editText wwmt_spritesmoke_ui "" type:#string
label wwmt_spriteflash_ui_label "Flash Sprite" 
editText wwmt_spriteflash_ui "" type:#string
label wwmt_spritescale_ui_label "Sprite scale" 
editText wwmt_spritescale_ui "" type:#string
label wwmt_rotatesound_ui_label "Rotate Sound" 
editText wwmt_rotatesound_ui "" type:#string
label wwmt_firerate_ui_label "Rate of Fire" 
editText wwmt_firerate_ui "" type:#string
label wwmt_bullet_damage_ui_label "Damage Per Bullet" 
editText wwmt_bullet_damage_ui "" type:#string
label wwmt_persistence_ui_label "Firing persistence" 
editText wwmt_persistence_ui "" type:#string
dropdownlist wwmt_firespread_ui "Bullet accuracy" type:#string items:#("Perfect Shot","Small cone","Medium cone","Large cone","Extra-large cone")
on wwmt_firespread_ui selected i do firespread = propMapfirespread[i] 
label wwmt_minrange_ui_label "Minmum target range" 
editText wwmt_minrange_ui "" type:#string
label wwmt_maxrange_ui_label "Maximum target range" 
editText wwmt_maxrange_ui "" type:#string
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Active" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Only Direct" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Controllable" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_tankrocket" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_tankrocket_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_tankrocket&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_tankrocket" address:"https://developer.valvesoftware.com/wiki/func_tankrocket?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if firespread != undefined AND findItem propMapfirespread firespread == 0 then (
 append propMapfirespread firespread
tmp = wwmt_firespread_ui.items
 append tmp firespread
wwmt_firespread_ui.items = tmp
wwmt_firespread_ui.selection = propMapfirespread.count
) else ( 
 if firespread != undefined then (
wwmt_firespread_ui.selection = (findItem propMapfirespread firespread)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_trackautochange_CA = attributes "WW Entity func_trackautochange" version:78 attribID:#(-1059899516L,-1832384351L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_trackautochange"
local hasOutputs = false
local hasInputs = false
local description = "Automatic track changing platform"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsounds="0"
local propMapsounds=#("0","1","2","3","4","5","6")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local propValmovesnd="0"
local propMapmovesnd=#("0","1","2","3","4","5","6","7","8","9","10","11","12","13")
local propValstopsnd="0"
local propMapstopsnd=#("0","1","2","3","4","5","6","7","8")
local exportProps=#()	
function resetExportProps = ( exportProps=#("wwmt_target","sounds","wheels","height","startspeed","speed","dmg","volume","bank","rotation","train","toptrack","bottomtrack","targetname","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight","movesnd","stopsnd"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
wwmt_target type:#string ui:wwmt_target_ui default:""
sounds type:#string ui:wwmt_sounds_ui default:"0"
wheels type:#integer ui:wwmt_wheels_ui default:50
height type:#integer ui:wwmt_height_ui default:4
startspeed type:#integer ui:wwmt_startspeed_ui default:0
speed type:#integer ui:wwmt_speed_ui default:64
dmg type:#integer ui:wwmt_dmg_ui default:0
volume type:#integer ui:wwmt_volume_ui default:10
bank type:#string ui:wwmt_bank_ui default:"0"
rotation type:#integer ui:wwmt_rotation_ui default:0
train type:#string ui:wwmt_train_ui default:""
toptrack type:#string ui:wwmt_toptrack_ui default:""
bottomtrack type:#string ui:wwmt_bottomtrack_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
movesnd type:#string ui:wwmt_movesnd_ui default:"0"
stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "func_trackautochange"
label wwmt_target_ui_label "First stop target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick First stop target" message:"Pick Target Entity for First stop target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
dropdownlist wwmt_sounds_ui "Sound" type:#string items:#("None","Rail 1","Rail 2","Rail 3","Rail 4","Rail 6","Rail 7")
on wwmt_sounds_ui selected i do sounds = propMapsounds[i] 
spinner wwmt_wheels_ui "Distance betw" type:#integer range:[-10000,10000,50]
spinner wwmt_height_ui "Height above " type:#integer range:[-10000,10000,4]
spinner wwmt_startspeed_ui "Initial speed" type:#integer range:[-10000,10000,0]
spinner wwmt_speed_ui "Speed (units " type:#integer range:[-10000,10000,64]
spinner wwmt_dmg_ui "Damage on cru" type:#integer range:[-10000,10000,0]
spinner wwmt_volume_ui "Volume (10 = " type:#integer range:[-10000,10000,10]
label wwmt_bank_ui_label "Bank angle on turns" 
editText wwmt_bank_ui "" type:#string
spinner wwmt_rotation_ui "Spin amount" type:#integer range:[-10000,10000,0]
label wwmt_train_ui_label "Train to switch" 
editText wwmt_train_ui "" type:#string
pickbutton wwmt_train_pickme_ui "Pick Train to switch" message:"Pick Target Entity for Train to switch" filter:target_name_filter 
on wwmt_train_pickme_ui picked obj do (
train = obj.targetname
) 
label wwmt_toptrack_ui_label "Top track" 
editText wwmt_toptrack_ui "" type:#string
pickbutton wwmt_toptrack_pickme_ui "Pick Top track" message:"Pick Target Entity for Top track" filter:target_name_filter 
on wwmt_toptrack_pickme_ui picked obj do (
toptrack = obj.targetname
) 
label wwmt_bottomtrack_ui_label "Bottom track" 
editText wwmt_bottomtrack_ui "" type:#string
pickbutton wwmt_bottomtrack_pickme_ui "Pick Bottom track" message:"Pick Target Entity for Bottom track" filter:target_name_filter 
on wwmt_bottomtrack_pickme_ui picked obj do (
bottomtrack = obj.targetname
) 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string
dropdownlist wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound","big elev 1","big elev 2","tech elev 1","tech elev 2","tech elev 3","freight elev 1","freight elev 2","heavy elev","rack elev","rail elev","squeak elev","odd elev 1","odd elev 2")
on wwmt_movesnd_ui selected i do movesnd = propMapmovesnd[i] 
dropdownlist wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound","big elev stop1","big elev stop2","freight elev stop","heavy elev stop","rack stop","rail stop","squeak stop","quick stop")
on wwmt_stopsnd_ui selected i do stopsnd = propMapstopsnd[i] 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "No Pitch (X-rot)" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "No User Control" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Passable" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Rotate Only" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "X Axis" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "Y Axis" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_trackautochange" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_trackautochange_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_trackautochange&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_trackautochange" address:"https://developer.valvesoftware.com/wiki/func_trackautochange?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if sounds != undefined AND findItem propMapsounds sounds == 0 then (
 append propMapsounds sounds
tmp = wwmt_sounds_ui.items
 append tmp sounds
wwmt_sounds_ui.items = tmp
wwmt_sounds_ui.selection = propMapsounds.count
) else ( 
 if sounds != undefined then (
wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)
 if movesnd != undefined AND findItem propMapmovesnd movesnd == 0 then (
 append propMapmovesnd movesnd
tmp = wwmt_movesnd_ui.items
 append tmp movesnd
wwmt_movesnd_ui.items = tmp
wwmt_movesnd_ui.selection = propMapmovesnd.count
) else ( 
 if movesnd != undefined then (
wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
)
)
 if stopsnd != undefined AND findItem propMapstopsnd stopsnd == 0 then (
 append propMapstopsnd stopsnd
tmp = wwmt_stopsnd_ui.items
 append tmp stopsnd
wwmt_stopsnd_ui.items = tmp
wwmt_stopsnd_ui.selection = propMapstopsnd.count
) else ( 
 if stopsnd != undefined then (
wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_traincontrols_CA = attributes "WW Entity func_traincontrols" version:78 attribID:#(-1629377049L,122952090L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_traincontrols"
local hasOutputs = false
local hasInputs = false
local description = "Train Controls"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local exportProps=#()	
function resetExportProps = ( exportProps=#("wwmt_target","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
wwmt_target type:#string ui:wwmt_target_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui

)

rollout params "Entity Properties"
(
label entityLabel "func_traincontrols"
label wwmt_target_ui_label "Train Name" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Train Name" message:"Pick Target Entity for Train Name" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_traincontrols" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_traincontrols_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_traincontrols&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_traincontrols" address:"https://developer.valvesoftware.com/wiki/func_traincontrols?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_train_CA = attributes "WW Entity func_train" version:78 attribID:#(721320529L,828994452L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_train"
local hasOutputs = false
local hasInputs = false
local description = "Platform follows paths"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValmovesnd="0"
local propMapmovesnd=#("0","1","2","3","4","5","6","7","8","9","10","11","12","13")
local propValstopsnd="0"
local propMapstopsnd=#("0","1","2","3","4","5","6","7","8")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local exportProps=#()	
function resetExportProps = ( exportProps=#("wwmt_target","movesnd","stopsnd","speed","dmg","skin","volume","targetname","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight","avelocity"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
wwmt_target type:#string ui:wwmt_target_ui default:""
movesnd type:#string ui:wwmt_movesnd_ui default:"0"
stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
speed type:#integer ui:wwmt_speed_ui default:64
dmg type:#integer ui:wwmt_dmg_ui default:0
skin type:#integer ui:wwmt_skin_ui default:0
volume type:#string ui:wwmt_volume_ui default:"0.85"
targetname type:#string ui:wwmt_targetname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
avelocity type:#string ui:wwmt_avelocity_ui default:""
spawnflags type:#integer default:0

		on skin set val do (
			getNode()
			if ::WallWormHelperOps != undefined then ::WallWormHelperOps.setProxySkin thisNode val
		)

)

rollout params "Entity Properties"
(
label entityLabel "func_train"
label wwmt_target_ui_label "First stop target" 
editText wwmt_target_ui "" type:#string
dropdownlist wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound","big elev 1","big elev 2","tech elev 1","tech elev 2","tech elev 3","freight elev 1","freight elev 2","heavy elev","rack elev","rail elev","squeek elev","odd elev 1","odd elev 2")
on wwmt_movesnd_ui selected i do movesnd = propMapmovesnd[i] 
dropdownlist wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound","big elev stop1","big elev stop2","freight elev stop","heavy elev stop","rack stop","rail stop","squeek stop","quick stop")
on wwmt_stopsnd_ui selected i do stopsnd = propMapstopsnd[i] 
spinner wwmt_speed_ui "Speed (units " type:#integer range:[-10000,10000,64]
spinner wwmt_dmg_ui "Damage on cru" type:#integer range:[-10000,10000,0]
spinner wwmt_skin_ui "Contents" type:#integer range:[-10000,10000,0]
label wwmt_volume_ui_label "Sound Volume 0.0 - 1.0" 
editText wwmt_volume_ui "" type:#string
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string
label wwmt_avelocity_ui_label "Angular Velocity (PYR)" 
editText wwmt_avelocity_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_8_ui.checked == true then (
sfs+=8
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_8_ui "Not solid" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_train" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_train_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_train&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_train" address:"https://developer.valvesoftware.com/wiki/func_train?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if movesnd != undefined AND findItem propMapmovesnd movesnd == 0 then (
 append propMapmovesnd movesnd
tmp = wwmt_movesnd_ui.items
 append tmp movesnd
wwmt_movesnd_ui.items = tmp
wwmt_movesnd_ui.selection = propMapmovesnd.count
) else ( 
 if movesnd != undefined then (
wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
)
)
 if stopsnd != undefined AND findItem propMapstopsnd stopsnd == 0 then (
 append propMapstopsnd stopsnd
tmp = wwmt_stopsnd_ui.items
 append tmp stopsnd
wwmt_stopsnd_ui.items = tmp
wwmt_stopsnd_ui.selection = propMapstopsnd.count
) else ( 
 if stopsnd != undefined then (
wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_wall_CA = attributes "WW Entity func_wall" version:78 attribID:#(533770476L,808840333L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_wall"
local hasOutputs = false
local hasInputs = false
local description = "Wall"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local exportProps=#()	
function resetExportProps = ( exportProps=#("targetname","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
targetname type:#string ui:wwmt_targetname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "func_wall"
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Starts Invisible" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_wall" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_wall_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_wall&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_wall" address:"https://developer.valvesoftware.com/wiki/func_wall?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_func_water_CA = attributes "WW Entity func_water" version:78 attribID:#(721320529L,-1779180711L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_water"
local hasOutputs = false
local hasInputs = false
local description = "Liquid"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValskin="-3"
local propMapskin=#("-3","-4","-5")
local propValmovesnd="0"
local propMapmovesnd=#("0","1","2","3","4","5","6","7","8","9","10")
local propValstopsnd="0"
local propMapstopsnd=#("0","1","2","3","4","5","6","7","8")
local propVallocked_sound="0"
local propMaplocked_sound=#("0","2","8","10","11","12")
local propValunlocked_sound="0"
local propMapunlocked_sound=#("0","1","3","4","5","6","7","8","9","10","13")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local exportProps=#()	
function resetExportProps = ( exportProps=#("skin","waveheight","targetname","angles","wait","lip","dmg","message","wwmt_target","delay","netname","health","killtarget","speed","master","movesnd","stopsnd","locked_sound","unlocked_sound","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
skin type:#string ui:wwmt_skin_ui default:"-3"
waveheight type:#string ui:wwmt_waveheight_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
wait type:#integer ui:wwmt_wait_ui default:4
lip type:#integer ui:wwmt_lip_ui
dmg type:#integer ui:wwmt_dmg_ui default:0
message type:#string ui:wwmt_message_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
delay type:#integer ui:wwmt_delay_ui
netname type:#string ui:wwmt_netname_ui default:""
health type:#integer ui:wwmt_health_ui default:0
killtarget type:#string ui:wwmt_killtarget_ui default:""
speed type:#integer ui:wwmt_speed_ui default:100
master type:#string ui:wwmt_master_ui default:""
movesnd type:#string ui:wwmt_movesnd_ui default:"0"
stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
locked_sound type:#string ui:wwmt_locked_sound_ui default:"0"
unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:"0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
spawnflags type:#integer default:0

		on skin set val do (
			getNode()
			if ::WallWormHelperOps != undefined then ::WallWormHelperOps.setProxySkin thisNode val
		)

)

rollout params "Entity Properties"
(
label entityLabel "func_water"
dropdownlist wwmt_skin_ui "Contents" type:#string items:#("Water","Slime","Lava")
on wwmt_skin_ui selected i do skin = propMapskin[i] 
label wwmt_waveheight_ui_label "Wave Height" 
editText wwmt_waveheight_ui "" type:#string
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
spinner wwmt_wait_ui "delay before " type:#integer range:[-10000,10000,4]
spinner wwmt_lip_ui "Lip" type:#integer range:[-10000,10000,0]
spinner wwmt_dmg_ui "Damage inflic" type:#integer range:[-10000,10000,0]
label wwmt_message_ui_label "Message if triggered" 
editText wwmt_message_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
spinner wwmt_delay_ui "Delay before " type:#integer range:[-10000,10000,0]
label wwmt_netname_ui_label "Fire on Close" 
editText wwmt_netname_ui "" type:#string
spinner wwmt_health_ui "Health (shoot" type:#integer range:[-10000,10000,0]
label wwmt_killtarget_ui_label "KillTarget" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
spinner wwmt_speed_ui "Speed" type:#integer range:[-10000,10000,100]
label wwmt_master_ui_label "Master" 
editText wwmt_master_ui "" type:#string
dropdownlist wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound","Servo (Sliding)","Pneumatic (Sliding)","Pneumatic (Rolling)","Vacuum","Power Hydraulic","Large Rollers","Track Door","Snappy Metal Door","Squeaky 1","Squeaky 2")
on wwmt_movesnd_ui selected i do movesnd = propMapmovesnd[i] 
dropdownlist wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound","Clang with brake","Clang reverb","Ratchet Stop","Chunk","Light airbrake","Metal Slide Stop","Metal Lock Stop","Snappy Metal Stop")
on wwmt_stopsnd_ui selected i do stopsnd = propMapstopsnd[i] 
dropdownlist wwmt_locked_sound_ui "Locked Sound" type:#string items:#("None","Access Denied","Small zap","Buzz","Buzz Off","Latch Locked")
on wwmt_locked_sound_ui selected i do locked_sound = propMaplocked_sound[i] 
dropdownlist wwmt_unlocked_sound_ui "Unlocked Sound" type:#string items:#("None","Big zap & Warmup","Access Granted","Quick Combolock","Power Deadbolt 1","Power Deadbolt 2","Plunger","Small zap","Keycard Sound","Buzz","Latch Unlocked")
on wwmt_unlocked_sound_ui selected i do unlocked_sound = propMapunlocked_sound[i] 
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Starts Open" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Use Only" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Don't link" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Passable" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Toggle" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_water" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_water_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_water&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_water" address:"https://developer.valvesoftware.com/wiki/func_water?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if skin != undefined AND findItem propMapskin skin == 0 then (
 append propMapskin skin
tmp = wwmt_skin_ui.items
 append tmp skin
wwmt_skin_ui.items = tmp
wwmt_skin_ui.selection = propMapskin.count
) else ( 
 if skin != undefined then (
wwmt_skin_ui.selection = (findItem propMapskin skin)
)
)
 if movesnd != undefined AND findItem propMapmovesnd movesnd == 0 then (
 append propMapmovesnd movesnd
tmp = wwmt_movesnd_ui.items
 append tmp movesnd
wwmt_movesnd_ui.items = tmp
wwmt_movesnd_ui.selection = propMapmovesnd.count
) else ( 
 if movesnd != undefined then (
wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
)
)
 if stopsnd != undefined AND findItem propMapstopsnd stopsnd == 0 then (
 append propMapstopsnd stopsnd
tmp = wwmt_stopsnd_ui.items
 append tmp stopsnd
wwmt_stopsnd_ui.items = tmp
wwmt_stopsnd_ui.selection = propMapstopsnd.count
) else ( 
 if stopsnd != undefined then (
wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
)
)
 if locked_sound != undefined AND findItem propMaplocked_sound locked_sound == 0 then (
 append propMaplocked_sound locked_sound
tmp = wwmt_locked_sound_ui.items
 append tmp locked_sound
wwmt_locked_sound_ui.items = tmp
wwmt_locked_sound_ui.selection = propMaplocked_sound.count
) else ( 
 if locked_sound != undefined then (
wwmt_locked_sound_ui.selection = (findItem propMaplocked_sound locked_sound)
)
)
 if unlocked_sound != undefined AND findItem propMapunlocked_sound unlocked_sound == 0 then (
 append propMapunlocked_sound unlocked_sound
tmp = wwmt_unlocked_sound_ui.items
 append tmp unlocked_sound
wwmt_unlocked_sound_ui.items = tmp
wwmt_unlocked_sound_ui.selection = propMapunlocked_sound.count
) else ( 
 if unlocked_sound != undefined then (
wwmt_unlocked_sound_ui.selection = (findItem propMapunlocked_sound unlocked_sound)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_momentary_door_CA = attributes "WW Entity momentary_door" version:78 attribID:#(62814769L,-1583901336L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="momentary_door"
local hasOutputs = false
local hasInputs = false
local description = "Momentary/Continuous door"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValg_a="1"
local propMapg_a=#("0","4","8")
local propValg_e="1"
local propMapg_e=#("1","2","4","8","16","32","64")
local propValgoal_result="0"
local propMapgoal_result=#("0","2","4","8","16","32")
local propValmovesnd="0"
local propMapmovesnd=#("0","1","2","3","4","5","6","7","8","9","10")
local propValstopsnd="0"
local propMapstopsnd=#("0","1","2","3","4","5","6","7","8")
local propVallocked_sound="0"
local propMaplocked_sound=#("0","2","8","10","11","12")
local propValunlocked_sound="0"
local propMapunlocked_sound=#("0","1","3","4","5","6","7","8","9","10","13")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local propValowned_by="0"
local propMapowned_by=#("0","1","2","3","4")
local exportProps=#()	
function resetExportProps = ( exportProps=#("targetname","angles","g_a","g_e","goal_result","wait","lip","dmg","message","wwmt_target","delay","netname","health","killtarget","speed","master","movesnd","stopsnd","locked_sound","unlocked_sound","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","frags","lives","armorvalue","armorclass","a_s","a_n","a_r","a_c","ammo_detpack","no_grenades_1","no_grenades_2","invincible_finished","invisible_finished","super_damage_finished","radsuit_finished","count","increase_team","increase_team1","increase_team2","increase_team3","increase_team4","owned_by","owned_by_teamcheck","deathtype","b_b","b_t","b_n","b_o","non_owners_team_broadcast","n_b","n_t","n_n","n_o","speak","ap_speak","team_speak","non_team_speak","owners_team_speak","non_owners_team_speak","avelocity"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
targetname type:#string ui:wwmt_targetname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
g_a type:#string ui:wwmt_g_a_ui default:"1"
g_e type:#string ui:wwmt_g_e_ui default:"1"
goal_result type:#string ui:wwmt_goal_result_ui default:"0"
wait type:#integer ui:wwmt_wait_ui default:4
lip type:#integer ui:wwmt_lip_ui
dmg type:#integer ui:wwmt_dmg_ui default:0
message type:#string ui:wwmt_message_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
delay type:#integer ui:wwmt_delay_ui
netname type:#string ui:wwmt_netname_ui default:""
health type:#integer ui:wwmt_health_ui default:0
killtarget type:#string ui:wwmt_killtarget_ui default:""
speed type:#integer ui:wwmt_speed_ui default:100
master type:#string ui:wwmt_master_ui default:""
movesnd type:#string ui:wwmt_movesnd_ui default:"0"
stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
locked_sound type:#string ui:wwmt_locked_sound_ui default:"0"
unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:"0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
frags type:#integer ui:wwmt_frags_ui
lives type:#integer ui:wwmt_lives_ui
armorvalue type:#integer ui:wwmt_armorvalue_ui
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
a_s type:#integer ui:wwmt_a_s_ui
a_n type:#integer ui:wwmt_a_n_ui
a_r type:#integer ui:wwmt_a_r_ui
a_c type:#integer ui:wwmt_a_c_ui
ammo_detpack type:#integer ui:wwmt_ammo_detpack_ui
no_grenades_1 type:#integer ui:wwmt_no_grenades_1_ui
no_grenades_2 type:#integer ui:wwmt_no_grenades_2_ui
invincible_finished type:#integer ui:wwmt_invincible_finished_ui
invisible_finished type:#integer ui:wwmt_invisible_finished_ui
super_damage_finished type:#integer ui:wwmt_super_damage_finished_ui
radsuit_finished type:#integer ui:wwmt_radsuit_finished_ui
count type:#integer ui:wwmt_count_ui
increase_team type:#integer ui:wwmt_increase_team_ui
increase_team1 type:#integer ui:wwmt_increase_team1_ui
increase_team2 type:#integer ui:wwmt_increase_team2_ui
increase_team3 type:#integer ui:wwmt_increase_team3_ui
increase_team4 type:#integer ui:wwmt_increase_team4_ui
owned_by type:#string ui:wwmt_owned_by_ui default:"0"
owned_by_teamcheck type:#string ui:wwmt_owned_by_teamcheck_ui default:""
deathtype type:#string ui:wwmt_deathtype_ui default:""
b_b type:#string ui:wwmt_b_b_ui default:""
b_t type:#string ui:wwmt_b_t_ui default:""
b_n type:#string ui:wwmt_b_n_ui default:""
b_o type:#string ui:wwmt_b_o_ui default:""
non_owners_team_broadcast type:#string ui:wwmt_non_owners_team_broadcast_ui default:""
n_b type:#string ui:wwmt_n_b_ui default:""
n_t type:#string ui:wwmt_n_t_ui default:""
n_n type:#string ui:wwmt_n_n_ui default:""
n_o type:#string ui:wwmt_n_o_ui default:""
speak type:#string ui:wwmt_speak_ui default:""
ap_speak type:#string ui:wwmt_ap_speak_ui default:""
team_speak type:#string ui:wwmt_team_speak_ui default:""
non_team_speak type:#string ui:wwmt_non_team_speak_ui default:""
owners_team_speak type:#string ui:wwmt_owners_team_speak_ui default:""
non_owners_team_speak type:#string ui:wwmt_non_owners_team_speak_ui default:""
avelocity type:#string ui:wwmt_avelocity_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "momentary_door"
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
dropdownlist wwmt_g_a_ui "Goal Activation bitfields" type:#string items:#("0 - none","4 - if AP fails criteria","8 - hit by engin. spanner")
on wwmt_g_a_ui selected i do g_a = propMapg_a[i] 
dropdownlist wwmt_g_e_ui "Goal Effects bitfields" type:#string items:#("1 - Activating Player(AP)","2 - APs team","4 - Not on APs team","8 - Not the AP","16 - Walls obstruct radius","32 - Same environment only","64 - Check APA individually")
on wwmt_g_e_ui selected i do g_e = propMapg_e[i] 
dropdownlist wwmt_goal_result_ui "Goal Result bitfields" type:#string items:#("none","2 - Sub-goals apply AP mods","4 - scores, intermission, end","8 - Sub-Goals don't apply results","16 - Prevent Spy disguise","32 - Force respawn, no die")
on wwmt_goal_result_ui selected i do goal_result = propMapgoal_result[i] 
spinner wwmt_wait_ui "delay before " type:#integer range:[-10000,10000,4]
spinner wwmt_lip_ui "Lip" type:#integer range:[-10000,10000,0]
spinner wwmt_dmg_ui "Damage inflic" type:#integer range:[-10000,10000,0]
label wwmt_message_ui_label "Message if triggered" 
editText wwmt_message_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
spinner wwmt_delay_ui "Delay before " type:#integer range:[-10000,10000,0]
label wwmt_netname_ui_label "Fire on Close" 
editText wwmt_netname_ui "" type:#string
spinner wwmt_health_ui "Health (shoot" type:#integer range:[-10000,10000,0]
label wwmt_killtarget_ui_label "KillTarget" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick KillTarget" message:"Pick Target Entity for KillTarget" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
spinner wwmt_speed_ui "Speed" type:#integer range:[-10000,10000,100]
label wwmt_master_ui_label "Master" 
editText wwmt_master_ui "" type:#string
dropdownlist wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound","Servo (Sliding)","Pneumatic (Sliding)","Pneumatic (Rolling)","Vacuum","Power Hydraulic","Large Rollers","Track Door","Snappy Metal Door","Squeaky 1","Squeaky 2")
on wwmt_movesnd_ui selected i do movesnd = propMapmovesnd[i] 
dropdownlist wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound","Clang with brake","Clang reverb","Ratchet Stop","Chunk","Light airbrake","Metal Slide Stop","Metal Lock Stop","Snappy Metal Stop")
on wwmt_stopsnd_ui selected i do stopsnd = propMapstopsnd[i] 
dropdownlist wwmt_locked_sound_ui "Locked Sound" type:#string items:#("None","Access Denied","Small zap","Buzz","Buzz Off","Latch Locked")
on wwmt_locked_sound_ui selected i do locked_sound = propMaplocked_sound[i] 
dropdownlist wwmt_unlocked_sound_ui "Unlocked Sound" type:#string items:#("None","Big zap & Warmup","Access Granted","Quick Combolock","Power Deadbolt 1","Power Deadbolt 2","Plunger","Small zap","Keycard Sound","Buzz","Latch Unlocked")
on wwmt_unlocked_sound_ui selected i do unlocked_sound = propMapunlocked_sound[i] 
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
spinner wwmt_frags_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_lives_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_armorvalue_ui "Armor Value  " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
spinner wwmt_a_s_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_n_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_r_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_c_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_ammo_detpack_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_1_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_2_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_invincible_finished_ui "Invincibility" type:#integer range:[-10000,10000,0]
spinner wwmt_invisible_finished_ui "Invisibility " type:#integer range:[-10000,10000,0]
spinner wwmt_super_damage_finished_ui "Quad Duration" type:#integer range:[-10000,10000,0]
spinner wwmt_radsuit_finished_ui "Rad Suit Dura" type:#integer range:[-10000,10000,0]
spinner wwmt_count_ui "Score to AP T" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team_ui "Teamcheck tea" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team1_ui "Blue point ga" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team2_ui "Red point gai" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team3_ui "Yellow point " type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team4_ui "Green point g" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_owned_by_ui "Owned by-for msg & item glow" type:#string items:#("Not Owned","Blue","Red","Yellow","Green")
on wwmt_owned_by_ui selected i do owned_by = propMapowned_by[i] 
label wwmt_owned_by_teamcheck_ui_label "Owned by teamcheck" 
editText wwmt_owned_by_teamcheck_ui "" type:#string
label wwmt_deathtype_ui_label "Goal death message" 
editText wwmt_deathtype_ui "" type:#string
label wwmt_b_b_ui_label "Message to all" 
editText wwmt_b_b_ui "" type:#string
label wwmt_b_t_ui_label "Message to AP team" 
editText wwmt_b_t_ui "" type:#string
label wwmt_b_n_ui_label "Message to non-AP team" 
editText wwmt_b_n_ui "" type:#string
label wwmt_b_o_ui_label "Message to owner team" 
editText wwmt_b_o_ui "" type:#string
label wwmt_non_owners_team_broadcast_ui_label "Message to non-owner team(s)" 
editText wwmt_non_owners_team_broadcast_ui "" type:#string
label wwmt_n_b_ui_label "Console msg. to all,  percents = AP name" 
editText wwmt_n_b_ui "" type:#string
label wwmt_n_t_ui_label "Console msg to AP team" 
editText wwmt_n_t_ui "" type:#string
label wwmt_n_n_ui_label "Console msg. to non-AP team" 
editText wwmt_n_n_ui "" type:#string
label wwmt_n_o_ui_label "Console msg. to owner team" 
editText wwmt_n_o_ui "" type:#string
label wwmt_speak_ui_label "Speak (global)" 
editText wwmt_speak_ui "" type:#string
label wwmt_ap_speak_ui_label "Speak (AP)" 
editText wwmt_ap_speak_ui "" type:#string
label wwmt_team_speak_ui_label "Speak (AP team)" 
editText wwmt_team_speak_ui "" type:#string
label wwmt_non_team_speak_ui_label "Speak (non-AP team)" 
editText wwmt_non_team_speak_ui "" type:#string
label wwmt_owners_team_speak_ui_label "Speak (owner team)" 
editText wwmt_owners_team_speak_ui "" type:#string
label wwmt_non_owners_team_speak_ui_label "Speak (non-owner teams)" 
editText wwmt_non_owners_team_speak_ui "" type:#string
label wwmt_avelocity_ui_label "Angular Velocity (PYR)" 
editText wwmt_avelocity_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Starts Open" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Don't link" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Passable" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Toggle" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Use Only" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with momentary_door" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"momentary_door_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=momentary_door&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: momentary_door" address:"https://developer.valvesoftware.com/wiki/momentary_door?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if g_a != undefined AND findItem propMapg_a g_a == 0 then (
 append propMapg_a g_a
tmp = wwmt_g_a_ui.items
 append tmp g_a
wwmt_g_a_ui.items = tmp
wwmt_g_a_ui.selection = propMapg_a.count
) else ( 
 if g_a != undefined then (
wwmt_g_a_ui.selection = (findItem propMapg_a g_a)
)
)
 if g_e != undefined AND findItem propMapg_e g_e == 0 then (
 append propMapg_e g_e
tmp = wwmt_g_e_ui.items
 append tmp g_e
wwmt_g_e_ui.items = tmp
wwmt_g_e_ui.selection = propMapg_e.count
) else ( 
 if g_e != undefined then (
wwmt_g_e_ui.selection = (findItem propMapg_e g_e)
)
)
 if goal_result != undefined AND findItem propMapgoal_result goal_result == 0 then (
 append propMapgoal_result goal_result
tmp = wwmt_goal_result_ui.items
 append tmp goal_result
wwmt_goal_result_ui.items = tmp
wwmt_goal_result_ui.selection = propMapgoal_result.count
) else ( 
 if goal_result != undefined then (
wwmt_goal_result_ui.selection = (findItem propMapgoal_result goal_result)
)
)
 if movesnd != undefined AND findItem propMapmovesnd movesnd == 0 then (
 append propMapmovesnd movesnd
tmp = wwmt_movesnd_ui.items
 append tmp movesnd
wwmt_movesnd_ui.items = tmp
wwmt_movesnd_ui.selection = propMapmovesnd.count
) else ( 
 if movesnd != undefined then (
wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
)
)
 if stopsnd != undefined AND findItem propMapstopsnd stopsnd == 0 then (
 append propMapstopsnd stopsnd
tmp = wwmt_stopsnd_ui.items
 append tmp stopsnd
wwmt_stopsnd_ui.items = tmp
wwmt_stopsnd_ui.selection = propMapstopsnd.count
) else ( 
 if stopsnd != undefined then (
wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
)
)
 if locked_sound != undefined AND findItem propMaplocked_sound locked_sound == 0 then (
 append propMaplocked_sound locked_sound
tmp = wwmt_locked_sound_ui.items
 append tmp locked_sound
wwmt_locked_sound_ui.items = tmp
wwmt_locked_sound_ui.selection = propMaplocked_sound.count
) else ( 
 if locked_sound != undefined then (
wwmt_locked_sound_ui.selection = (findItem propMaplocked_sound locked_sound)
)
)
 if unlocked_sound != undefined AND findItem propMapunlocked_sound unlocked_sound == 0 then (
 append propMapunlocked_sound unlocked_sound
tmp = wwmt_unlocked_sound_ui.items
 append tmp unlocked_sound
wwmt_unlocked_sound_ui.items = tmp
wwmt_unlocked_sound_ui.selection = propMapunlocked_sound.count
) else ( 
 if unlocked_sound != undefined then (
wwmt_unlocked_sound_ui.selection = (findItem propMapunlocked_sound unlocked_sound)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)
 if owned_by != undefined AND findItem propMapowned_by owned_by == 0 then (
 append propMapowned_by owned_by
tmp = wwmt_owned_by_ui.items
 append tmp owned_by
wwmt_owned_by_ui.items = tmp
wwmt_owned_by_ui.selection = propMapowned_by.count
) else ( 
 if owned_by != undefined then (
wwmt_owned_by_ui.selection = (findItem propMapowned_by owned_by)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_momentary_rot_button_CA = attributes "WW Entity momentary_rot_button" version:78 attribID:#(1150846017L,-748493796L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="momentary_rot_button"
local hasOutputs = false
local hasInputs = false
local description = "Direct wheel control"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsounds="0"
local propMapsounds=#("0","1","2","3","4","5","6","7","8","9","21","22","23","24","25")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16")
local propValzhlt_lightflags="0"
local propMapzhlt_lightflags=#("0","1","2","3")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local propValowned_by="0"
local propMapowned_by=#("0","1","2","3","4")
local exportProps=#()	
function resetExportProps = ( exportProps=#("speed","master","sounds","distance","returnspeed","targetname","wwmt_target","angles","rendermode","renderamt","rendercolor","renderfx","zhlt_lightflags","_minlight","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","frags","lives","health","armorvalue","armorclass","a_s","a_n","a_r","a_c","ammo_detpack","no_grenades_1","no_grenades_2","invincible_finished","invisible_finished","super_damage_finished","radsuit_finished","count","increase_team","increase_team1","increase_team2","increase_team3","increase_team4","owned_by","owned_by_teamcheck","deathtype","b_b","message","b_t","b_n","b_o","non_owners_team_broadcast","n_b","n_t","n_n","n_o","speak","ap_speak","team_speak","non_team_speak","owners_team_speak","non_owners_team_speak"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
speed type:#integer ui:wwmt_speed_ui default:50
master type:#string ui:wwmt_master_ui default:""
sounds type:#string ui:wwmt_sounds_ui default:"0"
distance type:#integer ui:wwmt_distance_ui default:90
returnspeed type:#integer ui:wwmt_returnspeed_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 0 0 0 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
zhlt_lightflags type:#string ui:wwmt_zhlt_lightflags_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
frags type:#integer ui:wwmt_frags_ui
lives type:#integer ui:wwmt_lives_ui
health type:#integer ui:wwmt_health_ui
armorvalue type:#integer ui:wwmt_armorvalue_ui
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
a_s type:#integer ui:wwmt_a_s_ui
a_n type:#integer ui:wwmt_a_n_ui
a_r type:#integer ui:wwmt_a_r_ui
a_c type:#integer ui:wwmt_a_c_ui
ammo_detpack type:#integer ui:wwmt_ammo_detpack_ui
no_grenades_1 type:#integer ui:wwmt_no_grenades_1_ui
no_grenades_2 type:#integer ui:wwmt_no_grenades_2_ui
invincible_finished type:#integer ui:wwmt_invincible_finished_ui
invisible_finished type:#integer ui:wwmt_invisible_finished_ui
super_damage_finished type:#integer ui:wwmt_super_damage_finished_ui
radsuit_finished type:#integer ui:wwmt_radsuit_finished_ui
count type:#integer ui:wwmt_count_ui
increase_team type:#integer ui:wwmt_increase_team_ui
increase_team1 type:#integer ui:wwmt_increase_team1_ui
increase_team2 type:#integer ui:wwmt_increase_team2_ui
increase_team3 type:#integer ui:wwmt_increase_team3_ui
increase_team4 type:#integer ui:wwmt_increase_team4_ui
owned_by type:#string ui:wwmt_owned_by_ui default:"0"
owned_by_teamcheck type:#string ui:wwmt_owned_by_teamcheck_ui default:""
deathtype type:#string ui:wwmt_deathtype_ui default:""
b_b type:#string ui:wwmt_b_b_ui default:""
message type:#string ui:wwmt_message_ui default:""
b_t type:#string ui:wwmt_b_t_ui default:""
b_n type:#string ui:wwmt_b_n_ui default:""
b_o type:#string ui:wwmt_b_o_ui default:""
non_owners_team_broadcast type:#string ui:wwmt_non_owners_team_broadcast_ui default:""
n_b type:#string ui:wwmt_n_b_ui default:""
n_t type:#string ui:wwmt_n_t_ui default:""
n_n type:#string ui:wwmt_n_n_ui default:""
n_o type:#string ui:wwmt_n_o_ui default:""
speak type:#string ui:wwmt_speak_ui default:""
ap_speak type:#string ui:wwmt_ap_speak_ui default:""
team_speak type:#string ui:wwmt_team_speak_ui default:""
non_team_speak type:#string ui:wwmt_non_team_speak_ui default:""
owners_team_speak type:#string ui:wwmt_owners_team_speak_ui default:""
non_owners_team_speak type:#string ui:wwmt_non_owners_team_speak_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "momentary_rot_button"
spinner wwmt_speed_ui "Speed" type:#integer range:[-10000,10000,50]
label wwmt_master_ui_label "Master" 
editText wwmt_master_ui "" type:#string
dropdownlist wwmt_sounds_ui "Sounds" type:#string items:#("None","Big zap & Warmup","Access Denied","Access Granted","Quick Combolock","Power Deadbolt 1","Power Deadbolt 2","Plunger","Small zap","Keycard Sound","Squeaky","Squeaky Pneumatic","Ratchet Groan","Clean Ratchet","Gas Clunk")
on wwmt_sounds_ui selected i do sounds = propMapsounds[i] 
spinner wwmt_distance_ui "Distance (deg" type:#integer range:[-10000,10000,90]
spinner wwmt_returnspeed_ui "Auto-return s" type:#integer range:[-10000,10000,0]
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)" 
editText wwmt_angles_ui "" type:#string

		
		Button btn_wwmt_angles_get_ui "Get" tooltip:"Get the Yaw/Pitch/Roll from the node's transform in the scene." across:2
		Button btn_wwmt_angles_set_ui "Set" tooltip:"Set the node's transform from the input Yaw/Pitch/Roll"
		on btn_wwmt_angles_get_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_update_entity_angles (getNode()))
		)
		on btn_wwmt_angles_set_ui pressed do (
			if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
			if ::WallWormEntityOps != undefined then (::WallWormEntityOps.wallworm_rotateEntByYZX (getNode()))
		)
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive")
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (1 " type:#integer range:[-10000,10000,0]
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 0 0 0 )
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_zhlt_lightflags_ui "ZHLT Light flags" type:#string items:#("Default","Embedded fix","Opaque, blocks light","Both")
on wwmt_zhlt_lightflags_ui selected i do zhlt_lightflags = propMapzhlt_lightflags[i] 
label wwmt__minlight_ui_label "Minimum light level" 
editText wwmt__minlight_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
spinner wwmt_frags_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_lives_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_health_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_armorvalue_ui "Armor Value  " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
spinner wwmt_a_s_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_n_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_r_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_c_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_ammo_detpack_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_1_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_2_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_invincible_finished_ui "Invincibility" type:#integer range:[-10000,10000,0]
spinner wwmt_invisible_finished_ui "Invisibility " type:#integer range:[-10000,10000,0]
spinner wwmt_super_damage_finished_ui "Quad Duration" type:#integer range:[-10000,10000,0]
spinner wwmt_radsuit_finished_ui "Rad Suit Dura" type:#integer range:[-10000,10000,0]
spinner wwmt_count_ui "Score to AP T" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team_ui "Teamcheck tea" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team1_ui "Blue point ga" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team2_ui "Red point gai" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team3_ui "Yellow point " type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team4_ui "Green point g" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_owned_by_ui "Owned by-for msg & item glow" type:#string items:#("Not Owned","Blue","Red","Yellow","Green")
on wwmt_owned_by_ui selected i do owned_by = propMapowned_by[i] 
label wwmt_owned_by_teamcheck_ui_label "Owned by teamcheck" 
editText wwmt_owned_by_teamcheck_ui "" type:#string
label wwmt_deathtype_ui_label "Goal death message" 
editText wwmt_deathtype_ui "" type:#string
label wwmt_b_b_ui_label "Message to all" 
editText wwmt_b_b_ui "" type:#string
label wwmt_message_ui_label "Message to AP" 
editText wwmt_message_ui "" type:#string
label wwmt_b_t_ui_label "Message to AP team" 
editText wwmt_b_t_ui "" type:#string
label wwmt_b_n_ui_label "Message to non-AP team" 
editText wwmt_b_n_ui "" type:#string
label wwmt_b_o_ui_label "Message to owner team" 
editText wwmt_b_o_ui "" type:#string
label wwmt_non_owners_team_broadcast_ui_label "Message to non-owner team(s)" 
editText wwmt_non_owners_team_broadcast_ui "" type:#string
label wwmt_n_b_ui_label "Console msg. to all,  percents = AP name" 
editText wwmt_n_b_ui "" type:#string
label wwmt_n_t_ui_label "Console msg to AP team" 
editText wwmt_n_t_ui "" type:#string
label wwmt_n_n_ui_label "Console msg. to non-AP team" 
editText wwmt_n_n_ui "" type:#string
label wwmt_n_o_ui_label "Console msg. to owner team" 
editText wwmt_n_o_ui "" type:#string
label wwmt_speak_ui_label "Speak (global)" 
editText wwmt_speak_ui "" type:#string
label wwmt_ap_speak_ui_label "Speak (AP)" 
editText wwmt_ap_speak_ui "" type:#string
label wwmt_team_speak_ui_label "Speak (AP team)" 
editText wwmt_team_speak_ui "" type:#string
label wwmt_non_team_speak_ui_label "Speak (non-AP team)" 
editText wwmt_non_team_speak_ui "" type:#string
label wwmt_owners_team_speak_ui_label "Speak (owner team)" 
editText wwmt_owners_team_speak_ui "" type:#string
label wwmt_non_owners_team_speak_ui_label "Speak (non-owner teams)" 
editText wwmt_non_owners_team_speak_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Door Hack" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Not useable" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Auto Return" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "X Axis" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "Y Axis" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with momentary_rot_button" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"momentary_rot_button_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=momentary_rot_button&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: momentary_rot_button" address:"https://developer.valvesoftware.com/wiki/momentary_rot_button?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if sounds != undefined AND findItem propMapsounds sounds == 0 then (
 append propMapsounds sounds
tmp = wwmt_sounds_ui.items
 append tmp sounds
wwmt_sounds_ui.items = tmp
wwmt_sounds_ui.selection = propMapsounds.count
) else ( 
 if sounds != undefined then (
wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if zhlt_lightflags != undefined AND findItem propMapzhlt_lightflags zhlt_lightflags == 0 then (
 append propMapzhlt_lightflags zhlt_lightflags
tmp = wwmt_zhlt_lightflags_ui.items
 append tmp zhlt_lightflags
wwmt_zhlt_lightflags_ui.items = tmp
wwmt_zhlt_lightflags_ui.selection = propMapzhlt_lightflags.count
) else ( 
 if zhlt_lightflags != undefined then (
wwmt_zhlt_lightflags_ui.selection = (findItem propMapzhlt_lightflags zhlt_lightflags)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)
 if owned_by != undefined AND findItem propMapowned_by owned_by == 0 then (
 append propMapowned_by owned_by
tmp = wwmt_owned_by_ui.items
 append tmp owned_by
wwmt_owned_by_ui.items = tmp
wwmt_owned_by_ui.selection = propMapowned_by.count
) else ( 
 if owned_by != undefined then (
wwmt_owned_by_ui.selection = (findItem propMapowned_by owned_by)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_trigger_cdaudio_CA = attributes "WW Entity trigger_cdaudio" version:78 attribID:#(276153110L,782425406L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_cdaudio"
local hasOutputs = false
local hasInputs = false
local description = "Trigger CD Audio"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValhealth="-1"
local propMaphealth=#("-1","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30")
local exportProps=#()	
function resetExportProps = ( exportProps=#("health","targetname"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
health type:#string ui:wwmt_health_ui default:"-1"
targetname type:#string ui:wwmt_targetname_ui default:""

)

rollout params "Entity Properties"
(
label entityLabel "trigger_cdaudio"
dropdownlist wwmt_health_ui "Track #" type:#string items:#("Stop","Track 1","Track 2","Track 3","Track 4","Track 5","Track 6","Track 7","Track 8","Track 9","Track 10","Track 11","Track 12","Track 13","Track 14","Track 15","Track 16","Track 17","Track 18","Track 19","Track 20","Track 21","Track 22","Track 23","Track 24","Track 25","Track 26","Track 27","Track 28","Track 29","Track 30")
on wwmt_health_ui selected i do health = propMaphealth[i] 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_cdaudio" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_cdaudio_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_cdaudio&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_cdaudio" address:"https://developer.valvesoftware.com/wiki/trigger_cdaudio?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if health != undefined AND findItem propMaphealth health == 0 then (
 append propMaphealth health
tmp = wwmt_health_ui.items
 append tmp health
wwmt_health_ui.items = tmp
wwmt_health_ui.selection = propMaphealth.count
) else ( 
 if health != undefined then (
wwmt_health_ui.selection = (findItem propMaphealth health)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_trigger_counter_CA = attributes "WW Entity trigger_counter" version:78 attribID:#(276153110L,-1040629305L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_counter"
local hasOutputs = false
local hasInputs = false
local description = "Trigger counter"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsounds="0"
local propMapsounds=#("0")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("master","count","killtarget","netname","sounds","delay","message","wwmt_target","targetname","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","frags","lives","health","armorvalue","armorclass","a_s","a_n","a_r","a_c","ammo_detpack","no_grenades_1","no_grenades_2","invincible_finished","invisible_finished","super_damage_finished","radsuit_finished","increase_team","increase_team1","increase_team2","increase_team3","increase_team4"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
master type:#string ui:wwmt_master_ui default:""
count type:#integer ui:wwmt_count_ui default:2
killtarget type:#string ui:wwmt_killtarget_ui default:""
netname type:#string ui:wwmt_netname_ui default:""
sounds type:#string ui:wwmt_sounds_ui default:"0"
delay type:#string ui:wwmt_delay_ui default:"0"
message type:#string ui:wwmt_message_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
frags type:#integer ui:wwmt_frags_ui
lives type:#integer ui:wwmt_lives_ui
health type:#integer ui:wwmt_health_ui
armorvalue type:#integer ui:wwmt_armorvalue_ui
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
a_s type:#integer ui:wwmt_a_s_ui
a_n type:#integer ui:wwmt_a_n_ui
a_r type:#integer ui:wwmt_a_r_ui
a_c type:#integer ui:wwmt_a_c_ui
ammo_detpack type:#integer ui:wwmt_ammo_detpack_ui
no_grenades_1 type:#integer ui:wwmt_no_grenades_1_ui
no_grenades_2 type:#integer ui:wwmt_no_grenades_2_ui
invincible_finished type:#integer ui:wwmt_invincible_finished_ui
invisible_finished type:#integer ui:wwmt_invisible_finished_ui
super_damage_finished type:#integer ui:wwmt_super_damage_finished_ui
radsuit_finished type:#integer ui:wwmt_radsuit_finished_ui
increase_team type:#integer ui:wwmt_increase_team_ui
increase_team1 type:#integer ui:wwmt_increase_team1_ui
increase_team2 type:#integer ui:wwmt_increase_team2_ui
increase_team3 type:#integer ui:wwmt_increase_team3_ui
increase_team4 type:#integer ui:wwmt_increase_team4_ui
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "trigger_counter"
label wwmt_master_ui_label "Master" 
editText wwmt_master_ui "" type:#string
spinner wwmt_count_ui "Count before " type:#integer range:[-10000,10000,2]
label wwmt_killtarget_ui_label "Kill target" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick Kill target" message:"Pick Target Entity for Kill target" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
label wwmt_netname_ui_label "Target Path" 
editText wwmt_netname_ui "" type:#string
pickbutton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter 
on wwmt_netname_pickme_ui picked obj do (
netname = obj.targetname
) 
dropdownlist wwmt_sounds_ui "Sound style" type:#string items:#("No Sound")
on wwmt_sounds_ui selected i do sounds = propMapsounds[i] 
label wwmt_delay_ui_label "Delay before trigger" 
editText wwmt_delay_ui "" type:#string
label wwmt_message_ui_label "Message (set sound too!)" 
editText wwmt_message_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
spinner wwmt_frags_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_lives_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_health_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_armorvalue_ui "Armor Value  " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
spinner wwmt_a_s_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_n_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_r_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_c_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_ammo_detpack_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_1_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_2_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_invincible_finished_ui "Invincibility" type:#integer range:[-10000,10000,0]
spinner wwmt_invisible_finished_ui "Invisibility " type:#integer range:[-10000,10000,0]
spinner wwmt_super_damage_finished_ui "Quad Duration" type:#integer range:[-10000,10000,0]
spinner wwmt_radsuit_finished_ui "Rad Suit Dura" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team_ui "Teamcheck tea" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team1_ui "Blue point ga" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team2_ui "Red point gai" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team3_ui "Yellow point " type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team4_ui "Green point g" type:#integer range:[-10000,10000,0]

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "No Message" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "No Clients" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_counter" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_counter_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_counter&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_counter" address:"https://developer.valvesoftware.com/wiki/trigger_counter?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if sounds != undefined AND findItem propMapsounds sounds == 0 then (
 append propMapsounds sounds
tmp = wwmt_sounds_ui.items
 append tmp sounds
wwmt_sounds_ui.items = tmp
wwmt_sounds_ui.selection = propMapsounds.count
) else ( 
 if sounds != undefined then (
wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_trigger_gravity_CA = attributes "WW Entity trigger_gravity" version:78 attribID:#(276153110L,1571249033L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_gravity"
local hasOutputs = false
local hasInputs = false
local description = "Trigger Gravity"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsounds="0"
local propMapsounds=#("0")
local exportProps=#()	
function resetExportProps = ( exportProps=#("gravity","killtarget","netname","master","sounds","delay","message","wwmt_target","targetname"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
gravity type:#integer ui:wwmt_gravity_ui default:1
killtarget type:#string ui:wwmt_killtarget_ui default:""
netname type:#string ui:wwmt_netname_ui default:""
master type:#string ui:wwmt_master_ui default:""
sounds type:#string ui:wwmt_sounds_ui default:"0"
delay type:#string ui:wwmt_delay_ui default:"0"
message type:#string ui:wwmt_message_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "trigger_gravity"
spinner wwmt_gravity_ui "Gravity (0-1)" type:#integer range:[-10000,10000,1]
label wwmt_killtarget_ui_label "Kill target" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick Kill target" message:"Pick Target Entity for Kill target" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
label wwmt_netname_ui_label "Target Path" 
editText wwmt_netname_ui "" type:#string
pickbutton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter 
on wwmt_netname_pickme_ui picked obj do (
netname = obj.targetname
) 
label wwmt_master_ui_label "Master" 
editText wwmt_master_ui "" type:#string
dropdownlist wwmt_sounds_ui "Sound style" type:#string items:#("No Sound")
on wwmt_sounds_ui selected i do sounds = propMapsounds[i] 
label wwmt_delay_ui_label "Delay before trigger" 
editText wwmt_delay_ui "" type:#string
label wwmt_message_ui_label "Message (set sound too!)" 
editText wwmt_message_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_2_ui "No Clients" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_gravity" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_gravity_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_gravity&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_gravity" address:"https://developer.valvesoftware.com/wiki/trigger_gravity?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if sounds != undefined AND findItem propMapsounds sounds == 0 then (
 append propMapsounds sounds
tmp = wwmt_sounds_ui.items
 append tmp sounds
wwmt_sounds_ui.items = tmp
wwmt_sounds_ui.selection = propMapsounds.count
) else ( 
 if sounds != undefined then (
wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
)
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_trigger_hurt_CA = attributes "WW Entity trigger_hurt" version:78 attribID:#(-1618386072L,1468683444L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_hurt"
local hasOutputs = false
local hasInputs = false
local description = "Trigger player hurt"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValdamagetype="0"
local propMapdamagetype=#("0","1","2","4","8","16","32","64","128","256","512","1024","16384","32768","65536","131072","262144","524288","1048576","2097152","4194304")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local exportProps=#()	
function resetExportProps = ( exportProps=#("master","dmg","delay","damagetype","targetname","wwmt_target","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
master type:#string ui:wwmt_master_ui default:""
dmg type:#integer ui:wwmt_dmg_ui default:10
delay type:#string ui:wwmt_delay_ui default:"0"
damagetype type:#string ui:wwmt_damagetype_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "trigger_hurt"
label wwmt_master_ui_label "Master" 
editText wwmt_master_ui "" type:#string
spinner wwmt_dmg_ui "Damage" type:#integer range:[-10000,10000,10]
label wwmt_delay_ui_label "Delay before trigger" 
editText wwmt_delay_ui "" type:#string
dropdownlist wwmt_damagetype_ui "Damage Type" type:#string items:#("GENERIC","CRUSH","BULLET","SLASH","BURN","FREEZE","FALL","BLAST","CLUB","SHOCK","SONIC","ENERGYBEAM","DROWN","PARALYSE","NERVEGAS","POISON","RADIATION","DROWNRECOVER","CHEMICAL","SLOWBURN","SLOWFREEZE")
on wwmt_damagetype_ui selected i do damagetype = propMapdamagetype[i] 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Target Once" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Start Off" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "No clients" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "FireClientOnly" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "TouchClientOnly" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_hurt" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_hurt_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_hurt&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_hurt" address:"https://developer.valvesoftware.com/wiki/trigger_hurt?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if damagetype != undefined AND findItem propMapdamagetype damagetype == 0 then (
 append propMapdamagetype damagetype
tmp = wwmt_damagetype_ui.items
 append tmp damagetype
wwmt_damagetype_ui.items = tmp
wwmt_damagetype_ui.selection = propMapdamagetype.count
) else ( 
 if damagetype != undefined then (
wwmt_damagetype_ui.selection = (findItem propMapdamagetype damagetype)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_trigger_multiple_CA = attributes "WW Entity trigger_multiple" version:78 attribID:#(935655839L,-492899498L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_multiple"
local hasOutputs = false
local hasInputs = false
local description = "Trigger Activate multiple"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsounds="0"
local propMapsounds=#("0")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("wait","killtarget","netname","master","sounds","delay","message","wwmt_target","targetname","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","frags","lives","health","armorvalue","armorclass","a_s","a_n","a_r","a_c","ammo_detpack","no_grenades_1","no_grenades_2","invincible_finished","invisible_finished","super_damage_finished","radsuit_finished","count","increase_team","increase_team1","increase_team2","increase_team3","increase_team4"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
wait type:#integer ui:wwmt_wait_ui default:10
killtarget type:#string ui:wwmt_killtarget_ui default:""
netname type:#string ui:wwmt_netname_ui default:""
master type:#string ui:wwmt_master_ui default:""
sounds type:#string ui:wwmt_sounds_ui default:"0"
delay type:#string ui:wwmt_delay_ui default:"0"
message type:#string ui:wwmt_message_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
frags type:#integer ui:wwmt_frags_ui
lives type:#integer ui:wwmt_lives_ui
health type:#integer ui:wwmt_health_ui
armorvalue type:#integer ui:wwmt_armorvalue_ui
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
a_s type:#integer ui:wwmt_a_s_ui
a_n type:#integer ui:wwmt_a_n_ui
a_r type:#integer ui:wwmt_a_r_ui
a_c type:#integer ui:wwmt_a_c_ui
ammo_detpack type:#integer ui:wwmt_ammo_detpack_ui
no_grenades_1 type:#integer ui:wwmt_no_grenades_1_ui
no_grenades_2 type:#integer ui:wwmt_no_grenades_2_ui
invincible_finished type:#integer ui:wwmt_invincible_finished_ui
invisible_finished type:#integer ui:wwmt_invisible_finished_ui
super_damage_finished type:#integer ui:wwmt_super_damage_finished_ui
radsuit_finished type:#integer ui:wwmt_radsuit_finished_ui
count type:#integer ui:wwmt_count_ui
increase_team type:#integer ui:wwmt_increase_team_ui
increase_team1 type:#integer ui:wwmt_increase_team1_ui
increase_team2 type:#integer ui:wwmt_increase_team2_ui
increase_team3 type:#integer ui:wwmt_increase_team3_ui
increase_team4 type:#integer ui:wwmt_increase_team4_ui
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "trigger_multiple"
spinner wwmt_wait_ui "Delay before " type:#integer range:[-10000,10000,10]
label wwmt_killtarget_ui_label "Kill target" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick Kill target" message:"Pick Target Entity for Kill target" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
label wwmt_netname_ui_label "Target Path" 
editText wwmt_netname_ui "" type:#string
pickbutton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter 
on wwmt_netname_pickme_ui picked obj do (
netname = obj.targetname
) 
label wwmt_master_ui_label "Master" 
editText wwmt_master_ui "" type:#string
dropdownlist wwmt_sounds_ui "Sound style" type:#string items:#("No Sound")
on wwmt_sounds_ui selected i do sounds = propMapsounds[i] 
label wwmt_delay_ui_label "Delay before trigger" 
editText wwmt_delay_ui "" type:#string
label wwmt_message_ui_label "Message (set sound too!)" 
editText wwmt_message_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
spinner wwmt_frags_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_lives_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_health_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_armorvalue_ui "Armor Value  " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
spinner wwmt_a_s_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_n_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_r_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_c_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_ammo_detpack_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_1_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_2_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_invincible_finished_ui "Invincibility" type:#integer range:[-10000,10000,0]
spinner wwmt_invisible_finished_ui "Invisibility " type:#integer range:[-10000,10000,0]
spinner wwmt_super_damage_finished_ui "Quad Duration" type:#integer range:[-10000,10000,0]
spinner wwmt_radsuit_finished_ui "Rad Suit Dura" type:#integer range:[-10000,10000,0]
spinner wwmt_count_ui "Score to AP T" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team_ui "Teamcheck tea" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team1_ui "Blue point ga" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team2_ui "Red point gai" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team3_ui "Yellow point " type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team4_ui "Green point g" type:#integer range:[-10000,10000,0]

function addFlags = (
 local sfs = 0

if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_2_ui "No Clients" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_multiple" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_multiple_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_multiple&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_multiple" address:"https://developer.valvesoftware.com/wiki/trigger_multiple?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if sounds != undefined AND findItem propMapsounds sounds == 0 then (
 append propMapsounds sounds
tmp = wwmt_sounds_ui.items
 append tmp sounds
wwmt_sounds_ui.items = tmp
wwmt_sounds_ui.selection = propMapsounds.count
) else ( 
 if sounds != undefined then (
wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_trigger_once_CA = attributes "WW Entity trigger_once" version:78 attribID:#(-1618386072L,-1287051376L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_once"
local hasOutputs = false
local hasInputs = false
local description = "Trigger Activate once"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsounds="0"
local propMapsounds=#("0")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("speed","killtarget","netname","master","sounds","delay","message","wwmt_target","targetname","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","frags","lives","health","armorvalue","armorclass","a_s","a_n","a_r","a_c","ammo_detpack","no_grenades_1","no_grenades_2","invincible_finished","invisible_finished","super_damage_finished","radsuit_finished","count","increase_team","increase_team1","increase_team2","increase_team3","increase_team4"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
speed type:#integer ui:wwmt_speed_ui default:40
killtarget type:#string ui:wwmt_killtarget_ui default:""
netname type:#string ui:wwmt_netname_ui default:""
master type:#string ui:wwmt_master_ui default:""
sounds type:#string ui:wwmt_sounds_ui default:"0"
delay type:#string ui:wwmt_delay_ui default:"0"
message type:#string ui:wwmt_message_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
frags type:#integer ui:wwmt_frags_ui
lives type:#integer ui:wwmt_lives_ui
health type:#integer ui:wwmt_health_ui
armorvalue type:#integer ui:wwmt_armorvalue_ui
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
a_s type:#integer ui:wwmt_a_s_ui
a_n type:#integer ui:wwmt_a_n_ui
a_r type:#integer ui:wwmt_a_r_ui
a_c type:#integer ui:wwmt_a_c_ui
ammo_detpack type:#integer ui:wwmt_ammo_detpack_ui
no_grenades_1 type:#integer ui:wwmt_no_grenades_1_ui
no_grenades_2 type:#integer ui:wwmt_no_grenades_2_ui
invincible_finished type:#integer ui:wwmt_invincible_finished_ui
invisible_finished type:#integer ui:wwmt_invisible_finished_ui
super_damage_finished type:#integer ui:wwmt_super_damage_finished_ui
radsuit_finished type:#integer ui:wwmt_radsuit_finished_ui
count type:#integer ui:wwmt_count_ui
increase_team type:#integer ui:wwmt_increase_team_ui
increase_team1 type:#integer ui:wwmt_increase_team1_ui
increase_team2 type:#integer ui:wwmt_increase_team2_ui
increase_team3 type:#integer ui:wwmt_increase_team3_ui
increase_team4 type:#integer ui:wwmt_increase_team4_ui
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "trigger_once"
spinner wwmt_speed_ui "Speed of push" type:#integer range:[-10000,10000,40]
label wwmt_killtarget_ui_label "Kill target" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick Kill target" message:"Pick Target Entity for Kill target" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
label wwmt_netname_ui_label "Target Path" 
editText wwmt_netname_ui "" type:#string
pickbutton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter 
on wwmt_netname_pickme_ui picked obj do (
netname = obj.targetname
) 
label wwmt_master_ui_label "Master" 
editText wwmt_master_ui "" type:#string
dropdownlist wwmt_sounds_ui "Sound style" type:#string items:#("No Sound")
on wwmt_sounds_ui selected i do sounds = propMapsounds[i] 
label wwmt_delay_ui_label "Delay before trigger" 
editText wwmt_delay_ui "" type:#string
label wwmt_message_ui_label "Message (set sound too!)" 
editText wwmt_message_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
spinner wwmt_frags_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_lives_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_health_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_armorvalue_ui "Armor Value  " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
spinner wwmt_a_s_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_n_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_r_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_c_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_ammo_detpack_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_1_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_2_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_invincible_finished_ui "Invincibility" type:#integer range:[-10000,10000,0]
spinner wwmt_invisible_finished_ui "Invisibility " type:#integer range:[-10000,10000,0]
spinner wwmt_super_damage_finished_ui "Quad Duration" type:#integer range:[-10000,10000,0]
spinner wwmt_radsuit_finished_ui "Rad Suit Dura" type:#integer range:[-10000,10000,0]
spinner wwmt_count_ui "Score to AP T" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team_ui "Teamcheck tea" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team1_ui "Blue point ga" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team2_ui "Red point gai" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team3_ui "Yellow point " type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team4_ui "Green point g" type:#integer range:[-10000,10000,0]

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Once Only" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Start Off" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_once" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_once_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_once&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_once" address:"https://developer.valvesoftware.com/wiki/trigger_once?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if sounds != undefined AND findItem propMapsounds sounds == 0 then (
 append propMapsounds sounds
tmp = wwmt_sounds_ui.items
 append tmp sounds
wwmt_sounds_ui.items = tmp
wwmt_sounds_ui.selection = propMapsounds.count
) else ( 
 if sounds != undefined then (
wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

global wallworm_trigger_teleport_CA = attributes "WW Entity trigger_teleport" version:78 attribID:#(935655839L,1008780661L)
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_teleport"
local hasOutputs = false
local hasInputs = false
local description = "Trigger teleport"
local wallworm_classes = #{1,3}

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsounds="0"
local propMapsounds=#("0")
local propValteam_no="0"
local propMapteam_no=#("0","1","2","3","4")
local propValplayerclass="0"
local propMapplayerclass=#("0","1","2","3","4","5","6","7","8","9")
local propValmaxammo_shells="0"
local propMapmaxammo_shells=#("0","1","2","3","4")
local propValmaxammo_nails="0"
local propMapmaxammo_nails=#("0","1","2","3","4")
local propValarmorclass="0"
local propMaparmorclass=#("0","1","2","4","8","16")
local exportProps=#()	
function resetExportProps = ( exportProps=#("killtarget","netname","master","sounds","delay","message","wwmt_target","targetname","team_no","teamcheck","playerclass","items_allowed","h_i_g","hasnt_item_from_group","if_item_has_moved","if_item_hasnt_moved","if_goal_is_active","if_goal_is_inactive","if_goal_is_removed","if_group_is_active","if_group_is_inactive","if_group_is_removed","maxammo_shells","maxammo_nails","t_length","else_goal","all_active","last_impulse","activate_goal_no","inactivate_goal_no","rv_g","rs_g","activate_group_no","inactivate_group_no","rv_gr","rs_gr","remove_spawnpoint","restore_spawnpoint","rv_s_h","rs_s_h","items","axhitme","return_item_no","r_i_g","frags","lives","health","armorvalue","armorclass","a_s","a_n","a_r","a_c","ammo_detpack","no_grenades_1","no_grenades_2","invincible_finished","invisible_finished","super_damage_finished","radsuit_finished","count","increase_team","increase_team1","increase_team2","increase_team3","increase_team4"))

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
killtarget type:#string ui:wwmt_killtarget_ui default:""
netname type:#string ui:wwmt_netname_ui default:""
master type:#string ui:wwmt_master_ui default:""
sounds type:#string ui:wwmt_sounds_ui default:"0"
delay type:#string ui:wwmt_delay_ui default:"0"
message type:#string ui:wwmt_message_ui default:""
wwmt_target type:#string ui:wwmt_target_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
team_no type:#string ui:wwmt_team_no_ui default:"0"
teamcheck type:#string ui:wwmt_teamcheck_ui default:""
playerclass type:#string ui:wwmt_playerclass_ui default:"0"
items_allowed type:#integer ui:wwmt_items_allowed_ui
h_i_g type:#integer ui:wwmt_h_i_g_ui
hasnt_item_from_group type:#integer ui:wwmt_hasnt_item_from_group_ui
if_item_has_moved type:#integer ui:wwmt_if_item_has_moved_ui
if_item_hasnt_moved type:#integer ui:wwmt_if_item_hasnt_moved_ui
if_goal_is_active type:#integer ui:wwmt_if_goal_is_active_ui
if_goal_is_inactive type:#integer ui:wwmt_if_goal_is_inactive_ui
if_goal_is_removed type:#integer ui:wwmt_if_goal_is_removed_ui
if_group_is_active type:#integer ui:wwmt_if_group_is_active_ui
if_group_is_inactive type:#integer ui:wwmt_if_group_is_inactive_ui
if_group_is_removed type:#integer ui:wwmt_if_group_is_removed_ui
maxammo_shells type:#string ui:wwmt_maxammo_shells_ui default:"0"
maxammo_nails type:#string ui:wwmt_maxammo_nails_ui default:"0"
t_length type:#integer ui:wwmt_t_length_ui default:0
else_goal type:#integer ui:wwmt_else_goal_ui
all_active type:#integer ui:wwmt_all_active_ui
last_impulse type:#integer ui:wwmt_last_impulse_ui
activate_goal_no type:#integer ui:wwmt_activate_goal_no_ui
inactivate_goal_no type:#integer ui:wwmt_inactivate_goal_no_ui
rv_g type:#integer ui:wwmt_rv_g_ui
rs_g type:#integer ui:wwmt_rs_g_ui
activate_group_no type:#integer ui:wwmt_activate_group_no_ui
inactivate_group_no type:#integer ui:wwmt_inactivate_group_no_ui
rv_gr type:#integer ui:wwmt_rv_gr_ui
rs_gr type:#integer ui:wwmt_rs_gr_ui
remove_spawnpoint type:#integer ui:wwmt_remove_spawnpoint_ui
restore_spawnpoint type:#integer ui:wwmt_restore_spawnpoint_ui
rv_s_h type:#integer ui:wwmt_rv_s_h_ui
rs_s_h type:#integer ui:wwmt_rs_s_h_ui
items type:#integer ui:wwmt_items_ui
axhitme type:#integer ui:wwmt_axhitme_ui
return_item_no type:#integer ui:wwmt_return_item_no_ui
r_i_g type:#integer ui:wwmt_r_i_g_ui
frags type:#integer ui:wwmt_frags_ui
lives type:#integer ui:wwmt_lives_ui
health type:#integer ui:wwmt_health_ui
armorvalue type:#integer ui:wwmt_armorvalue_ui
armorclass type:#string ui:wwmt_armorclass_ui default:"0"
a_s type:#integer ui:wwmt_a_s_ui
a_n type:#integer ui:wwmt_a_n_ui
a_r type:#integer ui:wwmt_a_r_ui
a_c type:#integer ui:wwmt_a_c_ui
ammo_detpack type:#integer ui:wwmt_ammo_detpack_ui
no_grenades_1 type:#integer ui:wwmt_no_grenades_1_ui
no_grenades_2 type:#integer ui:wwmt_no_grenades_2_ui
invincible_finished type:#integer ui:wwmt_invincible_finished_ui
invisible_finished type:#integer ui:wwmt_invisible_finished_ui
super_damage_finished type:#integer ui:wwmt_super_damage_finished_ui
radsuit_finished type:#integer ui:wwmt_radsuit_finished_ui
count type:#integer ui:wwmt_count_ui
increase_team type:#integer ui:wwmt_increase_team_ui
increase_team1 type:#integer ui:wwmt_increase_team1_ui
increase_team2 type:#integer ui:wwmt_increase_team2_ui
increase_team3 type:#integer ui:wwmt_increase_team3_ui
increase_team4 type:#integer ui:wwmt_increase_team4_ui
spawnflags type:#integer default:0

)

rollout params "Entity Properties"
(
label entityLabel "trigger_teleport"
label wwmt_killtarget_ui_label "Kill target" 
editText wwmt_killtarget_ui "" type:#string
pickbutton wwmt_killtarget_pickme_ui "Pick Kill target" message:"Pick Target Entity for Kill target" filter:target_name_filter 
on wwmt_killtarget_pickme_ui picked obj do (
killtarget = obj.targetname
) 
label wwmt_netname_ui_label "Target Path" 
editText wwmt_netname_ui "" type:#string
pickbutton wwmt_netname_pickme_ui "Pick Target Path" message:"Pick Target Entity for Target Path" filter:target_name_filter 
on wwmt_netname_pickme_ui picked obj do (
netname = obj.targetname
) 
label wwmt_master_ui_label "Master" 
editText wwmt_master_ui "" type:#string
dropdownlist wwmt_sounds_ui "Sound style" type:#string items:#("No Sound")
on wwmt_sounds_ui selected i do sounds = propMapsounds[i] 
label wwmt_delay_ui_label "Delay before trigger" 
editText wwmt_delay_ui "" type:#string
label wwmt_message_ui_label "Message (set sound too!)" 
editText wwmt_message_ui "" type:#string
label wwmt_target_ui_label "Target" 
editText wwmt_target_ui "" type:#string
pickbutton wwmt_target_pickme_ui "Pick Target" message:"Pick Target Entity for Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_targetname_ui_label "Name (targetname)" 
editText wwmt_targetname_ui "" type:#string
dropdownlist wwmt_team_no_ui "Team allowed to use goal" type:#string items:#("Any","Blue","Red","Yellow","Green")
on wwmt_team_no_ui selected i do team_no = propMapteam_no[i] 
label wwmt_teamcheck_ui_label "Targetname of teamcheck goal" 
editText wwmt_teamcheck_ui "" type:#string
dropdownlist wwmt_playerclass_ui "Player class allowed to use goal" type:#string items:#("Any","Scout","Sniper","Soldier","Demolitions man","Medic","Heavy Weapons Guy","Pyro","Spy","Engineer")
on wwmt_playerclass_ui selected i do playerclass = propMapplayerclass[i] 
spinner wwmt_items_allowed_ui "Has item #" type:#integer range:[-10000,10000,0]
spinner wwmt_h_i_g_ui "Has item from" type:#integer range:[-10000,10000,0]
spinner wwmt_hasnt_item_from_group_ui "Hasn't item f" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_has_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_item_hasnt_moved_ui "If item # has" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_active_ui "If goal # act" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_inactive_ui "If goal # ina" type:#integer range:[-10000,10000,0]
spinner wwmt_if_goal_is_removed_ui "If goal # rem" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_active_ui "If group # ac" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_inactive_ui "If group # in" type:#integer range:[-10000,10000,0]
spinner wwmt_if_group_is_removed_ui "If group # re" type:#integer range:[-10000,10000,0]
dropdownlist wwmt_maxammo_shells_ui "Affect all on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_shells_ui selected i do maxammo_shells = propMapmaxammo_shells[i] 
dropdownlist wwmt_maxammo_nails_ui "Affect all not on Team" type:#string items:#("Disabled","Blue","Red","Yellow","Green")
on wwmt_maxammo_nails_ui selected i do maxammo_nails = propMapmaxammo_nails[i] 
spinner wwmt_t_length_ui "Effect Radius" type:#integer range:[-10000,10000,0]
spinner wwmt_else_goal_ui "If criteria f" type:#integer range:[-10000,10000,0]
spinner wwmt_all_active_ui "If all goals " type:#integer range:[-10000,10000,0]
spinner wwmt_last_impulse_ui "...activate g" type:#integer range:[-10000,10000,0]
spinner wwmt_activate_goal_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_goal_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_g_ui "Remove goal #" type:#integer range:[-10000,10000,0]
spinner wwmt_rs_g_ui "Restore goal " type:#integer range:[-10000,10000,0]
spinner wwmt_activate_group_no_ui "Activate goal" type:#integer range:[-10000,10000,0]
spinner wwmt_inactivate_group_no_ui "Inactivate go" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_gr_ui "Remove goals " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_gr_ui "Restore goals" type:#integer range:[-10000,10000,0]
spinner wwmt_remove_spawnpoint_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_restore_spawnpoint_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_rv_s_h_ui "Remove Spawn " type:#integer range:[-10000,10000,0]
spinner wwmt_rs_s_h_ui "Restore Spawn" type:#integer range:[-10000,10000,0]
spinner wwmt_items_ui "Item to give" type:#integer range:[-10000,10000,0]
spinner wwmt_axhitme_ui "Remove item f" type:#integer range:[-10000,10000,0]
spinner wwmt_return_item_no_ui "Return item#," type:#integer range:[-10000,10000,0]
spinner wwmt_r_i_g_ui "Remove items " type:#integer range:[-10000,10000,0]
spinner wwmt_frags_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_lives_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_health_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_armorvalue_ui "Armor Value  " type:#integer range:[-10000,10000,0]
dropdownlist wwmt_armorclass_ui "Armor Class" type:#string items:#("Normal","1 - Kevlar (Shell Resistant)","2 - Wooden (Nail Resistant)","4 - Blast (Explosion Resistant)","8 - Shock (Electricity Resistant)","16 - Ceramic (Fire Resistant)")
on wwmt_armorclass_ui selected i do armorclass = propMaparmorclass[i] 
spinner wwmt_a_s_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_n_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_r_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_a_c_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_ammo_detpack_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_1_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_no_grenades_2_ui "Add/Subtract " type:#integer range:[-10000,10000,0]
spinner wwmt_invincible_finished_ui "Invincibility" type:#integer range:[-10000,10000,0]
spinner wwmt_invisible_finished_ui "Invisibility " type:#integer range:[-10000,10000,0]
spinner wwmt_super_damage_finished_ui "Quad Duration" type:#integer range:[-10000,10000,0]
spinner wwmt_radsuit_finished_ui "Rad Suit Dura" type:#integer range:[-10000,10000,0]
spinner wwmt_count_ui "Score to AP T" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team_ui "Teamcheck tea" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team1_ui "Blue point ga" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team2_ui "Red point gai" type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team3_ui "Yellow point " type:#integer range:[-10000,10000,0]
spinner wwmt_increase_team4_ui "Green point g" type:#integer range:[-10000,10000,0]

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Sync Movement" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "No Clients" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_teleport" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_teleport_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_teleport&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_teleport" address:"https://developer.valvesoftware.com/wiki/trigger_teleport?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if ::wallworm_entityFunctions_on_outputs_ui_selected == undefined then ( try(filein (::wallworm_installation_path+"/WallWorm.com/common/fgd_funcs.ms"))catch())
 if sounds != undefined AND findItem propMapsounds sounds == 0 then (
 append propMapsounds sounds
tmp = wwmt_sounds_ui.items
 append tmp sounds
wwmt_sounds_ui.items = tmp
wwmt_sounds_ui.selection = propMapsounds.count
) else ( 
 if sounds != undefined then (
wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
)
)
 if team_no != undefined AND findItem propMapteam_no team_no == 0 then (
 append propMapteam_no team_no
tmp = wwmt_team_no_ui.items
 append tmp team_no
wwmt_team_no_ui.items = tmp
wwmt_team_no_ui.selection = propMapteam_no.count
) else ( 
 if team_no != undefined then (
wwmt_team_no_ui.selection = (findItem propMapteam_no team_no)
)
)
 if playerclass != undefined AND findItem propMapplayerclass playerclass == 0 then (
 append propMapplayerclass playerclass
tmp = wwmt_playerclass_ui.items
 append tmp playerclass
wwmt_playerclass_ui.items = tmp
wwmt_playerclass_ui.selection = propMapplayerclass.count
) else ( 
 if playerclass != undefined then (
wwmt_playerclass_ui.selection = (findItem propMapplayerclass playerclass)
)
)
 if maxammo_shells != undefined AND findItem propMapmaxammo_shells maxammo_shells == 0 then (
 append propMapmaxammo_shells maxammo_shells
tmp = wwmt_maxammo_shells_ui.items
 append tmp maxammo_shells
wwmt_maxammo_shells_ui.items = tmp
wwmt_maxammo_shells_ui.selection = propMapmaxammo_shells.count
) else ( 
 if maxammo_shells != undefined then (
wwmt_maxammo_shells_ui.selection = (findItem propMapmaxammo_shells maxammo_shells)
)
)
 if maxammo_nails != undefined AND findItem propMapmaxammo_nails maxammo_nails == 0 then (
 append propMapmaxammo_nails maxammo_nails
tmp = wwmt_maxammo_nails_ui.items
 append tmp maxammo_nails
wwmt_maxammo_nails_ui.items = tmp
wwmt_maxammo_nails_ui.selection = propMapmaxammo_nails.count
) else ( 
 if maxammo_nails != undefined then (
wwmt_maxammo_nails_ui.selection = (findItem propMapmaxammo_nails maxammo_nails)
)
)
 if armorclass != undefined AND findItem propMaparmorclass armorclass == 0 then (
 append propMaparmorclass armorclass
tmp = wwmt_armorclass_ui.items
 append tmp armorclass
wwmt_armorclass_ui.items = tmp
wwmt_armorclass_ui.selection = propMaparmorclass.count
) else ( 
 if armorclass != undefined then (
wwmt_armorclass_ui.selection = (findItem propMaparmorclass armorclass)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
function resetThis = (thisNode = undefined;resetExportProps()) 

on create do resetThis() 

on clone orig do (orig.resetThis(); resetThis() )

		on update do (
			if isValidNode (getNode()) then (
				if ::WallWormEntityOps == undefined then ( try(macros.run "wallworm.com" "WallWormInitialize")catch())
				if ::WallWormEntityOps != undefined then ( ::WallWormEntityOps.wallworm_entity_ca_postupdate thisNode oldversion:version)
			)
		)
		
)

